"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = require("lodash");

var _reactPortal = require("react-portal");

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _bannerItem = _interopRequireDefault(require("./bannerItem"));

var _header = _interopRequireDefault(require("../header"));

var _icon = _interopRequireDefault(require("../icon"));

var _domUtils = _interopRequireDefault(require("../../utils/domUtils"));

var _withTheme = _interopRequireDefault(require("../../styles/withTheme"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  id: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]).isRequired,
  isOpen: _propTypes["default"].bool.isRequired,
  level: _propTypes["default"].oneOf(['error', 'purple', 'secondary', 'success', 'teal', 'warning']),
  levelIcon: _propTypes["default"].string,
  message: _propTypes["default"].string,
  onAfterClose: _propTypes["default"].func,
  onClose: _propTypes["default"].func.isRequired,
  onOpen: _propTypes["default"].func,
  style: _propTypes["default"].shape({}),
  theme: _propTypes["default"].shape({
    zIndex: _propTypes["default"].shape({
      banner: _propTypes["default"].number
    })
  }).isRequired,
  title: _propTypes["default"].string,
  topPosition: _propTypes["default"].number,
  type: _propTypes["default"].oneOf(['alert', 'notification'])
};
var defaultProps = {
  children: undefined,
  className: undefined,
  level: undefined,
  levelIcon: undefined,
  message: undefined,
  onAfterClose: undefined,
  onOpen: undefined,
  style: undefined,
  title: undefined,
  topPosition: undefined,
  type: undefined
};

var Banner = /*#__PURE__*/function (_React$Component) {
  _inherits(Banner, _React$Component);

  var _super = _createSuper(Banner);

  function Banner(props) {
    var _this;

    _classCallCheck(this, Banner);

    _this = _super.call(this, props);
    _this.state = {
      isOpen: props.isOpen
    };
    _this.onAnimationComplete = _this.onAnimationComplete.bind(_assertThisInitialized(_this));
    _this.onBeforeClose = _this.onBeforeClose.bind(_assertThisInitialized(_this));
    _this.onClose = _this.onClose.bind(_assertThisInitialized(_this));
    _this.onOpen = _this.onOpen.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(Banner, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var isOpen = this.state.isOpen;

      if (isOpen) {
        this.onOpen();
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this2 = this;

      var prevIsOpen = prevProps.isOpen;
      var isOpen = this.props.isOpen;

      if (!prevIsOpen && isOpen) {
        this.setState({
          isOpen: isOpen
        }, function () {
          _this2.onOpen();
        });
      }

      if (prevIsOpen && !isOpen) {
        this.onBeforeClose();
      }
    }
  }, {
    key: "onAnimationComplete",
    value: function onAnimationComplete() {
      var _this3 = this;

      var _this$props = this.props,
          id = _this$props.id,
          isOpen = _this$props.isOpen,
          onAfterClose = _this$props.onAfterClose; // eslint-disable-next-line react/no-find-dom-node

      var nodePortal = _reactDom["default"].findDOMNode(this);

      var bannerContainer = nodePortal.querySelector('.banner-container');

      var animationEvent = _domUtils["default"].cssAnimationType(bannerContainer);

      bannerContainer.removeEventListener(animationEvent, this.onAnimationComplete);
      this.setState({
        isOpen: false
      }, function () {
        _this3.bannerYPositions();

        if (!(0, _lodash.isUndefined)(onAfterClose) && !isOpen) {
          onAfterClose(id);
        }
      });
    }
  }, {
    key: "onBeforeClose",
    value: function onBeforeClose() {
      // eslint-disable-next-line react/no-find-dom-node
      var nodePortal = _reactDom["default"].findDOMNode(this);

      var bannerContainer = nodePortal.querySelector('.banner-container');

      var animationEvent = _domUtils["default"].cssAnimationType(bannerContainer);

      bannerContainer.className += ' animate-out';
      bannerContainer.addEventListener(animationEvent, this.onAnimationComplete);
    }
  }, {
    key: "onClose",
    value: function onClose() {
      var _this$props2 = this.props,
          id = _this$props2.id,
          onClose = _this$props2.onClose;
      onClose(id);
    }
  }, {
    key: "onOpen",
    value: function onOpen() {
      var _this$props3 = this.props,
          onOpen = _this$props3.onOpen,
          zIndex = _this$props3.theme.zIndex; // eslint-disable-next-line react/no-find-dom-node

      var nodePortal = _reactDom["default"].findDOMNode(this);

      nodePortal.style.zIndex = zIndex.banner;
      this.bannerYPositions();

      if ((0, _lodash.isFunction)(onOpen)) {
        onOpen();
      }
    }
  }, {
    key: "bannerYPositions",
    value: function bannerYPositions() {
      var topPosition = this.props.topPosition;
      var bannersYPosition = topPosition || 22;
      var containersArray = document.querySelectorAll('.ui.banner .banner-container');
      var containersLength = containersArray.length - 1;
      (0, _lodash.forEachRight)(containersArray, function (element, index) {
        var el = element;

        if (index !== containersLength) {
          bannersYPosition += el.offsetHeight + 11;
        }

        el.style.top = "".concat(bannersYPosition, "px");
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props4 = this.props,
          children = _this$props4.children,
          className = _this$props4.className,
          id = _this$props4.id,
          level = _this$props4.level,
          levelIcon = _this$props4.levelIcon,
          message = _this$props4.message,
          style = _this$props4.style,
          title = _this$props4.title,
          type = _this$props4.type;
      var isOpen = this.state.isOpen;

      if (!isOpen) {
        return false;
      }

      var containerClasses = (0, _classnames["default"])('ui', 'banner', className, {
        'banner-level-error': level === 'error',
        'banner-level-purple': level === 'purple',
        // Rename when better defined.
        'banner-level-secondary': !level || level === 'secondary',
        'banner-level-success': level === 'success',
        'banner-level-teal': level === 'teal',
        // Rename when better defined.
        'banner-level-warning': level === 'warning',
        'banner-type-alert': type === 'alert',
        'banner-type-notification': type === 'notification'
      });
      var containerInnerClasses = (0, _classnames["default"])('banner-container', className);
      var hasCloseButton = type === 'notification';
      var levelBasedIcon;

      switch (level) {
        case 'error':
          levelBasedIcon = 'times';
          break;

        case 'success':
          levelBasedIcon = 'check';
          break;

        case 'warning':
          levelBasedIcon = 'exclamation';
          break;

        case 'info':
        default:
          levelBasedIcon = 'circle';
      }

      return /*#__PURE__*/_react["default"].createElement(_reactPortal.Portal, null, /*#__PURE__*/_react["default"].createElement("div", {
        className: containerClasses,
        id: id,
        style: style
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: containerInnerClasses
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "banner-level-type"
      }, /*#__PURE__*/_react["default"].createElement(_icon["default"], {
        compact: true,
        inverse: true,
        type: levelIcon || levelBasedIcon
      })), /*#__PURE__*/_react["default"].createElement("div", {
        className: "banner-message-container"
      }, /*#__PURE__*/_react["default"].createElement(_header["default"], {
        size: "small",
        style: {
          marginBottom: '5px',
          paddingRight: hasCloseButton ? '16px' : null
        }
      }, title), message ? /*#__PURE__*/_react["default"].createElement("span", {
        className: "font-size-xxsmall"
      }, message) : null, children), hasCloseButton ? /*#__PURE__*/_react["default"].createElement(_icon["default"], {
        compact: true,
        id: "ui-button--close_banner_".concat(id),
        inverse: true,
        onClick: this.onClose,
        type: "times",
        style: {
          position: 'absolute',
          right: '11px',
          top: '11px'
        }
      }) : null)));
    }
  }]);

  return Banner;
}(_react["default"].Component);

Banner.Item = _bannerItem["default"];
Banner.propTypes = propTypes;
Banner.defaultProps = defaultProps;

var _default = (0, _withTheme["default"])(Banner);

exports["default"] = _default;