"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _card = _interopRequireDefault(require("../../surfaces/card"));

var _dataCardColumn = _interopRequireDefault(require("./dataCardColumn"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  cardProps: _propTypes["default"].func,
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({})).isRequired,
  data: _propTypes["default"].shape({}).isRequired,
  moduleType: _propTypes["default"].oneOf(['drawer', 'page']).isRequired,
  style: _propTypes["default"].shape({})
};
var defaultProps = {
  cardProps: undefined,
  style: {}
};

var DataCard = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(DataCard, _React$PureComponent);

  var _super = _createSuper(DataCard);

  function DataCard() {
    var _this;

    _classCallCheck(this, DataCard);

    _this = _super.call(this);
    _this.onClick = _this.onClick.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(DataCard, [{
    key: "onClick",
    value: function onClick() {
      var _this$props = this.props,
          cardProps = _this$props.cardProps,
          data = _this$props.data;
      var isTextSelect = window.getSelection().toString();

      if (!isTextSelect && _lodash["default"].isFunction(cardProps().onClick)) {
        cardProps().onClick(data);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          cardProps = _this$props2.cardProps,
          columns = _this$props2.columns,
          data = _this$props2.data,
          moduleType = _this$props2.moduleType;
      var elementClassName = "".concat(moduleType, "--data_card");
      return /*#__PURE__*/_react["default"].createElement(_card["default"], {
        className: "".concat(elementClassName),
        nest: true,
        onClick: _lodash["default"].isFunction(cardProps().onClick) ? this.onClick : null
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(elementClassName, "_inner_container")
      }, /*#__PURE__*/_react["default"].createElement(_dataCardColumn["default"], {
        columns: columns,
        data: data,
        moduleType: moduleType
      })));
    }
  }]);

  return DataCard;
}(_react["default"].PureComponent);

DataCard.propTypes = propTypes;
DataCard.defaultProps = defaultProps;
var _default = DataCard;
exports["default"] = _default;