"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _header = _interopRequireDefault(require("../header"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = {
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    style: _propTypes["default"].shape({})
  })).isRequired,
  data: _propTypes["default"].shape({}).isRequired,
  moduleType: _propTypes["default"].oneOf(['drawer', 'page']).isRequired
};

function DataCardColumn(props) {
  var columns = props.columns,
      data = props.data,
      moduleType = props.moduleType;
  var elementClassName = "".concat(moduleType, "--data_card_column");
  return _lodash["default"].map(columns, function (column, index) {
    var accessorClasses = (0, _classnames["default"])("".concat(elementClassName, "_accessor"), {
      'font-size-medium': column.fontSize === 'medium',
      'font-size-small': !column.fontSize || column.fontSize === 'small',
      'font-weight-bold': column.fontWeight === 'bold',
      'font-weight-normal': !column.fontWeight || column.fontWeight === 'normal',
      'font-weight-semibold': column.fontWeight === 'semibold'
    });
    var accessor = null;

    if (_lodash["default"].isString(column.accessor)) {
      accessor = _lodash["default"].get(data, column.accessor);
    } else if (_lodash["default"].isFunction(column.accessor)) {
      accessor = column.accessor(data);
    }

    return /*#__PURE__*/_react["default"].createElement("div", {
      className: elementClassName,
      key: "".concat(elementClassName, "-").concat(index),
      style: _objectSpread({
        marginBottom: column.width ? '11px' : null,
        width: column.width
      }, column.style || {})
    }, column.header && /*#__PURE__*/_react["default"].createElement(_header["default"], {
      color: "static",
      size: "xsmall",
      style: {
        margin: 0
      }
    }, column.header), /*#__PURE__*/_react["default"].createElement("span", {
      className: accessorClasses
    }, accessor));
  });
}

DataCardColumn.propTypes = propTypes;
var _default = DataCardColumn;
exports["default"] = _default;