"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _constants = require("../../global/constants");

var _dataCard = _interopRequireDefault(require("./dataCard"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var propTypes = {
  cardProps: _propTypes["default"].func,
  className: _propTypes["default"].string,
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({})).isRequired,
  data: _propTypes["default"].arrayOf(_propTypes["default"].shape({})).isRequired,

  /**
   * Used for DOM testing. https://testing-library.com/docs/queries/bytestid/
   */
  dataTestId: _propTypes["default"].string,
  moduleType: _propTypes["default"].oneOf(['drawer', 'page']).isRequired,
  style: _propTypes["default"].shape({})
};
var defaultProps = {
  cardProps: undefined,
  className: undefined,
  dataTestId: "".concat(_constants.UI_CLASS_NAME, "-data_cards"),
  style: {}
};

function DataCards(props) {
  var cardProps = props.cardProps,
      className = props.className,
      columns = props.columns,
      data = props.data,
      dataTestId = props.dataTestId,
      moduleType = props.moduleType,
      style = props.style;
  var containerClasses = (0, _classnames["default"])('ui', "".concat(moduleType, "--data_cards"), className);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: containerClasses,
    "data-testid": dataTestId,
    style: style
  }, _lodash["default"].map(data, function (d, index) {
    var id = d.id ? _lodash["default"].kebabCase(d.id) : index;
    return /*#__PURE__*/_react["default"].createElement(_dataCard["default"], {
      cardProps: cardProps,
      columns: columns,
      data: d,
      key: "".concat(moduleType, "CardItem-").concat(id),
      moduleType: moduleType
    });
  }));
}

DataCards.propTypes = propTypes;
DataCards.defaultProps = defaultProps;
var _default = DataCards;
exports["default"] = _default;