"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _constants = require("../../global/constants");

var _dataGridConstants = require("./dataGridConstants");

var _dataGridTable = _interopRequireDefault(require("./dataGridTable"));

var _makeStyles = _interopRequireDefault(require("../../styles/makeStyles"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = {
  bleed: _propTypes["default"].bool,
  classes: _propTypes["default"].shape({
    bleed: _propTypes["default"].string,
    root: _propTypes["default"].string
  }),
  className: _propTypes["default"].string,
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({})).isRequired,
  data: _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].arrayOf(_propTypes["default"].shape({})), _propTypes["default"].shape({})])).isRequired,

  /**
   * Used for DOM testing. https://testing-library.com/docs/queries/bytestid/
   */
  dataTestId: _propTypes["default"].string,
  fontSize: _propTypes["default"].string,
  id: _propTypes["default"].string.isRequired,
  minWidth: _propTypes["default"].number,
  moduleType: _propTypes["default"].oneOf(['drawer', 'page']),
  resizableColumnWidthPercentage: _propTypes["default"].number,
  rowProps: _propTypes["default"].func,
  size: _propTypes["default"].oneOf(['small', 'medium']),
  sortable: _propTypes["default"].arrayOf(_dataGridConstants.SORTABLE_PROP_TYPES),
  small: _propTypes["default"].bool,
  stickyColumnWidth: _propTypes["default"].number,
  stickyColumns: _propTypes["default"].number,
  stretch: _propTypes["default"].oneOfType([_propTypes["default"].oneOf(['very']), _propTypes["default"].bool]),
  style: _propTypes["default"].shape({})
};
var defaultProps = {
  bleed: true,
  classes: null,
  className: undefined,
  dataTestId: "".concat(_constants.UI_CLASS_NAME, "-").concat(_constants.BEM_DATA_GRID),
  fontSize: undefined,
  minWidth: 800,
  moduleType: null,
  resizableColumnWidthPercentage: undefined,
  rowProps: function rowProps() {
    return {
      className: null,
      id: null,
      onClick: null,
      selected: null,
      style: null
    };
  },
  size: 'small',
  small: false,
  sortable: null,
  stickyColumns: 0,
  stickyColumnWidth: 30,
  stretch: false,
  style: {}
};
var useStyles = (0, _makeStyles["default"])(function (theme) {
  return {
    bleed: _defineProperty({
      margin: [[0, -theme.gutters.page.sm]]
    }, theme.breakpoints.up(496), {
      margin: [[0, -theme.gutters.page[496]]]
    }),
    drawer: {},
    root: _defineProperty({
      '&$drawer': {
        marginTop: -33,
        '&$bleed': _defineProperty({
          margin: [[0, -22]]
        }, theme.breakpoints.up(496), {
          margin: [[0, -22]]
        }),
        '& .table-header-cell': {
          paddingTop: [[11, '!important']]
        }
      },
      '& .ui.table .table-cell:last-child': {
        paddingRight: [[11, '!important']]
      },
      '& .ui.table .table-header-cell:last-child': {
        paddingRight: [[11, '!important']],
        position: 'relative'
      }
    }, "& .".concat(_constants.BEM_DATA_GRID, "--table_body-drop_shadow"), {
      boxShadow: [[0, 4, 5, 0, 'rgba(0, 0, 0, .5)']]
    }),
    stickyColumns: {
      position: 'relative'
    }
  };
});

function DataGrid(props) {
  var _ClassNames;

  var bleed = props.bleed,
      className = props.className,
      columns = props.columns,
      data = props.data,
      dataTestId = props.dataTestId,
      fontSize = props.fontSize,
      id = props.id,
      minWidthProp = props.minWidth,
      moduleType = props.moduleType,
      rowProps = props.rowProps,
      sizeProp = props.size,
      smallProp = props.small,
      sortable = props.sortable,
      stickyColumns = props.stickyColumns,
      stickyColumnWidth = props.stickyColumnWidth,
      resizableColumnWidthPercentage = props.resizableColumnWidthPercentage,
      stretch = props.stretch,
      style = props.style;
  var minWidth;
  (0, _react.useEffect)(function () {
    // eslint-disable-next-line react-hooks/exhaustive-deps
    minWidth = minWidthProp;
  }, []);
  var classes = useStyles(props);
  var classNameModuleModifier;

  if (moduleType) {
    classNameModuleModifier = "".concat(_constants.BEM_DATA_GRID, "-").concat(moduleType);
  }

  var size = smallProp ? 'small' : sizeProp;
  var isStickyColumns = stickyColumns > 0;
  var rootClasses = (0, _classnames["default"])('ui', _constants.BEM_DATA_GRID, classes.root, classNameModuleModifier, className, (_ClassNames = {}, _defineProperty(_ClassNames, classes.drawer, moduleType === 'drawer'), _defineProperty(_ClassNames, classes.bleed, bleed), _defineProperty(_ClassNames, classes.stickyColumns, isStickyColumns), _ClassNames));
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: rootClasses,
    "data-testid": dataTestId,
    style: style
  }, /*#__PURE__*/_react["default"].createElement(_dataGridTable["default"], {
    bleed: bleed,
    className: className,
    columns: columns,
    data: data,
    fontSize: fontSize,
    id: id,
    minWidth: minWidth,
    moduleType: moduleType,
    rowProps: rowProps,
    size: size,
    sortable: sortable,
    stickyColumnWidth: stickyColumnWidth,
    stickyColumns: stickyColumns,
    resizableColumnWidthPercentage: resizableColumnWidthPercentage,
    stretch: stretch
  }));
}

DataGrid.propTypes = propTypes;
DataGrid.defaultProps = defaultProps;
var _default = DataGrid;
exports["default"] = _default;