"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = require("lodash");

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _constants = require("../../global/constants");

var _dataGridConstants = require("./dataGridConstants");

var _dataGridTableRow = _interopRequireDefault(require("./dataGridTableRow"));

var _table = _interopRequireDefault(require("../table"));

var _dataGridTableReactSortable = _interopRequireDefault(require("./dataGridTableReactSortable"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  bleed: _propTypes["default"].bool,
  className: _propTypes["default"].string,
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    className: _propTypes["default"].string,
    id: _propTypes["default"].string,
    style: _propTypes["default"].shape({})
  })).isRequired,
  data: _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].arrayOf(_propTypes["default"].shape({})), _propTypes["default"].shape({})])).isRequired,
  dropShadow: _propTypes["default"].bool,
  fontSize: _propTypes["default"].string,
  id: _propTypes["default"].string.isRequired,
  idPrefix: _propTypes["default"].string,
  resizableColumnWidthPercentage: _propTypes["default"].number,
  rowProps: _propTypes["default"].func,
  size: _propTypes["default"].oneOf(['small', 'medium']),
  sortable: _propTypes["default"].arrayOf(_dataGridConstants.SORTABLE_PROP_TYPES),
  stickyColumns: _propTypes["default"].number,
  stretch: _propTypes["default"].oneOfType([_propTypes["default"].oneOf(['very']), _propTypes["default"].bool]),
  style: _propTypes["default"].shape({})
};
var defaultProps = {
  bleed: true,
  className: undefined,
  dropShadow: false,
  fontSize: 'xsmall',
  idPrefix: 'base',
  resizableColumnWidthPercentage: undefined,
  rowProps: function rowProps() {
    return {
      className: null,
      id: null,
      onClick: null,
      selected: null,
      style: null
    };
  },
  size: 'small',
  sortable: null,
  stickyColumns: undefined,
  stretch: false,
  style: undefined
};

var DataGridTable = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(DataGridTable, _React$PureComponent);

  var _super = _createSuper(DataGridTable);

  function DataGridTable(props) {
    var _this;

    _classCallCheck(this, DataGridTable);

    _this = _super.call(this, props);
    _this.onSortableChange = _this.onSortableChange.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(DataGridTable, [{
    key: "onSortableChange",
    value: function onSortableChange(newData, index) {
      var sortable = this.props.sortable;

      if ((0, _lodash.isFunction)(sortable[index].onChange)) {
        sortable[index].onChange(newData, index);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          bleedProp = _this$props.bleed,
          className = _this$props.className,
          columns = _this$props.columns,
          dataProp = _this$props.data,
          dropShadow = _this$props.dropShadow,
          fontSize = _this$props.fontSize,
          id = _this$props.id,
          idPrefix = _this$props.idPrefix,
          rowProps = _this$props.rowProps,
          resizableColumnWidthPercentage = _this$props.resizableColumnWidthPercentage,
          size = _this$props.size,
          sortable = _this$props.sortable,
          stickyColumns = _this$props.stickyColumns,
          stretch = _this$props.stretch,
          style = _this$props.style;
      var isSelectable = (0, _lodash.isFunction)(rowProps().onClick);
      var rowKeyNum = 1;

      var tableRows = function tableRows(data, handle) {
        return (0, _lodash.flatMap)(data, function (row) {
          rowKeyNum += 1;
          return /*#__PURE__*/_react["default"].createElement(_dataGridTableRow["default"], {
            columns: columns,
            handle: handle,
            id: id,
            idPrefix: idPrefix,
            isClickable: isSelectable,
            key: "tableBodyRow-".concat(row.id || rowKeyNum),
            row: row,
            rowIndex: rowKeyNum,
            rowProps: rowProps(row)
          });
        });
      };

      var tableBody;
      var bodyClasses = (0, _classnames["default"])(_defineProperty({}, "".concat(_constants.BEM_DATA_GRID, "--table_body-drop_shadow"), dropShadow));

      if ((0, _lodash.isArray)(sortable) && sortable.length === 1 && !(0, _lodash.isArray)(dataProp[0])) {
        tableBody = /*#__PURE__*/_react["default"].createElement(_dataGridTableReactSortable["default"], {
          arrayIndex: 0,
          className: bodyClasses,
          list: dataProp,
          sortable: _objectSpread(_objectSpread({}, sortable), {}, {
            filter: "".concat(_constants.BEM_DATA_GRID, "--table-filter")
          })
        }, tableRows(dataProp, !(0, _lodash.isNil)(sortable[0].handle) ? sortable[0].handle : true));
      } else if ((0, _lodash.isArray)(sortable) && (0, _lodash.isArray)(dataProp[0])) {
        var tBodyKeyNum = 1;
        tableBody = (0, _lodash.map)(dataProp, function (arrayOfData, arrayIndex) {
          var hasHandle = !(0, _lodash.isNil)(sortable[arrayIndex].handle) ? sortable[arrayIndex].handle : true;
          tBodyKeyNum += 1;
          return /*#__PURE__*/_react["default"].createElement(_dataGridTableReactSortable["default"], {
            arrayIndex: arrayIndex,
            className: bodyClasses,
            key: "tbody--".concat(tBodyKeyNum),
            list: arrayOfData,
            sortable: _objectSpread(_objectSpread({}, sortable), {}, {
              filter: "".concat(_constants.BEM_DATA_GRID, "--table-filter")
            })
          }, tableRows(arrayOfData, hasHandle));
        });
      } else {
        tableBody = /*#__PURE__*/_react["default"].createElement(_table["default"].Body, {
          className: bodyClasses
        }, tableRows(dataProp));
      }

      var rootClasses = (0, _classnames["default"])('ui', "".concat(_constants.BEM_DATA_GRID, "--table"), className);
      var bleed = bleedProp ? 'very' : stretch;
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: rootClasses,
        style: style
      }, /*#__PURE__*/_react["default"].createElement(_table["default"], {
        basic: true,
        className: "".concat(_constants.BEM_DATA_GRID, "--table_component"),
        fontSize: fontSize,
        selectable: isSelectable,
        size: size,
        stretch: bleed,
        stickyColumnCount: stickyColumns,
        resizableColumnWidthPercentage: resizableColumnWidthPercentage
      }, /*#__PURE__*/_react["default"].createElement(_table["default"].Header, null, /*#__PURE__*/_react["default"].createElement(_table["default"].Row, null, (0, _lodash.map)(columns, function (column, index) {
        var headerCellClasses = (0, _classnames["default"])("".concat(_constants.BEM_DATA_GRID, "--table_header_cell"), column.className);
        var cellId = column.id || "".concat(_constants.BEM_DATA_GRID, "--table_").concat(id, "_header_").concat(idPrefix, "-").concat(index);
        return /*#__PURE__*/_react["default"].createElement(_table["default"].HeaderCell, {
          className: headerCellClasses,
          id: cellId,
          key: "tableBodyRow-".concat(index),
          style: column.style
        }, column.header);
      }))), tableBody));
    }
  }]);

  return DataGridTable;
}(_react["default"].PureComponent);

DataGridTable.propTypes = propTypes;
DataGridTable.defaultProps = defaultProps;
var _default = DataGridTable;
exports["default"] = _default;