"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = require("lodash");

var _reactSortablejs = require("react-sortablejs");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _dataGridConstants = require("./dataGridConstants");

var _table = _interopRequireDefault(require("../table"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var propTypes = {
  arrayIndex: _propTypes["default"].number.isRequired,
  children: _propTypes["default"].node.isRequired,
  className: _propTypes["default"].string.isRequired,
  list: _propTypes["default"].arrayOf(_propTypes["default"].shape({})),
  sortable: _dataGridConstants.SORTABLE_PROP_TYPES
};
var defaultProps = {
  list: null,
  sortable: null
};

function DataGridTableReactSortable(props) {
  var arrayIndex = props.arrayIndex,
      children = props.children,
      className = props.className,
      list = props.list,
      sortable = props.sortable;

  var onSortableChange = function onSortableChange(newData) {
    if (sortable && sortable[arrayIndex] && (0, _lodash.isFunction)(sortable[arrayIndex].onChange)) {
      sortable[arrayIndex].onChange(newData, arrayIndex);
    }
  };

  var isDisabled = sortable && sortable[arrayIndex] && !!sortable[arrayIndex].disabled;
  var isSortable = sortable && sortable[arrayIndex] && !(0, _lodash.isNil)(sortable[arrayIndex].sort) ? sortable[arrayIndex].sort : true;
  return /*#__PURE__*/_react["default"].createElement(_reactSortablejs.ReactSortable, {
    className: className,
    disabled: isDisabled,
    filter: sortable[arrayIndex].filter,
    list: list,
    setList: onSortableChange,
    sort: isSortable,
    tag: _table["default"].Body
  }, children);
}

DataGridTableReactSortable.propTypes = propTypes;
DataGridTableReactSortable.defaultProps = defaultProps;
var _default = DataGridTableReactSortable;
exports["default"] = _default;