"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = require("lodash");

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _constants = require("../../global/constants");

var _grid = _interopRequireDefault(require("../../layout/grid"));

var _icon = _interopRequireDefault(require("../icon"));

var _table = _interopRequireDefault(require("../table"));

var _withStyles = _interopRequireDefault(require("../../styles/withStyles"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  classes: _propTypes["default"].shape({
    handleGrid: _propTypes["default"].string,
    handleGridColumn: _propTypes["default"].string,
    dataValueGridColumn: _propTypes["default"].string
  }),
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    className: _propTypes["default"].string,
    id: _propTypes["default"].string,
    style: _propTypes["default"].shape({})
  })).isRequired,
  handle: _propTypes["default"].bool,
  id: _propTypes["default"].string.isRequired,
  idPrefix: _propTypes["default"].string.isRequired,
  isClickable: _propTypes["default"].bool,
  row: _propTypes["default"].shape({}).isRequired,
  rowIndex: _propTypes["default"].number.isRequired,
  rowProps: _propTypes["default"].shape({
    className: _propTypes["default"].string,
    id: _propTypes["default"].string,
    onClick: _propTypes["default"].func,
    selected: _propTypes["default"].bool,
    style: _propTypes["default"].shape({})
  })
};
var defaultProps = {
  classes: null,
  handle: false,
  isClickable: undefined,
  rowProps: undefined
};
var styles = {
  dataValueGridColumn: {
    flexBasis: '100%',
    flexGrow: 1,
    maxWidth: '100%'
  },
  handleGrid: {
    alignItems: 'center !important',
    flexWrap: 'nowrap !important'
  },
  handleGridColumn: {
    height: 16
  }
};

var DataGridTableRow = /*#__PURE__*/function (_React$Component) {
  _inherits(DataGridTableRow, _React$Component);

  var _super = _createSuper(DataGridTableRow);

  function DataGridTableRow() {
    var _this;

    _classCallCheck(this, DataGridTableRow);

    _this = _super.call(this);
    _this.onClick = _this.onClick.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(DataGridTableRow, [{
    key: "onClick",
    value: function onClick() {
      var _this$props = this.props,
          isClickable = _this$props.isClickable,
          row = _this$props.row,
          onClick = _this$props.rowProps.onClick;
      var isTextSelected = !(0, _lodash.isEmpty)(window.getSelection().toString());

      if (isClickable && !isTextSelected && !(0, _lodash.isUndefined)(onClick)) {
        onClick(row);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          classes = _this$props2.classes,
          columns = _this$props2.columns,
          handle = _this$props2.handle,
          tableId = _this$props2.id,
          idPrefix = _this$props2.idPrefix,
          isClickable = _this$props2.isClickable,
          row = _this$props2.row,
          rowIndex = _this$props2.rowIndex,
          rowProps = _this$props2.rowProps;
      var rowClassName = rowProps.className,
          rowId = rowProps.id,
          rowSelected = rowProps.selected,
          rowStyle = rowProps.style;
      var containerClasses = (0, _classnames["default"])("".concat(_constants.BEM_DATA_GRID, "--row"), rowClassName, _defineProperty({}, "".concat(_constants.BEM_DATA_GRID, "--row-selected"), rowSelected));
      return /*#__PURE__*/_react["default"].createElement(_table["default"].Row, {
        className: containerClasses,
        id: rowId,
        onClick: isClickable ? this.onClick : null,
        style: rowStyle
      }, (0, _lodash.map)(columns, function (cell, index) {
        var accessorDataValue = null;

        if ((0, _lodash.isString)(cell.accessor)) {
          accessorDataValue = (0, _lodash.get)(row, cell.accessor);
        } else if ((0, _lodash.isFunction)(cell.accessor)) {
          accessorDataValue = cell.accessor(row);
        }

        var cellId = cell.id || "".concat(_constants.BEM_DATA_GRID, "--table_").concat(tableId, "_cell_").concat(idPrefix, "-").concat(rowIndex, "_").concat(index);
        return /*#__PURE__*/_react["default"].createElement(_table["default"].Cell, {
          className: cell.className,
          id: cellId,
          key: cellId,
          textAlign: cell.textAlign,
          style: _objectSpread({}, cell.style)
        }, handle && index === 0 ? /*#__PURE__*/_react["default"].createElement(_grid["default"], {
          alignItems: "center",
          className: classes.handleGrid
        }, /*#__PURE__*/_react["default"].createElement(_grid["default"].Column, {
          classes: {
            root: classes.handleGridColumn
          }
        }, /*#__PURE__*/_react["default"].createElement(_icon["default"], {
          color: "static",
          size: 14,
          title: "Reorder",
          type: "splitter"
        })), /*#__PURE__*/_react["default"].createElement(_grid["default"].Column, {
          className: classes.dataValueGridColumn
        }, accessorDataValue)) : accessorDataValue);
      }));
    }
  }]);

  return DataGridTableRow;
}(_react["default"].Component);

DataGridTableRow.propTypes = propTypes;
DataGridTableRow.defaultProps = defaultProps;

var _default = (0, _withStyles["default"])(styles)(DataGridTableRow);

exports["default"] = _default;