"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _activityIndicator = _interopRequireDefault(require("../../feedback/activityIndicator"));

var _header = _interopRequireDefault(require("../header"));

var _icon = _interopRequireDefault(require("../icon"));

var _list = _interopRequireDefault(require("../list"));

var _dataGroupExpandedRow = _interopRequireDefault(require("./dataGroupExpandedRow"));

var _dataGroupRow = _interopRequireDefault(require("./dataGroupRow"));

var _dataGroupsPropTypes = require("./dataGroupsPropTypes");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  group: _dataGroupsPropTypes.groupPropTypes.isRequired,
  data: _propTypes["default"].shape({}).isRequired,
  moduleType: _propTypes["default"].string.isRequired,
  style: _propTypes["default"].shape({})
};
var defaultProps = {
  style: {}
};

var DataGroup = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(DataGroup, _React$PureComponent);

  var _super = _createSuper(DataGroup);

  function DataGroup(props) {
    var _this;

    _classCallCheck(this, DataGroup);

    _this = _super.call(this, props);
    _this.state = {
      isExpanded: false
    };
    _this.onToggleExpandClick = _this.onToggleExpandClick.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(DataGroup, [{
    key: "onToggleExpandClick",
    value: function onToggleExpandClick() {
      var isElementHighlighted = window.getSelection().toString();

      if (!isElementHighlighted) {
        this.setState(function (prevState) {
          return {
            isExpanded: !prevState.isExpanded
          };
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _ClassNames;

      var _this$props = this.props,
          _this$props$group = _this$props.group,
          className = _this$props$group.className,
          expandableSections = _this$props$group.expandableSections,
          id = _this$props$group.id,
          isExpandable = _this$props$group.isExpandable,
          header = _this$props$group.header,
          rows = _this$props$group.rows,
          style = _this$props$group.style,
          data = _this$props.data,
          moduleType = _this$props.moduleType;
      var isExpanded = this.state.isExpanded;
      var bemClassName = "".concat(moduleType, "--data_group");
      var rootClasses = (0, _classnames["default"])(bemClassName, className, (_ClassNames = {}, _defineProperty(_ClassNames, "".concat(bemClassName, "-is_expandable"), isExpandable), _defineProperty(_ClassNames, "".concat(bemClassName, "-expanded"), isExpandable && isExpanded), _ClassNames));
      var expandableJSX;

      var rowJSX = /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(bemClassName, "_contract_section")
      }, /*#__PURE__*/_react["default"].createElement(_list["default"], {
        className: "".concat(bemClassName, "_list"),
        divide: true
      }, _lodash["default"].map(rows, function (row, index) {
        return /*#__PURE__*/_react["default"].createElement(_list["default"].Item, {
          key: "".concat(bemClassName, "_list_item-").concat(index)
        }, /*#__PURE__*/_react["default"].createElement(_dataGroupRow["default"], {
          bemClassName: bemClassName,
          data: data,
          row: row
        }));
      })));

      if (isExpandable && !_lodash["default"].isEmpty(expandableSections)) {
        expandableJSX = /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(bemClassName, "_expand_section")
        }, _lodash["default"].map(expandableSections, function (expandRow, expandIndex) {
          return /*#__PURE__*/_react["default"].createElement("div", {
            className: "".concat(bemClassName, "_expand_section_list"),
            key: "".concat(bemClassName, "_expand_section_list-").concat(expandIndex)
          }, expandRow.header && /*#__PURE__*/_react["default"].createElement(_header["default"], {
            className: "".concat(bemClassName, "_header"),
            size: "medium",
            style: {
              marginBottom: '22px',
              lineHeight: '16px'
            },
            weight: "semibold"
          }, expandRow.header), /*#__PURE__*/_react["default"].createElement(_list["default"], {
            className: "".concat(bemClassName, "_list")
          }, _lodash["default"].map(expandRow.rows, function (row, index) {
            return /*#__PURE__*/_react["default"].createElement(_list["default"].Item, {
              key: "".concat(bemClassName, "_list_item-").concat(index)
            }, /*#__PURE__*/_react["default"].createElement(_dataGroupExpandedRow["default"], {
              bemClassName: bemClassName,
              data: data,
              row: row
            }));
          })));
        }));
      }

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: rootClasses,
        id: id,
        onClick: this.onToggleExpandClick,
        role: "presentation",
        style: style
      }, isExpandable && isExpanded && !_lodash["default"].isEmpty(expandableSections) && /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(bemClassName, "_inner_container_loader")
      }, /*#__PURE__*/_react["default"].createElement(_activityIndicator["default"], {
        color: "backgroundColorStatic",
        size: 32
      })), /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(bemClassName, "_inner_container")
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(bemClassName, "_header_section"),
        style: {
          marginBottom: '33px'
        }
      }, header && /*#__PURE__*/_react["default"].createElement(_header["default"], {
        className: "".concat(bemClassName, "_header_title"),
        weight: "bold",
        size: "large",
        style: {
          margin: '0',
          lineHeight: '16px'
        }
      }, header), isExpandable && !_lodash["default"].isEmpty(expandableSections) && /*#__PURE__*/_react["default"].createElement("div", {
        className: "".concat(bemClassName, "_header_icon_section")
      }, /*#__PURE__*/_react["default"].createElement(_icon["default"], {
        className: "".concat(bemClassName, "_header_icon"),
        type: isExpanded ? 'contract' : 'expand'
      }))), rowJSX, isExpandable && !_lodash["default"].isEmpty(expandableSections) && expandableJSX));
    }
  }]);

  return DataGroup;
}(_react["default"].PureComponent);

DataGroup.propTypes = propTypes;
DataGroup.defaultProps = defaultProps;
var _default = DataGroup;
exports["default"] = _default;