"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _dataGroupsPropTypes = require("./dataGroupsPropTypes");

var _header = _interopRequireDefault(require("../header"));

var _icon = _interopRequireDefault(require("../icon"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = {
  bemClassName: _propTypes["default"].string.isRequired,
  data: _propTypes["default"].shape({}).isRequired,
  row: _dataGroupsPropTypes.rowPropTypes.isRequired
};

function DataGroupRow(props) {
  var parentBemClassName = props.bemClassName,
      data = props.data,
      _props$row = props.row,
      accessor = _props$row.accessor,
      className = _props$row.className,
      fieldName = _props$row.fieldName,
      id = _props$row.id,
      header = _props$row.header,
      iconColor = _props$row.iconColor,
      iconSize = _props$row.iconSize,
      iconType = _props$row.iconType,
      style = _props$row.style;
  var bemClassName = "".concat(parentBemClassName, "_row");
  var rootClasses = (0, _classnames["default"])("".concat(bemClassName), className, _defineProperty({}, "".concat(bemClassName, "-header_icon"), iconType || header));
  var accessedData;

  if (_lodash["default"].isString(accessor)) {
    accessedData = _lodash["default"].get(data, accessor);
  } else if (_lodash["default"].isFunction(accessor)) {
    accessedData = accessor(data);
  }

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: rootClasses,
    id: id,
    style: style
  }, header || iconType ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, iconType && /*#__PURE__*/_react["default"].createElement(_icon["default"], {
    color: iconColor || 'primary',
    className: "".concat(bemClassName, "_icon"),
    size: iconSize || 16,
    style: {
      marginRight: '11px'
    },
    type: iconType
  }), /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(bemClassName, "_data")
  }, header && /*#__PURE__*/_react["default"].createElement(_header["default"], {
    className: "".concat(bemClassName, "_header"),
    size: "medium",
    style: {
      margin: 0,
      lineHeight: '16px'
    },
    weight: "semibold"
  }, header), /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(bemClassName, "_field_name_and_value")
  }, "".concat(accessedData, " | ").concat(fieldName)))) : /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(bemClassName, "_value")
  }, accessedData), /*#__PURE__*/_react["default"].createElement(_header["default"], {
    className: "".concat(bemClassName, "_field_name"),
    color: "static",
    size: "xxsmall",
    style: {
      margin: 0
    }
  }, fieldName)));
}

DataGroupRow.propTypes = propTypes;
var _default = DataGroupRow;
exports["default"] = _default;