"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = require("lodash");

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _dataGroupsPropTypes = require("./dataGroupsPropTypes");

var _constants = require("../../global/constants");

var _dataGroupsColumn = _interopRequireDefault(require("./dataGroupsColumn"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  className: _propTypes["default"].string,
  columns: _propTypes["default"].arrayOf(_dataGroupsPropTypes.groupPropTypes).isRequired,
  data: _propTypes["default"].shape({}).isRequired,

  /**
   * Used for DOM testing. https://testing-library.com/docs/queries/bytestid/
   */
  dataTestId: _propTypes["default"].string,
  moduleType: _propTypes["default"].string.isRequired,
  style: _propTypes["default"].shape({})
};
var defaultProps = {
  className: undefined,
  dataTestId: "".concat(_constants.UI_CLASS_NAME, "-data_groups"),
  style: {}
};

var DataGroups = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(DataGroups, _React$PureComponent);

  var _super = _createSuper(DataGroups);

  function DataGroups(props) {
    var _this;

    _classCallCheck(this, DataGroups);

    _this = _super.call(this, props);
    _this.state = {
      columns: []
    };
    _this.resizeWindow = _this.resizeWindow.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(DataGroups, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      window.addEventListener('resize', this.resizeWindow);
      this.resizeWindow();
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var nextColumns = this.props.columns;
      var prevColumns = prevProps.columns;

      if (!(0, _lodash.isEqual)(prevColumns, nextColumns)) {
        this.reorderColumns();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.resizeWindow);
    }
  }, {
    key: "resizeWindow",
    value: function resizeWindow() {
      this.reorderColumns();
    }
  }, {
    key: "reorderColumns",
    value: function reorderColumns() {
      var columns = this.props.columns;
      var blockSize = this.dataGroups.offsetWidth;
      var columnMinWidth = 300;
      var columnsLength = columns.length;
      var numberOfColumns = Math.floor(blockSize / columnMinWidth);
      var newColumns = [];

      if (numberOfColumns === 1 || numberOfColumns < 1) {
        numberOfColumns = 1;
      } else if (numberOfColumns > columnsLength) {
        numberOfColumns = columnsLength;
      }

      var columnNum = 0;

      while (columnNum < numberOfColumns) {
        for (var i = 0; i < columns.length; i += numberOfColumns) {
          var column = columns[i + columnNum];

          if (column !== undefined) {
            newColumns = [].concat(_toConsumableArray(newColumns), [_objectSpread(_objectSpread({}, column), {}, {
              columnIndex: columnNum
            })]);
          }
        }

        columnNum += 1;
      }

      newColumns = (0, _lodash.groupBy)(newColumns, 'columnIndex');
      this.setState({
        columns: newColumns
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          className = _this$props.className,
          data = _this$props.data,
          dataTestId = _this$props.dataTestId,
          moduleType = _this$props.moduleType,
          style = _this$props.style;
      var columns = this.state.columns;
      var bemClassName = "".concat(moduleType, "--data_groups");
      var rootClasses = (0, _classnames["default"])('ui', bemClassName, className);
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: rootClasses,
        "data-testid": dataTestId,
        ref: function ref(_ref) {
          _this2.dataGroups = _ref;
        },
        style: style
      }, !(0, _lodash.isEmpty)(columns) && (0, _lodash.map)(columns, function (column, index) {
        return /*#__PURE__*/_react["default"].createElement(_dataGroupsColumn["default"], {
          column: column,
          data: data,
          key: "".concat(bemClassName, "_group-").concat(index),
          moduleType: moduleType
        });
      }));
    }
  }]);

  return DataGroups;
}(_react["default"].PureComponent);

DataGroups.propTypes = propTypes;
DataGroups.defaultProps = defaultProps;
var _default = DataGroups;
exports["default"] = _default;