"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _dataGroup = _interopRequireDefault(require("./dataGroup"));

var _dataGroupsPropTypes = require("./dataGroupsPropTypes");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var propTypes = {
  column: _propTypes["default"].arrayOf(_dataGroupsPropTypes.groupPropTypes).isRequired,
  data: _propTypes["default"].shape({}).isRequired,
  moduleType: _propTypes["default"].string.isRequired
};

function DataGroupsColumn(props) {
  var column = props.column,
      data = props.data,
      moduleType = props.moduleType;
  var bemClassName = "".concat(moduleType, "--data_groups_column");
  var rootClasses = (0, _classnames["default"])(bemClassName);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: rootClasses
  }, _lodash["default"].map(column, function (group, index) {
    var id = group.id ? _lodash["default"].kebabCase(group.id) : index;
    return /*#__PURE__*/_react["default"].createElement(_dataGroup["default"], {
      group: group,
      data: data,
      key: "".concat(bemClassName, "_group-").concat(id),
      moduleType: moduleType
    });
  }));
}

DataGroupsColumn.propTypes = propTypes;
var _default = DataGroupsColumn;
exports["default"] = _default;