"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.groupPropTypes = exports.rowPropTypes = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var rowPropTypes = _propTypes["default"].shape({
  accessor: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].string]).isRequired,
  className: _propTypes["default"].string,
  fieldName: _propTypes["default"].string.isRequired,
  id: _propTypes["default"].string,
  header: _propTypes["default"].string,
  iconType: _propTypes["default"].string,
  iconColor: _propTypes["default"].string,
  iconSize: _propTypes["default"].oneOfType([_propTypes["default"].oneOf(_utils["default"].sizeEnums()), _propTypes["default"].number]),
  style: _propTypes["default"].shape({})
});

exports.rowPropTypes = rowPropTypes;

var groupPropTypes = _propTypes["default"].shape({
  // eslint-disable-line import/prefer-default-export
  className: _propTypes["default"].string,
  expandableSections: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    header: _propTypes["default"].string,
    iconType: _propTypes["default"].string,
    iconColor: _propTypes["default"].string,
    rows: _propTypes["default"].arrayOf(_propTypes["default"].shape({
      header: _propTypes["default"].string,
      rows: _propTypes["default"].arrayOf(rowPropTypes)
    }))
  })),
  id: _propTypes["default"].string,
  isExpandable: _propTypes["default"].bool,
  header: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].node]),
  rows: _propTypes["default"].arrayOf(rowPropTypes).isRequired,
  style: _propTypes["default"].shape({})
});

exports.groupPropTypes = groupPropTypes;