"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _Divider = _interopRequireDefault(require("@material-ui/core/Divider"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _constants = require("./constants");

var _dividerDeprecated = _interopRequireDefault(require("./dividerDeprecated"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = _objectSpread({
  /**
   * Absolutely position the element.
   */
  absolute: _propTypes["default"].bool,

  /**
   * Override or extend the styles applied to the component.
   * See [CSS API](#css) below for more details.
   */
  classes: _propTypes["default"].shape({}),

  /**
   * The component used for the root node.
   * Either a string to use a HTML element or a component.
   */
  component: _propTypes["default"].elementType,

  /**
   * If `true`, a vertical divider will have the correct height when used in flex container.
   * (By default, a vertical divider will have a calculated height of `0px` if it is the child of
   * a flex container.)
   */
  flexItem: _propTypes["default"].bool,

  /**
   * If `true`, the divider will have a lighter color.
   */
  light: _propTypes["default"].bool,

  /**
   * The divider orientation.
   */
  orientation: _propTypes["default"].oneOf(['horizontal', 'vertical']),

  /**
   * The variant to use.
   */
  variant: _propTypes["default"].oneOf(['fullWidth', 'inset', 'middle']),

  /**
   * Dependent on the designVersion number, the component can either use our old Divider component
   * or the new wrapped MUI Divider component.
   */
  designVersion: _propTypes["default"].number
}, _constants.DIVIDER_DEPRECATED_PROP_TYPES);

var defaultProps = {
  absolute: false,
  classes: null,
  component: 'hr',
  flexItem: false,
  light: false,
  orientation: 'horizontal',
  variant: 'fullWidth',
  designVersion: 1
};

function Divider(props) {
  var children = props.children,
      designVersion = props.designVersion,
      otherProps = _objectWithoutProperties(props, ["children", "designVersion"]);

  if (designVersion === 2) {
    return /*#__PURE__*/_react["default"].createElement(_Divider["default"] // eslint-disable-next-line react/jsx-props-no-spreading
    , otherProps);
  }

  return /*#__PURE__*/_react["default"].createElement(_dividerDeprecated["default"] // eslint-disable-next-line react/jsx-props-no-spreading
  , otherProps, children);
}

Divider.propTypes = propTypes;
Divider.defaultProps = defaultProps;
var _default = Divider;
exports["default"] = _default;