"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _constants = require("../../global/constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var propTypes = {
  className: _propTypes["default"].string,
  email: _propTypes["default"].string,
  id: _propTypes["default"].string,
  tabIndex: _propTypes["default"].number
};
var defaultProps = {
  className: null,
  email: null,
  id: null,
  tabIndex: -1
};

function EmailLink(props) {
  var className = props.className,
      email = props.email,
      id = props.id,
      tabIndex = props.tabIndex;

  if (!email) {
    return null;
  }

  var rootClasses = (0, _classnames["default"])(_constants.EMAIL_LINK_CLASSES, className);
  return /*#__PURE__*/_react["default"].createElement("a", {
    className: rootClasses,
    id: id,
    href: "mailto:".concat(email),
    tabIndex: tabIndex
  }, email);
}

EmailLink.propTypes = propTypes;
EmailLink.defaultProps = defaultProps;
var _default = EmailLink;
exports["default"] = _default;