"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = require("lodash");

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _icon = _interopRequireDefault(require("../icon"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  children: _propTypes["default"].string,
  className: _propTypes["default"].string,
  color: _propTypes["default"].oneOf(_utils["default"].colorEnums()),
  fluid: _propTypes["default"].bool,
  inverse: _propTypes["default"].bool,
  onClearClick: _propTypes["default"].func,
  onClearKeyDown: _propTypes["default"].func,
  onClick: _propTypes["default"].func,
  onKeyDown: _propTypes["default"].func,
  style: _propTypes["default"].shape({}),
  tabIndex: _propTypes["default"].number
};
var defaultProps = {
  children: null,
  className: null,
  color: null,
  fluid: null,
  inverse: false,
  onClearClick: null,
  onClearKeyDown: null,
  onClick: null,
  onKeyDown: null,
  style: null,
  tabIndex: -1
};
/**
 * @deprecated Label has been deprecated.
 * Use the Chip component instead.
 */

var Label = /*#__PURE__*/function (_React$Component) {
  _inherits(Label, _React$Component);

  var _super = _createSuper(Label);

  function Label() {
    var _this;

    _classCallCheck(this, Label);

    _this = _super.call(this);
    _this.onClearClick = _this.onClearClick.bind(_assertThisInitialized(_this));
    _this.onClearKeyDown = _this.onClearKeyDown.bind(_assertThisInitialized(_this));
    _this.onClick = _this.onClick.bind(_assertThisInitialized(_this));
    _this.onKeyDown = _this.onKeyDown.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(Label, [{
    key: "onClearClick",
    value: function onClearClick() {
      var onClearClick = this.props.onClearClick;

      if ((0, _lodash.isFunction)(onClearClick)) {
        onClearClick();
      }
    }
  }, {
    key: "onClearKeyDown",
    value: function onClearKeyDown() {
      var onClearKeyDown = this.props.onClearKeyDown;

      if ((0, _lodash.isFunction)(onClearKeyDown)) {
        onClearKeyDown();
      }
    }
  }, {
    key: "onClick",
    value: function onClick() {
      var onClick = this.props.onClick;

      if ((0, _lodash.isFunction)(onClick)) {
        onClick();
      }
    }
  }, {
    key: "onKeyDown",
    value: function onKeyDown() {
      var onKeyDown = this.props.onKeyDown;

      if ((0, _lodash.isFunction)(onKeyDown)) {
        onKeyDown();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          color = _this$props.color,
          fluid = _this$props.fluid,
          inverse = _this$props.inverse,
          onClick = _this$props.onClick,
          onClearClick = _this$props.onClearClick,
          style = _this$props.style,
          tabIndex = _this$props.tabIndex;
      var containerClasses = (0, _classnames["default"])('ui', 'label', className, {
        'label-clickable': onClick,
        'label-color-alert': color === 'alert',
        'label-color-highlight': color === 'highlight',
        'label-color-primary': color === 'primary',
        'label-color-success': color === 'success',
        'label-color-transparent': color === 'transparent',
        'label-color-warning': color === 'warning',
        'label-fluid': fluid,
        'label-inverse': inverse,
        'label-clearable': onClearClick
      });
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: containerClasses,
        onClick: this.onClick,
        onKeyDown: this.onKeyDown,
        role: "button",
        style: style,
        tabIndex: tabIndex
      }, /*#__PURE__*/_react["default"].createElement("span", {
        className: "label-inner-container"
      }, children, onClearClick && /*#__PURE__*/_react["default"].createElement("span", {
        className: "label-clearable-button",
        onClick: this.onClearClick,
        onKeyDown: this.onClearKeyDown,
        role: "button",
        tabIndex: -1
      }, /*#__PURE__*/_react["default"].createElement(_icon["default"], {
        compact: true,
        inverse: true,
        size: "xxsmall",
        type: "times"
      }))));
    }
  }]);

  return Label;
}(_react["default"].Component);

Label.propTypes = propTypes;
Label.defaultProps = defaultProps;
var _default = Label;
exports["default"] = _default;