"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = require("lodash");

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _constants = require("../../global/constants");

var _personPanelConstants = require("./personPanelConstants");

var _makeStyles = _interopRequireDefault(require("../../styles/makeStyles"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var propTypes = {
  /**
   * The content of the PersonPanel
   */
  children: _propTypes["default"].node,

  /**
   * Override or extend the styles applied to PersonPanel.
   */
  classes: _propTypes["default"].shape({
    root: _propTypes["default"].string
  }),

  /**
   * Assign additional class names to PersonPanel.
   */
  className: _propTypes["default"].string,

  /**
   * The `id` of the PersonPanel.
   */
  id: _propTypes["default"].string,

  /**
   * If `true`, the PersonPanelSummary is shown active and PersonPanelDetails is expanded.
   */
  isExpanded: _propTypes["default"].bool,

  /**
   * Event handler for consummer to control state outside of PersonPanel.
  */
  onChange: _propTypes["default"].func
};
var defaultProps = {
  children: null,
  classes: null,
  className: null,
  id: null,
  isExpanded: false,
  onChange: null
};
var useStyles = (0, _makeStyles["default"])({
  root: {
    display: 'flex',
    flexWrap: 'wrap',
    margin: '5px 0'
  }
});
/**
 * The PersonPanel displays a person's high level data in a grouped format.
 */

function PersonPanel(props) {
  var children = props.children,
      className = props.className,
      id = props.id,
      isExpandedProp = props.isExpanded,
      onChange = props.onChange;
  var classes = useStyles(props);

  var _useState = (0, _react.useState)(isExpandedProp),
      _useState2 = _slicedToArray(_useState, 2),
      isExpanded = _useState2[0],
      setIsExpandedState = _useState2[1];

  (0, _react.useEffect)(function () {
    setIsExpandedState(isExpandedProp);
  }, [isExpandedProp]);
  var onSummaryClick = (0, _react.useCallback)(function (event) {
    if ((0, _lodash.isFunction)(onChange)) {
      onChange(event, !isExpanded);
    } else {
      setIsExpandedState(!isExpanded);
    }
  }, [isExpanded, onChange, setIsExpandedState]);

  var clonedChildren = _react.Children.map(children, function (child) {
    var isChildFunction = /*#__PURE__*/_react["default"].isValidElement(child) && (0, _lodash.isFunction)(child.type);
    var isDetails = isChildFunction && child.type.name === 'PersonPanelDetails';
    var isSummary = isChildFunction && child.type.name === 'PersonPanelSummary';

    if (isDetails) {
      return /*#__PURE__*/_react["default"].cloneElement(child, _objectSpread(_objectSpread({}, child.props), {}, {
        isExpanded: isExpanded
      }));
    }

    if (isSummary) {
      return /*#__PURE__*/_react["default"].cloneElement(child, _objectSpread(_objectSpread({}, child.props), {}, {
        isExpanded: isExpanded,
        onClick: onSummaryClick
      }));
    }

    return child;
  });

  var rootClasses = (0, _classnames["default"])(classes.root, _constants.UI_CLASS_NAME, _personPanelConstants.BEM_BLOCK_NAME, className);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: rootClasses,
    id: id
  }, clonedChildren);
}

PersonPanel.propTypes = propTypes;
PersonPanel.defaultProps = defaultProps;
var _default = PersonPanel;
exports["default"] = _default;