"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RECORD_TYPE_PROP_TYPE = exports.RECORD_TYPE_DEFAULT_PROP = exports.RECORD_TYPE_COLOR = exports.GENDER_DEFAULT_TYPE = exports.GENDER_PROP_TYPE = exports.BEM_DETAILS_NAME = exports.BEM_BLOCK_NAME = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var BEM_BLOCK_NAME = 'person_panel';
exports.BEM_BLOCK_NAME = BEM_BLOCK_NAME;
var BEM_DETAILS_NAME = "".concat(BEM_BLOCK_NAME, "--details");
exports.BEM_DETAILS_NAME = BEM_DETAILS_NAME;

var GENDER_PROP_TYPE = _propTypes["default"].oneOf(['f', 'F', 'm', 'M', '', null]);

exports.GENDER_PROP_TYPE = GENDER_PROP_TYPE;
var GENDER_DEFAULT_TYPE = null;
exports.GENDER_DEFAULT_TYPE = GENDER_DEFAULT_TYPE;

var RECORD_TYPE_COLOR = function RECORD_TYPE_COLOR(_ref) {
  var gender = _ref.gender,
      isGradient = _ref.isGradient,
      recordType = _ref.recordType,
      theme = _ref.theme;
  var palette = theme.palette;

  switch (recordType) {
    case 'child':
      if (isGradient) {
        return palette.sky.G500;
      }

      return palette.sky[500];

    case 'student':
      if (isGradient) {
        return palette.redOrange.G500;
      }

      return palette.redOrange[500];

    case 'adult':
    default:
      switch (gender) {
        case 'f':
          if (isGradient) {
            return palette.cyan.G600;
          }

          return palette.cyan[600];

        case 'm':
          if (isGradient) {
            return palette.green.G600;
          }

          return palette.green[600];

        default:
          if (isGradient) {
            return palette.teal.G500;
          }

          return palette.teal[500];
      }

  }
};

exports.RECORD_TYPE_COLOR = RECORD_TYPE_COLOR;
var RECORD_TYPE_DEFAULT_PROP = 'adult';
exports.RECORD_TYPE_DEFAULT_PROP = RECORD_TYPE_DEFAULT_PROP;

var RECORD_TYPE_PROP_TYPE = _propTypes["default"].oneOf(['adult', 'child', 'student']);

exports.RECORD_TYPE_PROP_TYPE = RECORD_TYPE_PROP_TYPE;