"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = require("lodash");

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _button = _interopRequireDefault(require("../../inputs/button"));

var _prompt = _interopRequireDefault(require("../../inputs/prompt"));

var _makeStyles = _interopRequireDefault(require("../../styles/makeStyles"));

var _constants = require("../../global/constants");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var propTypes = {
  className: _propTypes["default"].string,
  disable: _propTypes["default"].bool,
  id: _propTypes["default"].string,
  label: _propTypes["default"].string,
  onClick: _propTypes["default"].func,
  onKeyDown: _propTypes["default"].func,
  onPromptCancelClick: _propTypes["default"].func,
  onPromptConfirmClick: _propTypes["default"].func,
  outlined: _propTypes["default"].bool,
  prompt: _propTypes["default"].bool,
  promptId: _propTypes["default"].string,
  title: _propTypes["default"].string
};
var defaultProps = {
  className: null,
  disable: false,
  id: null,
  onClick: null,
  onKeyDown: null,
  onPromptCancelClick: null,
  onPromptConfirmClick: null,
  outlined: false,
  prompt: false,
  promptId: null
};
var useStyles = (0, _makeStyles["default"])({
  button: {},
  prompt: {
    marginRight: 11
  }
});

function PersonPanelDetailsActionButton(props) {
  var className = props.className,
      disable = props.disable,
      id = props.id,
      label = props.label,
      onClickProp = props.onClick,
      onKeyDownProp = props.onKeyDown,
      onNoClickProp = props.onNoClick,
      onYesClickProp = props.onYesClick,
      outlined = props.outlined,
      prompt = props.prompt,
      promptId = props.promptId,
      title = props.title;

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      showPrompt = _useState2[0],
      setShowPrompt = _useState2[1];

  var classes = useStyles(props);

  var onClick = function onClick(event) {
    if ((0, _lodash.isFunction)(onClickProp)) {
      onClickProp(event);
    }
  };

  var onKeyDownClick = function onKeyDownClick(event) {
    if ((0, _lodash.isFunction)(onKeyDownProp)) {
      onKeyDownProp(event);
    }
  };

  var onNoClick = function onNoClick(event) {
    setShowPrompt(false);

    if ((0, _lodash.isFunction)(onNoClickProp)) {
      onNoClickProp(event);
    }
  };

  var onPromptClick = function onPromptClick() {
    setShowPrompt(true);
  };

  var onYesClick = function onYesClick(event) {
    setShowPrompt(false);

    if ((0, _lodash.isFunction)(onYesClickProp)) {
      onYesClickProp(event);
    }
  };

  var buttonJSX = /*#__PURE__*/_react["default"].createElement(_button["default"], {
    className: (0, _classnames["default"])(_constants.BEM_PERSON_PANEL_DETAILS_ACTION_BUTTON, classes.button, className),
    color: "primary",
    designVersion: 2,
    disabled: disable,
    id: id,
    onClick: onClick,
    onKeyDown: onKeyDownClick,
    title: title,
    variant: outlined ? 'outlined' : 'contained'
  }, label);

  if (prompt && !disable) {
    return /*#__PURE__*/_react["default"].createElement(_prompt["default"], {
      className: (0, _classnames["default"])(classes.prompt, className),
      id: promptId,
      inline: true,
      inlineMessageColor: "success",
      onClick: onPromptClick,
      onNoClick: onNoClick,
      onYesClick: onYesClick,
      show: showPrompt
    }, buttonJSX);
  }

  return buttonJSX;
}

PersonPanelDetailsActionButton.propTypes = propTypes;
PersonPanelDetailsActionButton.defaultProps = defaultProps;
var _default = PersonPanelDetailsActionButton;
exports["default"] = _default;