"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = require("lodash");

var _classnames = _interopRequireDefault(require("classnames"));

var _ClickAwayListener = _interopRequireDefault(require("@material-ui/core/ClickAwayListener"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Popper = _interopRequireDefault(require("@material-ui/core/Popper"));

var _react = _interopRequireWildcard(require("react"));

var _constants = require("../../global/constants");

var _grow = _interopRequireDefault(require("../../utils/grow"));

var _makeStyles = _interopRequireDefault(require("../../styles/makeStyles"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var propTypes = {
  /**
   * Override or extend the styles applied to Popover.
   */
  classes: _propTypes["default"].shape({
    arrow: _propTypes["default"].string,
    content: _propTypes["default"].string,
    popoverRoot: _propTypes["default"].string,
    popper: _propTypes["default"].string
  }),

  /**
   * Additional classes.
   */
  className: _propTypes["default"].string,

  /**
   * The anchor element.
   */
  children: _propTypes["default"].node.isRequired,

  /**
   * The content in the Popover.
   */
  content: _propTypes["default"].node,

  /**
   * If `true`, Popover will not be fired.
   */
  disable: _propTypes["default"].bool,

  /**
   * The `id` of the Popover.
   */
  id: _propTypes["default"].string,

  /**
   * The max-width of the Popover
   */
  maxWidth: _propTypes["default"].number,

  /**
   * Popper.js is based on a "plugin-like" architecture;
   * most of its features are fully encapsulated "modifiers".
   *
   * A modifier is a function that is called each time Popper.js needs to
   * compute the position of the popper.
   * For this reason, modifiers should be very performant to avoid bottlenecks.
   * To learn how to create a modifier, [read the modifiers documentation](https://popper.js.org/docs/v1/#modifiers).
   */
  modifiers: _propTypes["default"].shape({}),

  /**
   * The mouse event to listen to.
   */
  mouseEvent: _propTypes["default"].oneOf(['onClick', 'onMouseEnter']),

  /**
   * Event handler for when cursor clicks off of target.
   */
  onClickAway: _propTypes["default"].func,

  /**
   * If `true`, the Popover is visible.
   */
  open: _propTypes["default"].bool,

  /**
   * Popper placement.
   */
  placement: _propTypes["default"].oneOf(['bottom-end', 'bottom-start', 'bottom', 'left-end', 'left-start', 'left', 'right-end', 'right-start', 'right', 'top-end', 'top-start', 'top']),

  /**
   * The width of the Popover
   */
  width: _propTypes["default"].number
};
var defaultProps = {
  classes: undefined,
  className: undefined,
  content: undefined,
  id: undefined,
  disable: false,
  maxWidth: undefined,
  modifiers: undefined,
  mouseEvent: 'onClick',
  onClickAway: undefined,
  open: undefined,
  placement: 'bottom',
  width: 250
};
var useStyles = (0, _makeStyles["default"])(function (_ref) {
  var palette = _ref.palette,
      shadows = _ref.shadows,
      shape = _ref.shape,
      spacing = _ref.spacing,
      typography = _ref.typography,
      zIndex = _ref.zIndex;
  return {
    arrow: {
      boxSizing: 'border-box',
      color: (0, _lodash.get)(palette, 'background.primary'),
      height: '0.71em',
      overflow: 'hidden',
      position: 'absolute',
      width: '1em',
      '&::before': {
        backgroundColor: 'currentColor',
        boxShadow: shadows[1],
        content: '""',
        display: 'block',
        height: '100%',
        margin: 'auto',
        transform: 'rotate(45deg)',
        width: '100%'
      }
    },
    popoverRoot: {
      backgroundColor: (0, _lodash.get)(palette, 'background.primary'),
      borderRadius: shape.borderRadiusSecondary,
      boxShadow: '0 7px 22px 0 rgba(0, 0, 0, 0.34)',
      color: (0, _lodash.get)(palette, 'text.primary'),
      fontFamily: (0, _lodash.get)(typography, 'fontFamily'),
      fontSize: (0, _lodash.get)(typography, 'fontSize'),
      fontWeight: (0, _lodash.get)(typography, 'fontWeightRegular'),
      maxWidth: function maxWidth(_ref2) {
        var _maxWidth = _ref2.maxWidth;
        return _maxWidth || 'none';
      },
      overflow: 'visible',
      padding: spacing(2),
      position: 'relative',
      width: function width(_ref3) {
        var _width = _ref3.width;
        return _width;
      }
    },
    popper: {
      zIndex: zIndex.popover,
      '&[x-placement*="bottom"] $arrow': {
        top: 0,
        left: 0,
        marginTop: '-0.71em',
        marginLeft: 4,
        marginRight: 4,
        '&::before': {
          transformOrigin: '0 100%'
        }
      },
      '&[x-placement*="top"] $arrow': {
        bottom: 0,
        left: 0,
        marginBottom: '-0.71em',
        marginLeft: 4,
        marginRight: 4,
        '&::before': {
          transformOrigin: '100% 0'
        }
      },
      '&[x-placement*="right"] $arrow': {
        left: 0,
        marginLeft: '-0.71em',
        height: '1em',
        width: '0.71em',
        marginTop: 4,
        marginBottom: 4,
        '&::before': {
          transformOrigin: '100% 100%'
        }
      },
      '&[x-placement*="left"] $arrow': {
        right: 0,
        marginRight: '-0.71em',
        height: '1em',
        width: '0.71em',
        marginTop: 4,
        marginBottom: 4,
        '&::before': {
          transformOrigin: '0 0'
        }
      }
    },
    content: {}
  };
});
/**
 * The Popover is used to display some content on top of another.
 */

function Popover(props) {
  var children = props.children,
      className = props.className,
      content = props.content,
      disable = props.disable,
      id = props.id,
      modifiers = props.modifiers,
      mouseEvent = props.mouseEvent,
      onClickAwayProp = props.onClickAway,
      openProp = props.open,
      placement = props.placement;
  var classes = useStyles(props);

  var _useState = (0, _react.useState)(null),
      _useState2 = _slicedToArray(_useState, 2),
      arrowRef = _useState2[0],
      setArrowRef = _useState2[1];

  var _useState3 = (0, _react.useState)(null),
      _useState4 = _slicedToArray(_useState3, 2),
      childRef = _useState4[0],
      setChildRef = _useState4[1];

  var _useState5 = (0, _react.useState)(false),
      _useState6 = _slicedToArray(_useState5, 2),
      isOpen = _useState6[0],
      setIsOpen = _useState6[1];

  (0, _react.useEffect)(function () {
    if (openProp === true || openProp === false) {
      setIsOpen(!disable && openProp);
    } else {
      setIsOpen(!disable && Boolean(childRef));
    }
  }, [childRef, disable, openProp]);

  var _onClick = (0, _react.useCallback)(function (event, childProps) {
    var onClickChildProp = childProps.onClick;

    if ((0, _lodash.isFunction)(onClickChildProp)) {
      onClickChildProp(event);
    }

    if (event && event.currentTarget && mouseEvent === 'onClick') {
      setChildRef(event.currentTarget);
    }
  }, [mouseEvent]);

  var _onMouseEnter = (0, _react.useCallback)(function (event, childProps) {
    var onMouseEnterChildProp = childProps.onMouseEnter;

    if ((0, _lodash.isFunction)(onMouseEnterChildProp)) {
      onMouseEnterChildProp(event);
    }

    if (event && event.currentTarget && mouseEvent === 'onMouseEnter') {
      setChildRef(event.currentTarget);
    }
  }, [mouseEvent]);

  var _onMouseLeave = (0, _react.useCallback)(function (event, childProps) {
    var onMouseLeaveChildProp = childProps.onMouseLeave;

    if ((0, _lodash.isFunction)(onMouseLeaveChildProp)) {
      onMouseLeaveChildProp();
    }

    setChildRef(null);
  }, []);

  var onClickAway = (0, _react.useCallback)(function () {
    if ((0, _lodash.isFunction)(onClickAwayProp)) {
      onClickAwayProp();
    }

    setChildRef(null);
  }, [onClickAwayProp]);
  var rootClasses = (0, _classnames["default"])(_constants.UI_CLASS_NAME, _constants.BEM_POPOVER, className);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: rootClasses,
    id: id
  }, !disable || (0, _lodash.isNil)(content) ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].cloneElement(children, {
    onClick: function onClick(event) {
      return _onClick(event, children.props);
    },
    onMouseEnter: function onMouseEnter(event) {
      return _onMouseEnter(event, children.props);
    },
    onMouseLeave: function onMouseLeave(event) {
      return _onMouseLeave(event, children.props);
    }
  }), /*#__PURE__*/_react["default"].createElement(_Popper["default"], {
    anchorEl: childRef,
    className: (0, _classnames["default"])("".concat(_constants.BEM_POPOVER, "--popper"), classes.popper),
    modifiers: _objectSpread({
      arrow: {
        enabled: true,
        element: arrowRef
      },
      offset: {
        offset: '0, 11'
      }
    }, modifiers),
    open: isOpen,
    placement: placement,
    transition: true
  }, function (_ref4) {
    var TransitionProps = _ref4.TransitionProps;
    return /*#__PURE__*/_react["default"].createElement(_grow["default"] // eslint-disable-next-line react/jsx-props-no-spreading
    , TransitionProps, /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement(_ClickAwayListener["default"], {
      mouseEvent: "onClick",
      onClickAway: onClickAway
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: classes.popoverRoot
    }, /*#__PURE__*/_react["default"].createElement("span", {
      className: classes.arrow,
      ref: setArrowRef
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: (0, _classnames["default"])("".concat(_constants.BEM_POPOVER, "--content"), classes.content)
    }, content)))));
  })) : children);
}

Popover.defaultProps = defaultProps;
Popover.propTypes = propTypes;
var _default = Popover;
exports["default"] = _default;