"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var propTypes = {
  /**
   * The content of the TableBody
   */
  children: _propTypes["default"].node,

  /**
   * Assign additional class names to TableBody.
   */
  className: _propTypes["default"].string,

  /**
   * The `id` of the TableBody.
   */
  id: _propTypes["default"].string,
  style: _propTypes["default"].shape({})
};
var defaultProps = {
  children: null,
  className: null,
  id: null,
  style: null
};

var TableBody = /*#__PURE__*/_react["default"].forwardRef( // eslint-disable-next-line prefer-arrow-callback
function TableBody(props, ref) {
  var children = props.children,
      className = props.className,
      id = props.id,
      style = props.style;
  var containerClasses = (0, _classnames["default"])('table-body', className);
  return /*#__PURE__*/_react["default"].createElement("tbody", {
    className: containerClasses,
    id: id,
    ref: ref,
    style: style
  }, children);
});

TableBody.propTypes = propTypes;
TableBody.defaultProps = defaultProps;
var _default = TableBody;
exports["default"] = _default;