"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = require("lodash");

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  active: _propTypes["default"].bool,
  children: _propTypes["default"].oneOfType([_propTypes["default"].arrayOf(_propTypes["default"].node), _propTypes["default"].node]).isRequired,
  className: _propTypes["default"].string,

  /**
   * Deprecated prop. Please use `disabled` instead.
   */
  disable: _propTypes["default"].bool,

  /**
   * A TableRow can be disabled.
   */
  disabled: _propTypes["default"].bool,
  draggable: _propTypes["default"].bool,
  fontSize: _propTypes["default"].oneOf(_utils["default"].sizeEnums()),
  id: _propTypes["default"].string,
  onClick: _propTypes["default"].func,
  onDragEnd: _propTypes["default"].func,
  onDragOver: _propTypes["default"].func,
  onDragStart: _propTypes["default"].func,
  onDrop: _propTypes["default"].func,
  selected: _propTypes["default"].bool,
  style: _propTypes["default"].shape({}),
  textAlign: _propTypes["default"].oneOf(['center', 'left', 'right']),
  verticalAlign: _propTypes["default"].oneOf(['bottom', 'middle', 'top'])
};
var defaultProps = {
  active: false,
  className: null,
  disable: false,
  disabled: false,
  draggable: false,
  fontSize: null,
  id: null,
  onClick: null,
  onDragEnd: null,
  onDragOver: null,
  onDragStart: null,
  onDrop: null,
  selected: false,
  style: null,
  textAlign: null,
  verticalAlign: null
};

var TableRow = /*#__PURE__*/function (_React$Component) {
  _inherits(TableRow, _React$Component);

  var _super = _createSuper(TableRow);

  function TableRow(props) {
    var _this;

    _classCallCheck(this, TableRow);

    _this = _super.call(this, props);
    _this.state = {
      isDragging: false,
      selected: props.selected
    };
    _this.onClick = _this.onClick.bind(_assertThisInitialized(_this));
    _this.onDragEnd = _this.onDragEnd.bind(_assertThisInitialized(_this));
    _this.onDragOver = _this.onDragOver.bind(_assertThisInitialized(_this));
    _this.onDragStart = _this.onDragStart.bind(_assertThisInitialized(_this));
    _this.onDrop = _this.onDrop.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(TableRow, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var prevSelected = prevProps.selected;
      var selected = this.props.selected;

      if (selected !== prevSelected) {
        this.setState({
          selected: selected
        });
      }
    }
  }, {
    key: "onClick",
    value: function onClick() {
      var onClick = this.props.onClick;
      var isTextHighlighted = window.getSelection().toString();

      if (!isTextHighlighted && (0, _lodash.isFunction)(onClick)) {
        onClick();
      }
    }
  }, {
    key: "onDragEnd",
    value: function onDragEnd(event) {
      var _this$props = this.props,
          draggable = _this$props.draggable,
          onDragEnd = _this$props.onDragEnd;

      if (draggable) {
        this.setState({
          isDragging: false
        });

        if ((0, _lodash.isFunction)(onDragEnd)) {
          onDragEnd(event);
        }
      }
    }
  }, {
    key: "onDragOver",
    value: function onDragOver(event) {
      var _this$props2 = this.props,
          draggable = _this$props2.draggable,
          onDragOver = _this$props2.onDragOver;

      if (draggable) {
        if (!(0, _lodash.isFunction)(onDragOver)) {
          console.warn('Table Row is draggable but onDragOver event is not handled!'); // eslint-disable-line no-console
        } else {
          onDragOver(event);
          return;
        }
      }

      event.preventDefault();
    }
  }, {
    key: "onDragStart",
    value: function onDragStart(event) {
      var _this$props3 = this.props,
          draggable = _this$props3.draggable,
          onDragStart = _this$props3.onDragStart;

      if (draggable) {
        this.setState({
          isDragging: true
        });

        if (!(0, _lodash.isFunction)(onDragStart)) {
          console.warn('Table Row is draggable but onDragStart event is not handled!'); // eslint-disable-line no-console
        } else {
          onDragStart(event);
        }
      }
    }
  }, {
    key: "onDrop",
    value: function onDrop(event) {
      var _this$props4 = this.props,
          draggable = _this$props4.draggable,
          onDrop = _this$props4.onDrop;

      if (draggable) {
        if (!(0, _lodash.isFunction)(onDrop)) {
          console.warn('Table Row is draggable but onDrop event is not handled!'); // eslint-disable-line no-console
        } else {
          onDrop(event);
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props5 = this.props,
          active = _this$props5.active,
          children = _this$props5.children,
          className = _this$props5.className,
          disable = _this$props5.disable,
          disabled = _this$props5.disabled,
          draggable = _this$props5.draggable,
          fontSize = _this$props5.fontSize,
          id = _this$props5.id,
          onClick = _this$props5.onClick,
          style = _this$props5.style,
          textAlign = _this$props5.textAlign,
          verticalAlign = _this$props5.verticalAlign;
      var _this$state = this.state,
          isDragging = _this$state.isDragging,
          selected = _this$state.selected;
      var containerClasses = (0, _classnames["default"])('table-row', {
        'table-row-active': active,
        'table-row-disabled': disable || disabled,
        'table-row-clickable': onClick,
        'table-row-font-size-large': fontSize === 'large',
        'table-row-font-size-medium': fontSize === 'medium',
        'table-row-font-size-small': fontSize === 'small',
        'table-row-font-size-xlarge': fontSize === 'xlarge',
        'table-row-font-size-xsmall': fontSize === 'xsmall',
        'table-row-font-size-xxsmall': fontSize === 'xxsmall',
        'table-row-selected': selected,
        'table-row-text-align-center': textAlign === 'center',
        'table-row-text-align-left': textAlign === 'left',
        'table-row-text-align-right': textAlign === 'right',
        'table-row-vertical-align-bottom': verticalAlign === 'bottom',
        'table-row-vertical-align-middle': verticalAlign === 'middle',
        'table-row-vertical-align-top': verticalAlign === 'top',
        'table-row-dragging': isDragging
      }, className);
      return /*#__PURE__*/_react["default"].createElement("tr", {
        className: containerClasses,
        draggable: draggable,
        id: id,
        onClick: this.onClick,
        onDragEnd: draggable ? this.onDragEnd : undefined,
        onDragOver: draggable ? this.onDragOver : undefined,
        onDragStart: draggable ? this.onDragStart : undefined,
        onDrop: draggable ? this.onDrop : undefined,
        style: style
      }, children);
    }
  }]);

  return TableRow;
}(_react["default"].Component);

TableRow.propTypes = propTypes;
TableRow.defaultProps = defaultProps;
var _default = TableRow;
exports["default"] = _default;