"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _constants = require("../../global/constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var propTypes = {
  className: _propTypes["default"].string,
  formattedNumber: _propTypes["default"].string,
  id: _propTypes["default"].string,
  number: _propTypes["default"].string,
  tabIndex: _propTypes["default"].number
};
var defaultProps = {
  className: null,
  formattedNumber: null,
  id: null,
  number: null,
  tabIndex: -1
};

function TelephoneLink(props) {
  var className = props.className,
      formattedNumber = props.formattedNumber,
      id = props.id,
      number = props.number,
      tabIndex = props.tabIndex;

  if (!number) {
    return null;
  }

  var rootClasses = (0, _classnames["default"])(_constants.TELEPHONE_LINK_CLASSES, className);
  return /*#__PURE__*/_react["default"].createElement("a", {
    className: rootClasses,
    id: id,
    href: "tel:".concat(number),
    tabIndex: tabIndex
  }, formattedNumber || number);
}

TelephoneLink.propTypes = propTypes;
TelephoneLink.defaultProps = defaultProps;
var _default = TelephoneLink;
exports["default"] = _default;