"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _button = _interopRequireDefault(require("./button"));

var _buttonDeprecated = _interopRequireDefault(require("./buttonDeprecated"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var propTypes = {
  children: _propTypes["default"].node.isRequired,

  /**
   * Dependent on the designVersion number, the component can either use our old Button component
   * or the new Button component.
   */
  designVersion: _propTypes["default"].number
};
var defaultProps = {
  designVersion: 1
}; // eslint-disable-next-line prefer-arrow-callback

var ButtonBase = /*#__PURE__*/_react["default"].forwardRef(function ButtonBase(props, ref) {
  var children = props.children,
      designVersion = props.designVersion,
      otherProps = _objectWithoutProperties(props, ["children", "designVersion"]);

  if (designVersion === 2) {
    return /*#__PURE__*/_react["default"].createElement(_button["default"], _extends({
      ref: ref // eslint-disable-next-line react/jsx-props-no-spreading

    }, otherProps), children);
  }

  return /*#__PURE__*/_react["default"].createElement(_buttonDeprecated["default"], _extends({
    ref: ref // eslint-disable-next-line react/jsx-props-no-spreading

  }, otherProps), children);
});

ButtonBase.propTypes = propTypes;
ButtonBase.defaultProps = defaultProps;
var _default = ButtonBase;
exports["default"] = _default;