"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _momentTimezone = _interopRequireDefault(require("moment-timezone"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _datePickerUtils = _interopRequireDefault(require("../../utils/datePickerUtils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  date: _propTypes["default"].shape({}),
  dateFrom: _propTypes["default"].shape({}),
  dateInView: _propTypes["default"].shape({}).isRequired,
  dateTo: _propTypes["default"].shape({}),
  events: _propTypes["default"].array,
  excludeDates: _propTypes["default"].array,
  filterDates: _propTypes["default"].func,
  includeDates: _propTypes["default"].array,
  maxDate: _propTypes["default"].shape({}),
  minDate: _propTypes["default"].shape({}),
  month: _propTypes["default"].number,
  onDayClick: _propTypes["default"].func,
  range: _propTypes["default"].bool,
  rangeFrom: _propTypes["default"].bool,
  rangeTo: _propTypes["default"].bool,
  type: _propTypes["default"].string
};

var DatePickerDay = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(DatePickerDay, _React$PureComponent);

  var _super = _createSuper(DatePickerDay);

  function DatePickerDay(props) {
    var _this;

    _classCallCheck(this, DatePickerDay);

    _this = _super.call(this, props);
    _this.isDateRange = props.rangeFrom || props.rangeTo || props.range;
    _this.onDayClick = _this.onDayClick.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(DatePickerDay, [{
    key: "onDayClick",
    value: function onDayClick() {
      var _this$props = this.props,
          dateInView = _this$props.dateInView,
          onDayClick = _this$props.onDayClick;

      if (!this.isOutsideMonth() && !this.isDisabled() && !_lodash["default"].isUndefined(onDayClick)) {
        onDayClick(dateInView);
      }
    }
  }, {
    key: "isDaySelected",
    value: function isDaySelected() {
      var _this$props2 = this.props,
          date = _this$props2.date,
          dateInView = _this$props2.dateInView;
      return !this.isDateRange && _datePickerUtils["default"].isSameDay(dateInView, date);
    }
  }, {
    key: "isDayStartSelected",
    value: function isDayStartSelected() {
      var _this$props3 = this.props,
          dateFrom = _this$props3.dateFrom,
          dateInView = _this$props3.dateInView;
      return this.isDateRange && _datePickerUtils["default"].isSameDay(dateInView, dateFrom);
    }
  }, {
    key: "isDisabled",
    value: function isDisabled() {
      var dateInView = this.props.dateInView;
      return _datePickerUtils["default"].isDayDisabled(dateInView, this.props);
    }
  }, {
    key: "isDayEndSelected",
    value: function isDayEndSelected() {
      var _this$props4 = this.props,
          dateInView = _this$props4.dateInView,
          dateTo = _this$props4.dateTo;
      return this.isDateRange && _datePickerUtils["default"].isSameDay(dateInView, dateTo);
    }
  }, {
    key: "isInRange",
    value: function isInRange() {
      var _this$props5 = this.props,
          dateTo = _this$props5.dateTo,
          dateInView = _this$props5.dateInView,
          dateFrom = _this$props5.dateFrom;
      var newDateInView = dateInView.clone().startOf('day');

      if (!dateFrom || !dateTo) {
        return false;
      }

      var newDateFrom = dateFrom.clone().startOf('day');
      var newDateTo = dateTo.clone().startOf('day');
      return newDateInView.isBetween(newDateFrom, newDateTo);
    }
  }, {
    key: "isOutsideMonth",
    value: function isOutsideMonth() {
      var _this$props6 = this.props,
          dateInView = _this$props6.dateInView,
          month = _this$props6.month;
      return !_lodash["default"].isUndefined(month) && month !== dateInView.month();
    }
  }, {
    key: "isToday",
    value: function isToday() {
      var dateInView = this.props.dateInView;
      return dateInView.format('MM/DD/YYYY') === (0, _momentTimezone["default"])().format('MM/DD/YYYY');
    }
  }, {
    key: "isWeekend",
    value: function isWeekend() {
      var dateInView = this.props.dateInView;
      var weekday = dateInView.day();
      return weekday === 0 || weekday === 6;
    }
  }, {
    key: "hasEvent",
    value: function hasEvent() {
      var _this$props7 = this.props,
          dateInView = _this$props7.dateInView,
          events = _this$props7.events;
      return _lodash["default"].some(events, function (event) {
        return event.isSame(dateInView, 'day');
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props8 = this.props,
          dateInView = _this$props8.dateInView,
          dateTo = _this$props8.dateTo;
      var containerClasses = (0, _classnames["default"])('ui', 'date-picker-day', "date-picker-day-".concat((0, _momentTimezone["default"])(dateInView).format('DD')), {
        'date-picker-day-disabled': this.isDisabled(),
        'date-picker-day-end-selected': this.isDayEndSelected(),
        'date-picker-day-has-event': this.hasEvent(),
        'date-picker-day-in-range': this.isInRange(),
        'date-picker-day-no-end-day-selected': this.isDayStartSelected() && !dateTo,
        'date-picker-day-outside-month': this.isOutsideMonth(),
        'date-picker-day-selected': this.isDaySelected(),
        'date-picker-day-start-selected': this.isDayStartSelected(),
        'date-picker-day-today': this.isToday(),
        'date-picker-day-weekend': this.isWeekend()
      });
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: containerClasses,
        onClick: this.onDayClick,
        onKeyDown: function onKeyDown() {},
        role: "button",
        tabIndex: -1
      }, /*#__PURE__*/_react["default"].createElement("span", null, (0, _momentTimezone["default"])(dateInView).format('D')));
    }
  }]);

  return DatePickerDay;
}(_react["default"].PureComponent);

DatePickerDay.propTypes = propTypes;
var _default = DatePickerDay;
exports["default"] = _default;