"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _momentTimezone = _interopRequireDefault(require("moment-timezone"));

var _reactOnclickoutside = _interopRequireDefault(require("react-onclickoutside"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _reactCustomScrollbars = _interopRequireDefault(require("react-custom-scrollbars"));

var _datePickerDropdownYearListItem = _interopRequireDefault(require("./datePickerDropdownYearListItem"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  maxDate: _propTypes["default"].shape({}),
  onChange: _propTypes["default"].func.isRequired,
  onClose: _propTypes["default"].func.isRequired,
  year: _propTypes["default"].number.isRequired
};

var DatePickerDropdownYear = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(DatePickerDropdownYear, _React$PureComponent);

  var _super = _createSuper(DatePickerDropdownYear);

  function DatePickerDropdownYear() {
    var _this;

    _classCallCheck(this, DatePickerDropdownYear);

    _this = _super.call(this);
    _this.onClick = _this.onClick.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(DatePickerDropdownYear, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var maxDate = this.props.maxDate;

      if (!maxDate) {
        var selectedElement = _reactDom["default"].findDOMNode(document.querySelector('.date-picker-year-option-is-selected'));

        var selectedPosistion = selectedElement.offsetTop - 11;
        this.scrollComponent.scrollTop(selectedPosistion);
      }
    }
  }, {
    key: "generateYears",
    value: function generateYears() {
      var maxDate = this.props.maxDate;
      var maxYear = maxDate ? (0, _momentTimezone["default"])(maxDate).year() : null;
      var currentYear = (0, _momentTimezone["default"])().year().valueOf();
      var futureYear = maxYear || currentYear + 100;
      var listMultiplyYear = maxDate ? 100 : 200;
      var list = [];

      for (var i = 0; i < listMultiplyYear; i++) {
        list.push(futureYear - i);
      }

      return list;
    }
  }, {
    key: "handleClickOutside",
    value: function handleClickOutside() {
      var onClose = this.props.onClose;
      onClose();
    }
  }, {
    key: "onClick",
    value: function onClick(month) {
      var _this$props = this.props,
          onChange = _this$props.onChange,
          onClose = _this$props.onClose;
      onChange(month);
      onClose();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var year = this.props.year;
      var containerClasses = (0, _classnames["default"])('date-picker-dropdown-year');

      var options = _.map(this.generateYears(), function (y) {
        return /*#__PURE__*/_react["default"].createElement(_datePickerDropdownYearListItem["default"], {
          isSelected: year === y,
          key: y,
          onClick: _this2.onClick,
          year: y
        });
      });

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: containerClasses
      }, /*#__PURE__*/_react["default"].createElement(_reactCustomScrollbars["default"], {
        autoHide: true,
        className: "date-picker-dropdown-year-scrollbar",
        ref: function ref(_ref) {
          _this2.scrollComponent = _ref;
        }
      }, /*#__PURE__*/_react["default"].createElement("ul", null, options)));
    }
  }]);

  return DatePickerDropdownYear;
}(_react["default"].PureComponent);

DatePickerDropdownYear.propTypes = propTypes;

var _default = (0, _reactOnclickoutside["default"])(DatePickerDropdownYear);

exports["default"] = _default;