"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _datePickerWeek = _interopRequireDefault(require("./datePickerWeek"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  date: _propTypes["default"].shape({}),
  dateFrom: _propTypes["default"].shape({}),
  dateInView: _propTypes["default"].shape({}).isRequired,
  dateTo: _propTypes["default"].shape({}),
  events: _propTypes["default"].array,
  excludeDates: _propTypes["default"].array,
  filterDates: _propTypes["default"].func,
  includeDates: _propTypes["default"].array,
  maxDate: _propTypes["default"].shape({}),
  minDate: _propTypes["default"].shape({}),
  mode: _propTypes["default"].oneOf(['calendar', 'input']),
  onDayClick: _propTypes["default"].func.isRequired,
  range: _propTypes["default"].bool,
  rangeFrom: _propTypes["default"].bool,
  rangeTo: _propTypes["default"].bool
};

var DatePickerMonth = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(DatePickerMonth, _React$PureComponent);

  var _super = _createSuper(DatePickerMonth);

  function DatePickerMonth() {
    var _this;

    _classCallCheck(this, DatePickerMonth);

    _this = _super.call(this);
    _this.onDayClick = _this.onDayClick.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(DatePickerMonth, [{
    key: "onDayClick",
    value: function onDayClick(date) {
      var onDayClick = this.props.onDayClick;

      if (!_lodash["default"].isUndefined(onDayClick)) {
        onDayClick(date);
      }
    }
  }, {
    key: "isWeekInMonth",
    value: function isWeekInMonth(startOfWeek) {
      var dateInView = this.props.dateInView;
      var endOfWeek = startOfWeek.clone().add(6, 'days');
      return startOfWeek.isSame(dateInView, 'month') || endOfWeek.isSame(dateInView, 'month');
    }
  }, {
    key: "renderWeeks",
    value: function renderWeeks() {
      var _this2 = this;

      var _this$props = this.props,
          date = _this$props.date,
          dateFrom = _this$props.dateFrom,
          dateInView = _this$props.dateInView,
          dateTo = _this$props.dateTo,
          events = _this$props.events,
          excludeDates = _this$props.excludeDates,
          filterDates = _this$props.filterDates,
          includeDates = _this$props.includeDates,
          maxDate = _this$props.maxDate,
          minDate = _this$props.minDate,
          mode = _this$props.mode,
          range = _this$props.range,
          rangeFrom = _this$props.rangeFrom,
          rangeTo = _this$props.rangeTo;
      var startOfMonth = dateInView.clone().startOf('month').startOf('week');
      return _lodash["default"].map([0, 1, 2, 3, 4, 5], function (week) {
        var startOfWeek = startOfMonth.clone().add(week, 'weeks');
        return /*#__PURE__*/_react["default"].createElement(_datePickerWeek["default"], {
          date: date,
          dateFrom: dateFrom,
          dateInView: startOfWeek,
          dateTo: dateTo,
          events: events,
          excludeDates: excludeDates,
          filterDates: filterDates,
          includeDates: includeDates,
          key: week,
          maxDate: maxDate,
          minDate: minDate,
          month: dateInView.month(),
          onDayClick: _this2.onDayClick,
          mode: mode,
          range: range,
          rangeFrom: rangeFrom,
          rangeTo: rangeTo
        });
      });
    }
  }, {
    key: "render",
    value: function render() {
      var containerClasses = (0, _classnames["default"])('ui', 'date-picker-month');
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: containerClasses
      }, this.renderWeeks());
    }
  }]);

  return DatePickerMonth;
}(_react["default"].PureComponent);

DatePickerMonth.propTypes = propTypes;
var _default = DatePickerMonth;
exports["default"] = _default;