"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _momentTimezone = _interopRequireDefault(require("moment-timezone"));

var _react = _interopRequireDefault(require("react"));

var _datePickerUtils = _interopRequireDefault(require("../../utils/datePickerUtils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  date: _propTypes["default"].shape({}),
  dateEnd: _propTypes["default"].shape({}),
  dateInView: _propTypes["default"].shape({}).isRequired,
  dateSecondaryEnd: _propTypes["default"].shape({}),
  dateSecondaryStart: _propTypes["default"].shape({}),
  dateStart: _propTypes["default"].shape({}),
  events: _propTypes["default"].array,
  excludeDates: _propTypes["default"].array,
  filterDates: _propTypes["default"].func,
  includeDates: _propTypes["default"].array,
  maxDate: _propTypes["default"].shape({}),
  minDate: _propTypes["default"].shape({}),
  month: _propTypes["default"].number,
  onClick: _propTypes["default"].func,
  type: _propTypes["default"].string,
  uxMode: _propTypes["default"].string
};

var DatePickerDay = /*#__PURE__*/function (_React$Component) {
  _inherits(DatePickerDay, _React$Component);

  var _super = _createSuper(DatePickerDay);

  function DatePickerDay() {
    _classCallCheck(this, DatePickerDay);

    return _super.apply(this, arguments);
  }

  _createClass(DatePickerDay, [{
    key: "hasEvent",
    value: function hasEvent() {
      var _this = this;

      return _lodash["default"].some(this.props.events, function (event) {
        return _momentTimezone["default"].unix(event).utc().isSame(_this.props.dateInView, 'day');
      });
    }
  }, {
    key: "isDaySelected",
    value: function isDaySelected() {
      if (this.props.type !== 'dateRange' || this.props.type !== 'servicePeriod' || this.props.type !== 'servicePeriodRange' || this.props.type !== 'servicePeriodRangeEnd' || this.props.type !== 'servicePeriodRangeStart') {
        return _datePickerUtils["default"].isSameDay(this.props.dateInView, this.props.date);
      }
    }
  }, {
    key: "isDayStartSelected",
    value: function isDayStartSelected() {
      var _this$props = this.props,
          dateSecondaryStart = _this$props.dateSecondaryStart,
          dateStart = _this$props.dateStart;

      if (this.props.type === 'dateRange' || this.props.type === 'servicePeriod' || this.props.type === 'servicePeriodRange' || this.props.type === 'servicePeriodRangeEnd' || this.props.type === 'servicePeriodRangeStart') {
        return _datePickerUtils["default"].isSameDay(this.props.dateInView, dateStart) || _datePickerUtils["default"].isSameDay(this.props.dateInView, dateSecondaryStart);
      }
    }
  }, {
    key: "isDisabled",
    value: function isDisabled() {
      return _datePickerUtils["default"].isDayDisabled(this.props.dateInView, this.props);
    }
  }, {
    key: "isDayEndSelected",
    value: function isDayEndSelected() {
      var _this$props2 = this.props,
          dateEnd = _this$props2.dateEnd,
          dateSecondaryEnd = _this$props2.dateSecondaryEnd;

      if (this.props.type === 'dateRange' || this.props.type === 'servicePeriod' || this.props.type === 'servicePeriodRange' || this.props.type === 'servicePeriodRangeEnd' || this.props.type === 'servicePeriodRangeStart') {
        return _datePickerUtils["default"].isSameDay(this.props.dateInView, dateEnd) || _datePickerUtils["default"].isSameDay(this.props.dateInView, dateSecondaryEnd);
      }
    }
  }, {
    key: "isInRange",
    value: function isInRange() {
      var _this$props3 = this.props,
          dateEnd = _this$props3.dateEnd,
          dateInView = _this$props3.dateInView,
          dateSecondaryEnd = _this$props3.dateSecondaryEnd,
          dateSecondaryStart = _this$props3.dateSecondaryStart,
          dateStart = _this$props3.dateStart,
          type = _this$props3.type;
      var newDateInView = dateInView.clone().startOf('day');

      if (!dateStart || !dateEnd) {
        return false;
      }

      var newDateStart = dateStart.clone().startOf('day');
      var newDateEnd = dateEnd.clone().startOf('day');

      if (type === 'servicePeriodRangeEnd' && dateSecondaryStart || dateSecondaryEnd) {
        var newDateSecondaryStart = dateSecondaryStart.clone().startOf('day');
        var newDateSecondaryEnd = dateSecondaryEnd.clone().startOf('day');
        return newDateInView.isBetween(newDateStart, newDateEnd) || newDateInView.isBetween(newDateEnd, newDateSecondaryStart) || newDateInView.isBetween(newDateSecondaryStart, newDateSecondaryEnd);
      } else {
        return newDateInView.isBetween(newDateStart, newDateEnd);
      }
    }
  }, {
    key: "isOutsideMonth",
    value: function isOutsideMonth() {
      var month = this.props.month;
      return !_lodash["default"].isUndefined(month) && month !== this.props.dateInView.month();
    }
  }, {
    key: "isToday",
    value: function isToday() {
      return this.props.dateInView.format('MM/DD/YYYY') === (0, _momentTimezone["default"])().format('MM/DD/YYYY');
    }
  }, {
    key: "isWeekend",
    value: function isWeekend() {
      var weekday = this.props.dateInView.day();
      return weekday === 0 || weekday === 6;
    }
  }, {
    key: "onClick",
    value: function onClick(event) {
      if (!this.isOutsideMonth() && !this.isDisabled() && _lodash["default"].isFunction(this.props.onClick)) {
        this.props.onClick(event);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var containerClasses = (0, _classnames["default"])('ui', 'date-picker-deprecated-day', {
        'date-picker-deprecated-day-disabled': this.isDisabled(),
        'date-picker-deprecated-day-end-selected': this.isDayEndSelected(),
        'date-picker-deprecated-day-has-event': this.hasEvent(),
        'date-picker-deprecated-day-in-range': this.isInRange(),
        'date-picker-deprecated-day-no-end-day-selected': this.isDayStartSelected() && !this.props.dateEnd,
        'date-picker-deprecated-day-outside-month': this.isOutsideMonth(),
        'date-picker-deprecated-day-selected': this.isDaySelected(),
        'date-picker-deprecated-day-start-selected': this.isDayStartSelected(),
        'date-picker-deprecated-day-today': this.isToday(),
        'date-picker-deprecated-day-weekend': this.isWeekend()
      });
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: containerClasses,
        onClick: this.onClick.bind(this)
      }, /*#__PURE__*/_react["default"].createElement("span", null, (0, _momentTimezone["default"])(this.props.dateInView).format('DD')));
    }
  }]);

  return DatePickerDay;
}(_react["default"].Component);

DatePickerDay.propTypes = propTypes;
var _default = DatePickerDay;
exports["default"] = _default;