"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _datePickerDeprecatedWeek = _interopRequireDefault(require("./datePickerDeprecatedWeek"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  date: _propTypes["default"].shape({}),
  dateEnd: _propTypes["default"].shape({}),
  dateInView: _propTypes["default"].shape({}).isRequired,
  dateSecondaryEnd: _propTypes["default"].shape({}),
  dateSecondaryStart: _propTypes["default"].shape({}),
  dateStart: _propTypes["default"].shape({}),
  events: _propTypes["default"].array,
  excludeDates: _propTypes["default"].array,
  filterDates: _propTypes["default"].func,
  includeDates: _propTypes["default"].array,
  maxDate: _propTypes["default"].shape({}),
  minDate: _propTypes["default"].shape({}),
  onDayClick: _propTypes["default"].func,
  type: _propTypes["default"].string,
  uxMode: _propTypes["default"].string
};

var DatePickerMonth = /*#__PURE__*/function (_React$Component) {
  _inherits(DatePickerMonth, _React$Component);

  var _super = _createSuper(DatePickerMonth);

  function DatePickerMonth() {
    _classCallCheck(this, DatePickerMonth);

    return _super.apply(this, arguments);
  }

  _createClass(DatePickerMonth, [{
    key: "isWeekInMonth",
    value: function isWeekInMonth(startOfWeek) {
      var dateInView = this.props.dateInView;
      var endOfWeek = startOfWeek.clone().add(6, 'days');
      return startOfWeek.isSame(dateInView, 'month') || endOfWeek.isSame(dateInView, 'month');
    }
  }, {
    key: "onDayClick",
    value: function onDayClick(day) {
      if (this.props.onDayClick) {
        this.props.onDayClick(day);
      }
    }
  }, {
    key: "renderWeeks",
    value: function renderWeeks() {
      var _this = this;

      var startOfMonth = this.props.dateInView.clone().startOf('month').startOf('week');
      return [0, 1, 2, 3, 4, 5].map(function (offset) {
        return startOfMonth.clone().add(offset, 'weeks');
      }).filter(function (startOfWeek) {
        return _this.isWeekInMonth(startOfWeek);
      }).map(function (startOfWeek, offset) {
        return /*#__PURE__*/_react["default"].createElement(_datePickerDeprecatedWeek["default"], {
          date: _this.props.date,
          dateEnd: _this.props.dateEnd,
          dateInView: startOfWeek,
          dateSecondaryEnd: _this.props.dateSecondaryEnd,
          dateSecondaryStart: _this.props.dateSecondaryStart,
          dateStart: _this.props.dateStart,
          events: _this.props.events,
          key: offset,
          maxDate: _this.props.maxDate,
          minDate: _this.props.minDate,
          month: _this.props.dateInView.month(),
          onDayClick: _this.onDayClick.bind(_this),
          excludeDates: _this.props.excludeDates,
          filterDates: _this.props.filterDates,
          includeDates: _this.props.includeDates,
          type: _this.props.type,
          uxMode: _this.props.uxMode
        });
      });
    }
  }, {
    key: "render",
    value: function render() {
      var containerClasses = (0, _classnames["default"])('ui', 'date-picker-deprecated-month');
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: containerClasses
      }, this.renderWeeks());
    }
  }]);

  return DatePickerMonth;
}(_react["default"].Component);

DatePickerMonth.propTypes = propTypes;
var _default = DatePickerMonth;
exports["default"] = _default;