"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = require("lodash");

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _icon = require("../../dataDisplay/icon/icon");

var _models = require("../button/models");

var _button = _interopRequireDefault(require("../button"));

var _dropdownMenu = _interopRequireDefault(require("../dropdownMenu/dropdownMenu"));

var _dropdownMenuDivider = _interopRequireDefault(require("../dropdownMenu/dropdownMenuDivider"));

var _dropdownMenuHeading = _interopRequireDefault(require("../dropdownMenu/dropdownMenuHeading"));

var _dropdownMenuOption = _interopRequireDefault(require("../dropdownMenu/dropdownMenuOption"));

var _icon2 = _interopRequireDefault(require("../../dataDisplay/icon"));

var _makeStyles = _interopRequireDefault(require("../../styles/makeStyles"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = {
  /**
   * Dropdown Menu options
   */
  children: _propTypes["default"].node.isRequired,

  /**
   * Additional classes.
   */
  className: _propTypes["default"].string,

  /**
   * Override or extend the styles applied to ButtonDropdown.
   */
  classes: _propTypes["default"].shape({
    dropdownMenuRoot: _propTypes["default"].string,
    root: _propTypes["default"].string
  }),

  /**
   * Color of the Dropdown Button.
   */
  color: _propTypes["default"].oneOf(['active', 'default', 'error', 'link', 'primary', 'secondary', 'success', 'warning']),

  /**
   * A Dropdown Button can reduce its padding.
   */
  compact: _propTypes["default"].bool,

  /**
   * Dependent on the designVersion number, the component can either use our old Button component
   * or the new Button component.
   */
  designVersion: _propTypes["default"].number,

  /**
   * Deprecated prop. Please use `disabled` instead.
   */
  disable: _propTypes["default"].bool,

  /**
   * A Dropdown Button can be disabled.
   */
  disabled: _propTypes["default"].bool,

  /**
   * The Dropown Button will be resized to its parent container's width. (Using v1 Button)
   */
  fluid: _propTypes["default"].bool,

  /**
   * The Dropown Button will be resized to its parent container's width. (Using v2 Button)
   */
  fullWidth: _propTypes["default"].bool,

  /**
   * If `true`, the Dropown Button will be a square, housing the icon child.
   */
  icon: _propTypes["default"].bool,

  /**
   * Props to control the Icon in the Dropdown Button
   */
  iconProps: _propTypes["default"].shape(_objectSpread({}, _icon.propTypes)),

  /**
   * Change the position of the icon.
   */
  iconPosition: _propTypes["default"].oneOf(['left', 'right']),

  /**
   * The size of the icon that sits to the left of the label.
   */
  iconSize: _propTypes["default"].number,

  /**
   * The type of the icon that sits to the left of the label.
   */
  iconType: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].oneOf(['caret-down', 'chevron-down', 'ellipsis-h', 'plus'])]),

  /**
   * Assign the Dropdown Button an id attribute value.
   */
  id: _propTypes["default"].string,

  /**
   * Allows for style overrides of the Dropdown Button's inner container.
   */
  innerStyle: _propTypes["default"].shape({}),

  /**
   * A Dropdown Button can be formatted to appear on dark backgrounds better.
   */
  inverse: _propTypes["default"].bool,

  /**
   * The Dropdown Button's label.
   */
  label: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].node]),

  /**
   * Options list theme
   */
  optionsTheme: _propTypes["default"].oneOf(['dark', 'light']),

  /**
   * A Dropdown Button can be outlined.
   */
  outline: _propTypes["default"].bool,

  /**
   * Set a Dropdown Button with a pill like form.
   */
  pill: _propTypes["default"].bool,

  /**
   * A Dropdown Button can relax its padding.
   */
  relax: _propTypes["default"].bool,

  /**
   * Apply inline styles to the Dropdown Button.
   */
  style: _propTypes["default"].shape({}),

  /**
   * Indicates whether or not the Dropdown Button can be focused.
   */
  tabIndex: _propTypes["default"].number,

  /**
   * Where to display the linked URL.  (Button prop; probably not relevant for a Dropdown Button)
   */
  target: _propTypes["default"].oneOf(['_blank']),

  /**
   * If `true`, only the Dropdown Button's text is shown.
   */
  text: _propTypes["default"].bool,

  /**
   * The title attribute.
   */
  title: _propTypes["default"].string,

  /**
   * Set transparent styles.
   */
  transparent: _propTypes["default"].bool,

  /**
   * The variant to use.
   */
  variant: _propTypes["default"].oneOf(Object.values(_models.VariantType)),

  /**
   * Set a fixed width.
   */
  width: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string])
};
var defaultProps = {
  classes: undefined,
  className: undefined,
  color: undefined,
  compact: false,
  designVersion: 1,
  disable: false,
  disabled: false,
  fluid: false,
  fullWidth: false,
  icon: false,
  iconPosition: 'left',
  iconProps: undefined,
  iconSize: 16,
  iconType: 'chevron-down',
  id: undefined,
  innerStyle: {},
  inverse: false,
  label: undefined,
  optionsTheme: 'dark',
  outline: false,
  pill: false,
  relax: false,
  style: {},
  tabIndex: -1,
  target: undefined,
  text: false,
  title: undefined,
  transparent: false,
  variant: _models.VariantType.Contained,
  width: undefined
};
var useStyles = (0, _makeStyles["default"])({
  dropdownMenuRoot: {},
  root: {
    overflow: 'visible',
    position: 'relative'
  }
});

function DropdownButton(props) {
  var dropdownButtonRef = (0, _react.useRef)(null);

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      isMenuOpen = _useState2[0],
      setIsOpen = _useState2[1];

  var classes = useStyles(props);
  var children = props.children,
      className = props.className,
      color = props.color,
      compact = props.compact,
      designVersion = props.designVersion,
      disable = props.disable,
      disabled = props.disabled,
      fluid = props.fluid,
      fullWidth = props.fullWidth,
      id = props.id,
      icon = props.icon,
      iconProps = props.iconProps,
      iconPosition = props.iconPosition,
      iconSize = props.iconSize,
      iconType = props.iconType,
      innerStyle = props.innerStyle,
      inverse = props.inverse,
      label = props.label,
      optionsTheme = props.optionsTheme,
      outline = props.outline,
      pill = props.pill,
      relax = props.relax,
      style = props.style,
      tabIndex = props.tabIndex,
      target = props.target,
      text = props.text,
      title = props.title,
      transparent = props.transparent,
      variant = props.variant,
      width = props.width;
  var getParentContainer = (0, _react.useCallback)(function () {
    return dropdownButtonRef.current;
  }, [dropdownButtonRef]);
  var onMenuToggle = (0, _react.useCallback)(function (event) {
    if (!(0, _lodash.isEmpty)(event)) {
      event.stopPropagation();
    }

    setIsOpen(!isMenuOpen);
  }, [isMenuOpen, setIsOpen]);
  var bemClassName = 'button_dropdown';
  var rootClasses = (0, _classnames["default"])(bemClassName, className, _defineProperty({}, "".concat(bemClassName, "-open"), isMenuOpen));
  var dropdownIcon = iconType ? /*#__PURE__*/_react["default"].createElement(_icon2["default"], _extends({
    compact: icon && !label,
    size: iconSize,
    inverse: true,
    style: {
      margin: icon && !label ? 0 : null
    },
    type: iconType // eslint-disable-next-line react/jsx-props-no-spreading

  }, iconProps)) : null;
  var iconOnLeft = iconType && iconPosition === 'left' ? dropdownIcon : null;
  var iconOnRight = iconType && iconPosition === 'right' ? dropdownIcon : null;
  var isDesignV2 = designVersion === 2;
  var buttonProps = {};

  if (isDesignV2) {
    buttonProps = _objectSpread(_objectSpread({}, buttonProps), {}, {
      color: color,
      compact: compact,
      designVersion: designVersion,
      disabled: disabled,
      fullWidth: fullWidth,
      icon: icon,
      id: id,
      innerStyle: innerStyle,
      inverse: inverse,
      onClick: onMenuToggle,
      outline: outline,
      pill: pill,
      ref: dropdownButtonRef,
      relax: relax,
      style: style,
      tabIndex: tabIndex,
      text: text,
      title: title,
      transparent: transparent,
      variant: variant,
      width: width
    });
  } else {
    buttonProps = _objectSpread(_objectSpread({}, buttonProps), {}, {
      color: color,
      compact: compact,
      designVersion: designVersion,
      disable: disable,
      disabled: disabled,
      fluid: fluid,
      icon: icon,
      id: id,
      innerStyle: innerStyle,
      inverse: inverse,
      onClick: onMenuToggle,
      ref: dropdownButtonRef,
      relax: relax,
      style: style,
      tabIndex: tabIndex,
      target: target,
      title: title,
      width: width
    });
  }

  return /*#__PURE__*/_react["default"].createElement(_button["default"], _extends({
    className: rootClasses,
    classes: {
      root: classes.root
    } // eslint-disable-next-line react/jsx-props-no-spreading

  }, buttonProps), iconOnLeft, label && /*#__PURE__*/_react["default"].createElement("span", null, label), iconOnRight, /*#__PURE__*/_react["default"].createElement(_dropdownMenu["default"], {
    className: "".concat(bemClassName, "--menu"),
    classes: {
      root: classes.dropdownMenuRoot
    },
    isOpen: isMenuOpen,
    onToggleOpen: onMenuToggle,
    getParentContainer: getParentContainer,
    optionsTheme: optionsTheme
  }, children));
}

DropdownButton.Divider = _dropdownMenuDivider["default"];
DropdownButton.Option = _dropdownMenuOption["default"];
DropdownButton.Heading = _dropdownMenuHeading["default"];
DropdownButton.propTypes = propTypes;
DropdownButton.defaultProps = defaultProps;
var _default = DropdownButton;
exports["default"] = _default;