"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = require("lodash");

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _domUtils = _interopRequireDefault(require("../../utils/domUtils"));

var _dropdownMenuConstants = require("./dropdownMenuConstants");

var _makeStyles = _interopRequireDefault(require("../../styles/makeStyles"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var propTypes = {
  children: _propTypes["default"].node.isRequired,
  className: _propTypes["default"].string,
  id: _propTypes["default"].string,
  isOpen: _propTypes["default"].bool.isRequired,
  getParentContainer: _propTypes["default"].func,
  onToggleOpen: _propTypes["default"].func.isRequired,

  /**
   * Options list theme
   */
  optionsTheme: _propTypes["default"].oneOf(['dark', 'light']),
  style: _propTypes["default"].shape({}),

  /**
   * Indicates whether or not the Dropdown Menu can be focused.
   */
  tabIndex: _propTypes["default"].number
};
var defaultProps = {
  optionsTheme: 'dark',
  className: undefined,
  id: undefined,
  style: undefined,
  getParentContainer: undefined,
  tabIndex: -1
};
var useStyles = (0, _makeStyles["default"])(function (theme) {
  var backgroundColorInverse = (0, _lodash.get)(theme, 'palette.grey[500]');
  var backgroundColorPrimary = (0, _lodash.get)(theme, 'palette.background.primary');
  var borderColorPrimary = (0, _lodash.get)(theme, 'palette.border.primary');
  var borderRadiusMain = (0, _lodash.get)(theme, 'shape.borderRadius');
  var colorHighlight = (0, _lodash.get)(theme, 'palette.cyan[500]');
  var colorPrimary = (0, _lodash.get)(theme, 'palette.grey[600]');
  var colorStatic = (0, _lodash.get)(theme, 'palette.text.secondary');
  var fontWeightMedium = (0, _lodash.get)(theme, 'typography.fontWeightMedium');
  var textColorConstrast = (0, _lodash.get)(theme, 'palette.text.contrastText');
  var textColorPrimary = (0, _lodash.get)(theme, 'palette.text.primary');
  var pxToRem = (0, _lodash.get)(theme, 'typography.pxToRem', function (px) {
    return px;
  });
  return {
    root: {
      backgroundColor: function backgroundColor(_ref) {
        var optionsTheme = _ref.optionsTheme;
        return optionsTheme === _dropdownMenuConstants.OPTIONS_THEME_LIGHT ? backgroundColorPrimary : backgroundColorInverse;
      },
      borderRadius: borderRadiusMain,
      border: function border(_ref2) {
        var optionsTheme = _ref2.optionsTheme;
        return optionsTheme === _dropdownMenuConstants.OPTIONS_THEME_LIGHT ? "1px solid ".concat(borderColorPrimary) : 0;
      },
      boxShadow: '0 4px 4px 0 rgba(0, 0, 0, 0.43)',
      boxSizing: 'border-box',
      cursor: 'default',
      margin: '5px 0',
      padding: 0,
      position: 'absolute',
      textAlign: 'left',
      transform: 'opacity 300ms ease-in',
      zIndex: '1000',
      '& .dropdown_menu': {
        '&--option': {
          color: function color(_ref3) {
            var optionsTheme = _ref3.optionsTheme;
            return optionsTheme === _dropdownMenuConstants.OPTIONS_THEME_LIGHT ? textColorPrimary : textColorConstrast;
          },
          fontSize: pxToRem(14),
          fontWeight: fontWeightMedium,
          outline: 'none',
          padding: "".concat(pxToRem(4), " 0"),
          textAlign: 'left',
          '&:first-child': {
            paddingTop: pxToRem(11)
          },
          '&:last-child': {
            paddingBottom: pxToRem(11)
          },
          '&_inner': {
            alignItems: 'center',
            cursor: 'pointer',
            display: 'flex',
            justifyContent: 'flex-start',
            padding: "".concat(pxToRem(7), " ").concat(pxToRem(22)),
            transition: 'background-color 150ms ease-out, color 150ms ease-out',
            whiteSpace: 'nowrap',
            '&:hover': {
              backgroundColor: function backgroundColor(_ref4) {
                var optionsTheme = _ref4.optionsTheme;
                return optionsTheme === _dropdownMenuConstants.OPTIONS_THEME_LIGHT ? colorHighlight : backgroundColorPrimary;
              },
              color: function color(_ref5) {
                var optionsTheme = _ref5.optionsTheme;
                return optionsTheme === _dropdownMenuConstants.OPTIONS_THEME_LIGHT ? textColorConstrast : textColorPrimary;
              },
              '& .ui.icon-color-primary.icon-inverse': {
                '& .icon-use-path': {
                  fill: colorPrimary
                }
              }
            }
          },
          '&-disable': {
            color: "".concat(colorStatic, " !important"),
            cursor: 'default',
            pointerEvents: 'none'
          }
        }
      }
    },
    dropdownMenuClosed: {
      opacity: 0,
      visibility: 'hidden'
    },
    dropdownMenuOpen: {
      opacity: 1,
      visibility: 'visible'
    }
  };
});

function DropdownMenu(props) {
  var _ClassNames;

  var children = props.children,
      className = props.className,
      getParentContainer = props.getParentContainer,
      id = props.id,
      isOpen = props.isOpen,
      optionsTheme = props.optionsTheme,
      onToggleOpen = props.onToggleOpen,
      style = props.style,
      tabIndex = props.tabIndex;
  var dropdownMenuRef = (0, _react.useRef)(null);

  var _useState = (0, _react.useState)({
    bottom: null,
    left: 0,
    right: null,
    top: '100%'
  }),
      _useState2 = _slicedToArray(_useState, 2),
      menuPositionStyle = _useState2[0],
      setMenuPositionStyle = _useState2[1];

  var classes = useStyles(_objectSpread(_objectSpread({}, props), {}, {
    optionsTheme: optionsTheme // just to avoid the ESLint issue 'PropType is defined but prop is never used'

  }));

  function onDropdownMenuReposition() {
    var parentContainer = (0, _lodash.get)(dropdownMenuRef, 'current.parentElement');

    if ((0, _lodash.isFunction)(getParentContainer)) {
      // eslint-disable-next-line react/no-find-dom-node
      parentContainer = _reactDom["default"].findDOMNode(getParentContainer());
    }

    var dropdownMenuObj = _domUtils["default"].isInViewport(dropdownMenuRef.current, parentContainer);

    var isInTop = dropdownMenuObj.isInTop,
        isInRight = dropdownMenuObj.isInRight,
        isInBottom = dropdownMenuObj.isInBottom,
        topBias = dropdownMenuObj.topBias,
        bottomBias = dropdownMenuObj.bottomBias;
    var menuXPosition = isInRight ? 'left' : 'right';
    var menuYPosition = topBias < bottomBias ? 'top' : 'bottom';

    if (isInBottom || bottomBias < 0) {
      menuYPosition = 'top';
    } else if (isInTop || topBias < 0) {
      menuYPosition = 'bottom';
    }

    var newMenuPositionStyle = {
      bottom: menuYPosition === 'bottom' ? '100%' : null,
      left: menuXPosition === 'left' ? 0 : null,
      right: menuXPosition === 'right' ? 0 : null,
      top: menuYPosition === 'top' ? '100%' : null
    };
    setMenuPositionStyle(function (prevState) {
      return _objectSpread(_objectSpread({}, prevState), newMenuPositionStyle);
    });
  }

  var debounceDropdownMenuReposition = (0, _lodash.debounce)(function () {
    return onDropdownMenuReposition();
  }, 100);
  (0, _react.useEffect)(function () {
    function onClickOutside(event) {
      var parentContainer = dropdownMenuRef.current;
      var containsTarget = parentContainer.contains(event.target);

      if (!containsTarget || containsTarget && event.target.className === _dropdownMenuConstants.OPTION_INNER_CLASS_NAME) {
        onToggleOpen(event);
      }

      return null;
    }

    if (isOpen) {
      window.addEventListener('resize', debounceDropdownMenuReposition);
      window.addEventListener('scroll', debounceDropdownMenuReposition);
      document.addEventListener('click', onClickOutside);
    }

    onDropdownMenuReposition();
    return function () {
      if (isOpen) {
        window.removeEventListener('resize', debounceDropdownMenuReposition);
        window.removeEventListener('scroll', debounceDropdownMenuReposition);
        document.removeEventListener('click', onClickOutside);
      }
    }; // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [isOpen]);
  var rootClasses = (0, _classnames["default"])('ui', _dropdownMenuConstants.BEM_BLOCK_NAME, className, classes.root, (_ClassNames = {}, _defineProperty(_ClassNames, classes.dropdownMenuClosed, !isOpen), _defineProperty(_ClassNames, classes.dropdownMenuOpen, isOpen), _defineProperty(_ClassNames, "".concat(_dropdownMenuConstants.BEM_BLOCK_NAME, "-closed"), !isOpen), _defineProperty(_ClassNames, "".concat(_dropdownMenuConstants.BEM_BLOCK_NAME, "-opened"), isOpen), _ClassNames));
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: rootClasses,
    id: id,
    ref: dropdownMenuRef,
    style: _objectSpread(_objectSpread({}, style), menuPositionStyle),
    tabIndex: tabIndex
  }, children);
}

DropdownMenu.propTypes = propTypes;
DropdownMenu.defaultProps = defaultProps;
var _default = DropdownMenu;
exports["default"] = _default;