"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _makeStyles = _interopRequireDefault(require("../../styles/makeStyles"));

var _typography = _interopRequireDefault(require("../../dataDisplay/typography"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var propTypes = {
  children: _propTypes["default"].node.isRequired,
  classes: _propTypes["default"].shape({
    root: _propTypes["default"].string
  })
};
var defaultProps = {
  classes: undefined
};
var useStyles = (0, _makeStyles["default"])(function (_ref) {
  var spacing = _ref.spacing;
  return {
    root: {
      padding: [[spacing(1), spacing(2), spacing(1)]],
      '&:first-child': {
        paddingTop: spacing(2)
      }
    }
  };
});

function DropdownMenuHeading(props) {
  var children = props.children;
  var classes = useStyles(props);
  return /*#__PURE__*/_react["default"].createElement(_typography["default"], {
    classes: {
      root: classes.root
    },
    color: "textSecondary",
    component: "div",
    variant: "body1"
  }, children);
}

DropdownMenuHeading.propTypes = propTypes;
DropdownMenuHeading.defaultProps = defaultProps;
var _default = DropdownMenuHeading;
exports["default"] = _default;