"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _max = _interopRequireWildcard(require("react-phone-number-input/max"));

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _flags = _interopRequireDefault(require("react-phone-number-input/flags"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _phoneInputCountryDropdown = _interopRequireDefault(require("./phoneInputCountryDropdown"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  className: _propTypes["default"].string,
  country: _propTypes["default"].string,
  countryOptions: _propTypes["default"].arrayOf(_propTypes["default"].string),

  /**
   * Deprecated prop. Please use `disabled` instead.
   */
  disable: _propTypes["default"].bool,

  /**
   * A PhoneInput can be disabled.
   */
  disabled: _propTypes["default"].bool,
  error: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].string]),
  fluid: _propTypes["default"].bool,
  id: _propTypes["default"].string,
  label: _propTypes["default"].string,
  labelStyle: _propTypes["default"].shape({}),
  onChange: _propTypes["default"].func.isRequired,
  required: _propTypes["default"].bool,
  style: _propTypes["default"].shape({}),
  value: _propTypes["default"].string.isRequired
};
var defaultProps = {
  className: undefined,
  country: 'US',
  countryOptions: ['US', '|'],
  disable: false,
  disabled: false,
  error: false,
  fluid: false,
  id: undefined,
  label: undefined,
  labelStyle: undefined,
  required: false,
  style: undefined
};

var PhoneInput = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(PhoneInput, _React$PureComponent);

  var _super = _createSuper(PhoneInput);

  function PhoneInput() {
    var _this;

    _classCallCheck(this, PhoneInput);

    _this = _super.call(this);
    _this.onChange = _this.onChange.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(PhoneInput, [{
    key: "onChange",
    value: function onChange(value) {
      var onChange = this.props.onChange;
      var number = value || '';
      var phoneNumberObj = number && (0, _max.parsePhoneNumber)(number);
      var countryCode = phoneNumberObj && phoneNumberObj.country || '';
      var dialCode = phoneNumberObj && phoneNumberObj.countryCallingCode;
      var formattedNumber = number && (0, _max.formatPhoneNumberIntl)(number) || '';
      var isValid = number && (0, _max.isValidPhoneNumber)(number) || false;
      onChange(number, formattedNumber, dialCode, countryCode, isValid);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          countryOptions = _this$props.countryOptions,
          disable = _this$props.disable,
          disabled = _this$props.disabled,
          error = _this$props.error,
          fluid = _this$props.fluid,
          id = _this$props.id,
          label = _this$props.label,
          labelStyle = _this$props.labelStyle,
          required = _this$props.required,
          style = _this$props.style,
          value = _this$props.value;
      var isDisabled = disable || disabled;
      var containerClasses = (0, _classnames["default"])('ui', 'phone-input', className, {
        'phone-input--disabled': isDisabled,
        'phone-input--error': error,
        'phone-input--fluid': fluid
      });
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: containerClasses,
        id: id,
        style: style
      }, label ? /*#__PURE__*/_react["default"].createElement("label", {
        className: "label",
        htmlFor: id,
        style: labelStyle
      }, label, required && !value ? /*#__PURE__*/_react["default"].createElement("span", {
        className: "phone-input--required_indicator"
      }, "*") : null) : null, /*#__PURE__*/_react["default"].createElement(_max["default"] // eslint-disable-next-line react/jsx-props-no-spreading
      , _extends({}, this.props, {
        disabled: isDisabled,
        className: "",
        countryOptions: countryOptions,
        countrySelectComponent: _phoneInputCountryDropdown["default"],
        fluid: "",
        international: false,
        onChange: this.onChange,
        flags: _flags["default"],
        style: {}
      })), error && _lodash["default"].isString(error) ? /*#__PURE__*/_react["default"].createElement("p", {
        className: "input-error-message"
      }, error) : null);
    }
  }]);

  return PhoneInput;
}(_react["default"].PureComponent);

PhoneInput.propTypes = propTypes;
PhoneInput.defaultProps = defaultProps;
var _default = PhoneInput;
exports["default"] = _default;