"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _dropdown = _interopRequireDefault(require("../dropdown"));

var _phoneInputCountryDropdownItem = _interopRequireDefault(require("./phoneInputCountryDropdownItem"));

var _phoneInputCountryDropdownValue = _interopRequireDefault(require("./phoneInputCountryDropdownValue"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  /**
   * Deprecated prop. Please use `disabled` instead.
   */
  disable: _propTypes["default"].bool,

  /**
   * A PhoneInputCountryDropdown can be disabled.
   */
  disabled: _propTypes["default"].bool,
  options: _propTypes["default"].arrayOf(_propTypes["default"].shape({})),
  onChange: _propTypes["default"].func.isRequired,
  value: _propTypes["default"].string
};
var defaultProps = {
  disable: false,
  disabled: false,
  options: [],
  value: ''
};

var PhoneInputCountryDropdown = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(PhoneInputCountryDropdown, _React$PureComponent);

  var _super = _createSuper(PhoneInputCountryDropdown);

  function PhoneInputCountryDropdown(props) {
    var _this;

    _classCallCheck(this, PhoneInputCountryDropdown);

    _this = _super.call(this, props);
    _this.state = {
      selectedOption: _lodash["default"].find(props.options, function (o) {
        return !o.divider && o.value && o.value === props.value;
      })
    };
    _this.onChange = _this.onChange.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(PhoneInputCountryDropdown, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState) {
      var _prevState$selectedOp;

      var _this$props = this.props,
          onChange = _this$props.onChange,
          options = _this$props.options,
          value = _this$props.value;

      if (prevProps.value !== value && ((_prevState$selectedOp = prevState.selectedOption) === null || _prevState$selectedOp === void 0 ? void 0 : _prevState$selectedOp.value) !== value) {
        this.setState({
          selectedOption: _lodash["default"].find(options, function (o) {
            return !o.divider && o.value && o.value === value;
          })
        }, function () {
          onChange(value);
        });
      }
    }
  }, {
    key: "onChange",
    value: function onChange(selectedOption) {
      if (selectedOption) {
        var onChange = this.props.onChange;
        this.setState({
          selectedOption: selectedOption
        }, function () {
          onChange(selectedOption.value);
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          disable = _this$props2.disable,
          disabled = _this$props2.disabled,
          options = _this$props2.options;
      var selectedOption = this.state.selectedOption;
      return /*#__PURE__*/_react["default"].createElement(_dropdown["default"], {
        clearable: false,
        disable: disable || disabled,
        iconSize: 10,
        iconType: "caret-down",
        onChange: this.onChange,
        options: options,
        selection: true,
        selectionMenuContainerStyle: {
          width: 'auto'
        },
        selectionOptionComponent: _phoneInputCountryDropdownItem["default"],
        selectionValueComponent: function selectionValueComponent() {
          return (0, _phoneInputCountryDropdownValue["default"])(selectedOption);
        },
        value: selectedOption
      });
    }
  }]);

  return PhoneInputCountryDropdown;
}(_react["default"].PureComponent);

PhoneInputCountryDropdown.propTypes = propTypes;
PhoneInputCountryDropdown.defaultProps = defaultProps;
var _default = PhoneInputCountryDropdown;
exports["default"] = _default;