"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _divider = _interopRequireDefault(require("../../dataDisplay/divider"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  onFocus: _propTypes["default"].func.isRequired,
  onSelect: _propTypes["default"].func.isRequired,
  option: _propTypes["default"].shape({
    divider: _propTypes["default"].bool,
    icon: _propTypes["default"].node,
    label: _propTypes["default"].string,
    value: _propTypes["default"].string
  }).isRequired
};

var PhoneInputCountryDropdownItem = /*#__PURE__*/function (_React$Component) {
  _inherits(PhoneInputCountryDropdownItem, _React$Component);

  var _super = _createSuper(PhoneInputCountryDropdownItem);

  function PhoneInputCountryDropdownItem() {
    var _this;

    _classCallCheck(this, PhoneInputCountryDropdownItem);

    _this = _super.call(this);
    _this.onMouseDown = _this.onMouseDown.bind(_assertThisInitialized(_this));
    _this.onMouseEnter = _this.onMouseEnter.bind(_assertThisInitialized(_this));
    _this.onMouseMove = _this.onMouseMove.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(PhoneInputCountryDropdownItem, [{
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      var option = this.props.option;
      return option.value !== nextProps.option.value;
    }
  }, {
    key: "onMouseDown",
    value: function onMouseDown(event) {
      var _this$props = this.props,
          onSelect = _this$props.onSelect,
          option = _this$props.option;
      event.preventDefault();
      event.stopPropagation();
      onSelect(option, event);
    }
  }, {
    key: "onMouseEnter",
    value: function onMouseEnter(event) {
      var _this$props2 = this.props,
          onFocus = _this$props2.onFocus,
          option = _this$props2.option;
      onFocus(option, event);
    }
  }, {
    key: "onMouseMove",
    value: function onMouseMove(event) {
      var _this$props3 = this.props,
          onFocus = _this$props3.onFocus,
          option = _this$props3.option;
      onFocus(option, event);
    }
  }, {
    key: "render",
    value: function render() {
      var option = this.props.option;
      var isDivider = option && option.divider;

      if (isDivider) {
        return /*#__PURE__*/_react["default"].createElement(_divider["default"], null);
      }

      var FlagIcon = option.icon,
          title = option.label,
          countryCode = option.value;
      var containerClasses = (0, _classnames["default"])('Select-option');
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: containerClasses,
        onMouseDown: option.value && this.onMouseDown,
        onMouseEnter: option.value && this.onMouseEnter,
        onMouseMove: option.value && this.onMouseMove,
        role: "menuitem",
        style: {
          padding: '7px 11px'
        },
        title: title,
        tabIndex: -1
      }, /*#__PURE__*/_react["default"].createElement("div", {
        style: {
          alignItems: 'center',
          display: 'flex',
          justifyContent: 'flex-start'
        }
      }, /*#__PURE__*/_react["default"].createElement(FlagIcon, {
        value: countryCode
      }), /*#__PURE__*/_react["default"].createElement("span", {
        className: "country-name",
        style: {
          display: 'inline-block',
          flex: '0 1 auto',
          margin: '0 11px'
        }
      }, title), /*#__PURE__*/_react["default"].createElement("span", {
        className: "phone color-static",
        style: {
          display: 'inline-block',
          flex: '0 1 1px'
        }
      })));
    }
  }]);

  return PhoneInputCountryDropdownItem;
}(_react["default"].Component);

PhoneInputCountryDropdownItem.propTypes = propTypes;
var _default = PhoneInputCountryDropdownItem;
exports["default"] = _default;