"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = require("lodash");

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  checked: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].number]),
  className: _propTypes["default"].string,
  id: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
  index: _propTypes["default"].number,
  label: _propTypes["default"].string,
  name: _propTypes["default"].string,
  onClick: _propTypes["default"].func,
  onKeyDown: _propTypes["default"].func,
  style: _propTypes["default"].shape({}),
  tabIndex: _propTypes["default"].number,
  value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number, _propTypes["default"].bool])
};
var defaultProps = {
  checked: false,
  className: null,
  id: null,
  index: null,
  label: null,
  name: null,
  onClick: null,
  onKeyDown: null,
  style: null,
  tabIndex: -1,
  value: undefined
};

var RadioItem = /*#__PURE__*/function (_React$Component) {
  _inherits(RadioItem, _React$Component);

  var _super = _createSuper(RadioItem);

  function RadioItem() {
    var _this;

    _classCallCheck(this, RadioItem);

    _this = _super.call(this);
    _this.onClick = _this.onClick.bind(_assertThisInitialized(_this));
    _this.onKeyDown = _this.onKeyDown.bind(_assertThisInitialized(_this));
    _this.onMouseDown = _this.onMouseDown.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(RadioItem, [{
    key: "onClick",
    value: function onClick() {
      var _this$props = this.props,
          id = _this$props.id,
          index = _this$props.index,
          onClick = _this$props.onClick,
          customValue = _this$props.value;
      onClick(id || index, customValue);
    }
  }, {
    key: "onKeyDown",
    value: function onKeyDown(event) {
      var _this$props2 = this.props,
          id = _this$props2.id,
          index = _this$props2.index,
          onKeyDown = _this$props2.onKeyDown;

      if ((0, _lodash.isFunction)(onKeyDown)) {
        onKeyDown(event, id || index);
      }
    }
  }, {
    key: "onMouseDown",
    value: function onMouseDown(event) {
      event.preventDefault();
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          isChecked = _this$props3.checked,
          className = _this$props3.className,
          id = _this$props3.id,
          label = _this$props3.label,
          name = _this$props3.name,
          tabIndex = _this$props3.tabIndex;
      var rootClasses = (0, _classnames["default"])('radio-item', className, {
        'radio-item-is-checked': isChecked
      });
      return /*#__PURE__*/_react["default"].createElement("div", {
        "aria-checked": isChecked,
        className: rootClasses,
        onClick: this.onClick,
        onKeyDown: this.onKeyDown,
        onMouseDown: this.onMouseDown,
        role: "radio",
        tabIndex: tabIndex
      }, /*#__PURE__*/_react["default"].createElement("input", {
        checked: isChecked,
        className: "input",
        id: id,
        name: name,
        readOnly: true,
        type: "radio"
      }), /*#__PURE__*/_react["default"].createElement("label", {
        className: "label",
        htmlFor: id
      }, label));
    }
  }]);

  return RadioItem;
}(_react["default"].Component);

RadioItem.propTypes = propTypes;
RadioItem.defaultProps = defaultProps;
var _default = RadioItem;
exports["default"] = _default;