"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _icon = _interopRequireDefault(require("../../dataDisplay/icon"));

var _segmentedControlsItem = _interopRequireDefault(require("./segmentedControlsItem"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  className: _propTypes["default"].string,
  fluid: _propTypes["default"].bool,
  onClick: _propTypes["default"].func,
  selected: _propTypes["default"].number,
  style: _propTypes["default"].shape({})
};

var SegmentedControls = /*#__PURE__*/function (_React$Component) {
  _inherits(SegmentedControls, _React$Component);

  var _super = _createSuper(SegmentedControls);

  function SegmentedControls(props) {
    var _this;

    _classCallCheck(this, SegmentedControls);

    _this = _super.call(this, props);
    _this.state = {
      buttonWidth: null,
      selected: props.selected || 0
    };
    return _this;
  }

  _createClass(SegmentedControls, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      setTimeout(function () {
        _this2.findWidestButton();
      }, 150);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props.selected !== prevProps.selected) {
        this.setState({
          selected: this.props.selected
        });
      }
    }
  }, {
    key: "onButtonClick",
    value: function onButtonClick(index, label, onChildClick, event) {
      if (!_lodash["default"].isUndefined(this.props.onClick)) {
        this.props.onClick(index, label);
      } else {
        if (!_lodash["default"].isUndefined(onChildClick)) {
          onChildClick(index, label);
        }

        this.setState({
          selected: index
        });
      }

      event.preventDefault();
    }
  }, {
    key: "findWidestButton",
    value: function findWidestButton() {
      var buttons = _reactDom["default"].findDOMNode(this.refs.buttonsContainer).querySelectorAll('button .inner-container');

      var newButtonWidth = 0;

      _lodash["default"].forEach(buttons, function (button) {
        if (button.offsetWidth > newButtonWidth) {
          newButtonWidth = button.offsetWidth;
        }
      });

      if (newButtonWidth > 0) {
        this.setState({
          buttonWidth: newButtonWidth
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          fluid = _this$props.fluid,
          style = _this$props.style;
      var containerClasses = (0, _classnames["default"])('ui', 'segmented-controls', className, {
        'segmented-controls-fluid': fluid
      });
      var convertChildren = _lodash["default"].isArray(children) ? children : [children];

      var buttons = _lodash["default"].map(convertChildren, function (child, index) {
        var _child$props = child.props,
            icon = _child$props.icon,
            label = _child$props.label,
            onClick = _child$props.onClick;
        var isActiveClass = (0, _classnames["default"])('segmented-controls-button', {
          'segmented-controls-button-icon': icon,
          'segmented-controls-button-is-active': _this3.state.selected === index
        });
        return /*#__PURE__*/_react["default"].createElement("button", {
          className: isActiveClass,
          key: 'segmented-controls-buttons-' + index,
          onClick: _this3.onButtonClick.bind(_this3, index, label, onClick)
        }, /*#__PURE__*/_react["default"].createElement("span", {
          className: "inner-container",
          style: {
            alignItems: 'center',
            display: 'inline-flex',
            justifyContent: 'center',
            width: _this3.state.buttonWidth
          }
        }, !_lodash["default"].isUndefined(label) ? /*#__PURE__*/_react["default"].createElement("span", {
          className: "copy"
        }, label) : null, !_lodash["default"].isUndefined(icon) ? /*#__PURE__*/_react["default"].createElement(_icon["default"], {
          align: "right",
          compact: _lodash["default"].isUndefined(label),
          inverse: true,
          type: icon
        }) : null));
      });

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: containerClasses,
        style: style
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "segmented-controls-buttons",
        ref: "buttonsContainer"
      }, buttons));
    }
  }]);

  return SegmentedControls;
}(_react["default"].Component);

;
SegmentedControls.Item = _segmentedControlsItem["default"];
SegmentedControls.propTypes = propTypes;
var _default = SegmentedControls;
exports["default"] = _default;