"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = require("lodash");

var _autosize = _interopRequireDefault(require("autosize"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  autoFocus: _propTypes["default"].bool,
  autoHeight: _propTypes["default"].bool,
  className: _propTypes["default"].string,
  columns: _propTypes["default"].number,

  /**
   * Deprecated prop. Please use `disabled` instead.
   */
  disable: _propTypes["default"].bool,

  /**
   * A TextArea can be disabled.
   */
  disabled: _propTypes["default"].bool,
  error: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].string]),
  fluid: _propTypes["default"].bool,

  /**
   * Forwarded Ref
   */
  forwardedRef: _propTypes["default"].oneOfType([// Either a function
  _propTypes["default"].func, // Or the instance of a DOM native element (see the note about SSR)
  _propTypes["default"].shape({
    current: _propTypes["default"].instanceOf(Element)
  })]),
  id: _propTypes["default"].string,
  inverse: _propTypes["default"].bool,
  label: _propTypes["default"].string,
  labelStyle: _propTypes["default"].shape({}),
  maxHeight: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
  maxLength: _propTypes["default"].number,
  minHeight: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
  minLength: _propTypes["default"].number,
  name: _propTypes["default"].string,
  onAutoHeightResized: _propTypes["default"].func,
  onBlur: _propTypes["default"].func,
  onChange: _propTypes["default"].func,
  onClick: _propTypes["default"].func,
  onFocus: _propTypes["default"].func,
  onKeyDown: _propTypes["default"].func,
  placeholder: _propTypes["default"].string,
  required: _propTypes["default"].bool,
  resize: _propTypes["default"].bool,
  rows: _propTypes["default"].number,
  style: _propTypes["default"].shape({}),
  value: _propTypes["default"].string
};
var defaultProps = {
  autoFocus: false,
  autoHeight: false,
  className: null,
  columns: null,
  disable: false,
  disabled: false,
  error: null,
  fluid: false,
  forwardedRef: undefined,
  id: null,
  inverse: false,
  label: null,
  labelStyle: null,
  maxHeight: null,
  maxLength: null,
  minHeight: 88,
  minLength: null,
  name: null,
  onAutoHeightResized: null,
  onBlur: null,
  onChange: null,
  onClick: null,
  onFocus: null,
  onKeyDown: null,
  placeholder: null,
  required: false,
  resize: false,
  rows: null,
  style: null,
  value: undefined
};

var TextArea = /*#__PURE__*/function (_React$Component) {
  _inherits(TextArea, _React$Component);

  var _super = _createSuper(TextArea);

  function TextArea(props) {
    var _props$forwardedRef;

    var _this;

    _classCallCheck(this, TextArea);

    _this = _super.call(this, props);
    _this.state = {
      isFocused: false
    };
    _this.onAutoHeightResized = _this.onAutoHeightResized.bind(_assertThisInitialized(_this));
    _this.textArea = (_props$forwardedRef = props.forwardedRef) !== null && _props$forwardedRef !== void 0 ? _props$forwardedRef : /*#__PURE__*/_react["default"].createRef();
    return _this;
  }

  _createClass(TextArea, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var _this$props = this.props,
          autoFocus = _this$props.autoFocus,
          autoHeight = _this$props.autoHeight,
          onAutoHeightResized = _this$props.onAutoHeightResized,
          value = _this$props.value;

      if (autoHeight && this.textArea.current) {
        var textArea = this.textArea.current;
        var autoResize = setInterval(function () {
          if (value || (0, _lodash.get)(_this2, 'textArea.value')) {
            clearInterval(autoResize);
            (0, _autosize["default"])(textArea);

            if ((0, _lodash.isFunction)(onAutoHeightResized)) {
              textArea.addEventListener('autosize:resized', _this2.onAutoHeightResized);
            }
          }
        }, 150);
      }

      if (autoFocus && this.textArea.current) {
        this.textArea.current.focus();
        this.setState({
          isFocused: true
        });
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this$props2 = this.props,
          autoHeight = _this$props2.autoHeight,
          onAutoHeightResized = _this$props2.onAutoHeightResized;

      if (autoHeight && (0, _lodash.isFunction)(onAutoHeightResized)) {
        var textAreaElement = this.textArea.current;
        textAreaElement.removeEventListener('autosize:resized', this.onAutoHeightResized);
      }
    }
  }, {
    key: "onAutoHeightResized",
    value: function onAutoHeightResized() {
      var onAutoHeightResized = this.props.onAutoHeightResized;

      if ((0, _lodash.isFunction)(onAutoHeightResized)) {
        onAutoHeightResized();
      }
    }
  }, {
    key: "onBlur",
    value: function onBlur(event) {
      var onBlur = this.props.onBlur;

      if ((0, _lodash.isFunction)(onBlur)) {
        onBlur(event.target.value);
      }

      this.setState({
        isFocused: false
      });
    }
  }, {
    key: "onChange",
    value: function onChange(event) {
      var onChange = this.props.onChange;
      var valueEvent = event.target.value;

      if ((0, _lodash.isFunction)(onChange)) {
        onChange(valueEvent);
      } else {
        this.textArea.current.value = valueEvent;
      }
    }
  }, {
    key: "onClick",
    value: function onClick(event) {
      var onClick = this.props.onClick;

      if ((0, _lodash.isFunction)(onClick)) {
        onClick(event.target.value);
      }
    }
  }, {
    key: "onFocus",
    value: function onFocus(event) {
      var onFocus = this.props.onFocus;
      var isFocused = this.state.isFocused;

      if ((0, _lodash.isFunction)(onFocus)) {
        onFocus(event);
      }

      this.setState({
        isFocused: !isFocused
      });
    }
  }, {
    key: "onKeyDown",
    value: function onKeyDown(event) {
      var onKeyDown = this.props.onKeyDown;

      if ((0, _lodash.isFunction)(onKeyDown)) {
        onKeyDown(event);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          autoHeight = _this$props3.autoHeight,
          className = _this$props3.className,
          columns = _this$props3.columns,
          disable = _this$props3.disable,
          disabled = _this$props3.disabled,
          error = _this$props3.error,
          fluid = _this$props3.fluid,
          id = _this$props3.id,
          inverse = _this$props3.inverse,
          label = _this$props3.label,
          labelStyle = _this$props3.labelStyle,
          maxHeight = _this$props3.maxHeight,
          maxLength = _this$props3.maxLength,
          minHeight = _this$props3.minHeight,
          minLength = _this$props3.minLength,
          name = _this$props3.name,
          placeholder = _this$props3.placeholder,
          required = _this$props3.required,
          resize = _this$props3.resize,
          rows = _this$props3.rows,
          style = _this$props3.style,
          value = _this$props3.value;
      var isFocused = this.state.isFocused;
      var isDisabled = disable || disabled;
      var rootClasses = (0, _classnames["default"])('ui', 'text-area', className, {
        'text-area-auto-height': autoHeight,
        'text-area-disabled': isDisabled,
        'text-area-error': error,
        'text-area-fluid': fluid,
        'text-area-has-value': value,
        'text-area-focused': isFocused,
        'text-area-inverse': inverse
      });
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: rootClasses,
        style: style
      }, label && /*#__PURE__*/_react["default"].createElement("label", {
        className: "label",
        htmlFor: id,
        style: labelStyle
      }, label, required && !value ? /*#__PURE__*/_react["default"].createElement("span", {
        className: "text-area-required-indicator"
      }, "*") : null), /*#__PURE__*/_react["default"].createElement("div", {
        className: "text-area-container"
      }, /*#__PURE__*/_react["default"].createElement("textarea", {
        disabled: isDisabled,
        cols: columns,
        id: id,
        name: name,
        maxLength: maxLength,
        minLength: minLength,
        onBlur: this.onBlur.bind(this),
        onChange: this.onChange.bind(this),
        onClick: this.onClick.bind(this),
        onFocus: this.onFocus.bind(this),
        onKeyDown: this.onKeyDown.bind(this),
        placeholder: placeholder,
        ref: this.textArea,
        required: required,
        rows: rows,
        style: {
          maxHeight: maxHeight,
          minHeight: minHeight,
          resize: !(0, _lodash.isUndefined)(resize) && !resize ? 'none' : 'auto'
        },
        value: value
      }), error && (0, _lodash.isString)(error) && /*#__PURE__*/_react["default"].createElement("p", {
        className: "text-area-error-message"
      }, error)));
    }
  }]);

  return TextArea;
}(_react["default"].Component);

TextArea.propTypes = propTypes;
TextArea.defaultProps = defaultProps;

var TextAreaWrapper = /*#__PURE__*/_react["default"].forwardRef(function (props, ref) {
  return (
    /*#__PURE__*/
    // eslint-disable-next-line react/jsx-props-no-spreading
    _react["default"].createElement(TextArea, _extends({}, props, {
      forwardedRef: ref
    }))
  );
});

var wrapperPropTypes = _objectSpread({}, propTypes);

delete wrapperPropTypes.forwardedRef;

var wrapperDefaultProps = _objectSpread({}, defaultProps);

delete wrapperDefaultProps.forwardedRef;
TextAreaWrapper.displayName = 'TextArea';
TextAreaWrapper.propTypes = wrapperPropTypes;
TextAreaWrapper.defaultProps = wrapperDefaultProps;
var _default = TextAreaWrapper;
exports["default"] = _default;