"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _makeStyles = _interopRequireDefault(require("../../styles/makeStyles"));

var _constants = require("../../global/constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = {
  children: _propTypes["default"].node,
  classes: _propTypes["default"].shape({
    root: _propTypes["default"].string
  }),
  className: _propTypes["default"].string,
  id: _propTypes["default"].string,
  moduleType: _propTypes["default"].oneOf(['drawer', 'page'])
};
var defaultProps = {
  children: null,
  classes: null,
  className: null,
  id: null,
  moduleType: null
};
var useStyles = (0, _makeStyles["default"])(function (theme) {
  var _$isPage;

  var breakpoints = theme.breakpoints;
  return {
    isDrawer: {},
    isPage: {},
    root: {
      '&$isPage': (_$isPage = {
        marginTop: 50
      }, _defineProperty(_$isPage, breakpoints.down('md'), _defineProperty({
        transition: 'margin-top 333ms ease-in-out'
      }, "&.".concat(_constants.BEM_ACTION_BAR_SEARCH_VISIBLE), {
        marginTop: 105
      })), _defineProperty(_$isPage, breakpoints.up('md'), {
        marginTop: 70
      }), _$isPage)
    }
  };
});

function Container(props) {
  var _ClassNames;

  var children = props.children,
      className = props.className,
      id = props.id,
      moduleType = props.moduleType;
  var classes = useStyles(props);
  var rootClasses = (0, _classnames["default"])(_constants.UI_CLASS_NAME, _constants.BEM_CONTAINER, classes.root, className, (_ClassNames = {}, _defineProperty(_ClassNames, classes.isDrawer, moduleType === 'drawer'), _defineProperty(_ClassNames, classes.isPage, !moduleType || moduleType === 'page'), _ClassNames));
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: rootClasses,
    id: id
  }, children);
}

Container.propTypes = propTypes;
Container.defaultProps = defaultProps;
var _default = Container;
exports["default"] = _default;