"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var propTypes = {
  as: _propTypes["default"].oneOf(['div', 'section']),
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  maxWidth: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]),
  style: _propTypes["default"].shape({})
};
var defaultProps = {
  as: null,
  children: null,
  className: null,
  maxWidth: null,
  style: null
};

function ContainerDeprecatedContent(props) {
  var as = props.as,
      children = props.children,
      className = props.className,
      maxWidth = props.maxWidth,
      style = props.style;
  var rootClasses = (0, _classnames["default"])('container-content', className, {
    'container-content-max-width-laptop': maxWidth === 'laptop'
  });

  var ElementType = _utils["default"].getElementType(as || 'section', props);

  var rootStyle = _lodash["default"].merge(style, {
    maxWidth: _lodash["default"].isNumber(maxWidth) ? maxWidth : null
  });

  return /*#__PURE__*/_react["default"].createElement(ElementType, {
    className: rootClasses,
    style: rootStyle
  }, children);
}

ContainerDeprecatedContent.propTypes = propTypes;
ContainerDeprecatedContent.defaultProps = defaultProps;
var _default = ContainerDeprecatedContent;
exports["default"] = _default;