"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _reactTransitionGroup = require("react-transition-group");

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _constants = require("../../global/constants");

var _activityIndicator = _interopRequireDefault(require("../../feedback/activityIndicator"));

var _makeStyles = _interopRequireDefault(require("../../styles/makeStyles"));

var _pageActionBar = _interopRequireDefault(require("./pageActionBar"));

var _pageContainer = _interopRequireDefault(require("./pageContainer"));

var _pageContent = _interopRequireDefault(require("./pageContent"));

var _pageDataCards = _interopRequireDefault(require("./pageDataCards"));

var _pageDataGrid = _interopRequireDefault(require("./pageDataGrid"));

var _pageDataGroups = _interopRequireDefault(require("./pageDataGroups"));

var _pageDelayChildren = _interopRequireDefault(require("./pageDelayChildren"));

var _pageDeprecatedFiltersDrawer = _interopRequireDefault(require("./pageDeprecatedFiltersDrawer"));

var _pageDetailsWindow = _interopRequireDefault(require("./pageDetailsWindow"));

var _pageFiltersDrawer = _interopRequireDefault(require("./pageFiltersDrawer"));

var _pageFiltersRail = _interopRequireDefault(require("./pageFiltersRail"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = {
  // eslint-disable-next-line react/no-unused-prop-types
  backgroundColor: _propTypes["default"].oneOf(['grey', 'primary', 'secondary', 'white']),
  children: _propTypes["default"].node.isRequired,
  className: _propTypes["default"].string,
  classes: _propTypes["default"].shape({
    root: _propTypes["default"].string
  }),

  /**
   * Used for DOM testing. https://testing-library.com/docs/queries/bytestid/
   */
  dataTestId: _propTypes["default"].string,
  id: _propTypes["default"].string,
  isDataFetching: _propTypes["default"].bool,
  style: _propTypes["default"].shape({})
};
var defaultProps = {
  backgroundColor: 'grey',
  className: null,
  classes: null,
  dataTestId: "".concat(_constants.UI_CLASS_NAME, "-page"),
  id: null,
  isDataFetching: false,
  style: null
};
var ACTIVITY_INDICATOR_DURATION = 200;
var useStyles = (0, _makeStyles["default"])(function (theme) {
  var _root;

  var breakpoints = theme.breakpoints,
      gutters = theme.gutters,
      height = theme.height,
      palette = theme.palette,
      width = theme.width;
  return {
    root: (_root = {
      backgroundColor: function backgroundColor(props) {
        var backgroundColor = props.backgroundColor;

        if (backgroundColor === 'secondary' || backgroundColor === 'grey') {
          return palette.background.secondary;
        }

        return palette.background.primary;
      },
      minHeight: "calc(100vh - ".concat(height.appHeader.sm, "px)"),
      padding: "0 ".concat(gutters.page.sm, "px"),
      position: 'relative',
      width: '100%',
      '&.ui.page-has_action_bar': {
        minHeight: 'calc(100vh - 105px)'
      },
      '& .page--activity_indicator': {
        animationDuration: '200ms',
        animationFillMode: 'forwards',
        animationTimingFunction: 'ease-in-out',
        left: '50%',
        marginTop: "calc(".concat(height.appHeader.sm, "px / 2)"),
        position: 'fixed',
        top: '50%',
        '&-enter': {
          animationName: '$pageActivityIndicatorEnter'
        },
        '&-leave': {
          animationName: '$pageActivityIndicatorLeave'
        }
      }
    }, _defineProperty(_root, breakpoints.up(496), {
      padding: "0 ".concat(gutters.page[496], "px")
    }), _defineProperty(_root, breakpoints.up('md'), {
      minHeight: "calc(100vh - ".concat(height.appHeader.md, "px)"),
      '&.ui.page-has_action_bar': {
        minHeight: 'calc(100vh - 140px)'
      },
      '& .page--activity_indicator': {
        marginLeft: "calc(".concat(width.navigation.md.expanded - 70, "px / 2)"),
        marginTop: 0
      }
    }), _root),
    '@keyframes pageActivityIndicatorEnter': {
      '0%': {
        opacity: 0
      },
      '100%': {
        opacity: 1
      }
    },
    '@keyframes pageActivityIndicatorLeave': {
      '0%': {
        opacity: 1
      },
      '100%': {
        opacity: 0
      }
    }
  };
}); // eslint-disable-next-line prefer-arrow-callback

var Page = /*#__PURE__*/_react["default"].forwardRef(function Page(props, ref) {
  var children = props.children,
      className = props.className,
      dataTestId = props.dataTestId,
      id = props.id,
      isDataFetching = props.isDataFetching,
      style = props.style;

  var _useState = (0, _react.useState)(isDataFetching),
      _useState2 = _slicedToArray(_useState, 2),
      hasActivityIndicator = _useState2[0],
      setHasActivityIndicator = _useState2[1];

  var classes = useStyles(props);
  (0, _react.useEffect)(function () {
    setHasActivityIndicator(isDataFetching);
  }, [isDataFetching]);
  var rootClasses = (0, _classnames["default"])('ui', 'page', classes.root, className);
  return /*#__PURE__*/_react["default"].createElement("main", {
    className: rootClasses,
    id: id,
    ref: ref,
    style: style,
    "data-testid": dataTestId
  }, /*#__PURE__*/_react["default"].createElement(_reactTransitionGroup.CSSTransitionGroup, {
    transitionEnterTimeout: ACTIVITY_INDICATOR_DURATION,
    transitionLeaveTimeout: ACTIVITY_INDICATOR_DURATION,
    transitionName: {
      enter: 'page--activity_indicator-enter',
      leave: 'page--activity_indicator-leave'
    }
  }, hasActivityIndicator && isDataFetching && /*#__PURE__*/_react["default"].createElement(_activityIndicator["default"], {
    className: "page--activity_indicator",
    style: {
      transform: 'translate(-50%, -50%)'
    }
  })), hasActivityIndicator && /*#__PURE__*/_react["default"].createElement(_pageDelayChildren["default"], {
    isDataFetching: isDataFetching
  }, children), !hasActivityIndicator && !isDataFetching && children);
});

Page.ActionBar = _pageActionBar["default"];
Page.Container = _pageContainer["default"];
Page.Content = _pageContent["default"];
Page.DataCards = _pageDataCards["default"];
Page.DataGrid = _pageDataGrid["default"];
Page.DataGroups = _pageDataGroups["default"];
Page.DeprecatedFiltersDrawer = _pageDeprecatedFiltersDrawer["default"]; // TODO: Deprecated. Remove in a major release.

Page.Details = _pageDetailsWindow["default"]; // TODO: Deprecated. Alias name for Page.DetailsWindow. Remove in a major release.

Page.DetailsWindow = _pageDetailsWindow["default"];
Page.FiltersDrawer = _pageFiltersDrawer["default"]; // TODO: Deprecated. Remove in a major release.

Page.FiltersRail = _pageFiltersRail["default"];
Page.Grid = _pageDataCards["default"]; // TODO: Deprecated. Alias name for Page.DataCard. Remove in a major release.

Page.Table = _pageDataGrid["default"]; // TODO: Deprecated. Alias name for Page.DataGrid. Remove in a major release.

Page.propTypes = propTypes;
Page.defaultProps = defaultProps;
var _default = Page;
exports["default"] = _default;