"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _constants = require("../../global/constants");

var _actionBar = _interopRequireDefault(require("../../surfaces/actionBar"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var propTypes = {
  children: _propTypes["default"].node,
  classes: _propTypes["default"].shape({
    root: _propTypes["default"].string
  }),
  className: _propTypes["default"].string,
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({})),

  /**
   * Used for DOM testing. https://testing-library.com/docs/queries/bytestid/
   */
  dataTestId: _propTypes["default"].string,
  id: _propTypes["default"].string,
  style: _propTypes["default"].shape({})
};
var defaultProps = {
  children: undefined,
  classes: null,
  className: undefined,
  columns: undefined,
  dataTestId: "".concat(_constants.UI_CLASS_NAME, "-page_action_bar"),
  id: undefined,
  style: {}
};
var HAS_PAGE_ACTION_BAR_CLASS_NAME = 'page-has_action_bar';
var HAS_PAGE_CONTAINER_ACTION_BAR_MOBILE_SEARCH_VISIBLE_CLASS_NAME = 'page--container-has_action_bar_mobile_search_visible';

function PageActionBar(props) {
  (0, _react.useEffect)(function () {
    var PageNode = document.querySelector('.ui.page');

    if (PageNode) {
      PageNode.classList.add(HAS_PAGE_ACTION_BAR_CLASS_NAME);
    }

    return function () {
      if (PageNode) {
        PageNode.classList.remove(HAS_PAGE_ACTION_BAR_CLASS_NAME);
      }
    };
  }, []);

  var toggleSmSearchVisibleClassName = function toggleSmSearchVisibleClassName(isVisible) {
    var containerClassName = ".ui.".concat(_constants.BEM_CONTAINER);
    var containerNode = document.querySelector(containerClassName);

    if (containerNode) {
      if (isVisible) {
        document.querySelector(containerClassName).classList.add(HAS_PAGE_CONTAINER_ACTION_BAR_MOBILE_SEARCH_VISIBLE_CLASS_NAME);
      } else {
        document.querySelector(containerClassName).classList.remove(HAS_PAGE_CONTAINER_ACTION_BAR_MOBILE_SEARCH_VISIBLE_CLASS_NAME);
      }
    }
  };

  var children = props.children,
      classes = props.classes,
      className = props.className,
      columns = props.columns,
      dataTestId = props.dataTestId,
      id = props.id,
      style = props.style;
  return /*#__PURE__*/_react["default"].createElement(_actionBar["default"], {
    classes: classes,
    className: className,
    columns: columns,
    "data-testid": dataTestId,
    id: id,
    moduleType: "page",
    style: style,
    toggleSmSearchVisibleClassName: toggleSmSearchVisibleClassName
  }, children);
}

PageActionBar.propTypes = propTypes;
PageActionBar.defaultProps = defaultProps;
var _default = PageActionBar;
exports["default"] = _default;