"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _reactResponsive = _interopRequireDefault(require("react-responsive"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _button = _interopRequireDefault(require("../../inputs/button"));

var _drawer = _interopRequireDefault(require("../../surfaces/drawer"));

var _dropdown = _interopRequireDefault(require("../../inputs/dropdown/dropdown"));

var _header = _interopRequireDefault(require("../../dataDisplay/header"));

var _icon = _interopRequireDefault(require("../../dataDisplay/icon"));

var _label = _interopRequireDefault(require("../../dataDisplay/label"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var MultiSelectLabel = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(MultiSelectLabel, _React$PureComponent);

  var _super = _createSuper(MultiSelectLabel);

  function MultiSelectLabel() {
    var _this;

    _classCallCheck(this, MultiSelectLabel);

    _this = _super.call(this);
    _this.onClearClick = _this.onClearClick.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(MultiSelectLabel, [{
    key: "onClearClick",
    value: function onClearClick() {
      var _this$props = this.props,
          onItemChange = _this$props.onItemChange,
          selectedOption = _this$props.selectedOption,
          value = _this$props.value;

      var filteredOptions = _lodash["default"].differenceBy(value, [selectedOption], 'value');

      onItemChange(filteredOptions);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          color = _this$props2.color,
          label = _this$props2.label;
      return /*#__PURE__*/_react["default"].createElement(_label["default"], {
        color: color || 'highlight',
        onClearClick: this.onClearClick,
        style: {
          marginRight: '5px',
          marginTop: '11px'
        }
      }, label);
    }
  }]);

  return MultiSelectLabel;
}(_react["default"].PureComponent);

MultiSelectLabel.propTypes = {
  color: _propTypes["default"].string,
  label: _propTypes["default"].string.isRequired,
  onItemChange: _propTypes["default"].func.isRequired,
  selectedOption: _propTypes["default"].shape({}).isRequired,
  value: _propTypes["default"].array.isRequired
};

var NestedTogglesLabel = /*#__PURE__*/function (_React$PureComponent2) {
  _inherits(NestedTogglesLabel, _React$PureComponent2);

  var _super2 = _createSuper(NestedTogglesLabel);

  function NestedTogglesLabel() {
    var _this2;

    _classCallCheck(this, NestedTogglesLabel);

    _this2 = _super2.call(this);
    _this2.onClick = _this2.onClick.bind(_assertThisInitialized(_this2));
    return _this2;
  }

  _createClass(NestedTogglesLabel, [{
    key: "onClick",
    value: function onClick() {
      var _this$props3 = this.props,
          nestedTogglesData = _this$props3.nestedTogglesData,
          onClick = _this$props3.onClick;
      onClick(nestedTogglesData);
    }
  }, {
    key: "render",
    value: function render() {
      var label = this.props.nestedTogglesData.label;
      var containerClasses = (0, _classnames["default"])('page_deprecated_filters_drawer--nested_toggles_label');
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: containerClasses,
        onClick: this.onClick
      }, /*#__PURE__*/_react["default"].createElement("span", null, label), /*#__PURE__*/_react["default"].createElement(_icon["default"], {
        compact: true,
        type: "chevron-right"
      }));
    }
  }]);

  return NestedTogglesLabel;
}(_react["default"].PureComponent);

NestedTogglesLabel.propTypes = {
  nestedTogglesData: _propTypes["default"].shape({}).isRequired,
  onClick: _propTypes["default"].func.isRequired
};

var NestedTogglesWingOptionLabel = /*#__PURE__*/function (_React$PureComponent3) {
  _inherits(NestedTogglesWingOptionLabel, _React$PureComponent3);

  var _super3 = _createSuper(NestedTogglesWingOptionLabel);

  function NestedTogglesWingOptionLabel() {
    var _this3;

    _classCallCheck(this, NestedTogglesWingOptionLabel);

    _this3 = _super3.call(this);
    _this3.onClick = _this3.onClick.bind(_assertThisInitialized(_this3));
    return _this3;
  }

  _createClass(NestedTogglesWingOptionLabel, [{
    key: "onClick",
    value: function onClick() {
      var _this$props4 = this.props,
          onClick = _this$props4.onClick,
          option = _this$props4.option;
      onClick(option);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props5 = this.props,
          isSelected = _this$props5.isSelected,
          label = _this$props5.option.label;
      var containerClasses = (0, _classnames["default"])('page_deprecated__wing--option', {
        'page_deprecated_filters_drawer_wing--option-selected': isSelected
      });
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: containerClasses,
        onClick: this.onClick
      }, /*#__PURE__*/_react["default"].createElement("span", null, label), isSelected && /*#__PURE__*/_react["default"].createElement(_icon["default"], {
        compact: true,
        inverse: true,
        type: "check"
      }));
    }
  }]);

  return NestedTogglesWingOptionLabel;
}(_react["default"].PureComponent);

NestedTogglesWingOptionLabel.propTypes = {
  isSelected: _propTypes["default"].bool,
  onClick: _propTypes["default"].func.isRequired,
  option: _propTypes["default"].shape({}).isRequired
};

var NestedTogglesValueLabel = /*#__PURE__*/function (_React$PureComponent4) {
  _inherits(NestedTogglesValueLabel, _React$PureComponent4);

  var _super4 = _createSuper(NestedTogglesValueLabel);

  function NestedTogglesValueLabel() {
    var _this4;

    _classCallCheck(this, NestedTogglesValueLabel);

    _this4 = _super4.call(this);
    _this4.onClick = _this4.onClick.bind(_assertThisInitialized(_this4));
    return _this4;
  }

  _createClass(NestedTogglesValueLabel, [{
    key: "onClick",
    value: function onClick() {
      var _this$props6 = this.props,
          nestedTogglesData = _this$props6.nestedTogglesData,
          onClick = _this$props6.onClick,
          option = _this$props6.option;
      onClick(nestedTogglesData, option);
    }
  }, {
    key: "render",
    value: function render() {
      var label = this.props.option.label;
      var containerClasses = (0, _classnames["default"])('page_deprecated_filters_drawer--nested_toggles_value_label');
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: containerClasses
      }, /*#__PURE__*/_react["default"].createElement("span", null, label), /*#__PURE__*/_react["default"].createElement(_icon["default"], {
        onClick: this.onClick,
        size: "xsmall",
        type: "times"
      }));
    }
  }]);

  return NestedTogglesValueLabel;
}(_react["default"].PureComponent);

NestedTogglesValueLabel.propTypes = {
  nestedTogglesData: _propTypes["default"].shape({}).isRequired,
  onClick: _propTypes["default"].func.isRequired,
  option: _propTypes["default"].shape({}).isRequired
};

var PageFiltersDrawer = /*#__PURE__*/function (_React$Component) {
  _inherits(PageFiltersDrawer, _React$Component);

  var _super5 = _createSuper(PageFiltersDrawer);

  function PageFiltersDrawer() {
    var _this5;

    _classCallCheck(this, PageFiltersDrawer);

    _this5 = _super5.call(this);
    _this5.state = {
      nestedTogglesData: {} // This object is only to be populated when props.rows.items.nestedToggles is true and a label onClick event handler is triggered.

    };
    _this5.onApplyClick = _this5.onApplyClick.bind(_assertThisInitialized(_this5));
    _this5.onClearClick = _this5.onClearClick.bind(_assertThisInitialized(_this5));
    _this5.onMultiSelectLabelClearClick = _this5.onMultiSelectLabelClearClick.bind(_assertThisInitialized(_this5));
    _this5.onMultiSelectChange = _this5.onMultiSelectChange.bind(_assertThisInitialized(_this5));
    _this5.onNestedTogglesCloseWingClick = _this5.onNestedTogglesCloseWingClick.bind(_assertThisInitialized(_this5));
    _this5.onNestedTogglesLabelClick = _this5.onNestedTogglesLabelClick.bind(_assertThisInitialized(_this5));
    _this5.onNestedTogglesWingOptionLabelClick = _this5.onNestedTogglesWingOptionLabelClick.bind(_assertThisInitialized(_this5));
    _this5.onNestedTogglesValueLabelClick = _this5.onNestedTogglesValueLabelClick.bind(_assertThisInitialized(_this5));
    return _this5;
  }

  _createClass(PageFiltersDrawer, [{
    key: "onApplyClick",
    value: function onApplyClick() {
      var onApply = this.props.onApply;
      onApply();
    }
  }, {
    key: "onClearClick",
    value: function onClearClick() {
      var onClear = this.props.onClear;
      onClear();
    }
  }, {
    key: "onMultiSelectLabelClearClick",
    value: function onMultiSelectLabelClearClick(onItemChange, value, selectedOption) {
      var filteredOptions = _lodash["default"].differenceBy(value, [selectedOption], 'value');

      onItemChange(filteredOptions);
    }
  }, {
    key: "onMultiSelectChange",
    value: function onMultiSelectChange(onItemChange, value, selectedOption) {
      var filteredOptions = _lodash["default"].union(value, [selectedOption]);

      onItemChange(filteredOptions);
    }
  }, {
    key: "onNestedTogglesCloseWingClick",
    value: function onNestedTogglesCloseWingClick() {
      var nestedTogglesData = this.state.nestedTogglesData;
      this.setState({
        nestedTogglesData: {}
      }, function () {
        nestedTogglesData.onChange(nestedTogglesData.value);
      });
    }
  }, {
    key: "onNestedTogglesLabelClick",
    value: function onNestedTogglesLabelClick(nestedTogglesData) {
      this.setState({
        nestedTogglesData: _lodash["default"].cloneDeep(nestedTogglesData)
      });
    }
  }, {
    key: "onNestedTogglesValueLabelClick",
    value: function onNestedTogglesValueLabelClick(nestedTogglesData, selectedOption) {
      var selectedOptions = _lodash["default"].filter(nestedTogglesData.value, function (d) {
        return d.value !== selectedOption.value;
      });

      nestedTogglesData.onChange(selectedOptions);
    }
  }, {
    key: "onNestedTogglesWingOptionLabelClick",
    value: function onNestedTogglesWingOptionLabelClick(selectedOption) {
      var nestedTogglesData = this.state.nestedTogglesData;
      var selectedOptions;

      if (_lodash["default"].some(nestedTogglesData.value, selectedOption)) {
        // Subtract
        selectedOptions = _lodash["default"].filter(nestedTogglesData.value, function (d) {
          return d.value !== selectedOption.value;
        });
      } else {
        // Add
        selectedOptions = _lodash["default"].sortBy([].concat(_toConsumableArray(nestedTogglesData.value), [selectedOption]), ['value']);
      }

      var newNestedTogglesData = _lodash["default"].mapValues(nestedTogglesData, function (d, key) {
        if (key === 'value') {
          d = selectedOptions;
        }

        return d;
      });

      this.setState({
        nestedTogglesData: _lodash["default"].cloneDeep(newNestedTogglesData)
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this6 = this;

      var _this$props7 = this.props,
          children = _this$props7.children,
          className = _this$props7.className,
          isDirty = _this$props7.isDirty,
          isFiltering = _this$props7.isFiltering,
          isOpen = _this$props7.isOpen,
          onClose = _this$props7.onClose,
          rows = _this$props7.rows,
          style = _this$props7.style;
      var nestedTogglesData = this.state.nestedTogglesData;
      var containerClasses = (0, _classnames["default"])('ui', 'page--deprecated_filters_drawer', className);
      var canClear = isFiltering || isDirty;
      var clearFiltersClasses = (0, _classnames["default"])('clear-filters', 'font-size-xsmall', 'font-weight-semibold');

      var isNestedTogglesOptionsEmpty = _lodash["default"].isEmpty(nestedTogglesData);

      var rowKeyNum = 1;
      var itemKeyNum = 1;
      var multiSelectLabelKeyNum = 1;
      var nestedTogglesValueLabelKeyNum = 1;
      var nestedTogglesOptionLabelKeyNum = 1;
      return /*#__PURE__*/_react["default"].createElement(_reactResponsive["default"], {
        maxWidth: 767
      }, /*#__PURE__*/_react["default"].createElement(_drawer["default"], {
        className: containerClasses,
        isOpen: isOpen,
        onClose: onClose,
        style: style,
        wing: /*#__PURE__*/_react["default"].createElement(_drawer["default"].Wing, {
          className: "page_deprecated_filters_drawer--nested_toggles_wing",
          isOpen: !isNestedTogglesOptionsEmpty
        }, /*#__PURE__*/_react["default"].createElement(_drawer["default"].TitleBar, {
          className: "nested_toggles_wing--title_bar",
          title: /*#__PURE__*/_react["default"].createElement(_icon["default"], {
            className: "nested_toggles_wing--close_button",
            onClick: this.onNestedTogglesCloseWingClick,
            size: "medium",
            type: "chevron-left"
          })
        }), /*#__PURE__*/_react["default"].createElement(_drawer["default"].Content, {
          className: "nested_toggles_wing--content"
        }, /*#__PURE__*/_react["default"].createElement(_header["default"], {
          className: "nested_toggles_wing--title",
          size: "small",
          weight: "bold"
        }, nestedTogglesData.label), /*#__PURE__*/_react["default"].createElement("div", {
          className: "nested_toggles_wing--options"
        }, !isNestedTogglesOptionsEmpty && _lodash["default"].map(nestedTogglesData.options, function (option) {
          var isSelected = _lodash["default"].some(nestedTogglesData.value, option);

          return /*#__PURE__*/_react["default"].createElement(NestedTogglesWingOptionLabel, {
            key: nestedTogglesOptionLabelKeyNum++,
            isSelected: isSelected,
            onClick: _this6.onNestedTogglesWingOptionLabelClick,
            option: option
          });
        }))))
      }, /*#__PURE__*/_react["default"].createElement(_drawer["default"].TitleBar, {
        className: "page_deprecated_filters_drawer--title_bar",
        closeButton: /*#__PURE__*/_react["default"].createElement(_icon["default"], {
          className: "page_deprecated_filters_drawer--close_button",
          compact: true,
          onClick: onClose,
          type: "times"
        }),
        title: /*#__PURE__*/_react["default"].createElement("div", {
          className: "page_deprecated_filters_drawer--actions",
          title: "Filters"
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "page_deprecated_filters_drawer--clear_column"
        }, canClear ? /*#__PURE__*/_react["default"].createElement("a", {
          className: clearFiltersClasses,
          onClick: this.onClearClick
        }, "Clear Filters") : /*#__PURE__*/_react["default"].createElement(_icon["default"], {
          color: "static",
          compact: true,
          size: "medium",
          type: "filter"
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "page_deprecated_filters_drawer--apply_column"
        }, isDirty && /*#__PURE__*/_react["default"].createElement(_button["default"], {
          color: "success",
          icon: true,
          innerStyle: {
            height: '32px',
            width: '32px'
          },
          onClick: this.onApplyClick,
          style: {
            height: '32px',
            minHeight: '32px',
            width: '32px'
          }
        }, /*#__PURE__*/_react["default"].createElement(_icon["default"], {
          compact: true,
          type: "check"
        }))))
      }), /*#__PURE__*/_react["default"].createElement(_drawer["default"].Content, null, _lodash["default"].map(rows, function (row) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "page_deprecated_filters_drawer--row",
          key: "page--filters-drawer-row-".concat(rowKeyNum++)
        }, row.header && /*#__PURE__*/_react["default"].createElement(_header["default"], {
          className: "page_deprecated_filters_drawer--header",
          weight: "bold"
        }, row.header), /*#__PURE__*/_react["default"].createElement("div", {
          className: "page_deprecated_filters_drawer--items"
        }, _lodash["default"].isArray(row.items) && _lodash["default"].map(row.items, function (item) {
          var dropdown = item.dropdown,
              jsx = item.jsx,
              multiSelect = item.multiSelect,
              nestedToggles = item.nestedToggles;
          var className = (0, _classnames["default"])('page_deprecated_filters_drawer--item', {
            'page_deprecated_filters_drawer--item-dropdown': dropdown,
            'page_deprecated_filters_drawer--item-jsx': jsx,
            'page_deprecated_filters_drawer--item-multi_select': multiSelect,
            'page_deprecated_filters_drawer--item-nested_toggles': nestedToggles
          });
          var itemKey = "page_deprecated_filters_drawer--item-".concat(itemKeyNum++);

          if (!jsx && !dropdown && !nestedToggles && !multiSelect) {
            console.warn('<Page.FiltersDrawer>\'s rows.items must have one of the ' + 'following properties: dropdown, labels, multiSelect or jsx.');
          } else if (!jsx && dropdown && !nestedToggles && !multiSelect) {
            // Dropdown
            return /*#__PURE__*/_react["default"].createElement("div", {
              className: className,
              key: itemKey
            }, /*#__PURE__*/_react["default"].createElement(_dropdown["default"], {
              clearable: false,
              className: dropdown.className,
              fluid: true,
              id: dropdown.id,
              onChange: function onChange(selectedOption) {
                return dropdown.onChange(selectedOption);
              },
              options: dropdown.options,
              searchable: false,
              selection: true,
              selectionOptionComponent: dropdown.selectionCustomComponent,
              style: dropdown.style,
              value: dropdown.value
            }));
          } else if (!jsx && !dropdown && nestedToggles && !multiSelect) {
            // Nested Toggles
            return /*#__PURE__*/_react["default"].createElement("div", {
              className: className,
              key: itemKey
            }, /*#__PURE__*/_react["default"].createElement(NestedTogglesLabel, {
              onClick: _this6.onNestedTogglesLabelClick,
              nestedTogglesData: nestedToggles
            }), !_lodash["default"].isEmpty(nestedToggles.value) && /*#__PURE__*/_react["default"].createElement("div", null, _lodash["default"].map(nestedToggles.value, function (option) {
              return /*#__PURE__*/_react["default"].createElement(NestedTogglesValueLabel, {
                key: "nested-toggles-selected-filter-".concat(nestedTogglesValueLabelKeyNum++),
                nestedTogglesData: nestedToggles,
                onClick: _this6.onNestedTogglesValueLabelClick,
                option: option
              });
            })));
          } else if (!jsx && !dropdown && !nestedToggles && multiSelect) {
            // Multi Select
            var modifiedOptions = _lodash["default"].differenceBy(multiSelect.options, multiSelect.value, 'value');

            return /*#__PURE__*/_react["default"].createElement("div", {
              className: className,
              key: itemKey
            }, /*#__PURE__*/_react["default"].createElement(_dropdown["default"], {
              clearable: false,
              className: multiSelect.className,
              fluid: true,
              iconType: "plus",
              id: multiSelect.id,
              onChange: function onChange(selectedOption) {
                return _this6.onMultiSelectChange(multiSelect.onChange, multiSelect.value, selectedOption);
              },
              options: modifiedOptions,
              placeholder: multiSelect.placeholder,
              searchable: false,
              selection: true,
              selectionOptionComponent: multiSelect.selectionCustomComponent,
              style: multiSelect.style,
              value: ''
            }), !_lodash["default"].isEmpty(multiSelect.value) && _lodash["default"].map(multiSelect.value, function (v) {
              var selectedOption = v;
              return /*#__PURE__*/_react["default"].createElement(MultiSelectLabel, {
                color: multiSelect.labelColor,
                key: "multi-select-label-".concat(multiSelectLabelKeyNum++),
                onItemChange: multiSelect.onChange,
                label: v.label,
                selectedOption: selectedOption,
                value: multiSelect.value
              });
            })); // JSX
          } else if (jsx && !dropdown && !nestedToggles && !multiSelect) {
            return /*#__PURE__*/_react["default"].createElement("div", {
              className: className,
              key: itemKey
            }, jsx);
          }
        })));
      }), children)));
    }
  }]);

  return PageFiltersDrawer;
}(_react["default"].Component);

PageFiltersDrawer.propTypes = {
  className: _propTypes["default"].string,
  isDirty: _propTypes["default"].bool.isRequired,
  isFiltering: _propTypes["default"].bool.isRequired,
  isOpen: _propTypes["default"].bool.isRequired,
  onApply: _propTypes["default"].func.isRequired,
  onClear: _propTypes["default"].func.isRequired,
  onClose: _propTypes["default"].func.isRequired,
  rows: _propTypes["default"].array,
  style: _propTypes["default"].shape({})
};
var _default = PageFiltersDrawer;
exports["default"] = _default;