"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _detailsWindowPropTypes = require("../../surfaces/detailsWindow/detailsWindowPropTypes");

var _detailsWindow = _interopRequireDefault(require("../../surfaces/detailsWindow"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var propTypes = {
  bleed: _propTypes["default"].bool,
  className: _propTypes["default"].string,
  color: _propTypes["default"].oneOf([1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11]),
  columnProps: _propTypes["default"].shape({}),
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({})).isRequired,
  data: _propTypes["default"].shape({}).isRequired,
  expandableColumns: _propTypes["default"].arrayOf(_detailsWindowPropTypes.columnPropTypesShape),
  style: _propTypes["default"].shape({})
};
var defaultProps = {
  bleed: undefined,
  className: undefined,
  color: undefined,
  columnProps: undefined,
  expandableColumns: undefined,
  style: {}
}; // eslint-disable-next-line prefer-arrow-callback

var PageDetailsWindow = /*#__PURE__*/_react["default"].forwardRef(function PageDetailsWindow(props, ref) {
  var bleed = props.bleed,
      className = props.className,
      color = props.color,
      columnProps = props.columnProps,
      columns = props.columns,
      data = props.data,
      expandableColumns = props.expandableColumns,
      style = props.style;
  return /*#__PURE__*/_react["default"].createElement(_detailsWindow["default"], {
    bleed: bleed,
    className: className,
    color: color,
    columnProps: columnProps,
    columns: columns,
    data: data,
    expandableColumns: expandableColumns,
    forwardedRef: ref,
    style: style,
    moduleType: "page"
  });
});

PageDetailsWindow.propTypes = propTypes;
PageDetailsWindow.defaultProps = defaultProps;
var _default = PageDetailsWindow;
exports["default"] = _default;