"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = require("lodash");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _filtersDrawer = _interopRequireDefault(require("../../surfaces/filtersDrawer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var propTypes = {
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  id: _propTypes["default"].string,
  isDirty: _propTypes["default"].bool,
  isFiltering: _propTypes["default"].bool.isRequired,
  isOpen: _propTypes["default"].bool.isRequired,
  onApply: _propTypes["default"].func,
  onClear: _propTypes["default"].func,
  onClose: _propTypes["default"].func,
  rows: _propTypes["default"].arrayOf(_propTypes["default"].shape({})),
  style: _propTypes["default"].shape({})
};
var defaultProps = {
  children: undefined,
  className: undefined,
  id: undefined,
  isDirty: false,
  onApply: _lodash.noop,
  onClear: _lodash.noop,
  onClose: _lodash.noop,
  rows: undefined,
  style: {}
};

function PageFiltersDrawer(props) {
  var children = props.children,
      className = props.className,
      id = props.id,
      isDirty = props.isDirty,
      isFiltering = props.isFiltering,
      isOpen = props.isOpen,
      onApply = props.onApply,
      onClear = props.onClear,
      onClose = props.onClose,
      rows = props.rows,
      style = props.style;
  return /*#__PURE__*/_react["default"].createElement(_filtersDrawer["default"], {
    className: className,
    id: id,
    isDirty: isDirty,
    isFiltering: isFiltering,
    isOpen: isOpen,
    moduleType: "page",
    onApply: onApply,
    onClear: onClear,
    onClose: onClose,
    rows: rows,
    style: style
  }, children);
}

PageFiltersDrawer.propTypes = propTypes;
PageFiltersDrawer.defaultProps = defaultProps;
var _default = PageFiltersDrawer;
exports["default"] = _default;