"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.tabsState = exports.tabWidth = exports.items = void 0;
var items = [1, 2, 3, 4, 5, 6, 7, 8].map(function (tabNumber) {
  return {
    getContent: function getContent() {
      return "Example Tab ".concat(tabNumber, " content");
    },
    key: "exampleTab".concat(tabNumber),
    // eslint-disable-next-line no-console
    onClick: function onClick(clickedTab) {
      console.log("Example Tab ".concat(tabNumber, " clicked"), clickedTab);
    },
    title: "Example Tab ".concat(tabNumber)
  };
});
exports.items = items;
var tabWidth = 100;
exports.tabWidth = tabWidth;
var tabsDimensions = items.reduce(function (result, tab, index) {
  // eslint-disable-next-line no-param-reassign
  result[tab.key] = {
    width: tabWidth,
    offset: tabWidth * index
  };
  return result;
}, {});
var tabsState = {
  blockWidth: 1000,
  tabDimensions: tabsDimensions,
  tabsTotalWidth: items.length * tabWidth
};
exports.tabsState = tabsState;