"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _lodash = require("lodash");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _classnames = _interopRequireDefault(require("classnames"));

var _constants = require("../../global/constants");

var _constants2 = require("./constants");

var _typography = _interopRequireDefault(require("../../dataDisplay/typography"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  /**
   * Content to be rendered as the title
   */
  children: _propTypes["default"].oneOfType([_propTypes["default"].array, _propTypes["default"].object, _propTypes["default"].string]),

  /**
   * Aditional classNames to handle the tab states styles (disabled/selected)
   */
  classNames: _propTypes["default"].string.isRequired,

  /**
   * Aditional classes passed from the parent <SectionalTabs /> component to override
   * the label styling.
   */
  classes: _propTypes["default"].shape({
    sectionalTabLabel: _propTypes["default"].string,
    sectionalTabLabelSelected: _propTypes["default"].string
  }),

  /**
   * Sectional Tab identifier
   */
  id: _propTypes["default"].string.isRequired,

  /**
   * General <SectionalTabs /> onChange function, called on <SectionalTab /> click.
   */
  onChange: _propTypes["default"].func,

  /**
   * Independent <SectionalTab /> onClick function.
   */
  onClick: _propTypes["default"].func,

  /**
   * Key passed from the <SectionalTabs /> items objects.
   */
  originalKey: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]).isRequired,

  /**
   * Boolean used to apply the 'sectionalTabLabelSelected' class.
   */
  selected: _propTypes["default"].bool.isRequired,
  setSelectedTabDimensions: _propTypes["default"].func.isRequired
};
var defaultProps = {
  classes: {},
  children: undefined,
  onChange: undefined,
  onClick: undefined
};
/**
 * Used to render pages sections, built from the <SectionalTabs /> parent component.
 */

var SectionalTab = /*#__PURE__*/function (_Component) {
  _inherits(SectionalTab, _Component);

  var _super = _createSuper(SectionalTab);

  function SectionalTab(props) {
    var _this;

    _classCallCheck(this, SectionalTab);

    _this = _super.call(this, props);
    _this.onResizeDebounce = (0, _lodash.debounce)(function () {
      return _this.setSelectedTabDimensions();
    }, 80);
    _this.onTabClick = _this.onTabClick.bind(_assertThisInitialized(_this));
    _this.renderTab = _this.renderTab.bind(_assertThisInitialized(_this));
    _this.setSelectedTabDimensions = _this.setSelectedTabDimensions.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(SectionalTab, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      window.addEventListener('resize', this.onResizeDebounce);
      this.setSelectedTabDimensions();
    }
  }, {
    key: "shouldComponentUpdate",
    value: function shouldComponentUpdate(nextProps) {
      var _this$props = this.props,
          children = _this$props.children,
          classNames = _this$props.classNames,
          selected = _this$props.selected;
      return children !== nextProps.children || selected !== nextProps.selected || classNames !== nextProps.classNames;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var prevSelected = prevProps.selected;
      var selected = this.props.selected;

      if (!prevSelected && selected) {
        this.setSelectedTabDimensions();
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      window.removeEventListener('resize', this.onResizeDebounce);
    }
  }, {
    key: "onTabClick",
    value: function onTabClick(evt) {
      var _this$props2 = this.props,
          onChange = _this$props2.onChange,
          onClick = _this$props2.onClick,
          originalKey = _this$props2.originalKey;

      if ((0, _lodash.isFunction)(onClick)) {
        onClick(this.props);
      }

      if ((0, _lodash.isFunction)(onChange)) {
        onChange(originalKey, evt);
      }
    }
  }, {
    key: "setSelectedTabDimensions",
    value: function setSelectedTabDimensions() {
      var _this$props3 = this.props,
          selected = _this$props3.selected,
          setSelectedTabDimensions = _this$props3.setSelectedTabDimensions;

      if (this.tab && selected) {
        setSelectedTabDimensions({
          left: this.tab.offsetLeft + _constants2.PADDING_X,
          width: this.tab.offsetWidth - _constants2.PADDING_X * 2
        });
      }
    }
  }, {
    key: "renderTab",
    value: function renderTab() {
      var _Classnames;

      var _this$props4 = this.props,
          children = _this$props4.children,
          classes = _this$props4.classes,
          selected = _this$props4.selected;
      var tabLabelClassNames = (0, _classnames["default"])(classes.sectionalTabLabel, "".concat(_constants.BEM_NAVIGATION_TAB_ROOT_CLASS, "-label"), (_Classnames = {}, _defineProperty(_Classnames, classes.sectionalTabLabelSelected, selected), _defineProperty(_Classnames, "".concat(_constants.BEM_NAVIGATION_TAB_ROOT_CLASS, "-label_selected"), selected), _Classnames));
      return /*#__PURE__*/_react["default"].createElement(_typography["default"], {
        className: tabLabelClassNames,
        component: "span",
        variant: "h5"
      }, children);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props5 = this.props,
          classNames = _this$props5.classNames,
          id = _this$props5.id,
          selected = _this$props5.selected;
      return /*#__PURE__*/_react["default"].createElement("button", {
        "aria-selected": selected,
        className: classNames,
        id: id,
        onClick: this.onTabClick,
        onKeyDown: _lodash.noop,
        ref: function ref(e) {
          _this2.tab = e;
        },
        role: "tab",
        tabIndex: 0,
        type: "button"
      }, this.renderTab());
    }
  }]);

  return SectionalTab;
}(_react.Component);

SectionalTab.propTypes = propTypes;
SectionalTab.defaultProps = defaultProps;
var _default = SectionalTab;
exports["default"] = _default;