"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = require("lodash");

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _subNavigationItem = _interopRequireDefault(require("./subNavigationItem"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  border: _propTypes["default"].oneOf(['both', 'bottom', 'top']),
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  drawer: _propTypes["default"].bool,
  id: _propTypes["default"].string,
  onClick: _propTypes["default"].func,
  selected: _propTypes["default"].number,
  style: _propTypes["default"].shape({})
};
var defaultProps = {
  border: null,
  children: null,
  className: null,
  drawer: false,
  id: null,
  onClick: null,
  selected: null,
  style: null
};

var SubNavigation = /*#__PURE__*/function (_React$Component) {
  _inherits(SubNavigation, _React$Component);

  var _super = _createSuper(SubNavigation);

  function SubNavigation(props) {
    var _this;

    _classCallCheck(this, SubNavigation);

    _this = _super.call(this, props);
    _this.state = {
      selected: props.selected || 0
    };
    return _this;
  }

  _createClass(SubNavigation, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var selected = this.props.selected;

      if (prevProps.selected !== selected) {
        this.setState({
          selected: selected
        });
      }
    }
  }, {
    key: "onItemClick",
    value: function onItemClick(index, label, onChildClick, event) {
      var onClick = this.props.onClick;
      event.preventDefault();

      if ((0, _lodash.isFunction)(onClick)) {
        onClick(index, label);
      } else {
        if ((0, _lodash.isFunction)(onChildClick)) {
          onChildClick(index, label);
        }

        this.setState({
          selected: index
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          border = _this$props.border,
          children = _this$props.children,
          className = _this$props.className,
          drawer = _this$props.drawer,
          id = _this$props.id,
          style = _this$props.style;
      var selected = this.state.selected;
      var childrenArray = children && ((0, _lodash.isArray)(children) ? children : [children]);
      var buttons = (0, _lodash.flatMap)(childrenArray, function (child, index) {
        var _child$props = child.props,
            label = _child$props.label,
            onClick = _child$props.onClick,
            styleChildProp = _child$props.style;
        var isActive = (0, _classnames["default"])({
          'is-active': selected === index
        });
        var buttonID = id ? "".concat(id, "_").concat((0, _lodash.snakeCase)(child.props.label)) : "sub_navigation_button--".concat((0, _lodash.snakeCase)(child.props.label));
        return /*#__PURE__*/_react["default"].createElement("button", {
          className: isActive,
          id: buttonID,
          key: "sub-navigation-buttons-".concat(index),
          onClick: _this2.onItemClick.bind(_this2, index, label, onClick),
          style: styleChildProp,
          type: "button"
        }, /*#__PURE__*/_react["default"].createElement("span", {
          className: "sub-navigation-button-inner"
        }, /*#__PURE__*/_react["default"].createElement("span", {
          className: "copy"
        }, label), /*#__PURE__*/_react["default"].createElement("span", {
          className: "button-is-active-indicator"
        })));
      });
      var containerClasses = (0, _classnames["default"])('ui', 'sub-navigation', className, {
        'sub-navigation-border-bottom': !border || border === 'bottom' || border === 'both',
        'sub-navigation-border-top': border === 'top' || border === 'both',
        'sub-navigation-drawer': drawer
      });
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: containerClasses,
        id: id,
        style: style
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "sub-navigation-scroll-indicator"
      }), /*#__PURE__*/_react["default"].createElement("div", {
        className: "sub-navigation-scroll"
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "sub-navigation-item-container"
      }, buttons)));
    }
  }]);

  return SubNavigation;
}(_react["default"].Component);

SubNavigation.Item = _subNavigationItem["default"];
SubNavigation.propTypes = propTypes;
SubNavigation.defaultProps = defaultProps;
var _default = SubNavigation;
exports["default"] = _default;