"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _tabsItem = _interopRequireDefault(require("./tabsItem"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  className: _propTypes["default"].string,
  id: _propTypes["default"].string,
  nest: _propTypes["default"].bool,
  onClick: _propTypes["default"].func,
  selected: _propTypes["default"].number,
  style: _propTypes["default"].shape({})
};

var Tabs = /*#__PURE__*/function (_React$Component) {
  _inherits(Tabs, _React$Component);

  var _super = _createSuper(Tabs);

  function Tabs(props) {
    var _this;

    _classCallCheck(this, Tabs);

    _this = _super.call(this, props);
    _this.state = {
      selected: props.selected || 0
    };
    return _this;
  }

  _createClass(Tabs, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (this.props.selected !== prevProps.selected) {
        this.setState({
          selected: this.props.selected
        });
      }
    }
  }, {
    key: "_onTabClick",
    value: function _onTabClick(index, event) {
      if (!_lodash["default"].isUndefined(this.props.onClick)) {
        this.props.onClick(index);
      } else {
        this.setState({
          selected: index
        });
      }

      event.preventDefault();
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          children = _this$props.children,
          id = _this$props.id;
      var containerClasses = (0, _classnames["default"])('ui', 'tabs', this.props.className, {
        'tabs-nest': this.props.nest
      });
      var convertChildren = _lodash["default"].isArray(children) ? children : [children];

      var buttons = _lodash["default"].map(convertChildren, function (child, index) {
        var isActive = (0, _classnames["default"])({
          'is-active': _this2.state.selected === index
        });
        var buttonID = id ? "".concat(id, "_").concat(_lodash["default"].snakeCase(child.props.label)) : "tabs_button--".concat(_lodash["default"].snakeCase(child.props.label));
        return /*#__PURE__*/_react["default"].createElement("button", {
          className: isActive,
          id: buttonID,
          onClick: _this2._onTabClick.bind(_this2, index),
          key: "tabs-buttons-".concat(index)
        }, /*#__PURE__*/_react["default"].createElement("span", {
          className: "tab-button-inner"
        }, child.props.label ? /*#__PURE__*/_react["default"].createElement("span", {
          className: "copy"
        }, child.props.label) : null));
      });

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: containerClasses,
        id: id,
        style: this.props.style
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "ui tabs-buttons"
      }, buttons), this.props.children[this.state.selected]);
    }
  }]);

  return Tabs;
}(_react["default"].Component);

Tabs.Item = _tabsItem["default"];
Tabs.propTypes = propTypes;
var _default = Tabs;
exports["default"] = _default;