"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _createBreakpoints = _interopRequireDefault(require("@material-ui/core/styles/createBreakpoints"));

var _createSpacing = _interopRequireDefault(require("@material-ui/core/styles/createSpacing"));

var _transitions = _interopRequireDefault(require("@material-ui/core/styles/transitions"));

var _breakpointsConstants = require("./breakpointsConstants");

var _createMixins = _interopRequireDefault(require("./createMixins"));

var _createPalette = _interopRequireDefault(require("./createPalette"));

var _createTypography = _interopRequireDefault(require("./createTypography"));

var _shadows = _interopRequireDefault(require("./shadows"));

var _shape = _interopRequireDefault(require("./shape"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var spacing = 11;
var breakpoints = (0, _createBreakpoints["default"])({
  keys: _breakpointsConstants.keys,
  values: _breakpointsConstants.values
});
var palette = (0, _createPalette["default"])();
var theme = {
  breakpoints: breakpoints,
  gutters: {
    drawer: {
      sm: spacing * 2
    },
    page: {
      sm: spacing * 2,
      496: spacing * 4
    }
  },
  height: {
    actionBar: {
      sm: 50,
      md: 70
    },
    appHeader: {
      sm: spacing * 5,
      md: 70
    }
  },
  mixins: (0, _createMixins["default"])(breakpoints, spacing, {}),
  overrides: {
    MuiCard: {
      root: {
        borderRadius: 8,
        overflow: 'visible'
      }
    },
    MuiCardContent: {
      root: {
        padding: spacing * 2
      }
    }
  },
  palette: palette,
  shadows: _shadows["default"],
  shape: _shape["default"],
  spacing: (0, _createSpacing["default"])(spacing),
  transitions: _transitions["default"],
  typography: (0, _createTypography["default"])(),
  width: {
    navigation: {
      sm: {},
      md: {
        collapsed: 70,
        expanded: 250
      }
    }
  },
  zIndex: {
    drawer: 10000,
    modal: 11000,
    datePickerInputCalendar: 12000,
    prompt: 13000,
    banner: 14000,
    popover: 15000,
    tooltip: 16000
  }
};
var _default = theme;
exports["default"] = _default;