"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _actionBarActionsButtonDrawerOption = _interopRequireDefault(require("./actionBarActionsButtonDrawerOption"));

var _button = _interopRequireDefault(require("../../inputs/button"));

var _drawer = _interopRequireDefault(require("../../surfaces/drawer"));

var _header = _interopRequireDefault(require("../../dataDisplay/header"));

var _icon = _interopRequireDefault(require("../../dataDisplay/icon"));

var _prompt = _interopRequireDefault(require("../../inputs/prompt"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  className: _propTypes["default"].string,
  header: _propTypes["default"].string.isRequired,
  iconBackgroundColor: _propTypes["default"].string,
  iconBackgroundActiveColor: _propTypes["default"].string,
  iconType: _propTypes["default"].string,
  id: _propTypes["default"].string,
  isMobileSearchVisible: _propTypes["default"].bool,
  moduleType: _propTypes["default"].oneOf(['drawer', 'page']),
  options: _propTypes["default"].array.isRequired,
  // eslint-disable-line react/forbid-prop-types
  style: _propTypes["default"].shape({}) // eslint-disable-line react/forbid-prop-types

};
var defaultProps = {
  className: undefined,
  iconBackgroundColor: 'secondary',
  iconBackgroundActiveColor: 'active',
  iconType: 'ellipsis-h',
  id: undefined,
  isMobileSearchVisible: false,
  moduleType: undefined,
  style: {}
};

var ActionBarActionsButton = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(ActionBarActionsButton, _React$PureComponent);

  var _super = _createSuper(ActionBarActionsButton);

  function ActionBarActionsButton() {
    var _this;

    _classCallCheck(this, ActionBarActionsButton);

    _this = _super.call(this);
    _this.state = {
      isDrawerOpen: false,
      isPromptVisible: false,
      promptingOption: null,
      selectedOption: {}
    };
    _this.onDrawerCloseComplete = _this.onDrawerCloseComplete.bind(_assertThisInitialized(_this));
    _this.onDrawerToggle = _this.onDrawerToggle.bind(_assertThisInitialized(_this));
    _this.onOptionClick = _this.onOptionClick.bind(_assertThisInitialized(_this));
    _this.onPromptNoClick = _this.onPromptNoClick.bind(_assertThisInitialized(_this));
    _this.onPromptRequested = _this.onPromptRequested.bind(_assertThisInitialized(_this));
    _this.onPromptYesClick = _this.onPromptYesClick.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(ActionBarActionsButton, [{
    key: "onDrawerCloseComplete",
    value: function onDrawerCloseComplete() {
      this.setState({
        selectedOption: {}
      });
    }
  }, {
    key: "onDrawerToggle",
    value: function onDrawerToggle() {
      this.setState(function (prevState) {
        return {
          isDrawerOpen: !prevState.isDrawerOpen
        };
      });
    }
  }, {
    key: "onOptionClick",
    value: function onOptionClick(option) {
      this.setState({
        selectedOption: option || {}
      });
    }
  }, {
    key: "onPromptNoClick",
    value: function onPromptNoClick() {
      this.setState({
        isDrawerOpen: true,
        isPromptVisible: false,
        promptingOption: null
      });
    }
  }, {
    key: "onPromptRequested",
    value: function onPromptRequested(option) {
      this.setState({
        isDrawerOpen: false,
        isPromptVisible: true,
        promptingOption: option
      });
    }
  }, {
    key: "onPromptYesClick",
    value: function onPromptYesClick() {
      var promptingOption = this.state.promptingOption;

      if (!_lodash["default"].isEmpty(promptingOption) && _lodash["default"].isFunction(promptingOption.onClick)) {
        promptingOption.onClick();
      }

      this.setState({
        isPromptVisible: false,
        promptingOption: null
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          className = _this$props.className,
          header = _this$props.header,
          iconBackgroundColor = _this$props.iconBackgroundColor,
          iconBackgroundActiveColor = _this$props.iconBackgroundActiveColor,
          iconType = _this$props.iconType,
          id = _this$props.id,
          isMobileSearchVisible = _this$props.isMobileSearchVisible,
          moduleType = _this$props.moduleType,
          options = _this$props.options,
          style = _this$props.style;
      var _this$state = this.state,
          isDrawerOpen = _this$state.isDrawerOpen,
          isPromptVisible = _this$state.isPromptVisible,
          promptingOption = _this$state.promptingOption,
          selectedOption = _this$state.selectedOption;
      var hasSelectedOption = !_lodash["default"].isEmpty(selectedOption);
      var containerClasses = (0, _classnames["default"])('action_bar--actions_button_drawer', className);
      var titleClasses = (0, _classnames["default"])('actions_button_drawer--title', {
        'actions_button_drawer--title-hide': hasSelectedOption,
        'actions_button_drawer--title-show': !hasSelectedOption
      });
      var headerHeight = 55;
      var actionBarHeight = isMobileSearchVisible ? 105 : 50;
      var navigationBarHeight = 0;

      if (moduleType === 'drawer' && document.querySelector('.ui.drawer.drawer-has_navigation')) {
        navigationBarHeight = 55;
      }

      var promptMessage = !_lodash["default"].isEmpty(promptingOption) ? promptingOption.promptMessage : undefined;
      var promptColor = !_lodash["default"].isEmpty(promptingOption) ? promptingOption.promptColor : undefined;
      var optionKeyNum = 1;
      return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_prompt["default"], {
        inline: true,
        inlineHorizontalAlign: "right",
        inlineMessageColor: promptColor,
        message: promptMessage,
        onClick: this.onDrawerToggle,
        onNoClick: this.onPromptNoClick,
        onYesClick: this.onPromptYesClick,
        show: isPromptVisible
      }, /*#__PURE__*/_react["default"].createElement(_button["default"], {
        className: "action_bar--actions_button",
        color: isDrawerOpen ? iconBackgroundActiveColor : iconBackgroundColor,
        designVersion: 2,
        icon: true,
        id: id,
        style: style
      }, /*#__PURE__*/_react["default"].createElement(_icon["default"], {
        size: "small",
        type: iconType
      }))), /*#__PURE__*/_react["default"].createElement(_drawer["default"], {
        className: containerClasses,
        dimmer: false,
        isOpen: isDrawerOpen,
        maxWidth: 224,
        onClose: this.onDrawerToggle,
        onCloseComplete: this.onDrawerCloseComplete,
        positionYOffset: headerHeight + actionBarHeight + navigationBarHeight,
        shadowSize: "xsmall"
      }, /*#__PURE__*/_react["default"].createElement(_drawer["default"].Content, {
        className: "actions_button_drawer--content"
      }, /*#__PURE__*/_react["default"].createElement(_header["default"], {
        className: titleClasses,
        size: "small",
        fontWeight: "bold"
      }, header), /*#__PURE__*/_react["default"].createElement("div", {
        className: "actions_button_drawer--options"
      }, _lodash["default"].map(options, function (option) {
        optionKeyNum += 1;
        var isSelected = hasSelectedOption && selectedOption.label === option.label;
        var hide = hasSelectedOption && selectedOption.label !== option.label || false;
        return /*#__PURE__*/_react["default"].createElement(_actionBarActionsButtonDrawerOption["default"], {
          hide: hide,
          idNumber: optionKeyNum,
          isSelected: isSelected,
          key: "actions_button_drawer--option-".concat(optionKeyNum),
          onClick: _this2.onOptionClick,
          onRequestPrompt: _this2.onPromptRequested,
          onDrawerToggle: _this2.onDrawerToggle,
          option: option
        });
      })))));
    }
  }]);

  return ActionBarActionsButton;
}(_react["default"].PureComponent);

ActionBarActionsButton.propTypes = propTypes;
ActionBarActionsButton.defaultProps = defaultProps;
var _default = ActionBarActionsButton;
exports["default"] = _default;