"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.singleOptionPropTypeShape = void 0;

var _lodash = require("lodash");

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _icon = _interopRequireDefault(require("../../dataDisplay/icon"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var singleOptionPropTypeShape = {
  disable: _propTypes["default"].bool,
  disabled: _propTypes["default"].bool,
  id: _propTypes["default"].string,
  iconBackgroundColor: _propTypes["default"].string,
  iconColor: _propTypes["default"].string,
  iconSize: _propTypes["default"].oneOfType([_propTypes["default"].oneOf(_utils["default"].sizeEnums()), _propTypes["default"].number]),
  iconType: _propTypes["default"].string,
  label: _propTypes["default"].string,
  onClick: _propTypes["default"].func,
  promptColor: _propTypes["default"].string,
  promptMessage: _propTypes["default"].string,
  requiresPrompt: _propTypes["default"].bool
};
exports.singleOptionPropTypeShape = singleOptionPropTypeShape;
var propTypes = {
  isSelected: _propTypes["default"].bool.isRequired,
  onRequestPrompt: _propTypes["default"].func,
  onDrawerToggle: _propTypes["default"].func,
  subOption: _propTypes["default"].shape(singleOptionPropTypeShape).isRequired,
  subOptionClassNameNum: _propTypes["default"].number.isRequired
};
var defaultProps = {
  onRequestPrompt: undefined,
  onDrawerToggle: undefined
};

var ActionBarActionsButtonDrawerSubOption = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(ActionBarActionsButtonDrawerSubOption, _React$PureComponent);

  var _super = _createSuper(ActionBarActionsButtonDrawerSubOption);

  function ActionBarActionsButtonDrawerSubOption() {
    var _this;

    _classCallCheck(this, ActionBarActionsButtonDrawerSubOption);

    _this = _super.call(this);
    _this.onClick = _this.onClick.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(ActionBarActionsButtonDrawerSubOption, [{
    key: "onClick",
    value: function onClick() {
      var _this$props = this.props,
          onRequestPrompt = _this$props.onRequestPrompt,
          onDrawerToggle = _this$props.onDrawerToggle,
          subOption = _this$props.subOption;
      var disable = subOption.disable,
          disabled = subOption.disabled,
          subOptionOnClick = subOption.onClick,
          requiresPrompt = subOption.requiresPrompt;

      if (!(0, _lodash.isFunction)(subOptionOnClick)) {
        return false;
      }

      if (disable || disabled) {
        return false;
      }

      if (requiresPrompt && (0, _lodash.isFunction)(onRequestPrompt)) {
        onRequestPrompt(subOption);
        return false;
      }

      if ((0, _lodash.isFunction)(subOptionOnClick)) {
        onDrawerToggle();
        subOptionOnClick();
      }

      return true;
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          isSelected = _this$props2.isSelected,
          subOption = _this$props2.subOption,
          subOptionClassNameNum = _this$props2.subOptionClassNameNum;
      var isSubOptionDisabled = subOption.disable || subOption.disabled;
      var classNameNumber = subOptionClassNameNum;
      var subOptionClasses = (0, _classnames["default"])('actions_button_drawer--sub_option', "actions_button_drawer--sub_option-".concat(classNameNumber), "".concat(isSelected ? "actions_button_drawer--sub_option-".concat(classNameNumber, "-show") : ''), "".concat(isSubOptionDisabled ? "actions_button_drawer--sub_option-".concat(classNameNumber, "-disabled") : ''));
      /* eslint-disable jsx-a11y/click-events-have-key-events */

      /* eslint-disable jsx-a11y/interactive-supports-focus */

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: subOptionClasses,
        onClick: this.onClick,
        role: "menuitem"
      }, subOption.iconType && /*#__PURE__*/_react["default"].createElement("div", {
        className: "actions_button_drawer_sub_option--icon_container",
        id: subOption.id
      }, /*#__PURE__*/_react["default"].createElement(_icon["default"], {
        color: isSubOptionDisabled ? 'static' : subOption.iconColor,
        compact: true,
        className: "actions_button_drawer_sub_option--icon",
        size: subOption.iconSize || 16,
        type: subOption.iconType
      })), /*#__PURE__*/_react["default"].createElement("div", {
        className: "actions_button_drawer_sub_option--label"
      }, subOption.label));
      /* eslint-enable jsx-a11y/click-events-have-key-events */

      /* eslint-enable jsx-a11y/interactive-supports-focus */
    }
  }]);

  return ActionBarActionsButtonDrawerSubOption;
}(_react["default"].PureComponent);

ActionBarActionsButtonDrawerSubOption.propTypes = propTypes;
ActionBarActionsButtonDrawerSubOption.defaultProps = defaultProps;
var _default = ActionBarActionsButtonDrawerSubOption;
exports["default"] = _default;