"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _icon = _interopRequireDefault(require("../../dataDisplay/icon"));

var _input = _interopRequireDefault(require("../../inputs/input"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  autoFocus: _propTypes["default"].bool,
  id: _propTypes["default"].string,
  isMobileSearch: _propTypes["default"].bool,
  isMobileSearchVisible: _propTypes["default"].bool,
  onChange: _propTypes["default"].func.isRequired,
  onClearClick: _propTypes["default"].func,
  onFocus: _propTypes["default"].func,
  onKeyDown: _propTypes["default"].func,
  placeholder: _propTypes["default"].string,
  style: _propTypes["default"].shape({}),
  // eslint-disable-line react/forbid-prop-types
  value: _propTypes["default"].string
};
var defaultProps = {
  autoFocus: false,
  id: undefined,
  isMobileSearch: false,
  isMobileSearchVisible: false,
  onClearClick: undefined,
  onFocus: undefined,
  onKeyDown: undefined,
  placeholder: 'Search',
  style: {},
  value: ''
};

var ActionBarSearch = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(ActionBarSearch, _React$PureComponent);

  var _super = _createSuper(ActionBarSearch);

  function ActionBarSearch() {
    var _this;

    _classCallCheck(this, ActionBarSearch);

    _this = _super.call(this);
    _this.onChange = _this.onChange.bind(_assertThisInitialized(_this));
    _this.onClearClick = _this.onClearClick.bind(_assertThisInitialized(_this));
    _this.onClearKeyDown = _this.onClearKeyDown.bind(_assertThisInitialized(_this));
    _this.onKeyDown = _this.onKeyDown.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(ActionBarSearch, [{
    key: "onChange",
    value: function onChange(value) {
      var onChange = this.props.onChange;
      onChange(value);
    }
  }, {
    key: "onClearClick",
    value: function onClearClick() {
      var _this$props = this.props,
          onChange = _this$props.onChange,
          onClearClick = _this$props.onClearClick;

      if (_lodash["default"].isFunction(onClearClick)) {
        onClearClick();
      } else {
        onChange('');
      }
    }
  }, {
    key: "onClearKeyDown",
    value: function onClearKeyDown(event) {
      if (event.keyCode === 13) {
        this.onClearClick();
      }
    }
  }, {
    key: "onKeyDown",
    value: function onKeyDown(event) {
      var onKeyDown = this.props.onKeyDown;

      if (_lodash["default"].isFunction(onKeyDown)) {
        onKeyDown(event);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          autoFocus = _this$props2.autoFocus,
          id = _this$props2.id,
          isMobileSearch = _this$props2.isMobileSearch,
          isMobileSearchVisible = _this$props2.isMobileSearchVisible,
          onFocus = _this$props2.onFocus,
          placeholder = _this$props2.placeholder,
          style = _this$props2.style,
          value = _this$props2.value;
      var inputContainerClasses = (0, _classnames["default"])('action_bar--search', {
        'action_bar--search-mobile': isMobileSearch,
        'action_bar--search-mobile-show': isMobileSearch && isMobileSearchVisible
      });
      var magnificationIcon = null;

      if (onFocus) {
        onFocus(isMobileSearchVisible);
      }

      if (!isMobileSearch) {
        magnificationIcon = /*#__PURE__*/_react["default"].createElement(_icon["default"], {
          compact: true,
          title: "Search",
          type: "search"
        });
      }

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: inputContainerClasses
      }, /*#__PURE__*/_react["default"].createElement(_input["default"], {
        autoFocus: autoFocus,
        className: "action_bar--search_input",
        fluid: true,
        icon: value ? /*#__PURE__*/_react["default"].createElement("div", {
          className: "action_bar--clear_search",
          onClick: this.onClearClick,
          onKeyDown: this.onClearKeyDown,
          role: "button",
          tabIndex: 0
        }, /*#__PURE__*/_react["default"].createElement(_icon["default"], {
          compact: true,
          title: "Clear Search",
          type: "times-circle"
        })) : magnificationIcon,
        id: id,
        onChange: this.onChange,
        onKeyDown: this.onKeyDown,
        placeholder: placeholder,
        value: value,
        style: style
      }));
    }
  }]);

  return ActionBarSearch;
}(_react["default"].PureComponent);

ActionBarSearch.propTypes = propTypes;
ActionBarSearch.defaultProps = defaultProps;
var _default = ActionBarSearch;
exports["default"] = _default;