"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _header = _interopRequireDefault(require("../../dataDisplay/header"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var propTypes = {
  attached: _propTypes["default"].bool,
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  color: _propTypes["default"].oneOf(['blue', 'green', 'pink']),
  style: _propTypes["default"].shape({}),
  title: _propTypes["default"].string
};
var defaultProps = {
  attached: false,
  children: null,
  className: null,
  color: null,
  style: null,
  title: null
};

function CardHeader(props) {
  var attached = props.attached,
      children = props.children,
      className = props.className,
      color = props.color,
      style = props.style,
      title = props.title;
  var rootClasses = (0, _classnames["default"])('card-header', className, {
    'card-header-attached': attached,
    'card-header-color-blue': color === 'blue',
    'card-header-color-green': color === 'green',
    'card-header-color-pink': color === 'pink'
  });
  return /*#__PURE__*/_react["default"].createElement("header", {
    className: rootClasses,
    style: style
  }, title ? /*#__PURE__*/_react["default"].createElement(_header["default"], {
    size: "large"
  }, title) : children);
}

CardHeader.propTypes = propTypes;
CardHeader.defaultProps = defaultProps;
var _default = CardHeader;
exports["default"] = _default;