"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _detailsWindowPropTypes = require("./detailsWindowPropTypes");

var _button = _interopRequireDefault(require("../../inputs/button"));

var _header = _interopRequireDefault(require("../../dataDisplay/header"));

var _icon = _interopRequireDefault(require("../../dataDisplay/icon"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  column: _detailsWindowPropTypes.columnPropTypesShape.isRequired,
  columnNumber: _propTypes["default"].number,
  columnProps: _detailsWindowPropTypes.columnPropsPropTypesShape,
  data: _propTypes["default"].shape({}).isRequired,
  isExpanded: _propTypes["default"].bool,
  onExpandButtonToggle: _propTypes["default"].func,
  moduleType: _propTypes["default"].string,
  setColumnContainerHeight: _propTypes["default"].func
};
var defaultProps = {
  columnNumber: undefined,
  columnProps: undefined,
  isExpanded: false,
  moduleType: undefined,
  onExpandButtonToggle: undefined,
  setColumnContainerHeight: undefined
};

var nop = function nop() {};

var DetailsWindowColumn = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(DetailsWindowColumn, _React$PureComponent);

  var _super = _createSuper(DetailsWindowColumn);

  function DetailsWindowColumn() {
    _classCallCheck(this, DetailsWindowColumn);

    return _super.apply(this, arguments);
  }

  _createClass(DetailsWindowColumn, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var setColumnContainerHeight = this.props.setColumnContainerHeight;

      if (this.columnRef && _lodash["default"].isFunction(setColumnContainerHeight)) {
        setColumnContainerHeight(this.columnRef.offsetHeight);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _ClassNames,
          _this = this;

      var _this$props = this.props,
          _this$props$column = _this$props.column,
          accessor = _this$props$column.accessor,
          divide = _this$props$column.divide,
          expandedButton = _this$props$column.expandedButton,
          expandedButtonId = _this$props$column.expandedButtonId,
          flexBasis = _this$props$column.flexBasis,
          flexGrow = _this$props$column.flexGrow,
          flexShrink = _this$props$column.flexShrink,
          fontSize = _this$props$column.fontSize,
          fontWeight = _this$props$column.fontWeight,
          header = _this$props$column.header,
          style = _this$props$column.style,
          width = _this$props$column.width,
          columnNumber = _this$props.columnNumber,
          columnProps = _this$props.columnProps,
          data = _this$props.data,
          isExpanded = _this$props.isExpanded,
          onExpandButtonToggle = _this$props.onExpandButtonToggle,
          moduleType = _this$props.moduleType;
      var bemClassName = "".concat(moduleType, "--details_window_column");
      var containerClassName = "".concat(bemClassName).concat(columnNumber ? '_inner' : '');
      var containerClasses = (0, _classnames["default"])(containerClassName, (_ClassNames = {}, _defineProperty(_ClassNames, "".concat(containerClassName, "-divide_left"), divide === true || divide === 'left'), _defineProperty(_ClassNames, "".concat(containerClassName, "-divide_right"), divide === 'right'), _ClassNames));
      var accessorClasses = (0, _classnames["default"])("".concat(bemClassName, "_accessor"), {
        'font-size-large': fontSize === 'large',
        'font-size-medium': fontSize === 'medium',
        'font-size-small': !fontSize || fontSize === 'small',
        'font-weight-bold': !fontWeight || fontWeight === 'bold',
        'font-weight-normal': fontWeight === 'normal',
        'font-weight-semibold': fontWeight === 'semibold'
      });
      var horizontalSpacing;

      if (columnProps) {
        horizontalSpacing = columnProps.horizontalSpacing;
      }

      var accessedData;
      var flexBasisInlineStyleValue;
      var flexGrowInlineStyleValue;
      var flexShrinkInlineStyleValue;
      var horizontalSpacingInlineStyleValue;

      if (_lodash["default"].isString(accessor)) {
        accessedData = _lodash["default"].get(data, accessor);
      } else if (_lodash["default"].isFunction(accessor)) {
        accessedData = accessor(data);
      }

      if (columnNumber) {
        flexBasisInlineStyleValue = flexBasis || 'auto';
        flexGrowInlineStyleValue = flexGrow || 0;
        flexShrinkInlineStyleValue = flexShrink || 0;
        horizontalSpacingInlineStyleValue = horizontalSpacing || null;
      }

      return /*#__PURE__*/_react["default"].createElement("div", {
        className: containerClasses,
        style: _objectSpread({
          flexBasis: flexBasisInlineStyleValue,
          flexGrow: flexGrowInlineStyleValue,
          flexShrink: flexShrinkInlineStyleValue,
          paddingLeft: horizontalSpacingInlineStyleValue,
          paddingRight: horizontalSpacingInlineStyleValue,
          width: "".concat(width)
        }, style),
        ref: function ref(_ref) {
          _this.columnRef = _ref;
        }
      }, expandedButton && /*#__PURE__*/_react["default"].createElement(_button["default"], {
        className: "".concat(bemClassName, "_expandable_toggle_button"),
        designVersion: 2,
        icon: true,
        id: expandedButtonId,
        inverse: true,
        onClick: onExpandButtonToggle || nop,
        variant: "outlined"
      }, /*#__PURE__*/_react["default"].createElement(_icon["default"], {
        compact: true,
        rotate: isExpanded ? 180 : null,
        title: isExpanded ? 'Collapse' : 'Expand',
        type: "chevron-down"
      })), header && /*#__PURE__*/_react["default"].createElement(_header["default"], {
        size: "xsmall",
        style: {
          margin: 0
        }
      }, header), /*#__PURE__*/_react["default"].createElement("div", {
        className: accessorClasses
      }, accessedData));
    }
  }]);

  return DetailsWindowColumn;
}(_react["default"].PureComponent);

DetailsWindowColumn.propTypes = propTypes;
DetailsWindowColumn.defaultProps = defaultProps;
var _default = DetailsWindowColumn;
exports["default"] = _default;