"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _detailsWindowPropTypes = require("./detailsWindowPropTypes");

var _detailsWindowColumn = _interopRequireDefault(require("./detailsWindowColumn"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = {
  column: _propTypes["default"].oneOfType([_propTypes["default"].arrayOf(_detailsWindowPropTypes.columnPropTypesShape), _detailsWindowPropTypes.columnPropTypesShape]).isRequired,
  columnProps: _detailsWindowPropTypes.columnPropsPropTypesShape,
  data: _propTypes["default"].shape({}).isRequired,
  isExpanded: _propTypes["default"].bool,
  onExpandButtonToggle: _propTypes["default"].func,
  moduleType: _propTypes["default"].string,
  setColumnContainerHeight: _propTypes["default"].func
};
var defaultProps = {
  columnProps: undefined,
  isExpanded: false,
  moduleType: undefined,
  onExpandButtonToggle: undefined,
  setColumnContainerHeight: undefined
};

function DetailsWindowColumnContainer(props) {
  var column = props.column,
      _props$column = props.column,
      accessor = _props$column.accessor,
      columns = _props$column.columns,
      divide = _props$column.divide,
      flexBasis = _props$column.flexBasis,
      flexGrow = _props$column.flexGrow,
      flexShrink = _props$column.flexShrink,
      style = _props$column.style,
      width = _props$column.width,
      columnProps = props.columnProps,
      data = props.data,
      isExpanded = props.isExpanded,
      moduleType = props.moduleType,
      onExpandButtonToggle = props.onExpandButtonToggle,
      setColumnContainerHeight = props.setColumnContainerHeight;
  var horizontalSpacing;

  if (columnProps) {
    horizontalSpacing = columnProps.horizontalSpacing;
  }

  if (!accessor && columns && _lodash["default"].isArray(columns)) {
    var bemClassName = "".concat(moduleType, "--details_window_column");
    var containerClasses = (0, _classnames["default"])(bemClassName, _defineProperty({}, "".concat(bemClassName, "-divide"), divide));
    var innerColumnKeyNum = 1;
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: containerClasses,
      style: _objectSpread({
        flexBasis: flexBasis || 'auto',
        flexGrow: flexGrow || 0,
        flexShrink: flexShrink || 0,
        paddingLeft: horizontalSpacing ? "".concat(horizontalSpacing, "px") : null,
        paddingRight: horizontalSpacing ? "".concat(horizontalSpacing, "px") : null,
        width: "".concat(width)
      }, style)
    }, _lodash["default"].map(columns, function (innerColumn) {
      innerColumnKeyNum += 1;
      return /*#__PURE__*/_react["default"].createElement(_detailsWindowColumn["default"], {
        column: innerColumn,
        columnNumber: innerColumnKeyNum,
        columnProps: columnProps,
        data: data,
        isExpanded: isExpanded,
        key: innerColumnKeyNum,
        moduleType: moduleType,
        onExpandButtonToggle: onExpandButtonToggle,
        setColumnContainerHeight: setColumnContainerHeight
      });
    }));
  }

  return /*#__PURE__*/_react["default"].createElement(_detailsWindowColumn["default"], {
    column: column,
    data: data,
    isExpanded: isExpanded,
    onExpandButtonToggle: onExpandButtonToggle,
    moduleType: moduleType,
    setColumnContainerHeight: setColumnContainerHeight
  });
}

DetailsWindowColumnContainer.propTypes = propTypes;
DetailsWindowColumnContainer.defaultProps = defaultProps;
var _default = DetailsWindowColumnContainer;
exports["default"] = _default;