"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _constants = require("../../global/constants");

var _actionBar = _interopRequireDefault(require("../../surfaces/actionBar"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

// eslint-disable-line import/no-cycle
var propTypes = {
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({})),

  /**
   * Used for DOM testing. https://testing-library.com/docs/queries/bytestid/
   */
  dataTestId: _propTypes["default"].string,
  id: _propTypes["default"].string,
  style: _propTypes["default"].shape({})
};
var defaultProps = {
  children: undefined,
  className: undefined,
  columns: undefined,
  dataTestId: "".concat(_constants.UI_CLASS_NAME, "-drawer_action_bar"),
  id: undefined,
  style: {}
};
var hasClassName = 'drawer-has_action_bar';
var hasWingClassName = 'drawer--wing-has_action_bar';

var DrawerActionBar = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(DrawerActionBar, _React$PureComponent);

  var _super = _createSuper(DrawerActionBar);

  function DrawerActionBar() {
    _classCallCheck(this, DrawerActionBar);

    return _super.apply(this, arguments);
  }

  _createClass(DrawerActionBar, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var closestWing = this.drawerActionBarRef.closest('.ui.drawer--wing');

      if (closestWing) {
        closestWing.classList.add(hasWingClassName);
        return null;
      }

      var closestDrawer = this.drawerActionBarRef.closest('.ui.drawer');

      if (closestDrawer) {
        closestDrawer.classList.add(hasClassName);
      }

      return null;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var closestWing = this.drawerActionBarRef.closest('.ui.drawer--wing');

      if (closestWing) {
        closestWing.classList.remove(hasWingClassName);
        return null;
      }

      var closestDrawer = this.drawerActionBarRef.closest('.ui.drawer');

      if (closestDrawer) {
        closestDrawer.classList.add(hasClassName);
      }

      return null;
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;

      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          columns = _this$props.columns,
          dataTestId = _this$props.dataTestId,
          id = _this$props.id,
          style = _this$props.style;
      var containerClasses = (0, _classnames["default"])('drawer--action_bar', className);
      return /*#__PURE__*/_react["default"].createElement("div", {
        "data-testid": dataTestId,
        ref: function ref(_ref) {
          _this.drawerActionBarRef = _ref;
        }
      }, /*#__PURE__*/_react["default"].createElement(_actionBar["default"], {
        className: containerClasses,
        columns: columns,
        id: id,
        style: style,
        moduleType: "drawer"
      }, children));
    }
  }]);

  return DrawerActionBar;
}(_react["default"].PureComponent);

DrawerActionBar.propTypes = propTypes;
DrawerActionBar.defaultProps = defaultProps;
var _default = DrawerActionBar;
exports["default"] = _default;