"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _constants = require("../../global/constants");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var propTypes = {
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,

  /**
   * Used for DOM testing. https://testing-library.com/docs/queries/bytestid/
   */
  dataTestId: _propTypes["default"].string,
  id: _propTypes["default"].string,
  style: _propTypes["default"].shape({})
};
var defaultProps = {
  children: null,
  className: null,
  dataTestId: "".concat(_constants.UI_CLASS_NAME, "-drawer_container"),
  id: null,
  style: null
};

function DrawerContainer(props) {
  var children = props.children,
      className = props.className,
      dataTestId = props.dataTestId,
      id = props.id,
      style = props.style;
  var rootClasses = (0, _classnames["default"])('ui', 'drawer--container', className);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: rootClasses,
    "data-testid": dataTestId,
    id: id,
    style: style
  }, children);
}

DrawerContainer.propTypes = propTypes;
DrawerContainer.defaultProps = defaultProps;
var _default = DrawerContainer;
exports["default"] = _default;