"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _constants = require("../../global/constants");

var _dataCards = _interopRequireDefault(require("../../dataDisplay/dataCards"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var propTypes = {
  cardProps: _propTypes["default"].func,
  className: _propTypes["default"].string,
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({})).isRequired,

  /**
   * Used for DOM testing. https://testing-library.com/docs/queries/bytestid/
   */
  dataTestId: _propTypes["default"].string,
  data: _propTypes["default"].arrayOf(_propTypes["default"].shape({})).isRequired,
  style: _propTypes["default"].shape({})
};
var defaultProps = {
  cardProps: undefined,
  className: undefined,
  dataTestId: "".concat(_constants.UI_CLASS_NAME, "-drawer_data_cards"),
  style: {}
};

function DrawerDataCards(props) {
  var cardProps = props.cardProps,
      className = props.className,
      columns = props.columns,
      data = props.data,
      dataTestId = props.dataTestId,
      style = props.style;
  return /*#__PURE__*/_react["default"].createElement(_dataCards["default"], {
    cardProps: cardProps,
    className: className,
    columns: columns,
    data: data,
    "data-testid": dataTestId,
    moduleType: "drawer",
    style: style
  });
}

DrawerDataCards.propTypes = propTypes;
DrawerDataCards.defaultProps = defaultProps;
var _default = DrawerDataCards;
exports["default"] = _default;