"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _constants = require("../../global/constants");

var _dataGroupsPropTypes = require("../../dataDisplay/dataGroups/dataGroupsPropTypes");

var _dataGroups = _interopRequireDefault(require("../../dataDisplay/dataGroups"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var propTypes = {
  bleed: _propTypes["default"].bool,
  className: _propTypes["default"].string,
  columns: _propTypes["default"].arrayOf(_dataGroupsPropTypes.groupPropTypes).isRequired,
  data: _propTypes["default"].shape({}).isRequired,

  /**
   * Used for DOM testing. https://testing-library.com/docs/queries/bytestid/
   */
  dataTestId: _propTypes["default"].string,
  style: _propTypes["default"].shape({})
};
var defaultProps = {
  bleed: false,
  className: '',
  dataTestId: "".concat(_constants.UI_CLASS_NAME, "-drawer_data_groups"),
  style: {}
};

function DrawerDataGroups(props) {
  var bleed = props.bleed,
      className = props.className,
      columns = props.columns,
      data = props.data,
      dataTestId = props.dataTestId,
      style = props.style;
  return /*#__PURE__*/_react["default"].createElement(_dataGroups["default"], {
    bleed: bleed,
    className: className,
    columns: columns,
    data: data,
    "data-testid": dataTestId,
    moduleType: "drawer",
    style: style
  });
}

DrawerDataGroups.propTypes = propTypes;
DrawerDataGroups.defaultProps = defaultProps;
var _default = DrawerDataGroups;
exports["default"] = _default;