"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _constants = require("../../global/constants");

var _filtersDrawer = _interopRequireDefault(require("../../surfaces/filtersDrawer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// eslint-disable-line import/no-cycle
var propTypes = {
  breakpointDown: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].oneOf(['sm', 'md', 'lg', 'xl'])]),
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,

  /**
   * Used for DOM testing. https://testing-library.com/docs/queries/bytestid/
   */
  dataTestId: _propTypes["default"].string,
  id: _propTypes["default"].string,
  isDirty: _propTypes["default"].bool.isRequired,
  isFiltering: _propTypes["default"].bool.isRequired,
  isOpen: _propTypes["default"].bool.isRequired,
  onApply: _propTypes["default"].func.isRequired,
  onClear: _propTypes["default"].func.isRequired,
  onClose: _propTypes["default"].func.isRequired,
  rows: _propTypes["default"].arrayOf(_propTypes["default"].shape({})),
  style: _propTypes["default"].shape({})
};
var defaultProps = {
  breakpointDown: undefined,
  children: undefined,
  className: undefined,
  dataTestId: "".concat(_constants.UI_CLASS_NAME, "-drawer_filters_drawer"),
  id: undefined,
  rows: undefined,
  style: {}
};

function DrawerFiltersDrawer(props) {
  var breakpointDown = props.breakpointDown,
      children = props.children,
      className = props.className,
      dataTestId = props.dataTestId,
      id = props.id,
      isDirty = props.isDirty,
      isFiltering = props.isFiltering,
      isOpen = props.isOpen,
      onApply = props.onApply,
      onClear = props.onClear,
      onClose = props.onClose,
      rows = props.rows,
      style = props.style;
  return /*#__PURE__*/_react["default"].createElement(_filtersDrawer["default"], {
    breakpointDown: breakpointDown,
    className: className,
    "data-testid": dataTestId,
    id: id,
    isDirty: isDirty,
    isFiltering: isFiltering,
    isOpen: isOpen,
    moduleType: "drawer",
    onApply: onApply,
    onClear: onClear,
    onClose: onClose,
    rows: rows,
    style: style
  }, children);
}

DrawerFiltersDrawer.propTypes = propTypes;
DrawerFiltersDrawer.defaultProps = defaultProps;
var _default = DrawerFiltersDrawer;
exports["default"] = _default;