"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _constants = require("../../global/constants");

var _filtersRail = _interopRequireDefault(require("../filtersRail"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var propTypes = {
  breakpointUp: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].oneOf(['sm', 'md', 'lg', 'xl'])]),
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,

  /**
   * Used for DOM testing. https://testing-library.com/docs/queries/bytestid/
   */
  dataTestId: _propTypes["default"].string,
  id: _propTypes["default"].string,
  isOpen: _propTypes["default"].bool,
  isScrollable: _propTypes["default"].bool,
  style: _propTypes["default"].shape({})
};
var defaultProps = {
  breakpointUp: undefined,
  children: undefined,
  className: undefined,
  dataTestId: "".concat(_constants.UI_CLASS_NAME, "-drawer_filters_rail"),
  id: undefined,
  isOpen: undefined,
  isScrollable: false,
  style: {}
};

function DrawerFiltersRail(props) {
  var breakpointUp = props.breakpointUp,
      children = props.children,
      className = props.className,
      dataTestId = props.dataTestId,
      id = props.id,
      isOpen = props.isOpen,
      isScrollable = props.isScrollable,
      style = props.style;
  return /*#__PURE__*/_react["default"].createElement(_filtersRail["default"], {
    breakpointUp: breakpointUp,
    className: className,
    "data-testid": dataTestId,
    id: id,
    isOpen: isOpen,
    isScrollable: isScrollable,
    moduleType: "drawer",
    style: style
  }, children);
}

DrawerFiltersRail.propTypes = propTypes;
DrawerFiltersRail.defaultProps = defaultProps;
var _default = DrawerFiltersRail;
exports["default"] = _default;