"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _constants = require("../../global/constants");

var _subNavigation = _interopRequireDefault(require("../../navigation/subNavigation/subNavigation"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var hasClassName = 'drawer-has_navigation';
var propTypes = {
  className: _propTypes["default"].string,
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({})).isRequired,

  /**
   * Used for DOM testing. https://testing-library.com/docs/queries/bytestid/
   */
  dataTestId: _propTypes["default"].string,
  selectedColumnIndex: _propTypes["default"].number,
  style: _propTypes["default"].shape({})
};
var defaultProps = {
  className: undefined,
  dataTestId: "".concat(_constants.UI_CLASS_NAME, "-drawer_navigation"),
  selectedColumnIndex: 0,
  style: {}
};

var DrawerNavigation = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(DrawerNavigation, _React$PureComponent);

  var _super = _createSuper(DrawerNavigation);

  function DrawerNavigation() {
    _classCallCheck(this, DrawerNavigation);

    return _super.apply(this, arguments);
  }

  _createClass(DrawerNavigation, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.drawerNavigationRef.closest('.ui.drawer').classList.add(hasClassName);
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.drawerNavigationRef.closest('.ui.drawer').classList.remove(hasClassName);
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;

      var _this$props = this.props,
          columns = _this$props.columns,
          className = _this$props.className,
          dataTestId = _this$props.dataTestId,
          selectedColumnIndex = _this$props.selectedColumnIndex,
          style = _this$props.style;
      var containerClasses = (0, _classnames["default"])('ui', 'drawer--navigation', className);
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: containerClasses,
        "data-testid": dataTestId,
        ref: function ref(_ref) {
          _this.drawerNavigationRef = _ref;
        },
        style: style
      }, /*#__PURE__*/_react["default"].createElement(_subNavigation["default"], {
        border: "both",
        selected: selectedColumnIndex,
        style: {
          margin: 0
        }
      }, _lodash["default"].map(columns, function (column, index) {
        return /*#__PURE__*/_react["default"].createElement(_subNavigation["default"].Item, {
          key: "drawer-navigation-item-".concat(index),
          label: column.label || 'Need A Label',
          onClick: column.onClick
        });
      })));
    }
  }]);

  return DrawerNavigation;
}(_react["default"].PureComponent);

DrawerNavigation.propTypes = propTypes;
DrawerNavigation.defaultProps = defaultProps;
var _default = DrawerNavigation;
exports["default"] = _default;