"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _constants = require("../../global/constants");

var _header = _interopRequireDefault(require("../../dataDisplay/header"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  className: _propTypes["default"].string,
  closeButton: _propTypes["default"].shape({}),
  closeButtonStyle: _propTypes["default"].shape({}),

  /**
   * Used for DOM testing. https://testing-library.com/docs/queries/bytestid/
   */
  dataTestId: _propTypes["default"].string,
  style: _propTypes["default"].shape({}),
  title: _propTypes["default"].oneOfType([_propTypes["default"].node, _propTypes["default"].string]),
  titleStyle: _propTypes["default"].shape({})
};
var defaultProps = {
  className: undefined,
  closeButton: undefined,
  closeButtonStyle: {},
  dataTestId: "".concat(_constants.UI_CLASS_NAME, "-drawer_title_bar"),
  style: {},
  title: undefined,
  titleStyle: {}
};
var hasClassName = 'drawer-has_title_bar';
var hasWingClassName = 'drawer--wing-has_title_bar';

var DrawerTitleBar = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(DrawerTitleBar, _React$PureComponent);

  var _super = _createSuper(DrawerTitleBar);

  function DrawerTitleBar() {
    _classCallCheck(this, DrawerTitleBar);

    return _super.apply(this, arguments);
  }

  _createClass(DrawerTitleBar, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var closestDrawer = this.drawerTitleBarRef.closest('.ui.drawer');
      var closestWing = this.drawerTitleBarRef.closest('.ui.drawer--wing');

      if (closestWing) {
        closestWing.classList.add(hasWingClassName);
        return null;
      }

      closestDrawer.classList.add(hasClassName);
      return null;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var closestDrawer = this.drawerTitleBarRef.closest('.ui.drawer');
      var closestWing = this.drawerTitleBarRef.closest('.ui.drawer--wing');

      if (closestWing) {
        closestWing.classList.remove(hasWingClassName);
        return null;
      }

      closestDrawer.classList.remove(hasClassName);
      return null;
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;

      var _this$props = this.props,
          className = _this$props.className,
          closeButton = _this$props.closeButton,
          closeButtonStyle = _this$props.closeButtonStyle,
          dataTestId = _this$props.dataTestId,
          style = _this$props.style,
          title = _this$props.title,
          titleStyle = _this$props.titleStyle;
      var containerClasses = (0, _classnames["default"])('ui', 'drawer--title_bar', className);
      return /*#__PURE__*/_react["default"].createElement("header", {
        className: containerClasses,
        "data-testid": dataTestId,
        ref: function ref(_ref) {
          _this.drawerTitleBarRef = _ref;
        },
        style: style
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "drawer--title_bar_inner"
      }, _lodash["default"].isObject(title) && title, _lodash["default"].isString(title) && /*#__PURE__*/_react["default"].createElement(_header["default"], {
        as: "h2",
        className: "title",
        style: titleStyle
      }, title), _lodash["default"].isObject(closeButton) ? /*#__PURE__*/_react["default"].createElement("div", {
        className: "close-button",
        style: closeButtonStyle
      }, closeButton) : null));
    }
  }]);

  return DrawerTitleBar;
}(_react["default"].PureComponent);

DrawerTitleBar.propTypes = propTypes;
DrawerTitleBar.defaultProps = defaultProps;
var _default = DrawerTitleBar;
exports["default"] = _default;