"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _button = _interopRequireDefault(require("../../inputs/button"));

var _checkbox = _interopRequireDefault(require("../../inputs/checkbox/checkbox"));

var _drawer = _interopRequireDefault(require("../drawer"));

var _dropdown = _interopRequireDefault(require("../../inputs/dropdown/dropdown"));

var _header = _interopRequireDefault(require("../../dataDisplay/header"));

var _icon = _interopRequireDefault(require("../../dataDisplay/icon"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var DrawerFiltersDrawer = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(DrawerFiltersDrawer, _React$PureComponent);

  var _super = _createSuper(DrawerFiltersDrawer);

  function DrawerFiltersDrawer() {
    _classCallCheck(this, DrawerFiltersDrawer);

    return _super.apply(this, arguments);
  }

  _createClass(DrawerFiltersDrawer, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          className = _this$props.className,
          isDirty = _this$props.isDirty,
          isFiltering = _this$props.isFiltering,
          isOpen = _this$props.isOpen,
          onApply = _this$props.onApply,
          onClear = _this$props.onClear,
          onClose = _this$props.onClose,
          position = _this$props.position,
          rows = _this$props.rows,
          style = _this$props.style;
      var containerClasses = (0, _classnames["default"])('ui', 'drawer--filters_drawer', className);
      var isClearFiltersDisabled = isFiltering || isDirty;
      var clearFiltersClasses = (0, _classnames["default"])('clear-filters', 'font-size-xsmall', 'font-weight-semibold', {
        'color-disable': !isClearFiltersDisabled
      });
      var rowKeyNum = 1;
      var itemKeyNum = 1;
      var itemsId = 1;
      return /*#__PURE__*/_react["default"].createElement(_drawer["default"], {
        className: containerClasses,
        isOpen: isOpen,
        maxWidth: 250,
        position: position,
        style: style
      }, /*#__PURE__*/_react["default"].createElement(_drawer["default"].TitleBar, {
        closeButton: /*#__PURE__*/_react["default"].createElement(_icon["default"], {
          compact: true,
          onClick: onClose,
          type: "times"
        }),
        title: "Filters"
      }), /*#__PURE__*/_react["default"].createElement(_drawer["default"].ActionBar, {
        columns: [{
          flexGrow: 1,
          jsx: /*#__PURE__*/_react["default"].createElement("a", {
            className: clearFiltersClasses,
            onClick: !isClearFiltersDisabled ? null : onClear
          }, "Clear Filters")
        }, {
          jsx: /*#__PURE__*/_react["default"].createElement(_button["default"], {
            disabled: !isDirty,
            color: "success",
            onClick: onApply,
            style: {
              margin: 0
            }
          }, /*#__PURE__*/_react["default"].createElement("span", null, "Apply"))
        }]
      }), /*#__PURE__*/_react["default"].createElement(_drawer["default"].Content, null, _lodash["default"].map(rows, function (row) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "drawer--filters_drawer-row",
          key: "drawer--filters-drawer-row-".concat(rowKeyNum++)
        }, row.header && /*#__PURE__*/_react["default"].createElement(_header["default"], {
          weight: "bold"
        }, row.header), _lodash["default"].isArray(row.items) && _lodash["default"].map(row.items, function (item) {
          var className = 'drawer--filters_drawer-item';
          var itemKey = "drawer--filters-drawer-row-item-".concat(itemKeyNum++);

          if (!item.jsx && !item.checkbox && !item.dropdown) {
            console.warn('<Drawer.FiltersDrawer>\'s rows.items must have one of the ' + 'following properties: checkbox, dropdown or jsx.');
          } else if (!item.jsx && item.checkbox && !item.dropdown) {
            // Checkbox
            return /*#__PURE__*/_react["default"].createElement("div", {
              className: className,
              key: itemKey
            }, /*#__PURE__*/_react["default"].createElement(_checkbox["default"], {
              checked: item.checkbox.checked,
              id: item.checkbox.id || _lodash["default"].toString(itemsId++),
              label: item.checkbox.label,
              labelWeight: "semibold",
              onChange: function onChange(id, checked) {
                return item.checkbox.onChange(id, checked);
              },
              size: "small"
            }));
          } else if (!item.jsx && !item.checkbox && item.dropdown) {
            // Dropdown
            return /*#__PURE__*/_react["default"].createElement("div", {
              className: className,
              key: itemKey
            }, /*#__PURE__*/_react["default"].createElement(_dropdown["default"], {
              clearable: false,
              className: item.dropdown.className,
              fluid: true,
              id: item.dropdown.id,
              onChange: function onChange(selectedOption) {
                return item.dropdown.onChange(selectedOption);
              },
              options: item.dropdown.options,
              searchable: false,
              selection: true,
              selectionOptionComponent: item.dropdown.selectionCustomComponent,
              selectionUnderline: true,
              style: item.dropdown.style,
              value: item.dropdown.value
            }));
          } else if (item.jsx && !item.checkbox && !item.dropdown) {
            // JSX
            return /*#__PURE__*/_react["default"].createElement("div", {
              className: className,
              key: itemKey
            }, item.jsx);
          }
        }));
      })));
    }
  }]);

  return DrawerFiltersDrawer;
}(_react["default"].PureComponent);

DrawerFiltersDrawer.defaultProps = {
  position: 'right'
};
DrawerFiltersDrawer.propTypes = {
  className: _propTypes["default"].string,
  isDirty: _propTypes["default"].bool.isRequired,
  isFiltering: _propTypes["default"].bool.isRequired,
  isOpen: _propTypes["default"].bool.isRequired,
  onApply: _propTypes["default"].func.isRequired,
  onClear: _propTypes["default"].func.isRequired,
  onClose: _propTypes["default"].func.isRequired,
  position: _propTypes["default"].oneOf(['left', 'right']),
  rows: _propTypes["default"].array.isRequired,
  style: _propTypes["default"].shape({})
};
var _default = DrawerFiltersDrawer;
exports["default"] = _default;