"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = require("lodash");

var _classnames = _interopRequireDefault(require("classnames"));

var _reactResponsive = _interopRequireDefault(require("react-responsive"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _constants = require("../../global/constants");

var _button = _interopRequireDefault(require("../../inputs/button"));

var _checkbox = _interopRequireDefault(require("../../inputs/checkbox/checkbox"));

var _drawer = _interopRequireDefault(require("../../surfaces/drawer"));

var _dropdown = _interopRequireDefault(require("../../inputs/dropdown/dropdown"));

var _filtersDrawerNestedTogglesLabel = _interopRequireDefault(require("./filtersDrawerNestedTogglesLabel"));

var _filtersDrawerMultiSelectLabel = _interopRequireDefault(require("./filtersDrawerMultiSelectLabel"));

var _filtersDrawerNestedTogglesValueLabel = _interopRequireDefault(require("./filtersDrawerNestedTogglesValueLabel"));

var _filtersDrawerNestedTogglesWingOptionLabel = _interopRequireDefault(require("./filtersDrawerNestedTogglesWingOptionLabel"));

var _header = _interopRequireDefault(require("../../dataDisplay/header"));

var _icon = _interopRequireDefault(require("../../dataDisplay/icon"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var breakpoints = {
  values: {
    sm: 0,
    md: 767,
    lg: 1199,
    xl: 1685
  }
};
var propTypes = {
  breakpointDown: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].oneOf(['sm', 'md', 'lg', 'xl'])]),
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,

  /**
   * Used for DOM testing. https://testing-library.com/docs/queries/bytestid/
   */
  dataTestId: _propTypes["default"].string,
  id: _propTypes["default"].string,
  isDirty: _propTypes["default"].bool.isRequired,
  isFiltering: _propTypes["default"].bool.isRequired,
  isOpen: _propTypes["default"].bool.isRequired,
  moduleType: _propTypes["default"].string.isRequired,
  onApply: _propTypes["default"].func.isRequired,
  onClear: _propTypes["default"].func.isRequired,
  onClose: _propTypes["default"].func.isRequired,
  rows: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    header: _propTypes["default"].string,
    items: _propTypes["default"].arrayOf(_propTypes["default"].shape({
      checkbox: _propTypes["default"].shape({
        checked: _propTypes["default"].bool,
        className: _propTypes["default"].string,

        /**
         * A Checkbox can be disabled.
         */
        disable: _propTypes["default"].bool,

        /**
         * Deprecated prop. Please use `disable` instead.
         */
        disabled: _propTypes["default"].bool,
        id: _propTypes["default"].string,
        label: _propTypes["default"].oneOfType([_propTypes["default"].shape({}), _propTypes["default"].string]),
        name: _propTypes["default"].string,
        onChange: _propTypes["default"].func,
        style: _propTypes["default"].shape({})
      }),
      dropdown: _propTypes["default"].shape({
        onChange: _propTypes["default"].func,
        options: _propTypes["default"].arrayOf(_propTypes["default"].shape({
          label: _propTypes["default"].string,
          value: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string])
        })),
        value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].shape({
          label: _propTypes["default"].string,
          value: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string])
        })])
      }),
      jsx: _propTypes["default"].node,
      multiSelect: _propTypes["default"].shape({
        placeholder: _propTypes["default"].string,
        onChange: _propTypes["default"].func,
        options: _propTypes["default"].arrayOf(_propTypes["default"].shape({
          label: _propTypes["default"].string,
          value: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string])
        })),
        value: _propTypes["default"].arrayOf(_propTypes["default"].shape({
          label: _propTypes["default"].string,
          value: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string])
        }))
      }),
      nestedToggles: _propTypes["default"].shape({
        clearable: _propTypes["default"].bool,
        label: _propTypes["default"].string,
        onChange: _propTypes["default"].func,
        options: _propTypes["default"].arrayOf(_propTypes["default"].shape({
          label: _propTypes["default"].string,
          value: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string])
        })),
        singleSelection: _propTypes["default"].bool,
        value: _propTypes["default"].arrayOf(_propTypes["default"].shape({
          label: _propTypes["default"].string,
          value: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string])
        }))
      }),
      toggle: _propTypes["default"].shape({
        checked: _propTypes["default"].bool,
        className: _propTypes["default"].string,

        /**
         * A Toggle can be disabled.
         */
        disable: _propTypes["default"].bool,

        /**
         * Deprecated prop. Please use `disable` instead.
         */
        disabled: _propTypes["default"].bool,
        id: _propTypes["default"].string,
        label: _propTypes["default"].string,
        labelIconColor: _propTypes["default"].string,
        labelIconType: _propTypes["default"].string,
        name: _propTypes["default"].string,
        onChange: _propTypes["default"].func,
        style: _propTypes["default"].shape({})
      })
    }))
  })),
  style: _propTypes["default"].shape({})
};
var defaultProps = {
  breakpointDown: breakpoints.values.md,
  children: undefined,
  className: undefined,
  dataTestId: "".concat(_constants.UI_CLASS_NAME, "-fitlersDrawer"),
  id: undefined,
  rows: undefined,
  style: {}
};

var FiltersDrawer = /*#__PURE__*/function (_React$Component) {
  _inherits(FiltersDrawer, _React$Component);

  var _super = _createSuper(FiltersDrawer);

  _createClass(FiltersDrawer, null, [{
    key: "onMultiSelectChange",
    value: function onMultiSelectChange(onItemChange, value, selectedOption) {
      var filteredOptions = (0, _lodash.union)(value, [selectedOption]);
      onItemChange(filteredOptions);
    }
  }, {
    key: "onNestedTogglesValueLabelClick",
    value: function onNestedTogglesValueLabelClick(nestedTogglesData, selectedOption) {
      var selectedOptions = (0, _lodash.filter)(nestedTogglesData.value, function (d) {
        return d.value !== selectedOption.value;
      });
      nestedTogglesData.onChange(selectedOptions);
    }
  }]);

  function FiltersDrawer() {
    var _this;

    _classCallCheck(this, FiltersDrawer);

    _this = _super.call(this);
    /**
     * The nestedTogglesData object is only to be populated when props.rows.items.nestedToggles
     * is true and a label onClick event handler is triggered.
     */

    _this.state = {
      nestedTogglesData: {}
    };
    _this.onApplyClick = _this.onApplyClick.bind(_assertThisInitialized(_this));
    _this.onClearClick = _this.onClearClick.bind(_assertThisInitialized(_this));
    _this.onNestedTogglesCloseWingClick = _this.onNestedTogglesCloseWingClick.bind(_assertThisInitialized(_this));
    _this.onNestedTogglesLabelClick = _this.onNestedTogglesLabelClick.bind(_assertThisInitialized(_this));
    _this.onNestedTogglesWingOptionLabelClick = _this.onNestedTogglesWingOptionLabelClick.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(FiltersDrawer, [{
    key: "onApplyClick",
    value: function onApplyClick() {
      var onApply = this.props.onApply;
      onApply();
    }
  }, {
    key: "onClearClick",
    value: function onClearClick() {
      var onClear = this.props.onClear;
      onClear();
    }
  }, {
    key: "onNestedTogglesCloseWingClick",
    value: function onNestedTogglesCloseWingClick() {
      var nestedTogglesData = this.state.nestedTogglesData;
      this.setState({
        nestedTogglesData: {}
      }, function () {
        nestedTogglesData.onChange(nestedTogglesData.value);
      });
    }
  }, {
    key: "onNestedTogglesLabelClick",
    value: function onNestedTogglesLabelClick(nestedTogglesData) {
      this.setState({
        nestedTogglesData: (0, _lodash.cloneDeep)(nestedTogglesData)
      });
    }
  }, {
    key: "onNestedTogglesWingOptionLabelClick",
    value: function onNestedTogglesWingOptionLabelClick(selectedOption) {
      var nestedTogglesData = this.state.nestedTogglesData;
      var selectedOptions;

      if (nestedTogglesData.singleSelection) {
        selectedOptions = [selectedOption];
      } else if ((0, _lodash.some)(nestedTogglesData.value, selectedOption)) {
        // Subtract
        selectedOptions = (0, _lodash.filter)(nestedTogglesData.value, function (d) {
          return d.value !== selectedOption.value;
        });
      } else {
        // Add
        selectedOptions = (0, _lodash.sortBy)([].concat(_toConsumableArray(nestedTogglesData.value || []), [selectedOption]), ['value']);
      }

      var newNestedTogglesData = (0, _lodash.mapValues)(nestedTogglesData, function (data, key) {
        var newData = data;

        if (key === 'value') {
          newData = selectedOptions;
        }

        return newData;
      });
      this.setState({
        nestedTogglesData: newNestedTogglesData
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          breakpointDown = _this$props.breakpointDown,
          children = _this$props.children,
          className = _this$props.className,
          dataTestId = _this$props.dataTestId,
          id = _this$props.id,
          isDirty = _this$props.isDirty,
          isFiltering = _this$props.isFiltering,
          isOpen = _this$props.isOpen,
          moduleType = _this$props.moduleType,
          onClose = _this$props.onClose,
          rows = _this$props.rows,
          style = _this$props.style;
      var nestedTogglesData = this.state.nestedTogglesData;
      var bemClassName = "".concat(moduleType, "--filters_drawer");
      var bemBlockClassName = "".concat(moduleType, "_filters_drawer");
      var containerClasses = (0, _classnames["default"])('ui', bemClassName, className);
      var canClear = isFiltering || isDirty;
      var clearFiltersClasses = (0, _classnames["default"])('clear-filters', 'font-size-xsmall', 'font-weight-semibold');
      var isNestedTogglesOptionsEmpty = (0, _lodash.isEmpty)(nestedTogglesData);
      var rowKeyNum = 1;
      var itemKeyNum = 1;
      var multiSelectLabelKeyNum = 1;
      var nestedTogglesValueLabelKeyNum = 1;
      var nestedTogglesOptionLabelKeyNum = 1;
      return /*#__PURE__*/_react["default"].createElement(_reactResponsive["default"], {
        maxWidth: breakpointDown
      }, /*#__PURE__*/_react["default"].createElement(_drawer["default"], {
        className: containerClasses,
        "data-testid": dataTestId,
        id: id,
        isOpen: isOpen,
        onClose: onClose,
        style: style,
        wing: /*#__PURE__*/_react["default"].createElement(_drawer["default"].Wing, {
          className: "".concat(bemBlockClassName, "--nested_toggles_wing"),
          isOpen: !isNestedTogglesOptionsEmpty
        }, /*#__PURE__*/_react["default"].createElement(_drawer["default"].TitleBar, {
          className: "nested_toggles_wing--title_bar",
          title: /*#__PURE__*/_react["default"].createElement(_icon["default"], {
            className: "nested_toggles_wing--close_button",
            onClick: this.onNestedTogglesCloseWingClick,
            size: "medium",
            type: "chevron-left"
          })
        }), /*#__PURE__*/_react["default"].createElement(_drawer["default"].Content, {
          className: "nested_toggles_wing--content"
        }, /*#__PURE__*/_react["default"].createElement(_header["default"], {
          className: "nested_toggles_wing--title",
          size: "small",
          weight: "bold"
        }, nestedTogglesData.label), /*#__PURE__*/_react["default"].createElement("div", {
          className: "nested_toggles_wing--options"
        }, !isNestedTogglesOptionsEmpty && (0, _lodash.map)(nestedTogglesData.options, function (option) {
          nestedTogglesOptionLabelKeyNum += 1;
          var isSelected = (0, _lodash.some)(nestedTogglesData.value, function (v) {
            var selectedValue = (0, _lodash.isObject)(v) ? v.value : v;
            return option.value === selectedValue;
          });
          return /*#__PURE__*/_react["default"].createElement(_filtersDrawerNestedTogglesWingOptionLabel["default"], {
            key: nestedTogglesOptionLabelKeyNum,
            isSelected: isSelected,
            onClick: _this2.onNestedTogglesWingOptionLabelClick,
            option: option
          });
        }))))
      }, /*#__PURE__*/_react["default"].createElement(_drawer["default"].TitleBar, {
        className: "".concat(bemBlockClassName, "--title_bar"),
        closeButton: /*#__PURE__*/_react["default"].createElement(_icon["default"], {
          className: "".concat(bemBlockClassName, "--close_button"),
          compact: true,
          onClick: onClose,
          type: "times"
        }),
        title: /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(bemBlockClassName, "--actions"),
          title: "Filters"
        }, /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(bemBlockClassName, "--clear_column")
        }, canClear ? /*#__PURE__*/_react["default"].createElement("a", {
          className: clearFiltersClasses,
          onClick: this.onClearClick
        }, "Clear Filters") : /*#__PURE__*/_react["default"].createElement(_icon["default"], {
          color: "static",
          compact: true,
          size: "medium",
          type: "filter"
        })), /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(bemBlockClassName, "--apply_column")
        }, isDirty && /*#__PURE__*/_react["default"].createElement(_button["default"], {
          color: "success",
          designVersion: 2,
          icon: true,
          innerStyle: {
            height: '32px',
            width: '32px'
          },
          onClick: this.onApplyClick,
          style: {
            height: '32px',
            minHeight: '32px',
            width: '32px'
          }
        }, /*#__PURE__*/_react["default"].createElement(_icon["default"], {
          compact: true,
          type: "check"
        }))))
      }), /*#__PURE__*/_react["default"].createElement(_drawer["default"].Content, null, (0, _lodash.map)(rows, function (row) {
        rowKeyNum += 1;
        return /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(bemBlockClassName, "--row"),
          key: "".concat(bemBlockClassName, "--filters-drawer-row-").concat(rowKeyNum)
        }, row.header && /*#__PURE__*/_react["default"].createElement(_header["default"], {
          className: "".concat(bemBlockClassName, "--header"),
          weight: "bold"
        }, row.header), /*#__PURE__*/_react["default"].createElement("div", {
          className: "".concat(bemBlockClassName, "--items")
        }, (0, _lodash.isArray)(row.items) && (0, _lodash.map)(row.items, function (item) {
          var _ClassNames;

          var checkbox = item.checkbox,
              dropdown = item.dropdown,
              jsx = item.jsx,
              multiSelect = item.multiSelect,
              nestedToggles = item.nestedToggles,
              toggle = item.toggle;
          var itemClassName = (0, _classnames["default"])("".concat(bemBlockClassName, "--item"), (_ClassNames = {}, _defineProperty(_ClassNames, "".concat(bemBlockClassName, "--item-checkbox"), checkbox), _defineProperty(_ClassNames, "".concat(bemBlockClassName, "--item-dropdown"), dropdown), _defineProperty(_ClassNames, "".concat(bemBlockClassName, "--item-jsx"), jsx), _defineProperty(_ClassNames, "".concat(bemBlockClassName, "--item-multi_select"), multiSelect), _defineProperty(_ClassNames, "".concat(bemBlockClassName, "--item-nested_toggles"), nestedToggles), _defineProperty(_ClassNames, "".concat(bemBlockClassName, "--item-toggle"), toggle), _ClassNames));
          itemKeyNum += 1;
          var itemKey = "".concat(bemBlockClassName, "--item-").concat(itemKeyNum);

          if (!dropdown && !jsx && !multiSelect && !nestedToggles && !toggle && checkbox) {
            // Checkbox
            return /*#__PURE__*/_react["default"].createElement("div", {
              className: itemClassName,
              key: itemKey
            }, /*#__PURE__*/_react["default"].createElement(_checkbox["default"], {
              checked: checkbox.checked,
              className: checkbox.className,
              disabled: checkbox.disable || checkbox.disabled,
              fluid: true,
              id: checkbox.id,
              label: checkbox.label,
              name: checkbox.name,
              onChange: checkbox.onChange,
              style: checkbox.style
            }));
          }

          if (!checkbox && !jsx && !multiSelect && !nestedToggles && !toggle && dropdown) {
            // Dropdown
            return /*#__PURE__*/_react["default"].createElement("div", {
              className: itemClassName,
              key: itemKey
            }, /*#__PURE__*/_react["default"].createElement(_dropdown["default"], {
              clearable: false,
              className: dropdown.className,
              fluid: true,
              id: dropdown.id,
              onChange: function onChange(selectedOption) {
                dropdown.onChange(selectedOption);
              },
              options: dropdown.options,
              searchable: false,
              selection: true,
              selectionOptionComponent: dropdown.selectionCustomComponent,
              style: dropdown.style,
              value: dropdown.value
            }));
          }

          if (!checkbox && !dropdown && !multiSelect && !nestedToggles && !toggle && jsx) {
            return /*#__PURE__*/_react["default"].createElement("div", {
              className: className,
              key: itemKey
            }, jsx);
          }

          if (!checkbox && !dropdown && !jsx && !nestedToggles && !toggle && multiSelect) {
            // Multi Select
            var modifiedOptions = (0, _lodash.differenceWith)(multiSelect.options, multiSelect.value, function (option, value) {
              var selectedValue = (0, _lodash.isObject)(value) ? value.value : value;
              return option.value === selectedValue;
            });
            return /*#__PURE__*/_react["default"].createElement("div", {
              className: className,
              key: itemKey
            }, /*#__PURE__*/_react["default"].createElement(_dropdown["default"], {
              clearable: false,
              className: multiSelect.className,
              fluid: true,
              iconType: "plus",
              id: multiSelect.id,
              onChange: function onChange(selectedOption) {
                FiltersDrawer.onMultiSelectChange(multiSelect.onChange, multiSelect.value, selectedOption);
              },
              options: modifiedOptions,
              placeholder: multiSelect.placeholder,
              searchable: false,
              selection: true,
              selectionOptionComponent: multiSelect.selectionCustomComponent,
              style: multiSelect.style,
              value: ""
            }), !(0, _lodash.isEmpty)(multiSelect.value) && (0, _lodash.map)(multiSelect.value, function (v) {
              var selectedValue = (0, _lodash.isObject)(v) ? v.value : v;
              var selectedOption = (0, _lodash.find)(multiSelect.options, {
                value: selectedValue
              });
              multiSelectLabelKeyNum += 1;
              return /*#__PURE__*/_react["default"].createElement(_filtersDrawerMultiSelectLabel["default"], {
                color: multiSelect.labelColor,
                key: "multi-select-label-".concat(multiSelectLabelKeyNum),
                onItemChange: multiSelect.onChange,
                label: selectedOption.label,
                selectedOption: selectedOption,
                value: multiSelect.value
              });
            })); // JSX
          }

          if (!checkbox && !dropdown && !jsx && !multiSelect && !toggle && nestedToggles) {
            // Nested Toggles
            return /*#__PURE__*/_react["default"].createElement("div", {
              className: className,
              key: itemKey
            }, /*#__PURE__*/_react["default"].createElement(_filtersDrawerNestedTogglesLabel["default"], {
              onClick: _this2.onNestedTogglesLabelClick,
              nestedTogglesData: nestedToggles
            }), !(0, _lodash.isEmpty)(nestedToggles.value) && /*#__PURE__*/_react["default"].createElement("div", null, (0, _lodash.map)(nestedToggles.value, function (value) {
              nestedTogglesValueLabelKeyNum += 1;
              var selectedValue = (0, _lodash.isObject)(value) ? value.value : value;
              var option = (0, _lodash.find)(nestedToggles.options, {
                value: selectedValue
              });
              return /*#__PURE__*/_react["default"].createElement(_filtersDrawerNestedTogglesValueLabel["default"], {
                key: "nested-toggles-selected-filter-".concat(nestedTogglesValueLabelKeyNum),
                nestedTogglesData: nestedToggles,
                onClick: FiltersDrawer.onNestedTogglesValueLabelClick,
                option: option
              });
            })));
          }

          if (!dropdown && !jsx && !multiSelect && !nestedToggles && !checkbox && toggle) {
            // Toggle
            var newLabel = toggle.label;

            if (toggle.labelIconType) {
              newLabel = /*#__PURE__*/_react["default"].createElement("span", {
                className: "item_toggle--label_with_icon"
              }, /*#__PURE__*/_react["default"].createElement(_icon["default"], {
                color: toggle.labelIconColor || 'highlight',
                size: 24,
                type: toggle.labelIconType
              }), toggle.label);
            }

            return /*#__PURE__*/_react["default"].createElement("div", {
              className: itemClassName,
              key: itemKey
            }, /*#__PURE__*/_react["default"].createElement(_checkbox["default"], {
              align: "right",
              checked: toggle.checked,
              className: toggle.className,
              disabled: toggle.disable || toggle.disabled,
              fluid: true,
              id: toggle.id,
              label: newLabel,
              name: toggle.name,
              onChange: toggle.onChange,
              style: toggle.style,
              toggle: true
            }));
          }

          console.warn( // eslint-disable-line no-console
          '<Page.FiltersDrawer>\'s rows.items must ' + 'have one of the following properties: ' + 'dropdown, labels, multiSelect or jsx.');
          return null;
        })));
      }), children)));
    }
  }]);

  return FiltersDrawer;
}(_react["default"].Component);

FiltersDrawer.propTypes = propTypes;
FiltersDrawer.defaultProps = defaultProps;
var _default = FiltersDrawer;
exports["default"] = _default;