"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = require("lodash");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _label = _interopRequireDefault(require("../../dataDisplay/label"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  color: _propTypes["default"].string,
  label: _propTypes["default"].string.isRequired,
  onItemChange: _propTypes["default"].func.isRequired,
  selectedOption: _propTypes["default"].shape({
    value: _propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string]).isRequired
  }).isRequired,
  value: _propTypes["default"].arrayOf(_propTypes["default"].shape({})).isRequired
};
var defaultProps = {
  color: undefined
};

var FiltersDrawerMultiSelectLabel = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(FiltersDrawerMultiSelectLabel, _React$PureComponent);

  var _super = _createSuper(FiltersDrawerMultiSelectLabel);

  function FiltersDrawerMultiSelectLabel() {
    var _this;

    _classCallCheck(this, FiltersDrawerMultiSelectLabel);

    _this = _super.call(this);
    _this.onClearClick = _this.onClearClick.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(FiltersDrawerMultiSelectLabel, [{
    key: "onClearClick",
    value: function onClearClick() {
      var _this$props = this.props,
          onItemChange = _this$props.onItemChange,
          selectedOption = _this$props.selectedOption,
          value = _this$props.value;
      var filteredOptions = (0, _lodash.filter)(value, function (v) {
        var currentValue = (0, _lodash.isObject)(v) ? v.value : v;
        return currentValue !== selectedOption.value;
      });
      onItemChange(filteredOptions);
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          color = _this$props2.color,
          label = _this$props2.label;
      return /*#__PURE__*/_react["default"].createElement(_label["default"], {
        color: color || 'highlight',
        onClearClick: this.onClearClick,
        style: {
          marginRight: '5px',
          marginTop: '11px'
        }
      }, label);
    }
  }]);

  return FiltersDrawerMultiSelectLabel;
}(_react["default"].PureComponent);

FiltersDrawerMultiSelectLabel.propTypes = propTypes;
FiltersDrawerMultiSelectLabel.defaultProps = defaultProps;
var _default = FiltersDrawerMultiSelectLabel;
exports["default"] = _default;