"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function InfoBar(props) {
  var as = props.as,
      children = props.children,
      className = props.className,
      color = props.color,
      style = props.style;
  var containerClasses = (0, _classnames["default"])('ui', 'info-bar', className, {
    'info-bar-color-one': color === 1,
    'info-bar-color-two': color === 2,
    'info-bar-color-three': color === 3,
    'info-bar-color-four': color === 4,
    'info-bar-color-five': color === 5,
    'info-bar-color-six': color === 6,
    'info-bar-color-seven': color === 7,
    'info-bar-color-eight': color === 8,
    'info-bar-color-nine': color === 9,
    'info-bar-color-ten': color === 10,
    'info-bar-color-eleven': color === 11
  });

  var ElementType = _utils["default"].getElementType(as, props);

  return /*#__PURE__*/_react["default"].createElement(ElementType, {
    className: containerClasses,
    style: style
  }, children);
}

var asEnums = ['div', 'section'];
var colorEnums = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11];
InfoBar.propTypes = {
  as: _propTypes["default"].oneOf(asEnums),
  children: _propTypes["default"].node,
  className: _propTypes["default"].string,
  color: _propTypes["default"].oneOf(colorEnums),
  style: _propTypes["default"].shape({}) // eslint-disable-line react/forbid-prop-types

};
InfoBar.defaultProps = {
  as: 'div',
  children: undefined,
  className: undefined,
  color: undefined,
  style: {}
};
var _default = InfoBar;
exports["default"] = _default;