"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = require("lodash");

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _constants = require("../../global/constants");

var _makeStyles = _interopRequireDefault(require("../../styles/makeStyles"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var propTypes = {
  /**
   * Defines the `align-items` style property.
   * It's applied for all screen sizes.
   */
  alignItems: _propTypes["default"].oneOf(['baseline', 'center', 'flex-end', 'flex-start', 'stretch']),

  /**
   * The content of the ModalContent
   */
  children: _propTypes["default"].node,

  /**
   * Override or extend the styles applied to ModalContent.
   */
  classes: _propTypes["default"].shape({
    root: _propTypes["default"].string
  }),

  /**
   * Assign additional class names to ModalContent.
   */
  className: _propTypes["default"].string,

  /**
   * The `id` of the ModalContent.
   */
  id: _propTypes["default"].string
};
var defaultProps = {
  alignItems: 'stretch',
  children: null,
  classes: null,
  className: null,
  id: null
};
var useStyles = (0, _makeStyles["default"])(function () {
  return {
    'alignItems-baseline': {
      alignItems: 'baseline'
    },
    'alignItems-center': {
      alignItems: 'center'
    },
    'alignItems-flexStart': {
      alignItems: 'flex-start'
    },
    'alignItems-flexEnd': {
      alignItems: 'flex-end'
    },
    'alignItems-stretch': {
      alignItems: 'stretch'
    },
    root: {
      display: 'flex',
      flexDirection: 'column',
      '& > h2': {
        margin: 0,
        '& + h6': {
          marginTop: 8
        },
        '& + p': {
          marginTop: 22
        }
      },
      '& > p': {
        margin: [[22, 0]]
      },
      '& > .icon': {
        '& + h2': {
          marginTop: 18
        }
      }
    }
  };
});

function ModalContent(props) {
  var alignItems = props.alignItems,
      children = props.children,
      className = props.className,
      id = props.id;
  var classes = useStyles(props);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])(_constants.BEM_MODAL_CONTENT, classes.root, className, classes["alignItems-".concat((0, _lodash.camelCase)(alignItems))]),
    id: id
  }, children);
}

ModalContent.propTypes = propTypes;
ModalContent.defaultProps = defaultProps;
var _default = ModalContent;
exports["default"] = _default;