"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = require("lodash");

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _button = _interopRequireDefault(require("../../inputs/button"));

var _header = _interopRequireDefault(require("../../dataDisplay/header"));

var _icon = _interopRequireDefault(require("../../dataDisplay/icon"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  children: _propTypes["default"].node,
  closeButton: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].shape({}), _propTypes["default"].string]),

  /**
   * Add a `data-testid` attribute to the Modal's Close Button.
   * Used for DOM Testing.
   * See https://testing-library.com/docs/queries/bytestid/.
   */
  closeButtonDataTestId: _propTypes["default"].string,
  inverse: _propTypes["default"].bool,
  onClose: _propTypes["default"].func,
  style: _propTypes["default"].shape({}),
  title: _propTypes["default"].string,
  titleTruncate: _propTypes["default"].bool
};
var defaultProps = {
  children: null,
  closeButton: null,
  closeButtonDataTestId: undefined,
  inverse: false,
  onClose: null,
  style: null,
  title: null,
  titleTruncate: false
};

var ModalHeader = /*#__PURE__*/function (_React$Component) {
  _inherits(ModalHeader, _React$Component);

  var _super = _createSuper(ModalHeader);

  function ModalHeader() {
    var _this;

    _classCallCheck(this, ModalHeader);

    _this = _super.call(this);
    _this.onCloseClick = _this.onCloseClick.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(ModalHeader, [{
    key: "onCloseClick",
    value: function onCloseClick() {
      var onClose = this.props.onClose;

      if ((0, _lodash.isFunction)(onClose)) {
        onClose();
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          closeButton = _this$props.closeButton,
          closeButtonDataTestId = _this$props.closeButtonDataTestId,
          inverse = _this$props.inverse,
          style = _this$props.style,
          title = _this$props.title,
          titleTruncate = _this$props.titleTruncate;
      var titleClass = (0, _classnames["default"])('title', {
        'modal-title-truncate': titleTruncate
      });
      var isCloseButtonNullish = (0, _lodash.isNil)(closeButton);
      var isCloseButtonAnObject = (0, _lodash.isObject)(closeButton);
      var isCloseButtonAString = (0, _lodash.isString)(closeButton); // If `closeButton` prop is nullish (`null`/`undefined`) then we want to render default Close Button
      // HOWEVER if `closeButton` prop is explicitly Boolean `false` we will respect user's wishes and not render a Close Button

      var shouldRenderCloseButton = isCloseButtonNullish || !!closeButton;
      return /*#__PURE__*/_react["default"].createElement("header", {
        className: "modal-header",
        style: style
      }, /*#__PURE__*/_react["default"].createElement(_header["default"], {
        as: "h3",
        className: titleClass,
        title: title,
        weight: "bold"
      }, title), /*#__PURE__*/_react["default"].createElement("div", {
        className: "modal-close-button-container"
      }, shouldRenderCloseButton && !isCloseButtonAnObject && /*#__PURE__*/_react["default"].createElement(_button["default"], {
        className: "modal-close-button",
        color: inverse ? 'transparent' : 'alternate',
        "data-testid": closeButtonDataTestId,
        onClick: this.onCloseClick,
        icon: true
      }, /*#__PURE__*/_react["default"].createElement(_icon["default"], {
        inverse: true,
        title: false,
        type: isCloseButtonAString ? closeButton : 'times'
      })), isCloseButtonAnObject && closeButton), children && /*#__PURE__*/_react["default"].createElement("div", {
        className: "modal-header-children"
      }, children));
    }
  }]);

  return ModalHeader;
}(_react["default"].Component);

ModalHeader.propTypes = propTypes;
ModalHeader.defaultProps = defaultProps;
var _default = ModalHeader;
exports["default"] = _default;