"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.waitForComponentToPaint = exports.createMatchMedia = void 0;

var _testUtils = require("react-dom/test-utils");

var _enzyme = require("enzyme");

var React = _interopRequireWildcard(require("react"));

var _cssMediaquery = _interopRequireDefault(require("css-mediaquery"));

var _styles = require("../styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

// eslint-disable-next-line react/prop-types
var getThemeProviderWrappingComponent = function getThemeProviderWrappingComponent(customTheme) {
  return function (_ref) {
    var children = _ref.children;
    return /*#__PURE__*/React.createElement(_styles.ThemeProvider, {
      theme: customTheme || _styles.theme
    }, children);
  };
};

var createMatchMedia = function createMatchMedia(width) {
  return function (query) {
    return {
      matches: _cssMediaquery["default"].match(query, {
        width: width
      }),
      addListener: function addListener() {},
      removeListener: function removeListener() {}
    };
  };
};

exports.createMatchMedia = createMatchMedia;

var waitForComponentToPaint = /*#__PURE__*/function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(wrapper) {
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return (0, _testUtils.act)( /*#__PURE__*/_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
              return regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                  switch (_context.prev = _context.next) {
                    case 0:
                      _context.next = 2;
                      return new Promise(function (resolve) {
                        return setTimeout(resolve, 0);
                      });

                    case 2:
                      wrapper.update();

                    case 3:
                    case "end":
                      return _context.stop();
                  }
                }
              }, _callee);
            })));

          case 2:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));

  return function waitForComponentToPaint(_x) {
    return _ref2.apply(this, arguments);
  };
}();

exports.waitForComponentToPaint = waitForComponentToPaint;

function mountWithTheme(component, customTheme) {
  var wrapper = (0, _enzyme.mount)(component, {
    wrappingComponent: getThemeProviderWrappingComponent(customTheme)
  });
  return wrapper;
}

var _default = mountWithTheme;
exports["default"] = _default;