"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.propTypes = void 0;

var _lodash = require("lodash");

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _constants = require("../../global/constants");

var _iconConstants = require("./iconConstants");

var _models = require("./models");

var _iconSVG = _interopRequireDefault(require("./iconSVG"));

var _utils = _interopRequireDefault(require("../../utils/utils"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var propTypes = {
  /**
   * Changes the margin from left or right.
   */
  align: _propTypes["default"].oneOf(['left', 'right']),

  /**
   * Additional classes.
   */
  className: _propTypes["default"].string,

  /**
   * Color of the icon.
   */
  color: _propTypes["default"].oneOf(Object.values(_models.ColorType)),

  /**
   * If `true`, removes the margin.
   */
  compact: _propTypes["default"].bool,

  /**
   * Used for DOM testing. https://testing-library.com/docs/queries/bytestid/
   */
  dataTestId: _propTypes["default"].string,

  /**
   * If `true`, an icon can be disabled.
   */
  disable: _propTypes["default"].bool,

  /**
   * If defined, `color` will be overriden and the `gradient.linearGradient` will be used.
   * Note: `id` needs to be defined on the `<linearGradient>` element.
   */
  gradient: _propTypes["default"].element,

  /**
   * The `id` of the icon.
   */
  id: _propTypes["default"].string,

  /**
   * If `true`, a icon can be formatted to appear on dark backgrounds.
   */
  inverse: _propTypes["default"].bool,

  /**
   * Event handler for onClick
   */
  onClick: _propTypes["default"].func,

  /**
   * Event handler for onKeyDown
   */
  onKeyDown: _propTypes["default"].func,

  /**
   * Transforms the rotation of the icon with the given number.
   */
  rotate: _propTypes["default"].number,

  /**
   * Changes the height and width of the icon with the given number.
   */
  size: _propTypes["default"].oneOfType([_propTypes["default"].oneOf(_utils["default"].sizeEnums()), _propTypes["default"].number]),

  /**
   * If `true`, endlessly spins the icon counter-clockwise
   */
  spin: _propTypes["default"].bool,

  /**
   * Supply any inline styles to the icon.
   */
  style: _propTypes["default"].shape({}),

  /**
   * Indicates whether or not the Icon can be focused.
   */
  tabIndex: _propTypes["default"].number,

  /**
   * Provides a human-readable title for the element that contains it.
   */
  title: _iconConstants.TITLE_PROP_TYPE,

  /**
   * The string for the icon you want to display.
   */
  type: _propTypes["default"].string.isRequired
};
exports.propTypes = propTypes;
var defaultProps = {
  align: 'left',
  className: null,
  color: _models.ColorType.Primary,
  dataTestId: "".concat(_constants.UI_CLASS_NAME, "-icon"),
  compact: false,
  disable: false,
  gradient: null,
  id: null,
  inverse: false,
  onClick: null,
  onKeyDown: null,
  rotate: null,
  size: null,
  spin: false,
  style: {},
  tabIndex: -1,
  title: null
};

function iconUniqueId() {
  var now = new Date().getTime().toString();
  return now.substring(now.length - 6, now.length) + (0, _lodash.uniqueId)();
}
/**
 * The Icon provides a simple way to render an image by requesting it from the set.
 */


var Icon = /*#__PURE__*/function (_React$PureComponent) {
  _inherits(Icon, _React$PureComponent);

  var _super = _createSuper(Icon);

  function Icon() {
    var _this;

    _classCallCheck(this, Icon);

    _this = _super.call(this);
    _this.onClick = _this.onClick.bind(_assertThisInitialized(_this));
    _this.onKeyDown = _this.onKeyDown.bind(_assertThisInitialized(_this));
    _this.onMouseDown = _this.onMouseDown.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(Icon, [{
    key: "onClick",
    value: function onClick(event) {
      var _this$props = this.props,
          disable = _this$props.disable,
          onClick = _this$props.onClick;

      if ((0, _lodash.isFunction)(onClick) && !disable) {
        onClick(event);
      }
    }
  }, {
    key: "onKeyDown",
    value: function onKeyDown(event) {
      var _this$props2 = this.props,
          disable = _this$props2.disable,
          onKeyDown = _this$props2.onKeyDown;

      if ((0, _lodash.isFunction)(onKeyDown) && !disable) {
        onKeyDown(event);
      }
    }
  }, {
    key: "onMouseDown",
    value: function onMouseDown(event) {
      event.preventDefault();
    }
  }, {
    key: "render",
    value: function render() {
      var _gradient$props$id, _gradient$props;

      var _this$props3 = this.props,
          align = _this$props3.align,
          className = _this$props3.className,
          color = _this$props3.color,
          compact = _this$props3.compact,
          dataTestId = _this$props3.dataTestId,
          disable = _this$props3.disable,
          gradient = _this$props3.gradient,
          id = _this$props3.id,
          inverse = _this$props3.inverse,
          onClick = _this$props3.onClick,
          rotate = _this$props3.rotate,
          size = _this$props3.size,
          spin = _this$props3.spin,
          style = _this$props3.style,
          tabIndex = _this$props3.tabIndex,
          type = _this$props3.type,
          title = _this$props3.title,
          otherProps = _objectWithoutProperties(_this$props3, ["align", "className", "color", "compact", "dataTestId", "disable", "gradient", "id", "inverse", "onClick", "rotate", "size", "spin", "style", "tabIndex", "type", "title"]);

      var rootClasses = (0, _classnames["default"])(_constants.UI_CLASS_NAME, 'ui', 'icon', "icon-".concat(type), className, {
        'icon-align-left': !align && !compact || align === 'left',
        'icon-align-right': !compact && align === 'right',
        'icon-clickable': onClick,
        'icon-color-alert': color === _models.ColorType.Alert,
        'icon-color-disable': color === _models.ColorType.Disable,
        'icon-color-highlight': color === _models.ColorType.Highlight,
        'icon-color-primary': (0, _lodash.isNil)(color) && !disable || color === _models.ColorType.Primary,
        'icon-color-static': color === _models.ColorType.Static,
        'icon-color-success': color === _models.ColorType.Success,
        'icon-color-warning': color === _models.ColorType.Warning,
        'icon-compact': compact,
        'icon-disable': disable,
        'icon-inverse': inverse,
        'icon-size-large': size === 'large',
        'icon-size-medium': size === 'medium',
        'icon-size-small': size === 'small',
        'icon-size-xlarge': size === 'xlarge',
        'icon-size-xsmall': size === 'xsmall',
        'icon-size-xxlarge': size === 'xxlarge',
        'icon-size-xxsmall': size === 'xxsmall',
        'icon-spin': spin || type === 'spinner'
      });

      var containerStyle = _objectSpread(_objectSpread({}, style), {}, {
        height: (0, _lodash.isNumber)(size) ? "".concat(size / 16, "rem") : null,
        width: (0, _lodash.isNumber)(size) ? "".concat(size / 16, "rem") : null
      });

      var svgStyle = {
        height: (0, _lodash.isNumber)(size) ? "".concat(size / 16, "rem") : null,
        width: (0, _lodash.isNumber)(size) ? "".concat(size / 16, "rem") : null,
        transform: (0, _lodash.isNumber)(rotate) ? "rotate(".concat(rotate, "deg)") : null
      };
      var gradientId = (_gradient$props$id = gradient === null || gradient === void 0 ? void 0 : (_gradient$props = gradient.props) === null || _gradient$props === void 0 ? void 0 : _gradient$props.id) !== null && _gradient$props$id !== void 0 ? _gradient$props$id : "icon-svg-gradient-color-".concat(color, "-").concat(type, "-").concat(iconUniqueId());
      var maskId = "icon-svg-mask-".concat(type, "-").concat(iconUniqueId());
      var pathId = "icon-svg-path-".concat(type, "-").concat(iconUniqueId());
      var polygonId = "icon-svg-polygon-".concat(type, "-").concat(iconUniqueId());
      var circleId = "icon-svg-circle-".concat(type, "-").concat(iconUniqueId());
      var renderGradientColor;

      switch (color) {
        case _models.ColorType.Action:
          renderGradientColor = /*#__PURE__*/_react["default"].createElement("linearGradient", {
            x1: "112.199955%",
            y1: "32.8609914%",
            x2: "-2.68483922%",
            y2: "32.8609914%",
            id: gradientId
          }, /*#__PURE__*/_react["default"].createElement("stop", {
            stopColor: "#F99E49",
            offset: "0%"
          }), /*#__PURE__*/_react["default"].createElement("stop", {
            stopColor: "#C33580",
            offset: "100%"
          }));
          break;

        case _models.ColorType.Condition:
          renderGradientColor = /*#__PURE__*/_react["default"].createElement("linearGradient", {
            x1: "100%",
            y1: "57.7671349%",
            x2: "0%",
            y2: "57.7671349%",
            id: gradientId
          }, /*#__PURE__*/_react["default"].createElement("stop", {
            stopColor: "#56C4C4",
            offset: "0%"
          }), /*#__PURE__*/_react["default"].createElement("stop", {
            stopColor: "#329594",
            offset: "100%"
          }));
          break;

        case _models.ColorType.Configuration:
          renderGradientColor = /*#__PURE__*/_react["default"].createElement("linearGradient", {
            x1: "100%",
            y1: "57.3795795%",
            x2: "2.77555756e-15%",
            y2: "57.3795795%",
            id: gradientId
          }, /*#__PURE__*/_react["default"].createElement("stop", {
            stopColor: "#5AC9F5",
            offset: "0%"
          }), /*#__PURE__*/_react["default"].createElement("stop", {
            stopColor: "#1C93C4",
            offset: "100%"
          }));
          break;

        case _models.ColorType.Object:
        case _models.ColorType.Subject:
          renderGradientColor = /*#__PURE__*/_react["default"].createElement("linearGradient", {
            x1: "100.881138%",
            y1: "32.8609914%",
            x2: "-2.68483922%",
            y2: "32.8609914%",
            id: gradientId
          }, /*#__PURE__*/_react["default"].createElement("stop", {
            stopColor: "#9958D1",
            offset: "0%"
          }), /*#__PURE__*/_react["default"].createElement("stop", {
            stopColor: "#134174",
            offset: "100%"
          }));
          break;

        case _models.ColorType.CustomGradient:
          renderGradientColor = gradient;
          break;

        default:
      }

      var circle;
      var path;
      var polygon;
      var viewBox = '0 0 24 24';

      switch (type) {
        case 'action':
          path = {
            d: 'M11.25,0 L12.75,0 C13.1642136,0 13.5,0.335786438 13.5,0.75 L13.5,5.25 L10.5,5.25 L10.5,0.75 C10.5,0.335786438 10.8357864,0 11.25,0 Z M19.9549513,2.98438854 L21.0156115,4.04504871 C21.3085047,4.33794193 21.3085047,4.81281566 21.0156115,5.10570888 L17.8336309,8.2876894 L15.7123106,6.16636906 L18.8942911,2.98438854 C19.1871843,2.69149532 19.6620581,2.69149532 19.9549513,2.98438854 Z M24,11.25 L24,12.75 C24,13.1642136 23.6642136,13.5 23.25,13.5 L18.75,13.5 L18.75,10.5 L23.25,10.5 C23.6642136,10.5 24,10.8357864 24,11.25 Z M21.0156115,19.9549513 L19.9549513,21.0156115 C19.6620581,21.3085047 19.1871843,21.3085047 18.8942911,21.0156115 L15.7123106,17.8336309 L17.8336309,15.7123106 L21.0156115,18.8942911 C21.3085047,19.1871843 21.3085047,19.6620581 21.0156115,19.9549513 Z M12.75,24 L11.25,24 C10.8357864,24 10.5,23.6642136 10.5,23.25 L10.5,18.75 L13.5,18.75 L13.5,23.25 C13.5,23.6642136 13.1642136,24 12.75,24 Z M4.04504871,21.0156115 L2.98438854,19.9549513 C2.69149532,19.6620581 2.69149532,19.1871843 2.98438854,18.8942911 L6.16636906,15.7123106 L8.2876894,17.8336309 L5.10570888,21.0156115 C4.81281566,21.3085047 4.33794193,21.3085047 4.04504871,21.0156115 Z M0,12.75 L0,11.25 C0,10.8357864 0.335786438,10.5 0.75,10.5 L5.25,10.5 L5.25,13.5 L0.75,13.5 C0.335786438,13.5 0,13.1642136 0,12.75 Z M2.98438854,4.04504871 L4.04504871,2.98438854 C4.33794193,2.69149532 4.81281566,2.69149532 5.10570888,2.98438854 L8.2876894,6.16636906 L6.16636906,8.2876894 L2.98438854,5.10570888 C2.69149532,4.81281566 2.69149532,4.33794193 2.98438854,4.04504871 Z',
            id: pathId
          };
          break;

        case 'activity':
          path = {
            d: 'M16.1569397,10.4025598 L12.3103892,19.4443818 C12.106888,19.922738 11.711997,20.2941604 11.2266291,20.5183896 C11.0191481,20.6707457 10.7766368,20.7942687 10.50452,20.8790055 C9.29297836,21.2562775 7.95335703,20.72183 7.51239195,19.6852837 L5.22215892,14.3017903 L4.52880169,15.9316175 C4.08783661,16.9681638 2.74821527,17.5026113 1.53667368,17.1253393 C0.32513209,16.7480673 -0.2995436,15.6019411 0.141421477,14.5653948 L2.80288115,8.3092844 C3.17500823,7.43455084 4.18711735,6.91738921 5.22215892,7.00397397 C6.25720049,6.91738921 7.2693096,7.43455084 7.64143669,8.3092844 L9.8601486,13.524658 L13.7782203,4.31471625 C14.1454851,3.45141192 15.1361174,2.93639652 16.1569397,3.00632054 C17.1777621,2.93639652 18.1683943,3.45141192 18.5356592,4.31471625 L23.8585785,16.826937 C24.2995436,17.8634833 23.6748679,19.0096095 22.4633263,19.3868815 C21.2517847,19.7641535 19.9121634,19.229706 19.4711983,18.1931597 L16.1569397,10.4025598 Z',
            id: pathId
          };
          break;

        case 'add':
        case 'plus':
          // alias
          path = {
            d: 'M14.25,9.75 L21.75,9.75 C22.9926407,9.75 24,10.7573593 24,12 C24,13.2426407 22.9926407,14.25 21.75,14.25 L14.25,14.25 L14.25,21.75 C14.25,22.9926407 13.2426407,24 12,24 C10.7573593,24 9.75,22.9926407 9.75,21.75 L9.75,14.25 L2.25,14.25 C1.00735931,14.25 1.52179594e-16,13.2426407 0,12 C-1.52179594e-16,10.7573593 1.00735931,9.75 2.25,9.75 L9.75,9.75 L9.75,2.25 C9.75,1.00735931 10.7573593,2.28269391e-16 12,0 C13.2426407,-2.28269391e-16 14.25,1.00735931 14.25,2.25 L14.25,9.75 Z',
            id: pathId
          };
          break;

        case 'roster':
        case 'contact-info': // alias

        case 'address-book':
          // alias
          path = {
            d: 'M3,20.25 L4.00208688,20.25 C5.10173938,20.25 6,19.3545822 6,18.2500283 L6,17.7499717 C6,16.6390552 5.10550383,15.75 4.00208688,15.75 L3,15.75 L3,14.25 L4.00208688,14.25 C5.10173938,14.25 6,13.3545822 6,12.2500283 L6,11.7499717 C6,10.6390552 5.10550383,9.75 4.00208688,9.75 L3,9.75 L3,8.25 L4.00208688,8.25 C5.10173938,8.25 6,7.35458219 6,6.25002835 L6,5.74997165 C6,4.63905519 5.10550383,3.75 4.00208688,3.75 L3,3.75 L3,2.00494659 C3,0.897645164 3.90234375,-1.84831745e-22 4.99456145,1.56701153e-22 L22.0054385,5.47594672e-21 C23.1070044,5.82040277e-21 24,0.897026226 24,2.00494659 L24,21.9950534 C24,23.1023548 23.0976563,24 22.0054385,24 L4.99456145,24 C3.89299558,24 3,23.1029738 3,21.9950534 L3,20.25 Z M0,6 C0,5.58578644 0.338231385,5.25 0.743083477,5.25 L3.75691652,5.25 C4.1673102,5.25 4.5,5.58289862 4.5,6 C4.5,6.41421356 4.16176862,6.75 3.75691652,6.75 L0.743083477,6.75 C0.332689805,6.75 0,6.41710138 0,6 Z M0,12 C0,11.5857864 0.338231385,11.25 0.743083477,11.25 L3.75691652,11.25 C4.1673102,11.25 4.5,11.5828986 4.5,12 C4.5,12.4142136 4.16176862,12.75 3.75691652,12.75 L0.743083477,12.75 C0.332689805,12.75 0,12.4171014 0,12 Z M0,18 C0,17.5857864 0.338231385,17.25 0.743083477,17.25 L3.75691652,17.25 C4.1673102,17.25 4.5,17.5828986 4.5,18 C4.5,18.4142136 4.16176862,18.75 3.75691652,18.75 L0.743083477,18.75 C0.332689805,18.75 0,18.4171014 0,18 Z M10.0066982,17.25 L19.2441419,17.25 C19.6853605,16.5196184 19.509669,15.0573317 19.0684504,14.5701059 C18.8629085,14.3434043 17.6495814,14.1288247 17.6495814,14.1288247 C16.5700726,13.8807152 16.1344503,12.9189805 16.6747087,11.9628535 C16.6747087,11.9628535 17.0625,11.7251752 17.0625,10.546875 C17.0625,8.8289395 16.7199356,7.5 14.625,7.5 C12.5303487,7.5 12.1875,8.8289395 12.1875,10.546875 C12.1875,11.7288317 12.5767404,11.9661186 12.5767404,11.9661186 C13.0790688,12.9357304 12.6939332,13.8898751 11.6272878,14.1242655 C11.6272878,14.1242655 10.3987346,14.3379196 10.1869383,14.5701059 C9.74230822,15.0573317 9.56206813,16.5196184 10.0066982,17.25 Z',
            id: pathId
          };
          break;

        case 'mention':
        case 'at':
          // alias
          path = {
            d: 'M15.6850394,5.52777778 L15.4150731,6.5 C14.6861642,5.33333333 13.9302587,4.94444444 12.4184477,4.94444444 C8.82789651,4.94444444 5.83127109,8.83333333 5.83127109,13.5277778 C5.83127109,16.6944444 7.53205849,18.75 10.2047244,18.75 C11.7165354,18.75 12.7964004,18.2222222 13.8222722,17 C13.9032621,17.5 13.9302587,17.6388889 14.0652418,17.8611111 C14.4701912,18.5277778 15.3340832,18.9444444 16.3869516,18.9444444 C18.1957255,18.9444444 20.0314961,18.1111111 21.4353206,16.6666667 C23.0821147,14.9722222 24,12.5833333 24,9.97222222 C24,4.16666667 19.5185602,0 13.2283465,0 C9.04386952,0 5.77727784,1.25 3.2935883,3.80555556 C1.13385827,6.05555556 0,9.02777778 0,12.4722222 C0,15.6944444 1.10686164,18.6388889 3.13160855,20.6944444 C5.26434196,22.8888889 8.23397075,24 12.0404949,24 C13.984252,24 15.928009,23.6944444 17.7637795,23.1111111 C19.0326209,22.7222222 19.6805399,22.3888889 21.1383577,21.5 L19.4915636,19.0555556 C18.1957255,19.8611111 17.5208099,20.1944444 16.4679415,20.5277778 C15.2260967,20.9166667 13.7412823,21.1388889 12.3374578,21.1388889 C6.91113611,21.1388889 3.32058493,17.6388889 3.32058493,12.3055556 C3.32058493,6.80555556 7.31608549,2.91666667 13.0123735,2.91666667 C14.9291339,2.91666667 16.6299213,3.33333333 17.8447694,4.08333333 C19.7885264,5.33333333 20.9493813,7.55555556 20.9493813,10.1111111 C20.9493813,12.25 20.0854893,14.3055556 18.7626547,15.3611111 C18.2227222,15.8055556 17.5748031,16.0833333 17.0618673,16.0833333 C16.6029246,16.0833333 16.359955,15.8333333 16.359955,15.3888889 C16.359955,15.1388889 16.3869516,14.8611111 16.4679415,14.5555556 L18.087739,8.38888889 C18.2227222,7.77777778 18.7086614,6.08333333 18.8706412,5.52777778 L15.6850394,5.52777778 Z M10.663667,16 C9.63779528,16 9.09786277,15.2222222 9.09786277,13.75 C9.09786277,12.4722222 9.52980877,10.8333333 10.1777278,9.58333333 C10.8526434,8.27777778 11.7975253,7.58333333 12.8233971,7.58333333 C13.768279,7.58333333 14.3892013,8.36111111 14.3892013,9.5 C14.3892013,10.7777778 13.9572553,12.4722222 13.3093363,13.7777778 C12.6074241,15.1944444 11.6625422,16 10.663667,16 L10.663667,16 Z',
            id: pathId
          };
          break;

        case 'attendance':
        case 'chair':
          // alias
          path = {
            d: 'M18.4056031,24 L18.2954569,24 C17.991395,24 17.7059648,23.751676 17.6579973,23.4453248 L17.3853535,21.7468744 L6.48424262,21.7468744 L6.21243911,23.4459527 C6.16469083,23.7519346 5.88061232,24 5.57797518,24 L5.46837699,24 C5.16573986,24 4.95911074,23.7519346 5.00685902,23.4459527 L6.194465,16.0217193 C6.23099773,15.9847828 7.43657783,15.9847828 7.4000451,16.0217193 L6.66738119,20.6018434 L17.2014843,20.6018434 L16.4647287,16.0125221 C16.428196,15.9755856 17.6393291,15.9755856 17.6760445,16.0125221 L18.869313,23.4453248 C18.9172805,23.751676 18.709665,24 18.4056031,24 Z M18.1341596,15.256167 L5.74204291,15.256167 C5.5452409,15.256167 5.35649938,15.17743 5.21733934,15.0372773 C5.0781793,14.8971246 5,14.7070367 5,14.5088308 L5,13.0888921 C5,12.6761498 5.33222393,12.341556 5.74204291,12.341556 L18.1341596,12.341556 C18.5439786,12.341556 18.8762025,12.6761498 18.8762025,13.0888921 L18.8762025,14.5088308 C18.8762025,14.7070367 18.7980232,14.8971246 18.6588632,15.0372773 C18.5197031,15.17743 18.3309616,15.256167 18.1341596,15.256167 Z M16.6897594,10.9297913 L6.45611671,10.9297913 C6.05527381,10.9297913 5.73032645,10.598033 5.73032645,10.1887885 L6.81901184,0.741002798 C6.81901184,0.331758253 7.1439592,7.51770033e-17 7.54480209,0 L15.601074,0 C16.0019169,2.50590011e-17 16.3268642,0.331758253 16.3268642,0.741002798 L17.4155496,10.1887885 C17.4155496,10.598033 17.0906022,10.9297913 16.6897594,10.9297913 Z',
            id: pathId
          };
          break;

        case 'award':
          path = {
            d: 'M6.07012476,11.7151629 L2,2.57351301 L7.73778717,0.0188855773 L11.9593409,9.50065053 C11.9047954,9.49961875 11.8501242,9.49910054 11.7953319,9.49910054 C9.59011953,9.49910054 7.58099085,10.3384979 6.07012476,11.7151629 Z M17.8062592,11.9878395 C17.0990884,11.2810486 16.26799,10.6982029 15.3483524,10.2746852 L13.4956752,6.11350405 L16.2175825,1.25233157e-13 L21.9977874,2.57351301 L17.8062592,11.9878395 Z M11.7953319,24 C8.48111257,24 5.79440696,21.313732 5.79440696,18.0000524 C5.79440696,14.6863728 8.48111257,12.0001048 11.7953319,12.0001048 C15.1095512,12.0001048 17.7962568,14.6863728 17.7962568,18.0000524 C17.7962568,21.313732 15.1095512,24 11.7953319,24 Z',
            id: pathId
          };
          break;

        case 'archive':
          path = {
            d: 'M9.00639765,4.5 C8.17646277,4.5 7.5,5.17157288 7.5,6 C7.5,6.83420277 8.1744372,7.5 9.00639765,7.5 L14.9936024,7.5 C15.8235372,7.5 16.5,6.82842712 16.5,6 C16.5,5.16579723 15.8255628,4.5 14.9936024,4.5 L9.00639765,4.5 Z M3.49456145,4.5 L2.00494659,4.5 C0.897645164,4.5 0,3.61094481 0,2.50002835 L0,1.99997165 C0,0.895417808 0.897026226,0 2.00494659,0 L21.9950534,0 C23.1023548,0 24,0.889055192 24,1.99997165 L24,2.50002835 C24,3.60458219 23.1029738,4.5 21.9950534,4.5 L20.5054385,4.5 C21.6070044,4.5 22.5,5.38854557 22.5,6.49520242 L22.5,22.0047976 C22.5,23.1067175 21.5976562,24 20.5054385,24 L3.49456145,24 C2.39299558,24 1.5,23.1114544 1.5,22.0047976 L1.5,6.49520242 C1.5,5.39328255 2.40234375,4.5 3.49456145,4.5 Z',
            id: pathId
          };
          break;

        case 'arrows-alt':
          path = {
            d: 'M28.038 10.539v-3.756l-3.69 3.686c0 0-1.409 1.407-2.819 0-1.409-1.409 0-2.819 0-2.819l3.69-3.688h-3.76c-1.072 0-1.945-0.872-1.945-1.945 0.002-1.076 0.872-1.945 1.947-1.947h8.194c0.112-0.022 0.214-0.070 0.33-0.070 0.038 0 0.062 0.040 0.1 0.044 0.442 0.022 0.87 0.19 1.219 0.504 0.070 0.048 0.080 0.050 0.090 0.058 0.042 0.052 0.042 0.090 0.068 0.12 0.258 0.3 0.384 0.652 0.426 1.024 0.016 0.098 0.112 0.164 0.11 0.266 0 0.12-0.046 0.224-0.066 0.336l-0.002 8.188c0 1.076-0.87 1.947-1.947 1.947-1.074 0-1.945-0.872-1.945-1.947v0zM3.964 10.539l-0.002-3.756 3.692 3.686c0 0 1.409 1.407 2.817 0 1.409-1.409 0-2.819 0-2.819l-3.688-3.688h3.758c1.074 0 1.945-0.872 1.945-1.945 0-1.076-0.872-1.945-1.947-1.947h-8.194c-0.112-0.022-0.212-0.070-0.328-0.070-0.040 0-0.062 0.040-0.102 0.042-0.442 0.024-0.868 0.192-1.217 0.506-0.072 0.048-0.082 0.050-0.090 0.058-0.042 0.052-0.044 0.090-0.070 0.12-0.256 0.3-0.382 0.652-0.424 1.024-0.018 0.098-0.112 0.166-0.112 0.266 0.002 0.12 0.046 0.224 0.068 0.336v8.188c0 1.076 0.872 1.947 1.947 1.947s1.945-0.872 1.947-1.947v0zM28.038 21.461v3.756l-3.69-3.686c0 0-1.409-1.407-2.819 0-1.409 1.409 0 2.819 0 2.819l3.69 3.688h-3.76c-1.074 0-1.945 0.872-1.945 1.945 0.002 1.076 0.872 1.945 1.947 1.947h8.196c0.11 0.022 0.212 0.070 0.328 0.070 0.038 0 0.062-0.040 0.1-0.042 0.442-0.024 0.87-0.192 1.219-0.506 0.070-0.048 0.080-0.050 0.090-0.058 0.042-0.052 0.044-0.090 0.068-0.12 0.258-0.3 0.384-0.652 0.426-1.024 0.016-0.098 0.112-0.164 0.112-0.266-0.002-0.12-0.048-0.224-0.068-0.336l-0.002-8.188c0-1.076-0.87-1.947-1.947-1.947-1.074 0-1.945 0.872-1.945 1.947v0zM10.541 28.036l-3.758 0.002 3.686-3.69c0 0 1.409-1.409 0-2.819s-2.819 0-2.819 0l-3.688 3.69v-3.76c0-1.074-0.872-1.945-1.945-1.945-1.076 0.002-1.945 0.872-1.947 1.947v8.194c-0.022 0.112-0.070 0.212-0.070 0.328 0 0.040 0.040 0.062 0.044 0.102 0.022 0.442 0.19 0.868 0.504 1.217 0.050 0.072 0.050 0.082 0.058 0.090 0.052 0.042 0.090 0.044 0.12 0.070 0.302 0.256 0.652 0.382 1.024 0.426 0.098 0.016 0.164 0.11 0.266 0.11 0.12-0.002 0.224-0.046 0.336-0.068h8.188c1.076 0 1.947-0.872 1.947-1.947s-0.872-1.945-1.945-1.947v0z',
            id: pathId
          };
          viewBox = '0 0 32 32';
          break;

        case 'baptism':
        case 'droplet':
          // alias
          path = {
            d: 'M7.00171396,0 C7.00171396,0 6.48117521,2.64650124 4.91955897,5.35323972 C4.86173839,5.35323972 0.639607833,13.653688 0.639607833,13.653688 C0.639607833,13.653688 -0.0544438298,15.2774863 0.00342792121,16.7813423 C0.0612485035,16.7813423 0.00342792121,23.8186708 7.00171396,23.9991164 C7.00171396,23.9991164 13.4216407,24.239693 14,16.7813423 C13.9421794,16.7813423 14.1735129,14.9167546 12.9589225,12.7514064 C13.0167943,12.8717212 9.08381778,5.59376302 9.08381778,5.59376302 C9.08381778,5.59376302 7.69556095,2.64650124 7.00171396,0 Z',
            id: pathId
          };
          viewBox = '0 0 14 24';
          break;

        case 'alert':
        case 'bell':
          // alias
          path = {
            d: 'M16.9793653,20.5178624 L10.2151143,18.6433685 C10.2207186,18.6312478 10.2263836,18.6191634 10.2321088,18.6071154 L2,16.3251353 C2,16.3251353 5.71655184,13.5367987 6.31134294,11.2390653 C7.01680946,8.51674251 7.78653912,5.54386705 7.78653912,5.54386705 C8.81974767,1.5552779 12.7840696,-0.813720506 16.6398583,0.257504867 C20.497075,1.32497945 22.785557,5.42459196 21.7516344,9.41468143 C21.7516344,9.41468143 21.5274274,10.2811137 21.2132521,11.4941189 L21.0033258,12.3035392 L21.0033258,12.302789 C20.7734065,13.1932264 20.5149259,14.1879357 20.2650137,15.1533888 C19.6745068,17.4346187 21.5517046,21.7442754 21.5517046,21.7442754 L16.981881,20.478009 C16.9811066,20.4913118 16.9802667,20.5045961 16.9793618,20.5178615 Z M16.5972317,21.9604552 C16.0088334,23.170619 14.8168377,24 13.4338414,24 C11.4616769,24 9.86366675,22.3203966 9.86366675,20.2492109 C9.86366675,20.1976289 9.86468089,20.1463203 9.86668791,20.0953021 L16.5972317,21.9604552 Z',
            id: pathId
          };
          break;

        case 'recurring-alert':
        case 'bell-recurring':
          // alias
          path = {
            d: 'M8.78198314,16.5 L11.3293883,16.5 C13.3876285,16.5 15.0561611,14.821068 15.0561611,12.75 L15.0561611,4.6293435 C15.9548412,4.06396575 16.9924962,3.75 18.0673963,3.75 C18.5757239,3.75 19.0915139,3.8200965 19.6058039,3.966519 C22.7676017,4.86842325 24.6444018,8.3265 23.7961892,11.6926732 C23.7961892,11.6926732 23.6128367,12.4247887 23.3549417,13.4466345 L23.1820217,14.1304613 C22.9941917,14.8828268 22.7825117,15.7224233 22.5782791,16.5355387 C22.0938016,18.4608465 23.6337017,22.0965 23.6337017,22.0965 L19.886064,21.0263655 C19.886064,21.0403845 19.8845715,21.0512888 19.8845715,21.0621922 L14.3376385,19.4811345 C14.342116,19.470231 14.3480785,19.4593268 14.351056,19.449981 L7.60261555,17.5231155 C7.60261555,17.5231155 8.13050309,17.1156172 8.78198314,16.5 Z M14.049931,20.8363267 C14.049931,20.7911535 14.0514235,20.7475388 14.052916,20.7039233 L19.5700289,22.27875 C19.0885289,23.2990387 18.1106263,24 16.9776837,24 C15.3602711,24 14.049931,22.5825 14.049931,20.8363267 Z M3.57770276,15 L3.57770276,17.25 L0,13.5 L3.57770276,9.75 L3.57770276,12 L10.7331083,12 L10.7331083,9.77545275 L13.595266,6.75 L13.595266,12 C13.595266,13.6568542 12.3138309,15 10.7331083,15 L3.57770276,15 Z M10.7331083,2.25 L10.7331083,0 L14.310811,3.75 L10.7331083,7.5 L10.7331083,5.25 L3.57770276,5.25 L3.57770276,7.47454725 L0.715537552,10.5 L0.715537552,5.25 C0.715537552,3.59314575 1.99697265,2.25 3.57770276,2.25 L10.7331083,2.25 Z',
            id: pathId
          };
          break;

        case 'birthday':
        case 'birthday-cake':
          // temp alias
          path = {
            d: 'M12.04046,17.1780355 C5.728,17.1780355 5,15.0410414 5,15.0410414 L5,11.8356923 C5.728,9.78078107 9.69364,9.45202367 9.69364,9.45202367 L9.69364,11.1780355 C9.69364,11.1780355 9.96342,12.4109822 11.87862,12.4109822 C13.79382,12.4109822 13.98268,11.1781775 13.98268,11.1781775 L13.98268,9.45202367 C18.65,9.86300592 19,11.8356923 19,11.8356923 L19,14.9589586 C19,14.9589586 18.35264,17.1780355 12.04046,17.1780355 Z M13.33532,7.47947929 L13.33532,10.931503 C13.33532,10.931503 13.17348,11.7534675 11.87932,11.7534675 C10.58516,11.7534675 10.341,11.0137278 10.341,11.0137278 L10.341,7.47947929 C10.341,7.47947929 10.61078,6.73973964 11.87862,6.73973964 C13.14646,6.73973964 13.33532,7.47947929 13.33532,7.47947929 Z M11.87932,6.1644497 C10.04532,6.1644497 9.96412,4.21888757 9.9371,4.19190533 C10.36802,2.30144379 11.87862,0 11.87862,0 C12.7553528,1.24565985 13.4124948,2.63610481 13.82084,4.10953846 C13.82084,4.10953846 13.7129,6.1644497 11.87862,6.1644497 L11.87932,6.1644497 Z M18.91908,18 L18.91908,21.4520237 C18.91908,21.4520237 18.35264,24 12.04046,24 C5.72828,24 5,21.5342485 5,21.5342485 L5,17.9177751 C5,17.9177751 6.72634,19.8082367 12.04046,19.8082367 C17.35458,19.8082367 18.91908,18 18.91908,18 Z',
            id: pathId
          };
          break;

        case 'blocked':
        case 'block':
          // temp alias
          path = {
            d: 'M17.1181882,17.9886356 C17.515731,18.3685915 17.4999824,18.9842895 17.0921035,19.3555607 L12.2968225,23.7204583 C11.8848735,24.0954342 11.231265,24.0938958 10.8311079,23.7114413 L3.28919446,16.5031748 C2.89165164,16.1232189 2.90740025,15.5075209 3.31527912,15.1362498 L8.11056021,10.7713521 C8.5225092,10.3963762 9.17611772,10.3979146 9.5762748,10.7803691 L17.1181882,17.9886356 Z M20.7108055,7.49682517 C21.1083484,7.87678108 21.0925998,8.4924791 20.6847209,8.86375025 L15.8894398,13.2286479 C15.4774908,13.6036238 14.8238823,13.6020854 14.4237252,13.2196309 L6.8818118,6.01136441 C6.48426897,5.63140849 6.50001758,5.01571048 6.90789645,4.64443933 L11.7031775,0.279541719 C12.1151265,-0.0954342435 12.768735,-0.0938957948 13.1688921,0.288558722 L20.7108055,7.49682517 Z',
            id: pathId
          };
          break;

        case 'discipleship':
        case 'book-open':
          // temp alias
          path = {
            d: 'M17.4988334,22.3993067 C14.625425,22.3993067 11.9992001,24 11.9992001,24 C11.9992001,24 9.37297513,22.3993067 6.4995667,22.3993067 C3.03019799,22.3993067 0,24 0,24 L0,1.60069329 C0,1.60069329 2.92060529,0 6.34997667,0 C9.28178121,0 12,1.60069329 12,1.60069329 C12,1.60069329 14.7182188,0 17.6500233,0 C21.0793947,0 24,1.60069329 24,1.60069329 L24,24 C23.9984001,24 20.9682021,22.3993067 17.4988334,22.3993067 L17.4988334,22.3993067 Z M11.3684211,1.26315789 L12.6315789,1.26315789 L12.6315789,24 L11.3684211,24 L11.3684211,1.26315789 Z M15.1989867,16.0005333 C15.1989867,16.0005333 16.7004866,15.1989867 18.2491834,15.1989867 C19.8978735,15.1989867 20.7994134,16.0005333 20.7994134,16.0005333 L20.7994134,17.6004266 C20.7994134,17.6004266 19.9994667,16.79968 18.3995734,16.79968 C16.79968,16.79968 15.1997867,17.6004266 15.1997867,17.6004266 L15.1997867,16.0005333 L15.1989867,16.0005333 Z M15.1989867,12.7999467 L15.1989867,11.2000533 C15.1989867,11.2000533 16.7004866,10.4001067 18.2491834,10.4001067 C19.8978735,10.4001067 20.7994134,11.2000533 20.7994134,11.2000533 L20.7994134,12.7999467 C20.7994134,12.7999467 19.9994667,12 18.3995734,12 C16.7988801,12 15.1989867,12.7999467 15.1989867,12.7999467 L15.1989867,12.7999467 Z M15.1989867,8.0010666 L15.1989867,6.39957336 C15.1989867,6.39957336 16.7004866,5.60042664 18.2491834,5.60042664 C19.8978735,5.60042664 20.7994134,6.39957336 20.7994134,6.39957336 L20.7994134,8.0010666 C20.7994134,8.0010666 19.9994667,7.20031998 18.3995734,7.20031998 C16.7988801,7.20031998 15.1989867,8.0010666 15.1989867,8.0010666 L15.1989867,8.0010666 Z M3.19978668,17.6004266 L3.19978668,16.0005333 C3.19978668,16.0005333 3.90133991,15.1989867 5.45003666,15.1989867 C7.09872675,15.1989867 8.80021332,16.0005333 8.80021332,16.0005333 L8.80021332,17.6004266 C8.80021332,17.6004266 7.20031998,16.79968 5.60042664,16.79968 C3.99973335,16.79968 3.19978668,17.6004266 3.19978668,17.6004266 L3.19978668,17.6004266 Z M3.19978668,12.7999467 L3.19978668,11.2000533 C3.19978668,11.2000533 3.90133991,10.4001067 5.45003666,10.4001067 C7.09872675,10.4001067 8.80021332,11.2000533 8.80021332,11.2000533 L8.80021332,12.7999467 C8.80021332,12.7999467 7.20031998,12 5.60042664,12 C3.99973335,12 3.19978668,12.7999467 3.19978668,12.7999467 L3.19978668,12.7999467 Z M3.19978668,8.0010666 L3.19978668,6.39957336 C3.19978668,6.39957336 3.90133991,5.60042664 5.45003666,5.60042664 C7.09872675,5.60042664 8.80021332,6.39957336 8.80021332,6.39957336 L8.80021332,8.0010666 C8.80021332,8.0010666 7.20031998,7.20031998 5.60042664,7.20031998 C3.99973335,7.20031998 3.19978668,8.0010666 3.19978668,8.0010666 L3.19978668,8.0010666 Z',
            id: pathId
          };
          break;

        case 'doj-cleared':
          path = {
            d: 'M12,9.89735842 L23.5645287,21.4618871 C24.1451571,22.0425155 24.1451571,22.9839002 23.5645287,23.5645287 C22.9839002,24.1451571 22.0425155,24.1451571 21.4618871,23.5645287 L9.89735842,12 L8.32037724,13.5769812 C7.7397488,14.1576096 6.7983641,14.1576096 6.21773566,13.5769812 L3.0637733,10.4230188 C2.48314486,9.84239038 2.48314486,8.90100568 3.0637733,8.32037724 L8.32037724,3.0637733 C8.90100568,2.48314486 9.84239038,2.48314486 10.4230188,3.0637733 L13.5769812,6.21773566 C14.1576096,6.7983641 14.1576096,7.7397488 13.5769812,8.32037724 L12,9.89735842 Z M10.9486792,0.435471329 C11.5293077,-0.14515711 12.4706923,-0.14515711 13.0513208,0.435471329 L16.2052832,3.58943369 C16.7859116,4.17006213 16.7859116,5.11144683 16.2052832,5.69207527 C15.6246547,6.27270371 14.68327,6.27270371 14.1026416,5.69207527 L10.9486792,2.53811291 C10.3680508,1.95748447 10.3680508,1.01609977 10.9486792,0.435471329 Z M0.435471329,10.9486792 C1.01609977,10.3680508 1.95748447,10.3680508 2.53811291,10.9486792 L5.69207527,14.1026416 C6.27270371,14.68327 6.27270371,15.6246547 5.69207527,16.2052832 C5.11144683,16.7859116 4.17006213,16.7859116 3.58943369,16.2052832 L0.435471329,13.0513208 C-0.14515711,12.4706923 -0.14515711,11.5293077 0.435471329,10.9486792 Z',
            id: pathId
          };
          break;

        case 'occupation':
        case 'briefcase':
          // temp alias
          path = {
            d: 'M24,13.5 L0,13.5 L0,7.99508929 C0,6.8932319 0.897026226,6 2.00494659,6 L3,6 L3,8.49013764 C3,9.61019951 3.89449617,10.5 4.99791312,10.5 L7.00208688,10.5 C8.10173938,10.5 9,9.60015397 9,8.49013764 L9,6 L15,6 L15,8.49013764 C15,9.61019951 15.8944962,10.5 16.9979131,10.5 L19.0020869,10.5 C20.1017394,10.5 21,9.60015397 21,8.49013764 L21,6 L21.9950534,6 C23.1023548,6 24,6.8926228 24,7.99508929 L24,13.5 Z M24,15 L24,22.0049107 C24,23.1067681 23.1029738,24 21.9950534,24 L2.00494659,24 C0.897645164,24 0,23.1073772 0,22.0049107 L0,15 L24,15 Z M4.5,3 L4.5,1.5 C4.5,0.671572875 5.16388585,0 5.99309635,0 L18.0069036,0 C18.831518,0 19.5,0.665797234 19.5,1.5 L19.5,3 L19.5,8.00922203 C19.5,8.55641359 19.0573397,9 18.5010434,9 L17.4989566,9 C16.9472481,9 16.5,8.54902482 16.5,8.00922203 L16.5,3 L7.5,3 L7.5,8.00922203 C7.5,8.55641359 7.05733967,9 6.50104344,9 L5.49895656,9 C4.94724809,9 4.5,8.54902482 4.5,8.00922203 L4.5,3 Z',
            id: pathId
          };
          break;

        case 'media':
          path = {
            d: 'M15.1578947,0 L15.1578947,6.53105091 C15.1578947,7.63438128 16.0561953,8.53125 17.1643053,8.53125 L17.1643053,8.53125 L24,8.53125 L24,16.4958598 C24,18.1550006 22.6561963,19.5 21.0072199,19.5 L15.5988,19.4998204 C14.2335834,22.1711457 11.4548319,24 8.24892849,24 C3.69317108,24 0,20.3068289 0,15.7510715 C0,11.4211969 3.33602179,7.87049199 7.57798665,7.52903541 L7.57894737,3.00414019 C7.57894737,1.34499938 8.92275103,0 10.5717274,0 L15.1578947,0 Z M8.24892849,9.56437514 C4.83211044,9.56437514 2.06223212,12.3342534 2.06223212,15.7510715 C2.06223212,19.1678896 4.83211044,21.9377679 8.24892849,21.9377679 C11.6657466,21.9377679 14.4356249,19.1678896 14.4356249,15.7510715 C14.4356249,12.3342534 11.6657466,9.56437514 8.24892849,9.56437514 Z M7.38112878,13.1466714 L10.8472718,15.2382673 C11.3799877,15.5597273 11.388481,16.075792 10.8472718,16.4023772 L7.38112878,18.493973 C6.8484128,18.8154331 6.41656116,18.5866138 6.41656116,17.9714558 L6.41656116,13.6691886 C6.41656116,13.0591502 6.83991959,12.8200862 7.38112878,13.1466714 Z M17.6842105,0 L17.6842105,5.08749112 C17.6842105,5.64323256 18.1384265,6.09375 18.6849661,6.09375 L24,6.09375 L17.6842105,0 Z',
            id: pathId
          };
          break;

        case 'membership':
        case 'briefcase-membership':
          // temp alias
          path = {
            d: 'M6.80316664,6 C6.76812897,5.75504776 6.75,5.504641 6.75,5.25 C6.75,2.35050506 9.10050506,0 12,0 C14.8994949,0 17.25,2.35050506 17.25,5.25 C17.25,5.504641 17.231871,5.75504776 17.1968334,6 L21.9950534,6 C23.1023548,6 24,6.8926228 24,7.99508929 L24,22.0049107 C24,23.1067681 23.1029738,24 21.9950534,24 L2.00494659,24 C0.897645164,24 0,23.1073772 0,22.0049107 L0,7.99508929 C0,6.8932319 0.897026226,6 2.00494659,6 L6.80316664,6 Z M12,7.5 C13.2426407,7.5 14.25,6.49264069 14.25,5.25 C14.25,4.00735931 13.2426407,3 12,3 C10.7573593,3 9.75,4.00735931 9.75,5.25 C9.75,6.49264069 10.7573593,7.5 12,7.5 Z M12,12 C12,12.4171014 12.334962,12.75 12.7481585,12.75 L18.0018415,12.75 C18.4059866,12.75 18.75,12.4142136 18.75,12 C18.75,11.5828986 18.415038,11.25 18.0018415,11.25 L12.7481585,11.25 C12.3440134,11.25 12,11.5857864 12,12 Z M12,15 C12,15.4171014 12.3366169,15.75 12.751855,15.75 L20.248145,15.75 C20.6581793,15.75 21,15.4142136 21,15 C21,14.5828986 20.6633831,14.25 20.248145,14.25 L12.751855,14.25 C12.3418207,14.25 12,14.5857864 12,15 Z M12,18 C12,18.4171014 12.334241,18.75 12.7465482,18.75 L18.7534518,18.75 C19.1582517,18.75 19.5,18.4142136 19.5,18 C19.5,17.5828986 19.165759,17.25 18.7534518,17.25 L12.7465482,17.25 C12.3417483,17.25 12,17.5857864 12,18 Z M6,18.75 C8.07106781,18.75 9.75,17.0710678 9.75,15 C9.75,12.9289322 8.07106781,11.25 6,11.25 C3.92893219,11.25 2.25,12.9289322 2.25,15 C2.25,17.0710678 3.92893219,18.75 6,18.75 Z',
            id: pathId
          };
          break;

        case 'staff':
        case 'briefcase-user':
          // alias
          path = {
            d: 'M6.80316664,6 C6.76812897,5.75504776 6.75,5.504641 6.75,5.25 C6.75,2.35050506 9.10050506,0 12,0 C14.8994949,0 17.25,2.35050506 17.25,5.25 C17.25,5.504641 17.231871,5.75504776 17.1968334,6 L21.9950534,6 C23.1023548,6 24,6.8926228 24,7.99508929 L24,22.0049107 C24,23.1067681 23.1029738,24 21.9950534,24 L2.00494659,24 C0.897645164,24 0,23.1073772 0,22.0049107 L0,7.99508929 C0,6.8932319 0.897026226,6 2.00494659,6 L6.80316664,6 Z M12,7.5 C13.2426407,7.5 14.25,6.49264069 14.25,5.25 C14.25,4.00735931 13.2426407,3 12,3 C10.7573593,3 9.75,4.00735931 9.75,5.25 C9.75,6.49264069 10.7573593,7.5 12,7.5 Z M2.44746019,18.75 L9.55318605,18.75 C9.89258499,18.188168 9.75743773,17.0633321 9.41803879,16.688543 C9.25992962,16.5141571 8.77251569,16.4619261 8.77251569,16.4619261 C7.70011538,16.2035367 7.23698305,15.2262356 7.7461536,14.2536489 C7.7461536,14.2536489 7.875,14.5001348 7.875,13.59375 C7.875,12.2722612 7.61148892,11.25 6,11.25 C4.38872977,11.25 4.125,12.2722612 4.125,13.59375 C4.125,14.5029474 4.25432787,14.2553216 4.25432787,14.2553216 C4.71402742,15.2606548 4.31428732,16.2154367 3.24673714,16.4575981 C3.24673714,16.4575981 2.74902664,16.5099381 2.5861064,16.688543 C2.24408324,17.0633321 2.10543703,18.188168 2.44746019,18.75 Z M12,12 C12,12.4171014 12.334962,12.75 12.7481585,12.75 L18.0018415,12.75 C18.4059866,12.75 18.75,12.4142136 18.75,12 C18.75,11.5828986 18.415038,11.25 18.0018415,11.25 L12.7481585,11.25 C12.3440134,11.25 12,11.5857864 12,12 Z M12,15 C12,15.4171014 12.3366169,15.75 12.751855,15.75 L20.248145,15.75 C20.6581793,15.75 21,15.4142136 21,15 C21,14.5828986 20.6633831,14.25 20.248145,14.25 L12.751855,14.25 C12.3418207,14.25 12,14.5857864 12,15 Z M12,18 C12,18.4171014 12.334241,18.75 12.7465482,18.75 L18.7534518,18.75 C19.1582517,18.75 19.5,18.4142136 19.5,18 C19.5,17.5828986 19.165759,17.25 18.7534518,17.25 L12.7465482,17.25 C12.3417483,17.25 12,17.5857864 12,18 Z',
            id: pathId
          };
          break;

        case 'live':
        case 'broadcast':
          // alias
          path = {
            d: 'M15.4021064,5.09410305 L16.4398286,4.06152195 C16.4398286,4.06152195 17.8480907,5.17345706 17.8480907,7.09051718 C17.8480907,9.00757729 16.5139015,10.1883693 16.5139015,10.1883693 L15.4021064,9.22442748 C15.4021064,9.22442748 16.2915659,8.10716221 16.2915659,7.15921088 C16.2915659,6.21125954 15.4021064,5.09421183 15.4021064,5.09421183 L15.4021064,5.09410305 Z M8.39040772,5.09410305 L7.35268547,4.06152195 C7.35268547,4.06152195 5.94442342,5.17345706 5.94442342,7.09051718 C5.94442342,9.00757729 7.27861264,10.1883693 7.27861264,10.1883693 L8.39040772,9.22442748 C8.39040772,9.22442748 7.50094823,8.10716221 7.50094823,7.15921088 C7.50094823,6.21125954 8.39040772,5.09421183 8.39040772,5.09421183 L8.39040772,5.09410305 Z M17.6256965,3.02888645 L18.6634188,2.06510782 C18.6634188,2.06510782 20.9609646,3.92489599 20.9609646,7.15942844 C20.9609646,10.3939609 18.6633017,12.185001 18.6633017,12.185001 L17.5515066,11.2212223 C17.5515066,11.2212223 19.4044398,9.63490363 19.4044398,7.15964599 C19.4044398,4.68438836 17.6256965,3.02899523 17.6256965,3.02899523 L17.6256965,3.02888645 Z M6.27035557,3.02888645 L5.23263333,2.06510782 C5.23263333,2.06510782 2.93508746,3.92489599 2.93508746,7.15942844 C2.93508746,10.3939609 5.23275044,12.185001 5.23275044,12.185001 L6.34454551,11.2212223 C6.34454551,11.2212223 4.49161228,9.63490363 4.49161228,7.15964599 C4.49161228,4.68438836 6.27035557,3.02899523 6.27035557,3.02899523 L6.27035557,3.02888645 Z M19.7751553,1.03252672 L20.8128775,0 C20.8128775,0 24,2.44126431 24,7.22833969 C24,12.0154151 20.8128775,14.25 20.8128775,14.25 L19.7751553,13.2173645 C19.7751553,13.2173645 22.4434752,10.9707052 22.4434752,7.22828531 C22.4434752,3.48586546 19.7751553,1.0326355 19.7751553,1.0326355 L19.7751553,1.03252672 Z M4.2248447,1.03252672 L4.2248447,1.0326355 C4.2248447,1.0326355 1.55652481,3.48586546 1.55652481,7.22828531 C1.55652481,10.9707052 4.2248447,13.2173645 4.2248447,13.2173645 L3.18712245,14.25 C3.18712245,14.25 0,12.0154151 0,7.22833969 C0,2.44126431 3.18712245,0 3.18712245,0 L4.2248447,1.03252672 Z M10.4353602,6.75269615 C10.4353602,5.92277998 11.1011575,5.25 11.9353602,5.25 C12.7637874,5.25 13.4353602,5.91732243 13.4353602,6.75269615 L13.4353602,22.4973039 C13.4353602,23.32722 12.769563,24 11.9353602,24 C11.1069331,24 10.4353602,23.3326776 10.4353602,22.4973039 L10.4353602,6.75269615 Z',
            id: pathId
          };
          break;

        case 'building':
          path = {
            d: 'M3.68689661,2.77354391 L12.0997326,0 L20.3194116,2.77059506 C20.7261235,2.90768484 21,3.28901635 21,3.71821115 L21,20.2815424 C21,20.7108568 20.7259733,21.0922666 20.3191035,21.2292623 L12.0901636,24 L3.68659937,21.2265964 C3.27681226,21.0913555 3,20.7085024 3,20.2769754 L3,3.72326296 C3,3.29162069 3.27695773,2.90869257 3.68689661,2.77354391 Z M5.31124128,5.06578369 C4.84035951,5.15629379 4.5,5.56830565 4.5,6.04780719 L4.5,7.49221778 C4.5,7.53368281 4.50257902,7.57510769 4.50772212,7.61625252 C4.57622462,8.16427245 5.0760148,8.55299815 5.62403473,8.48449566 L9.62403473,7.98449566 C10.1244636,7.92194206 10.5,7.49654105 10.5,6.99221778 L10.5,5.27895097 C10.5,5.21560404 10.4939808,5.15240042 10.4820235,5.09019225 C10.3777749,4.54783565 9.85359788,4.19267891 9.31124128,4.29692747 L5.31124128,5.06578369 Z M5.46211503,10.236063 C4.92495732,10.2564278 4.5,10.6978015 4.5,11.2353451 L4.5,12.7646789 C4.5,13.3022225 4.92495732,13.7435962 5.46211503,13.763961 L9.46211503,13.9156097 C9.47473768,13.9160883 9.48736828,13.9163276 9.5,13.9163276 C10.0522847,13.9163276 10.5,13.4686124 10.5,12.9163276 L10.5,11.0836963 C10.5,11.0710646 10.4997607,11.058434 10.4992821,11.0458113 C10.4783588,10.4939231 10.0140033,10.0634909 9.46211503,10.0844142 L5.46211503,10.236063 Z M5.62403473,15.5155043 C5.58288991,15.5103612 5.54146502,15.5077822 5.5,15.5077822 C4.94771525,15.5077822 4.5,15.9554975 4.5,16.5077822 L4.5,17.9522219 C4.5,18.4317219 4.84035736,18.8437329 5.31123723,18.9342446 L9.31123723,19.703118 C9.37344671,19.7150758 9.43665169,19.7210953 9.5,19.7210953 C10.0522847,19.7210953 10.5,19.27338 10.5,18.7210953 L10.5,17.0077822 C10.5,16.5034589 10.1244636,16.0780579 9.62403473,16.0155043 L5.62403473,15.5155043 Z M18.6887587,5.06578369 L14.6887587,4.29692747 C14.1464021,4.19267891 13.6222251,4.54783565 13.5179765,5.09019225 C13.5060192,5.15240042 13.5,5.21560404 13.5,5.27895097 L13.5,6.99221778 C13.5,7.49654105 13.8755364,7.92194206 14.3759653,7.98449566 L18.3759653,8.48449566 C18.9239852,8.55299815 19.4237754,8.16427245 19.4922779,7.61625252 C19.497421,7.57510769 19.5,7.53368281 19.5,7.49221778 L19.5,6.04780719 C19.5,5.56830565 19.1596405,5.15629379 18.6887587,5.06578369 Z M18.537885,10.236063 L14.537885,10.0844142 C13.9859967,10.0634909 13.5216412,10.4939231 13.5007179,11.0458113 C13.5002393,11.058434 13.5,11.0710646 13.5,11.0836963 L13.5,12.9163276 C13.5,13.4686124 13.9477153,13.9163276 14.5,13.9163276 C14.5126317,13.9163276 14.5252623,13.9160883 14.537885,13.9156097 L18.537885,13.763961 C19.0750427,13.7435962 19.5,13.3022225 19.5,12.7646789 L19.5,11.2353451 C19.5,10.6978015 19.0750427,10.2564278 18.537885,10.236063 Z M18.3759653,15.5155043 L14.3759653,16.0155043 C13.8755364,16.0780579 13.5,16.5034589 13.5,17.0077822 L13.5,18.7210953 C13.5,19.27338 13.9477153,19.7210953 14.5,19.7210953 C14.5633483,19.7210953 14.6265533,19.7150758 14.6887628,19.703118 L18.6887628,18.9342446 C19.1596426,18.8437329 19.5,18.4317219 19.5,17.9522219 L19.5,16.5077822 C19.5,15.9554975 19.0522847,15.5077822 18.5,15.5077822 C18.458535,15.5077822 18.4171101,15.5103612 18.3759653,15.5155043 Z',
            id: pathId
          };
          break;

        case 'calendar-one':
          path = {
            d: 'M21,3 L21.9950534,3 C23.1023548,3 24,3.90234375 24,4.99456145 L24,22.0054385 C24,23.1070044 23.1029738,24 21.9950534,24 L2.00494659,24 C0.897645164,24 0,23.0976562 0,22.0054385 L0,4.99456145 C0,3.89299558 0.897026226,3 2.00494659,3 L3,3 L3,5.49013764 C3,6.61019951 3.89449617,7.5 4.99791312,7.5 L7.00208688,7.5 C8.10173938,7.5 9,6.60015397 9,5.49013764 L9,3 L15,3 L15,5.49013764 C15,6.61019951 15.8944962,7.5 16.9979131,7.5 L19.0020869,7.5 C20.1017394,7.5 21,6.60015397 21,5.49013764 L21,3 Z M3,12.4996846 L3,19.0003154 C3,20.1047759 3.8932319,21 4.99508929,21 L19.0049107,21 C20.1073772,21 21,20.1047107 21,19.0003154 L21,12.4996846 C21,11.3952241 20.1067681,10.5 19.0049107,10.5 L4.99508929,10.5 C3.8926228,10.5 3,11.3952893 3,12.4996846 Z M4.5,0.990777969 C4.5,0.443586406 4.94266033,0 5.49895656,0 L6.50104344,0 C7.05275191,0 7.5,0.45097518 7.5,0.990777969 L7.5,5.00922203 C7.5,5.55641359 7.05733967,6 6.50104344,6 L5.49895656,6 C4.94724809,6 4.5,5.54902482 4.5,5.00922203 L4.5,0.990777969 Z M16.5,0.990777969 C16.5,0.443586406 16.9426603,0 17.4989566,0 L18.5010434,0 C19.0527519,0 19.5,0.45097518 19.5,0.990777969 L19.5,5.00922203 C19.5,5.55641359 19.0573397,6 18.5010434,6 L17.4989566,6 C16.9472481,6 16.5,5.54902482 16.5,5.00922203 L16.5,0.990777969 Z M13.5,12 L13.5,19.5 L11.5591142,19.5 L11.5591142,15.4789994 C11.5591142,14.8983912 11.5447018,14.5494138 11.5158766,14.4320568 C11.4870515,14.3146998 11.4077834,14.2259114 11.2780701,14.1656887 C11.1483568,14.105466 10.8593086,14.0753552 10.4109169,14.0753552 L10.21875,14.0753552 L10.21875,13.1998147 C11.1571698,13.0052492 11.8697816,12.6053149 12.3566069,12 L13.5,12 Z',
            id: pathId
          };
          break;

        case 'date-range':
        case 'calendar-range':
          // alias
          path = {
            d: 'M21,3 L22.4986925,3 C23.3278417,3 24,3.67492314 24,4.49343323 L24,22.5065668 C24,23.3313672 23.3330537,24 22.4986925,24 L1.50130749,24 C0.672158257,24 0,23.3250769 0,22.5065668 L0,4.49343323 C0,3.66863283 0.666946292,3 1.50130749,3 L3,3 L3,6.00028876 C3,6.83442503 3.67093534,7.5 4.49857602,7.5 L7.50142398,7.5 C8.33497024,7.5 9,6.82855641 9,6.00028876 L9,3 L15,3 L15,6.00028876 C15,6.83442503 15.6709353,7.5 16.498576,7.5 L19.501424,7.5 C20.3349702,7.5 21,6.82855641 21,6.00028876 L21,3 Z M4.5,0.747772604 C4.5,0.334789199 4.83251488,0 5.25702667,0 L6.74297333,0 C7.16106761,0 7.5,0.339777231 7.5,0.747772604 L7.5,5.2522274 C7.5,5.6652108 7.16748512,6 6.74297333,6 L5.25702667,6 C4.83893239,6 4.5,5.66022277 4.5,5.2522274 L4.5,0.747772604 Z M16.5,0.747772604 C16.5,0.334789199 16.8325149,0 17.2570267,0 L18.7429733,0 C19.1610676,0 19.5,0.339777231 19.5,0.747772604 L19.5,5.2522274 C19.5,5.6652108 19.1674851,6 18.7429733,6 L17.2570267,6 C16.8389324,6 16.5,5.66022277 16.5,5.2522274 L16.5,0.747772604 Z M11.6284691,21.780729 C15.2254727,21.780729 18.1414202,18.9271412 18.1414202,15.4070624 C18.1414202,11.8869835 15.2254727,9.0333958 11.6284691,9.0333958 C8.03146558,9.0333958 5.11551806,11.8869835 5.11551806,15.4070624 C5.11551806,18.9271412 8.03146558,21.780729 11.6284691,21.780729 Z M7.80191666,18.8668377 L11.6338305,15.4064581 L11.6338305,10.3081301 C14.5108811,10.3098425 16.8426479,12.592056 16.8426479,15.4070624 C16.8426479,18.2231255 14.5091302,20.5059957 11.6305902,20.5059957 C10.1170061,20.5059957 8.75411148,19.8748207 7.80191666,18.8668377 Z',
            id: pathId
          };
          break;

        case 'calendar-recurring':
          path = {
            d: 'M21,3 L21.9950534,3 C23.1023548,3 24,3.90234375 24,4.99456145 L24,22.0054385 C24,23.1070044 23.1029738,24 21.9950534,24 L2.00494659,24 C0.897645164,24 0,23.0976562 0,22.0054385 L0,4.99456145 C0,3.89299558 0.897026226,3 2.00494659,3 L3,3 L3,5.49013764 C3,6.61019951 3.89449617,7.5 4.99791312,7.5 L7.00208688,7.5 C8.10173938,7.5 9,6.60015397 9,5.49013764 L9,3 L15,3 L15,5.49013764 C15,6.61019951 15.8944962,7.5 16.9979131,7.5 L19.0020869,7.5 C20.1017394,7.5 21,6.60015397 21,5.49013764 L21,3 Z M4.5,0.990777969 C4.5,0.443586406 4.94266033,0 5.49895656,0 L6.50104344,0 C7.05275191,0 7.5,0.45097518 7.5,0.990777969 L7.5,5.00922203 C7.5,5.55641359 7.05733967,6 6.50104344,6 L5.49895656,6 C4.94724809,6 4.5,5.54902482 4.5,5.00922203 L4.5,0.990777969 Z M16.5,0.990777969 C16.5,0.443586406 16.9426603,0 17.4989566,0 L18.5010434,0 C19.0527519,0 19.5,0.45097518 19.5,0.990777969 L19.5,5.00922203 C19.5,5.55641359 19.0573397,6 18.5010434,6 L17.4989566,6 C16.9472481,6 16.5,5.54902482 16.5,5.00922203 L16.5,0.990777969 Z M12.75,18.1875 L9.75,15.375 L9.75,21 L12.75,18.1875 Z M11.25,11.8125 L14.25,14.625 L14.25,9 L11.25,11.8125 Z M16.125,10.875 L16.125,18.75 L17.0625,18.75 C17.5838767,18.75 18,18.3317039 18,17.8157095 L18,11.8092905 C18,11.2983942 17.580267,10.875 17.0625,10.875 L16.125,10.875 Z M6,11.8213799 L6,18.1786201 C6,18.7045391 6.41973305,19.125 6.9375,19.125 L7.875,19.125 L7.875,10.875 L6.9375,10.875 C6.41612327,10.875 6,11.2987087 6,11.8213799 Z M14.25,10.875 L14.25,12.75 L16.125,12.75 L16.125,10.875 L14.25,10.875 Z M7.875,17.25 L7.875,19.125 L9.75,19.125 L9.75,17.25 L7.875,17.25 Z M7.875,10.875 L7.875,12.75 L9.75,12.75 L9.75,10.875 L7.875,10.875 Z M14.25,16.875 L14.25,18.75 L16.125,18.75 L16.125,16.875 L14.25,16.875 Z',
            id: pathId
          };
          break;

        case 'caret-down':
          polygon = {
            id: polygonId,
            points: '12 5 24 19 0 19',
            transform: 'translate(12.000000, 12.000000) rotate(180.000000) translate(-12.000000, -12.000000)'
          };
          break;

        case 'caret-left':
          polygon = {
            id: polygonId,
            points: '5 12 19 0 19 24'
          };
          break;

        case 'caret-right':
          polygon = {
            id: polygonId,
            points: '14 5 26 19 2 19',
            transform: 'translate(14.000000, 12.000000) rotate(90.000000) translate(-14.000000, -12.000000)'
          };
          break;

        case 'caret-up':
          polygon = {
            id: polygonId,
            points: '12 5 24 19 0 19'
          };
          break;

        case 'true':
        case 'check-circle':
          // alias
          path = {
            d: 'M12,24 C5.372583,24 0,18.627417 0,12 C0,5.372583 5.372583,0 12,0 C18.627417,0 24,5.372583 24,12 C24,18.627417 18.627417,24 12,24 Z M7.67656775,12.3593732 C7.2861859,11.9689913 6.6564981,11.9657451 6.26287002,12.3593732 L5.55380618,13.068437 C5.16342433,13.4588189 5.16606157,14.0943901 5.54801911,14.4763477 L8.39141866,17.3197472 C8.7786044,17.706933 9.41085843,17.702431 9.80491142,17.3083781 L18.2862702,8.82701932 C18.6797349,8.43355456 18.6854803,7.80136758 18.2918523,7.40773949 L17.5827884,6.69867565 C17.1924066,6.3082938 16.5611786,6.30658773 16.1714817,6.69628467 L9.09248046,13.7752859 L7.67656775,12.3593732 Z',
            id: pathId
          };
          break;

        case 'selected':
        case 'check-square':
          // alias
          path = {
            d: 'M0,2.00494659 C0,0.897645164 0.897026226,0 2.00494659,0 L21.9950534,0 C23.1023548,0 24,0.897026226 24,2.00494659 L24,21.9950534 C24,23.1023548 23.1029738,24 21.9950534,24 L2.00494659,24 C0.897645164,24 0,23.1029738 0,21.9950534 L0,2.00494659 Z M7.48795557,12.9478351 C7.10002253,12.5599021 6.47043115,12.5605297 6.08312575,12.9478351 L5.41320792,13.617753 C5.02527488,14.005686 5.02267958,14.6320544 5.41469833,15.0240732 L8.15638299,17.7657578 C8.54513916,18.154514 9.18243095,18.1475205 9.57224033,17.7577111 L17.830492,9.4994595 C18.2236922,9.10625925 18.2273345,8.47239797 17.8400291,8.08509257 L17.1701113,7.41517474 C16.7821782,7.0272417 16.1505008,7.02995535 15.7656455,7.41481067 L8.86028831,14.3201679 L7.48795557,12.9478351 Z',
            id: pathId
          };
          break;

        case 'chevron-down':
        case 'chevron-wh-down': // temp alias

        case 'chevron-wl-down':
          // temp alias
          path = {
            d: 'M18.3815642,11.8451227 C18.7152312,12.2341359 18.6947797,12.8254075 18.3215393,13.1986479 L8.12861462,23.3915726 C7.73035448,23.7898327 7.10630707,23.7868938 6.71959367,23.4001804 L5.28735371,21.9679405 C4.90111359,21.5817004 4.90449418,20.9503869 5.29596157,20.5589195 L14.0097584,11.8451227 L5.29596157,3.1313259 C4.90449418,2.73985852 4.90111359,2.10854506 5.28735371,1.72230495 L6.71959367,0.290064986 C7.10630707,-0.0966484099 7.73035448,-0.0995872988 8.12861462,0.298672846 L18.3215393,10.4915975 C18.6947797,10.8648379 18.7152312,11.4561095 18.3815642,11.8451227 Z',
            id: pathId,
            transform: 'translate(11.808750, 11.845123) rotate(90.000000) translate(-11.808750, -11.845123)'
          };
          break;

        case 'chevron-left':
        case 'chevron-wh-left': // temp alias

        case 'chevron-wl-left':
          // temp alias
          path = {
            d: 'M5.23593668,11.8451227 C4.90226973,11.4561095 4.92272118,10.8648379 5.29596157,10.4915975 L15.4888863,0.298672846 C15.8871464,-0.0995872988 16.5111938,-0.0966484099 16.8979072,0.290064986 L18.3301472,1.72230495 C18.7163873,2.10854506 18.7130067,2.73985852 18.3215393,3.1313259 L9.60774251,11.8451227 L18.3215393,20.5589195 C18.7130067,20.9503869 18.7163873,21.5817004 18.3301472,21.9679405 L16.8979072,23.4001804 C16.5111938,23.7868938 15.8871464,23.7898327 15.4888863,23.3915726 L5.29596157,13.1986479 C4.92272118,12.8254075 4.90226973,12.2341359 5.23593668,11.8451227 Z',
            id: pathId
          };
          break;

        case 'chevron-right':
        case 'chevron-wh-right': // temp alias

        case 'chevron-wl-right':
          // temp alias
          path = {
            d: 'M18.3815642,11.8451227 C18.7152312,12.2341359 18.6947797,12.8254075 18.3215393,13.1986479 L8.12861462,23.3915726 C7.73035448,23.7898327 7.10630707,23.7868938 6.71959367,23.4001804 L5.28735371,21.9679405 C4.90111359,21.5817004 4.90449418,20.9503869 5.29596157,20.5589195 L14.0097584,11.8451227 L5.29596157,3.1313259 C4.90449418,2.73985852 4.90111359,2.10854506 5.28735371,1.72230495 L6.71959367,0.290064986 C7.10630707,-0.0966484099 7.73035448,-0.0995872988 8.12861462,0.298672846 L18.3215393,10.4915975 C18.6947797,10.8648379 18.7152312,11.4561095 18.3815642,11.8451227 Z',
            id: pathId
          };
          break;

        case 'chevron-up':
        case 'chevron-wh-up': // temp alias

        case 'chevron-wl-up':
          // temp alias
          path = {
            d: 'M11.8087504,5.27230895 C12.1977636,4.938642 12.7890352,4.95909345 13.1622756,5.33233383 L23.3552003,15.5252585 C23.7534604,15.9235187 23.7505216,16.5475661 23.3638082,16.9342795 L21.9315682,18.3665194 C21.5453281,18.7527596 20.9140146,18.749379 20.5225472,18.3579116 L11.8087504,9.64411478 L3.09495363,18.3579116 C2.70348625,18.749379 2.0721728,18.7527596 1.68593269,18.3665194 L0.253692719,16.9342795 C-0.133020677,16.5475661 -0.135959566,15.9235187 0.262300579,15.5252585 L10.4552253,5.33233383 C10.8284657,4.95909345 11.4197373,4.938642 11.8087504,5.27230895 Z',
            id: pathId
          };
          break;

        case 'child':
          path = {
            d: 'M9.95139682,8.59990704 L14.0485804,8.59990704 L18.5637864,4.16090971 C19.0982313,3.63548531 19.9637643,3.61082965 20.5290252,4.10492773 C21.0942861,4.59902581 21.1595006,5.43725372 20.6770983,6.00816884 L16.1328623,11.3861963 C16.1135504,11.4090516 16.0937534,11.4312929 16.0734977,11.4529178 L16.0734977,22.4022301 C16.0734977,23.284654 15.3581517,24 14.4757278,24 C13.5798544,24 12.8405493,23.2991011 12.7928024,22.4045009 L12.5523819,17.8999068 L11.3434435,17.8999068 L11.103023,22.4045009 C11.0552761,23.2991011 10.315971,24 9.42009763,24 C8.53767367,24 7.82232772,23.284654 7.82232772,22.4022301 L7.82232772,11.3331868 L3.32290173,6.00819122 C2.84049939,5.4372761 2.90571392,4.59904819 3.4709748,4.10495012 C4.03623568,3.61085204 4.90176868,3.63550769 5.43621357,4.1609321 L9.95139682,8.59990704 Z M12,7.5 C9.92893219,7.5 8.25,5.82106781 8.25,3.75 C8.25,1.67893219 9.92893219,0 12,0 C14.0710678,0 15.75,1.67893219 15.75,3.75 C15.75,5.82106781 14.0710678,7.5 12,7.5 Z',
            id: pathId
          };
          viewBox = '0 0 18 24';
          break;

        case 'campus':
        case 'church':
          // alias
          path = {
            d: 'M12.529425,7.09088103 L21,14.8636399 L19.5441,17.1818392 L12,10.090881 L4.4559,17.1818392 L3,14.8636399 L11.3382,7.09088103 L11.3382,3.81816077 L9.0882,3.81816077 L9.0882,2.45455949 L11.3382,2.45455949 L11.3382,0 L12.529425,0 L12.529425,2.45455949 L14.779425,2.45455949 L14.779425,3.81816077 L12.529425,3.81816077 L12.529425,7.09088103 Z M18.220575,17.1818392 L18.220575,24 L13.985325,24 L13.985325,20.8636399 C13.985325,20.8636399 13.52205,19.2272412 11.867625,19.2272412 C10.2132,19.2272412 9.882375,20.8636399 9.882375,20.8636399 L9.882375,24 L5.64705,24 L5.64705,17.1818392 L12,11.3181994 L18.220575,17.1818392 Z',
            id: pathId
          };
          break;

        case 'open':
        case 'circle':
          // alias
          path = {
            d: 'M12,24 C5.372583,24 0,18.627417 0,12 C0,5.372583 5.372583,0 12,0 C18.627417,0 24,5.372583 24,12 C24,18.627417 18.627417,24 12,24 Z M12,19.5 C16.1421356,19.5 19.5,16.1421356 19.5,12 C19.5,7.85786438 16.1421356,4.5 12,4.5 C7.85786438,4.5 4.5,7.85786438 4.5,12 C4.5,16.1421356 7.85786438,19.5 12,19.5 Z',
            id: pathId
          };
          break;

        case 'time-period':
        case 'clock-period':
          // alias
          path = {
            d: 'M11.9964148,24 C6.32167508,24 1.72138962,19.3079528 1.72138962,13.5200193 C1.72138962,7.73208572 6.32167508,3.04003852 11.9964148,3.04003852 C17.6711545,3.04003852 22.2714399,7.73208572 22.2714399,13.5200193 C22.2714399,19.3079528 17.6711545,24 11.9964148,24 Z M11.9975448,21.0064295 C16.0509303,21.0064295 19.3368485,17.6549672 19.3368485,13.5207289 C19.3368485,9.38649071 16.0509303,6.03502842 11.9975448,6.03502842 C7.94415931,6.03502842 4.65824112,9.38649071 4.65824112,13.5207289 C4.65824112,17.6549672 7.94415931,21.0064295 11.9975448,21.0064295 Z M7.68548559,17.5841423 L12.0035864,13.5200193 L12.0035864,7.5321695 C15.2456725,7.53418085 17.87329,10.2145795 17.87329,13.5207289 C17.87329,16.8281195 15.2436994,19.5092894 11.999935,19.5092894 C10.2943098,19.5092894 8.75849333,18.7679913 7.68548559,17.5841423 Z M1.4958015,3.28761062 L5.93682025,0.292105653 C6.460463,-0.0610958409 7.1712857,0.077074096 7.52448719,0.600716844 C7.87768869,1.12435959 7.73951875,1.8351823 7.215876,2.18838379 L2.77485725,5.18388876 C2.2512145,5.53709025 1.5403918,5.39892032 1.18719031,4.87527757 C0.833988813,4.35163482 0.972158749,3.64081212 1.4958015,3.28761062 Z M18.0631798,0.292105653 L22.5041985,3.28761062 C23.0278413,3.64081212 23.1660112,4.35163482 22.8128097,4.87527757 C22.4596082,5.39892032 21.7487855,5.53709025 21.2251427,5.18388876 L16.784124,2.18838379 C16.2604813,1.8351823 16.1223113,1.12435959 16.4755128,0.600716844 C16.8287143,0.077074096 17.539537,-0.0610958409 18.0631798,0.292105653 Z',
            id: pathId
          };
          break;

        case 'close':
        case 'times':
          // alias
          path = {
            d: 'M14.9243697,12.1008403 L23.394958,3.6302521 C24.2016807,2.82352941 24.2016807,1.61344538 23.394958,0.806722689 C22.5882353,2.23910526e-16 21.3781513,2.23910526e-16 20.5714286,0.806722689 L12.1008403,9.07563025 L3.42857143,0.605042017 C2.62184874,-0.201680672 1.41176471,-0.201680672 0.605042017,0.605042017 C-0.201680672,1.41176471 -0.201680672,2.62184874 0.605042017,3.42857143 L9.07563025,12.1008403 L0.605042017,20.5714286 C-0.201680672,21.3781513 -0.201680672,22.5882353 0.605042017,23.394958 C1.41176471,24.2016807 2.62184874,24.2016807 3.42857143,23.394958 L12.1008403,14.9243697 L20.5714286,23.394958 C21.3781513,24.2016807 22.5882353,24.2016807 23.394958,23.394958 C24.2016807,22.5882353 24.2016807,21.3781513 23.394958,20.5714286 L14.9243697,12.1008403 L14.9243697,12.1008403 Z',
            id: pathId
          };
          break;

        case 'comment':
          path = {
            d: 'M10.5,16.5 L2.00494659,16.5 C0.897645164,16.5 0,15.6128883 0,14.5097145 L0,1.99028552 C0,0.891081181 0.897026226,0 2.00494659,0 L21.9950534,0 C23.1023548,0 24,0.887111664 24,1.99028552 L24,14.5097145 C24,15.6089188 23.1029738,16.5 21.9950534,16.5 L21,16.5 L21,24 L10.5,16.5 Z',
            id: pathId
          };
          break;

        case 'sms':
        case 'comment-lines': // alias

        case 'comment-sms':
          // temp alias
          path = {
            d: 'M18.375,24 L10.1240625,18 L5.625,18 C2.518125,18 0,16.4203125 0,13.3125 L0,5.625 C0,2.5190625 2.518125,0 5.625,0 L18.375,0 C21.4809375,0 24,2.5190625 24,5.625 L24,12.3759375 C24,15.481875 21.4809375,18 18.375,18 L18.375,24 Z M7.49554521,7.5 C6.6695784,7.5 6,6.83420277 6,6 L6,6 C6,5.17157288 6.67955446,4.5 7.49554521,4.5 L16.5044548,4.5 C17.3304216,4.5 18,5.16579723 18,6 L18,6 C18,6.82842712 17.3204455,7.5 16.5044548,7.5 L7.49554521,7.5 Z M15.0006104,10.125 C15.9322538,10.125 16.6875,10.8740219 16.6875,11.8125 L16.6875,11.8125 C16.6875,12.7444805 15.9361519,13.5 15.0006104,13.5 L8.99938964,13.5 C8.06774622,13.5 7.3125,12.7509781 7.3125,11.8125 L7.3125,11.8125 C7.3125,10.8805195 8.06384807,10.125 8.99938964,10.125 L15.0006104,10.125 Z',
            id: pathId
          };
          break;

        case 'configuration-1':
        case 'wrench-screwdriver':
          // alias
          path = {
            d: 'M20.194902,7.17333918 C20.1967294,7.17153005 17.9440899,7.69666151 17.9611452,7.67989686 L15.5190093,10.0965388 L13.7969723,8.39245466 C13.7969723,8.39245466 16.1927545,6.03810724 16.2369764,5.99438649 C16.1927545,6.03810724 16.7592949,3.77258832 16.7505236,3.76571361 C16.7866443,3.79701164 22.2779631,0 22.2779631,0 L24,1.70408416 C24,1.70408416 20.1966076,7.17153005 20.194902,7.17333918 Z M23.2251413,19.5965457 C24.1761569,20.5376575 24.22647,22.0137907 23.3374017,22.8935728 L22.8544931,23.3714256 C21.9651811,24.2511474 20.4738171,24.2013962 19.5226187,23.2602844 L5.14153027,9.02920973 C3.60343303,9.26590396 2.05204089,8.69100644 1.04894162,7.51262409 C0.045842351,6.33424174 -0.263615331,4.72312171 0.232589029,3.26247268 L2.92123499,5.92304628 C3.4172565,6.41482415 4.22194871,6.41568789 4.71904616,5.92497602 L5.70679158,4.94738001 C5.94489306,4.71125273 6.07845614,4.39112822 6.07807915,4.05747653 C6.07770215,3.72382484 5.94341598,3.40399697 5.70478149,3.16839768 L3.01613554,0.507703465 C4.49140304,0.0157393503 6.11903493,0.321382613 7.30987861,1.31399981 C8.50072229,2.30661701 9.08223649,3.84238788 8.84393097,5.3654107 L23.2251413,19.5965457 Z M19.7380028,22.706448 C20.32981,23.2926309 21.2200319,23.4681035 21.9934852,23.1510285 C22.7669385,22.8339534 23.2712709,22.0867872 23.2712709,21.2579946 C23.2712709,20.4292019 22.7669385,19.6820357 21.9934852,19.3649606 C21.2200319,19.0478856 20.32981,19.2233582 19.7380028,19.8095411 C18.9308282,20.6098442 18.9308282,21.9061449 19.7380028,22.706448 Z M6.99525846,12.9081149 L7.94621316,13.8491664 L2.10264158,19.6323665 C1.86472017,19.867554 1.82579754,20.2112896 2.01572047,20.3989572 C2.2056434,20.5866247 2.55247507,20.5483314 2.79045739,20.3128423 L8.63402898,14.5296422 L9.32507312,15.213495 L3.48156245,20.9966952 C3.24364104,21.2318827 3.20471841,21.5756183 3.39464134,21.7633461 C3.58456427,21.951074 3.93139594,21.9127204 4.16937826,21.6772313 L10.0128889,15.8940312 L10.9560469,16.8273637 L5.01459012,22.706448 C4.06337152,23.6476289 2.52173487,23.6476289 1.57051627,22.706448 L1.05392347,22.1952469 C0.597232756,21.7434068 0.340641321,21.1304016 0.340641321,20.4911929 C0.340641321,19.8519842 0.597232756,19.238979 1.05392347,18.7871389 L6.99525846,12.9081149 Z',
            id: pathId
          };
          break;

        case 'configuration-2':
        case 'sliders':
          // alias
          path = {
            d: 'M2.90909091,14.3741496 C3.75650354,14.673667 4.36363636,15.4818409 4.36363636,16.4318182 L4.36363636,18.0681818 C4.36363636,19.0181591 3.75650354,19.826333 2.90909091,20.1258504 L2.90909091,23.2727273 C2.90909091,23.6743889 2.58347982,24 2.18181818,24 C1.78015655,24 1.45454545,23.6743889 1.45454545,23.2727273 L1.45454545,20.1258504 C0.60713282,19.826333 0,19.0181591 0,18.0681818 L0,16.4318182 C0,15.4818409 0.60713282,14.673667 1.45454545,14.3741496 L1.45454545,0.727272727 C1.45454545,0.325611091 1.78015655,0 2.18181818,0 C2.58347982,0 2.90909091,0.325611091 2.90909091,0.727272727 L2.90909091,14.3741496 Z M9.45454545,3.12414961 C10.3019581,3.42366699 10.9090909,4.23184085 10.9090909,5.18181818 L10.9090909,6.81818182 C10.9090909,7.76815915 10.3019581,8.57633301 9.45454545,8.87585039 L9.45454545,23.2727273 C9.45454545,23.6743889 9.12893436,24 8.72727273,24 C8.32561109,24 8,23.6743889 8,23.2727273 L8,8.87585039 C7.15258737,8.57633301 6.54545455,7.76815915 6.54545455,6.81818182 L6.54545455,5.18181818 C6.54545455,4.23184085 7.15258737,3.42366699 8,3.12414961 L8,0.727272727 C8,0.325611091 8.32561109,0 8.72727273,0 C9.12893436,0 9.45454545,0.325611091 9.45454545,0.727272727 L9.45454545,3.12414961 Z M16,12.8741496 C16.8474126,13.173667 17.4545455,13.9818409 17.4545455,14.9318182 L17.4545455,16.5681818 C17.4545455,17.5181591 16.8474126,18.326333 16,18.6258504 L16,23.2727273 C16,23.6743889 15.6743889,24 15.2727273,24 C14.8710656,24 14.5454545,23.6743889 14.5454545,23.2727273 L14.5454545,18.6258504 C13.6980419,18.326333 13.0909091,17.5181591 13.0909091,16.5681818 L13.0909091,14.9318182 C13.0909091,13.9818409 13.6980419,13.173667 14.5454545,12.8741496 L14.5454545,0.727272727 C14.5454545,0.325611091 14.8710656,0 15.2727273,0 C15.6743889,0 16,0.325611091 16,0.727272727 L16,12.8741496 Z M22.5454545,4.62414961 C23.3928672,4.92366699 24,5.73184085 24,6.68181818 L24,8.31818182 C24,9.26815915 23.3928672,10.076333 22.5454545,10.3758504 L22.5454545,23.2727273 C22.5454545,23.6743889 22.2198435,24 21.8181818,24 C21.4165202,24 21.0909091,23.6743889 21.0909091,23.2727273 L21.0909091,10.3758504 C20.2434965,10.076333 19.6363636,9.26815915 19.6363636,8.31818182 L19.6363636,6.68181818 C19.6363636,5.73184085 20.2434965,4.92366699 21.0909091,4.62414961 L21.0909091,0.727272727 C21.0909091,0.325611091 21.4165202,0 21.8181818,0 C22.2198435,0 22.5454545,0.325611091 22.5454545,0.727272727 L22.5454545,4.62414961 Z',
            id: pathId
          };
          break;

        case 'connection-cards':
        case 'cards':
          // temp alias
          path = {
            d: 'M19.037037,19.5 L19.037037,4.99520242 C19.037037,3.88854557 18.1433371,3 17.0409023,3 L8.66666667,3 L8.66666667,1.99520242 C8.66666667,0.89328255 9.56220798,0 10.6628014,0 L20.0038653,0 C21.1063,0 22,0.888545573 22,1.99520242 L22,17.5047976 C22,18.6067175 21.1044587,19.5 20.0038653,19.5 L19.037037,19.5 Z M2,8.24172605 C2,6.58944138 3.34948139,5.25 5.00197928,5.25 L13.0720948,5.25 C14.7300422,5.25 16.0740741,6.59845376 16.0740741,8.24172605 L16.0740741,21.0082739 C16.0740741,22.6605586 14.7245927,24 13.0720948,24 L5.00197928,24 C3.3440319,24 2,22.6515462 2,21.0082739 L2,8.24172605 Z M3.51946819,9.78900146 C3.51946819,10.2061028 3.85150933,10.5390015 4.26110284,10.5390015 L11.1349086,10.5390015 C11.5385854,10.5390015 11.8765432,10.203215 11.8765432,9.78900146 C11.8765432,9.37190008 11.5445021,9.03900146 11.1349086,9.03900146 L4.26110284,9.03900146 C3.857426,9.03900146 3.51946819,9.3747879 3.51946819,9.78900146 Z M3.51946819,12.7890015 C3.51946819,13.2061028 3.85218681,13.5390015 4.26261603,13.5390015 L13.1096535,13.5390015 C13.5089929,13.5390015 13.8528014,13.203215 13.8528014,12.7890015 C13.8528014,12.3719001 13.5200828,12.0390015 13.1096535,12.0390015 L4.26261603,12.0390015 C3.86327667,12.0390015 3.51946819,12.3747879 3.51946819,12.7890015 Z M3.51946819,15.7890015 C3.51946819,16.2061028 3.85643665,16.5390015 4.27210832,16.5390015 L12.358471,16.5390015 C12.7697395,16.5390015 13.1111111,16.203215 13.1111111,15.7890015 C13.1111111,15.3719001 12.7741426,15.0390015 12.358471,15.0390015 L4.27210832,15.0390015 C3.86083984,15.0390015 3.51946819,15.3747879 3.51946819,15.7890015 Z M3.51946819,18.7890015 C3.51946819,19.2061028 3.85413332,19.5390015 4.26696368,19.5390015 L7.17843044,19.5390015 C7.58015858,19.5390015 7.92592593,19.203215 7.92592593,18.7890015 C7.92592593,18.3719001 7.5912608,18.0390015 7.17843044,18.0390015 L4.26696368,18.0390015 C3.86523553,18.0390015 3.51946819,18.3747879 3.51946819,18.7890015 Z',
            id: pathId
          };
          break;

        case 'delete':
        case 'trash':
          // alias
          path = {
            d: 'M3,7.5 L1,7.5 C0.44771525,7.5 6.76353751e-17,7.05228475 0,6.5 L0,4.75 C-6.76353751e-17,4.19771525 0.44771525,3.75 1,3.75 L6,3.75 L6,2 C6,0.8954305 6.8954305,2.02906125e-16 8,0 L16,0 C17.1045695,-2.02906125e-16 18,0.8954305 18,2 L18,3.75 L23,3.75 C23.5522847,3.75 24,4.19771525 24,4.75 L24,6.5 C24,7.05228475 23.5522847,7.5 23,7.5 L21,7.5 L21,22 C21,23.1045695 20.1045695,24 19,24 L5,24 C3.8954305,24 3,23.1045695 3,22 L3,7.5 Z M5.25,10.7483625 L5.25,20.0016375 C5.25,20.5450531 5.69724809,21 6.24895656,21 L7.25104344,21 C7.80733967,21 8.25,20.5530179 8.25,20.0016375 L8.25,10.7483625 C8.25,10.2049469 7.80275191,9.75 7.25104344,9.75 L6.24895656,9.75 C5.69266033,9.75 5.25,10.1969821 5.25,10.7483625 Z M10.5,10.7483625 L10.5,20.0016375 C10.5,20.5450531 10.9472481,21 11.4989566,21 L12.5010434,21 C13.0573397,21 13.5,20.5530179 13.5,20.0016375 L13.5,10.7483625 C13.5,10.2049469 13.0527519,9.75 12.5010434,9.75 L11.4989566,9.75 C10.9426603,9.75 10.5,10.1969821 10.5,10.7483625 Z M15.75,10.7483625 L15.75,20.0016375 C15.75,20.5450531 16.1972481,21 16.7489566,21 L17.7510434,21 C18.3073397,21 18.75,20.5530179 18.75,20.0016375 L18.75,10.7483625 C18.75,10.2049469 18.3027519,9.75 17.7510434,9.75 L16.7489566,9.75 C16.1926603,9.75 15.75,10.1969821 15.75,10.7483625 Z',
            id: pathId
          };
          break;

        case 'download-1':
        case 'arrow-to-bottom':
          // alias
          path = {
            d: 'M1.5,24 C0.671572875,24 0,23.3284271 0,22.5 C0,21.6715729 0.671572875,21 1.5,21 L22.5,21 C23.3284271,21 24,21.6715729 24,22.5 C24,23.3284271 23.3284271,24 22.5,24 L1.5,24 Z M16.3743166,8.99672727 C17.0903652,8.26936364 18.2487894,8.26936364 18.9629635,8.99672727 C19.6790122,9.726 19.6790122,10.9058182 18.9629635,11.6350909 L13.51762,17.1829091 C12.940656,17.7276364 12.4345483,18 11.9992971,18 C11.5640458,18 11.0598127,17.7289091 10.4865975,17.1867273 L5.0356306,11.6350909 C4.32145647,10.9058182 4.32145647,9.726 5.0356306,8.99672727 C5.74980474,8.26936364 6.91010341,8.26936364 7.62427755,8.99672727 L10.1248243,11.5434545 L10.1234184,1.90909091 C10.1234184,1.90909091 10.1234184,0 11.9978912,0 C13.872364,0 13.872364,1.90909091 13.872364,1.90909091 L13.8756444,11.5434545 L16.3743166,8.99672727 Z',
            id: pathId
          };
          break;

        case 'download-2':
        case 'cloud-download':
          // alias
          path = {
            d: 'M18.7004967,17.3918684 C19.1978279,17.1152814 19.6447618,16.756979 20.023166,16.3343858 C20.8365774,15.4259866 21.3333333,15.2205183 21.3333333,13.8910521 C21.3333333,11.1586773 19.236,9.94612652 16.6013333,9.80099797 C16.2866667,7.47564276 14.358,5.67868742 12,5.67868742 C9.42266667,5.67868742 7.33333333,7.81669486 7.33333333,10.4560555 C4.756,10.4560555 2.66666667,11.5940629 2.66666667,14.2321042 C2.66666667,16.0986972 3.71217295,16.7147422 5.33333333,17.5006634 L5.33333333,20.3078416 C2.442026,19.4216135 0,17.9970963 0,14.2314445 C0,11.2635656 1.33333333,9.5625 4.78933333,7.90204668 C6.66666667,4.3125 9.102,3 12,3 C14.664,3 17.3333333,4.3125 19.0126667,7.24830853 C21.3333333,8.25 24,11.1875 24,13.8897327 C24,17.7850614 21.4466396,19.2356088 18.6920276,20.2083939 C18.6666667,18.0625 18.6666667,19.375 18.7004967,17.3918684 Z M15.113,14.81025 C15.6223333,14.3101875 16.4463333,14.3101875 16.9543333,14.81025 C17.4636667,15.311625 17.4636667,16.12275 16.9543333,16.624125 L13.081,20.43825 C13.0383333,20.4999375 13.0103333,20.5695 12.9543333,20.6259375 C12.9063333,20.6731875 12.8303333,20.6600625 12.7756667,20.698125 C12.5796667,20.8516875 12.3543333,20.9566875 12.0903333,20.976375 C12.0636667,20.979 12.045,20.9960625 12.001,21 C11.993,21 11.9876667,20.9960625 11.9303333,20.9855625 C11.617,20.9685 11.3356667,20.84775 11.1156667,20.6535 C11.0956667,20.6364375 11.0663333,20.6443125 11.0476667,20.6259375 C10.993,20.572125 10.9676667,20.5025625 10.925,20.440875 L7.04766667,16.624125 C6.53966667,16.12275 6.53966667,15.311625 7.04766667,14.81025 C7.55566667,14.3101875 8.381,14.3101875 8.889,14.81025 L10.6676667,16.561125 L10.6666667,10.875 C10.6666667,10.875 10.6666667,9.5625 12,9.5625 C13.3333333,9.5625 13.3333333,10.875 13.3333333,10.875 L13.3356667,16.561125 L15.113,14.81025 Z',
            id: pathId
          };
          break;

        case 'drag-and-drop-1':
        case 'drag':
          // alias
          path = {
            d: 'M18,0.99077794 C18,0.443586393 18.4509752,0 18.990778,0 L23.009222,0 C23.5564136,0 24,0.450975166 24,0.99077794 L24,5.00922188 C24,5.55641343 23.5490248,5.99999982 23.009222,5.99999982 L18.990778,5.99999982 C18.4435864,5.99999982 18,5.54902465 18,5.00922188 L18,0.99077794 Z M18,9.99077803 C18,9.44358648 18.4509752,9.00000009 18.990778,9.00000009 L23.009222,9.00000009 C23.5564136,9.00000009 24,9.45097526 24,9.99077803 L24,14.009222 C24,14.5564135 23.5490248,14.9999999 23.009222,14.9999999 L18.990778,14.9999999 C18.4435864,14.9999999 18,14.5490247 18,14.009222 L18,9.99077803 Z M18,18.9907781 C18,18.4435866 18.4509752,18.0000002 18.990778,18.0000002 L23.009222,18.0000002 C23.5564136,18.0000002 24,18.4509753 24,18.9907781 L24,23.0092221 C24,23.5564136 23.5490248,24 23.009222,24 L18.990778,24 C18.4435864,24 18,23.5490248 18,23.0092221 L18,18.9907781 Z M2.27373675e-13,0.99077794 C2.27373675e-13,0.443586393 0.45097518,0 0.990777969,0 L5.00922203,0 C5.55641359,0 6,0.450975166 6,0.99077794 L6,5.00922188 C6,5.55641343 5.54902482,5.99999982 5.00922203,5.99999982 L0.990777969,5.99999982 C0.443586406,5.99999982 2.27373675e-13,5.54902465 2.27373675e-13,5.00922188 L2.27373675e-13,0.99077794 Z M2.27373675e-13,9.99077803 C2.27373675e-13,9.44358648 0.45097518,9.00000009 0.990777969,9.00000009 L5.00922203,9.00000009 C5.55641359,9.00000009 6,9.45097526 6,9.99077803 L6,14.009222 C6,14.5564135 5.54902482,14.9999999 5.00922203,14.9999999 L0.990777969,14.9999999 C0.443586406,14.9999999 2.27373675e-13,14.5490247 2.27373675e-13,14.009222 L2.27373675e-13,9.99077803 Z M2.27373675e-13,18.9907781 C2.27373675e-13,18.4435866 0.45097518,18.0000002 0.990777969,18.0000002 L5.00922203,18.0000002 C5.55641359,18.0000002 6,18.4509753 6,18.9907781 L6,23.0092221 C6,23.5564136 5.54902482,24 5.00922203,24 L0.990777969,24 C0.443586406,24 2.27373675e-13,23.5490248 2.27373675e-13,23.0092221 L2.27373675e-13,18.9907781 Z M9,0.99077794 C9,0.443586393 9.45097518,0 9.99077797,0 L14.009222,0 C14.5564136,0 15,0.450975166 15,0.99077794 L15,5.00922188 C15,5.55641343 14.5490248,5.99999982 14.009222,5.99999982 L9.99077797,5.99999982 C9.44358641,5.99999982 9,5.54902465 9,5.00922188 L9,0.99077794 Z M9,9.99077803 C9,9.44358648 9.45097518,9.00000009 9.99077797,9.00000009 L14.009222,9.00000009 C14.5564136,9.00000009 15,9.45097526 15,9.99077803 L15,14.009222 C15,14.5564135 14.5490248,14.9999999 14.009222,14.9999999 L9.99077797,14.9999999 C9.44358641,14.9999999 9,14.5490247 9,14.009222 L9,9.99077803 Z M9,18.9907781 C9,18.4435866 9.45097518,18.0000002 9.99077797,18.0000002 L14.009222,18.0000002 C14.5564136,18.0000002 15,18.4509753 15,18.9907781 L15,23.0092221 C15,23.5564136 14.5490248,24 14.009222,24 L9.99077797,24 C9.44358641,24 9,23.5490248 9,23.0092221 L9,18.9907781 Z',
            id: pathId
          };
          break;

        case 'duplicate':
          path = {
            d: 'M19.5,16.5 L19.5,6.49028552 C19.5,5.38711166 18.6089188,4.5 17.5097145,4.5 L7.5,4.5 L7.5,1.99028552 C7.5,0.891081181 8.38711166,0 9.49028552,0 L22.0097145,0 C23.1089188,0 24,0.887111664 24,1.99028552 L24,14.5097145 C24,15.6089188 23.1128883,16.5 22.0097145,16.5 L19.5,16.5 Z M0,9.49028552 C0,8.39108118 0.887111664,7.5 1.99028552,7.5 L14.5097145,7.5 C15.6089188,7.5 16.5,8.38711166 16.5,9.49028552 L16.5,22.0097145 C16.5,23.1089188 15.6128883,24 14.5097145,24 L1.99028552,24 C0.891081181,24 0,23.1128883 0,22.0097145 L0,9.49028552 Z',
            id: pathId
          };
          break;

        case 'edit-1':
        case 'edit':
          // alias
          path = {
            d: 'M3,5.25 L3,21 L18.75,21 L18.75,14.25 L21.75,14.25 L21.75,21.75 C21.75,22.9926407 20.7426407,24 19.5,24 L2.25,24 C1.00735931,24 0,22.9926407 0,21.75 L0,4.5 C0,3.25735931 1.00735931,2.25 2.25,2.25 L10.5,2.25 L10.5,5.25 L3,5.25 Z M13.4823628,13.4082339 L10.5918895,10.5177606 L17.1722446,3.94187901 L18.7822581,2.32978767 L21.6729018,5.22043135 L20.0632231,6.83283675 L13.4823628,13.4082339 Z M11.9948455,14.8945162 L11.1132178,15.7754121 L7.5,16.5 L8.22291305,12.8851266 L9.10448411,12.0041548 L11.9948455,14.8945162 Z M23.0310954,3.85993707 L20.1407255,0.969567114 L20.5119277,0.597885819 C21.3089511,-0.199295273 22.6058827,-0.199295273 23.4022324,0.597885819 C24.1992559,1.39439475 24.1992559,2.6909903 23.4022324,3.48817139 L23.0310954,3.85993707 Z',
            id: pathId
          };
          break;

        case 'edit-2':
        case 'pencil':
          // alias
          path = {
            d: 'M8.70161857,19.5028857 L4.4972938,15.2985609 L14.0687194,5.7336422 L16.4105573,3.38878206 L20.6151299,7.59335469 L18.273779,9.93867164 L8.70161857,19.5028857 Z M6.53795715,21.6647509 L5.25558948,22.946054 L2.40676268e-16,24 L1.05150988,18.7420023 L2.33379506,17.4605888 L6.53795715,21.6647509 Z M22.5906843,5.61445392 L18.3865098,1.41027944 L18.9264403,0.8696521 C20.0857471,-0.289884033 21.9721931,-0.289884033 23.1305199,0.8696521 C24.2898267,2.02821055 24.2898267,3.91416771 23.1305199,5.07370385 L22.5906843,5.61445392 Z',
            id: pathId
          };
          break;

        case 'edit-text':
        case 'text-edit':
          // alias
          path = {
            d: 'M1.5,0 L22.5,0 C23.3284271,0 24,0.671572875 24,1.5 C24,2.32842712 23.3284271,3 22.5,3 L1.5,3 C0.671572875,3 0,2.32842712 0,1.5 C0,0.671572875 0.671572875,0 1.5,0 Z M1.5,6 L13.5,6 C14.3284271,6 15,6.67157288 15,7.5 C15,8.32842712 14.3284271,9 13.5,9 L1.5,9 C0.671572875,9 0,8.32842712 0,7.5 C0,6.67157288 0.671572875,6 1.5,6 Z M1.5,12 L7.5,12 C8.32842712,12 9,12.6715729 9,13.5 C9,14.3284271 8.32842712,15 7.5,15 L1.5,15 C0.671572875,15 0,14.3284271 0,13.5 C0,12.6715729 0.671572875,12 1.5,12 Z M1.5,18 L2.25,18 C3.07842712,18 3.75,18.6715729 3.75,19.5 C3.75,20.3284271 3.07842712,21 2.25,21 L1.5,21 C0.671572875,21 0,20.3284271 0,19.5 C0,18.6715729 0.671572875,18 1.5,18 Z M12.5262139,20.6271642 L9.37297035,17.4739207 L16.5515396,10.3002317 L18.307918,8.54158655 L21.4613474,11.695016 L19.7053343,13.4540037 L12.5262139,20.6271642 Z M10.9034679,22.2485632 L9.94169211,23.2095405 L6,24 L6.78863241,20.0565017 L7.7503463,19.0954416 L10.9034679,22.2485632 Z M22.9430132,10.2108404 L19.7898823,7.05770958 L20.1948302,6.65223907 C21.0643103,5.78258698 22.4791448,5.78258698 23.3478899,6.65223907 C24.21737,7.52115791 24.21737,8.93562579 23.3478899,9.80527788 L22.9430132,10.2108404 Z',
            id: pathId
          };
          break;

        case 'button':
        case 'element-button':
          // alias
          path = {
            d: 'M9.16791275,12.635877 C6.22428764,12.0717283 4,9.48311927 4,6.375 C4,2.85418472 6.85418472,0 10.375,0 C13.8958153,0 16.75,2.85418472 16.75,6.375 C16.75,9.27762517 14.8101082,11.7271643 12.1560747,12.4978673 L12.1560747,13.4057034 C12.4298443,13.156914 12.8303936,13 13.2766355,13 C14.0306594,13 14.654224,13.4480138 14.7561314,14.030268 C15.0301552,13.7736953 15.4370444,13.6111111 15.8912772,13.6111111 C16.6453012,13.6111111 17.2688658,14.0591249 17.3707732,14.6413791 C17.6447969,14.3848064 18.0516861,14.2222222 18.505919,14.2222222 C19.3310772,14.2222222 20,14.7587541 20,15.4205997 L20,20.0516225 C19.9642858,22.2500793 17.7607363,24 15.047619,24 L14.1202937,24 C12.5842941,24 11.2116174,23.4391284 10.3032416,22.5587947 C10.244523,22.5201805 8.24904093,20.4482984 4.31679553,16.3431482 C3.80877744,15.8112294 3.92406581,15.0431294 4.57429931,14.6275488 C5.2245328,14.2119683 6.16348123,14.3062791 6.67149932,14.8381979 L9.16791275,17.4520603 L9.16791275,12.635877 Z M9.16791275,11.0994025 L9.16791275,9.52773098 C7.90012751,9.04203654 7,7.81363629 7,6.375 C7,4.51103897 8.51103897,3 10.375,3 C12.238961,3 13.75,4.51103897 13.75,6.375 C13.75,7.58519726 13.1130368,8.6466238 12.1560747,9.24231526 L12.1560747,10.9143977 C13.9675424,10.2030975 15.25,8.43881575 15.25,6.375 C15.25,3.68261184 13.0673882,1.5 10.375,1.5 C7.68261184,1.5 5.5,3.68261184 5.5,6.375 C5.5,8.65075221 7.05937695,10.5622924 9.16791275,11.0994025 Z',
            id: pathId
          };
          break;

        case 'checkbox':
        case 'element-checkbox':
          // alias
          path = {
            d: 'M3,0 L21,0 C22.6568542,0 24,1.34314575 24,3 L24,21 C24,22.6568542 22.6568542,24 21,24 L3,24 C1.34314575,24 0,22.6568542 0,21 L0,3 C0,1.34314575 1.34314575,0 3,0 Z M4.5,3 C3.67157288,3 3,3.67157288 3,4.5 L3,19.5 C3,20.3284271 3.67157288,21 4.5,21 L19.5,21 C20.3284271,21 21,20.3284271 21,19.5 L21,4.5 C21,3.67157288 20.3284271,3 19.5,3 L4.5,3 Z M7.60850244,12.5620391 L9.19289995,14.1248219 L16.4290315,6.98740719 C16.722042,6.69839399 17.2025254,6.69676503 17.49786,6.98807058 L18.5475069,8.02339806 C18.8391642,8.31107651 18.8442096,8.78565378 18.5505626,9.07529473 L9.72459476,17.7808569 C9.42760324,18.0737968 8.95257396,18.0682508 8.65611682,17.775838 L5.491387,14.6542821 C5.19461662,14.3615603 5.19401984,13.8886721 5.4893544,13.5973665 L6.53900138,12.5620391 C6.83065869,12.2743606 7.31316788,12.2707335 7.60850244,12.5620391 Z',
            id: pathId
          };
          break;

        case 'date-select':
        case 'element-calendar':
          // alias
          path = {
            d: 'M9.5625,10.5 L11.5,10.5 C12.6045695,10.5 13.5,11.3954305 13.5,12.5 L13.5,14.4375 L20.9375,14.4375 C21.4897847,14.4375 21.9375,13.9897847 21.9375,13.4375 L21.9375,8.21875 C21.9375,7.66646525 21.4897847,7.21875 20.9375,7.21875 L10.5625,7.21875 C10.0102153,7.21875 9.5625,7.66646525 9.5625,8.21875 L9.5625,10.5 Z M13.5,16.5 L13.5,22 C13.5,23.1045695 12.6045695,24 11.5,24 L2,24 C0.8954305,24 1.3527075e-16,23.1045695 0,22 L0,12.5 C-1.3527075e-16,11.3954305 0.8954305,10.5 2,10.5 L7.5,10.5 L7.5,4.06997252 C7.5,2.96127606 8.38711166,2.0625 9.49028552,2.0625 L9.5625,2.0625 L9.5625,3.1479446 C9.5625,4.25809979 10.4534549,5.15625 11.5525035,5.15625 L11.6974965,5.15625 C12.7924364,5.15625 13.6875,4.25710105 13.6875,3.1479446 L13.6875,2.0625 L17.8125,2.0625 L17.8125,3.1479446 C17.8125,4.25809979 18.7034549,5.15625 19.8025035,5.15625 L19.9474965,5.15625 C21.0424364,5.15625 21.9375,4.25710105 21.9375,3.1479446 L21.9375,2.0625 L22.0097145,2.0625 C23.1089188,2.0625 24,2.96563029 24,4.06997252 L24,14.4925275 C24,15.6012239 23.1128883,16.5 22.0097145,16.5 L13.5,16.5 Z M10.59375,0.998547435 C10.59375,0.447064915 11.0412818,0 11.600832,0 L11.649168,0 C12.205364,0 12.65625,0.441447258 12.65625,0.998547435 L12.65625,3.12645257 C12.65625,3.67793509 12.2087182,4.125 11.649168,4.125 L11.600832,4.125 C11.044636,4.125 10.59375,3.68355274 10.59375,3.12645257 L10.59375,0.998547435 Z M18.84375,0.998547435 C18.84375,0.447064915 19.2912818,0 19.850832,0 L19.899168,0 C20.455364,0 20.90625,0.441447258 20.90625,0.998547435 L20.90625,3.12645257 C20.90625,3.67793509 20.4587182,4.125 19.899168,4.125 L19.850832,4.125 C19.294636,4.125 18.84375,3.68355274 18.84375,3.12645257 L18.84375,0.998547435 Z M6.74971266,19.7620571 L9.21607597,15.75 L4.28334934,15.75 L6.74971266,19.7620571 Z',
            id: pathId
          };
          break;

        case 'text-field':
        case 'element-input':
          // alias
          path = {
            d: 'M8.25,5.25 L8.25,18.75 L10.5,18.75 C10.9142136,18.75 11.25,19.0857864 11.25,19.5 L11.25,20.25 C11.25,20.6642136 10.9142136,21 10.5,21 L3.75,21 C3.33578644,21 3,20.6642136 3,20.25 L3,19.5 C3,19.0857864 3.33578644,18.75 3.75,18.75 L6,18.75 L6,5.25 L3.75,5.25 C3.33578644,5.25 3,4.91421356 3,4.5 L3,3.75 C3,3.33578644 3.33578644,3 3.75,3 L10.5,3 C10.9142136,3 11.25,3.33578644 11.25,3.75 L11.25,4.5 C11.25,4.91421356 10.9142136,5.25 10.5,5.25 L8.25,5.25 Z M4.5,6.75 L4.5,9 L3,9 C2.58578644,9 2.25,9.33578644 2.25,9.75 L2.25,14.25 C2.25,14.6642136 2.58578644,15 3,15 L4.5,15 L4.5,17.25 L1.5,17.25 C0.671572875,17.25 0,16.5784271 0,15.75 L0,8.25 C0,7.42157288 0.671572875,6.75 1.5,6.75 L4.5,6.75 Z M9.75,6.75 L22.5,6.75 C23.3284271,6.75 24,7.42157288 24,8.25 L24,15.75 C24,16.5784271 23.3284271,17.25 22.5,17.25 L9.75,17.25 L9.75,15 L21,15 C21.4142136,15 21.75,14.6642136 21.75,14.25 L21.75,9.75 C21.75,9.33578644 21.4142136,9 21,9 L9.75,9 L9.75,6.75 Z',
            id: pathId
          };
          break;

        case 'numerical-select':
        case 'element-input-number':
          // alias
          path = {
            d: 'M1.5,3 L22.5,3 C23.3284271,3 24,3.67157288 24,4.5 L24,19.5 C24,20.3284271 23.3284271,21 22.5,21 L1.5,21 C0.671572875,21 0,20.3284271 0,19.5 L0,4.5 C0,3.67157288 0.671572875,3 1.5,3 Z M3,5.25 C2.58578644,5.25 2.25,5.58578644 2.25,6 L2.25,18 C2.25,18.4142136 2.58578644,18.75 3,18.75 L21,18.75 C21.4142136,18.75 21.75,18.4142136 21.75,18 L21.75,6 C21.75,5.58578644 21.4142136,5.25 21,5.25 L3,5.25 Z M17.625,6.75 L20.25,10.5 L15,10.5 L17.625,6.75 Z M17.625,17.25 L15,13.5 L20.25,13.5 L17.625,17.25 Z M6.33,13.698 C6.56200116,13.9220011 6.81599862,14.1059993 7.092,14.25 C7.36800138,14.3940007 7.66999836,14.466 7.998,14.466 C8.37400188,14.466 8.67399888,14.3880008 8.898,14.232 C9.12200112,14.0759992 9.234,13.8540014 9.234,13.566 C9.234,13.3979992 9.2040003,13.2460007 9.144,13.11 C9.0839997,12.9739993 8.97800076,12.8600005 8.826,12.768 C8.67399924,12.6759995 8.46600132,12.6040003 8.202,12.552 C7.93799868,12.4999997 7.59800208,12.474 7.182,12.474 L7.182,11.226 C7.52600172,11.226 7.81199886,11.2020002 8.04,11.154 C8.26800114,11.1059998 8.4519993,11.0360005 8.592,10.944 C8.7320007,10.8519995 8.8319997,10.7440006 8.892,10.62 C8.9520003,10.4959994 8.982,10.3580008 8.982,10.206 C8.982,9.94199868 8.9020008,9.73600074 8.742,9.588 C8.5819992,9.43999926 8.35000152,9.366 8.046,9.366 C7.77399864,9.366 7.5280011,9.4259994 7.308,9.546 C7.0879989,9.6660006 6.8580012,9.82999896 6.618,10.038 L5.73,8.958 C6.08200176,8.65399848 6.45199806,8.41600086 6.84,8.244 C7.22800194,8.07199914 7.65799764,7.986 8.13,7.986 C8.52200196,7.986 8.87999838,8.03199954 9.204,8.124 C9.52800162,8.21600046 9.80399886,8.3519991 10.032,8.532 C10.2600011,8.7120009 10.4379994,8.92999872 10.566,9.186 C10.6940006,9.44200128 10.758,9.73799832 10.758,10.074 C10.758,10.474002 10.6480011,10.8119986 10.428,11.088 C10.2079989,11.3640014 9.89400204,11.5899991 9.486,11.766 L9.486,11.814 C9.9260022,11.9420006 10.2879986,12.1599985 10.572,12.468 C10.8560014,12.7760015 10.998,13.1779975 10.998,13.674 C10.998,14.0260018 10.9220008,14.3399986 10.77,14.616 C10.6179992,14.8920014 10.4140013,15.1239991 10.158,15.312 C9.90199872,15.5000009 9.60200172,15.6439995 9.258,15.744 C8.91399828,15.8440005 8.55000192,15.894 8.166,15.894 C7.54199688,15.894 7.01400216,15.796001 6.582,15.6 C6.14999784,15.403999 5.7940014,15.1420016 5.514,14.814 L6.33,13.698 Z',
            id: pathId
          };
          break;

        case 'single-select':
        case 'element-select':
          // alias
          path = {
            d: 'M3,6 C1.34314575,6 0,4.65685425 0,3 C0,1.34314575 1.34314575,0 3,0 C4.65685425,0 6,1.34314575 6,3 C6,4.65685425 4.65685425,6 3,6 Z M3,4.5 C3.82842712,4.5 4.5,3.82842712 4.5,3 C4.5,2.17157288 3.82842712,1.5 3,1.5 C2.17157288,1.5 1.5,2.17157288 1.5,3 C1.5,3.82842712 2.17157288,4.5 3,4.5 Z M10.5,0 L22.5,0 C23.3284271,0 24,0.671572875 24,1.5 L24,4.5 C24,5.32842712 23.3284271,6 22.5,6 L10.5,6 C9.67157288,6 9,5.32842712 9,4.5 L9,1.5 C9,0.671572875 9.67157288,0 10.5,0 Z M11.25,1.5 C10.8357864,1.5 10.5,1.83578644 10.5,2.25 L10.5,3.75 C10.5,4.16421356 10.8357864,4.5 11.25,4.5 L21.75,4.5 C22.1642136,4.5 22.5,4.16421356 22.5,3.75 L22.5,2.25 C22.5,1.83578644 22.1642136,1.5 21.75,1.5 L11.25,1.5 Z M3,15 C1.34314575,15 0,13.6568542 0,12 C0,10.3431458 1.34314575,9 3,9 C4.65685425,9 6,10.3431458 6,12 C6,13.6568542 4.65685425,15 3,15 Z M10.5,9 L22.5,9 C23.3284271,9 24,9.67157288 24,10.5 L24,13.5 C24,14.3284271 23.3284271,15 22.5,15 L10.5,15 C9.67157288,15 9,14.3284271 9,13.5 L9,10.5 C9,9.67157288 9.67157288,9 10.5,9 Z M3,24 C1.34314575,24 0,22.6568542 0,21 C0,19.3431458 1.34314575,18 3,18 C4.65685425,18 6,19.3431458 6,21 C6,22.6568542 4.65685425,24 3,24 Z M3,22.5 C3.82842712,22.5 4.5,21.8284271 4.5,21 C4.5,20.1715729 3.82842712,19.5 3,19.5 C2.17157288,19.5 1.5,20.1715729 1.5,21 C1.5,21.8284271 2.17157288,22.5 3,22.5 Z M10.5,18 L22.5,18 C23.3284271,18 24,18.6715729 24,19.5 L24,22.5 C24,23.3284271 23.3284271,24 22.5,24 L10.5,24 C9.67157288,24 9,23.3284271 9,22.5 L9,19.5 C9,18.6715729 9.67157288,18 10.5,18 Z M11.25,19.5 C10.8357864,19.5 10.5,19.8357864 10.5,20.25 L10.5,21.75 C10.5,22.1642136 10.8357864,22.5 11.25,22.5 L21.75,22.5 C22.1642136,22.5 22.5,22.1642136 22.5,21.75 L22.5,20.25 C22.5,19.8357864 22.1642136,19.5 21.75,19.5 L11.25,19.5 Z',
            id: pathId
          };
          break;

        case 'multi-select':
        case 'element-select-multi':
          // alias
          path = {
            d: 'M3,15 C1.34314575,15 0,13.6568542 0,12 C0,10.3431458 1.34314575,9 3,9 C4.65685425,9 6,10.3431458 6,12 C6,13.6568542 4.65685425,15 3,15 Z M3,13.5 C3.82842712,13.5 4.5,12.8284271 4.5,12 C4.5,11.1715729 3.82842712,10.5 3,10.5 C2.17157288,10.5 1.5,11.1715729 1.5,12 C1.5,12.8284271 2.17157288,13.5 3,13.5 Z M10.5,9 L22.5,9 C23.3284271,9 24,9.67157288 24,10.5 L24,13.5 C24,14.3284271 23.3284271,15 22.5,15 L10.5,15 C9.67157288,15 9,14.3284271 9,13.5 L9,10.5 C9,9.67157288 9.67157288,9 10.5,9 Z M11.25,10.5 C10.8357864,10.5 10.5,10.8357864 10.5,11.25 L10.5,12.75 C10.5,13.1642136 10.8357864,13.5 11.25,13.5 L21.75,13.5 C22.1642136,13.5 22.5,13.1642136 22.5,12.75 L22.5,11.25 C22.5,10.8357864 22.1642136,10.5 21.75,10.5 L11.25,10.5 Z M3,24 C1.34314575,24 0,22.6568542 0,21 C0,19.3431458 1.34314575,18 3,18 C4.65685425,18 6,19.3431458 6,21 C6,22.6568542 4.65685425,24 3,24 Z M10.5,18 L22.5,18 C23.3284271,18 24,18.6715729 24,19.5 L24,22.5 C24,23.3284271 23.3284271,24 22.5,24 L10.5,24 C9.67157288,24 9,23.3284271 9,22.5 L9,19.5 C9,18.6715729 9.67157288,18 10.5,18 Z M3,6 C1.34314575,6 0,4.65685425 0,3 C0,1.34314575 1.34314575,0 3,0 C4.65685425,0 6,1.34314575 6,3 C6,4.65685425 4.65685425,6 3,6 Z M10.5,0 L22.5,0 C23.3284271,0 24,0.671572875 24,1.5 L24,4.5 C24,5.32842712 23.3284271,6 22.5,6 L10.5,6 C9.67157288,6 9,5.32842712 9,4.5 L9,1.5 C9,0.671572875 9.67157288,0 10.5,0 Z',
            id: pathId
          };
          break;

        case 'time-select':
        case 'element-time':
          // alias
          path = {
            d: 'M13.5,16.1894513 L13.5,22 C13.5,23.1045695 12.6045695,24 11.5,24 L2,24 C0.8954305,24 1.3527075e-16,23.1045695 0,22 L0,12.5 C-1.3527075e-16,11.3954305 0.8954305,10.5 2,10.5 L7.81054873,10.5 C7.60825074,9.78475231 7.5,9.03001781 7.5,8.25 C7.5,3.69365081 11.1936508,0 15.75,0 C20.3063492,0 24,3.69365081 24,8.25 C24,12.8063492 20.3063492,16.5 15.75,16.5 C14.9699822,16.5 14.2152477,16.3917493 13.5,16.1894513 Z M13.5,14.0156921 C14.197348,14.288027 14.9562184,14.4375 15.75,14.4375 C19.1672619,14.4375 21.9375,11.6672619 21.9375,8.25 C21.9375,4.83273811 19.1672619,2.0625 15.75,2.0625 C12.3327381,2.0625 9.5625,4.83273811 9.5625,8.25 C9.5625,9.04378164 9.71197297,9.80265199 9.98430785,10.5 L11.5,10.5 C12.6045695,10.5 13.5,11.3954305 13.5,12.5 L13.5,14.0156921 Z M16.78125,6.87369858 L19.0784199,9.92214595 C19.4088417,10.3606306 19.3192868,10.985424 18.8724101,11.3221697 L18.8338073,11.351259 C18.3896094,11.6859861 17.7617143,11.6019515 17.4312341,11.1633894 L15.0260754,7.97163603 C14.9087779,7.85970741 14.8189394,7.71952125 14.7675096,7.56140059 C14.7059094,7.39690994 14.6904479,7.22089188 14.71875,7.05132847 L14.71875,5.12354743 C14.71875,4.57206491 15.1662818,4.125 15.725832,4.125 L15.774168,4.125 C16.330364,4.125 16.78125,4.56644726 16.78125,5.12354743 L16.78125,6.87369858 Z M6.74971266,19.7620571 L9.21607597,15.75 L4.28334934,15.75 L6.74971266,19.7620571 Z',
            id: pathId
          };
          break;

        case 'toggle':
        case 'element-toggle':
          // alias
          path = {
            d: 'M6,6 L18,6 C21.3137085,6 24,8.6862915 24,12 C24,15.3137085 21.3137085,18 18,18 L6,18 C2.6862915,18 4.05812251e-16,15.3137085 0,12 C-4.05812251e-16,8.6862915 2.6862915,6 6,6 Z M6,16.5 C8.48528137,16.5 10.5,14.4852814 10.5,12 C10.5,9.51471863 8.48528137,7.5 6,7.5 C3.51471863,7.5 1.5,9.51471863 1.5,12 C1.5,14.4852814 3.51471863,16.5 6,16.5 Z',
            id: pathId
          };
          break;

        case 'email':
        case 'envelope':
          // alias
          path = {
            d: 'M22.62,20.9704623 C22.62,20.9704623 1.44,21.0369221 1.44,20.9704623 C0.717415005,20.9346467 0.115987029,20.3181988 0,19.4945001 L0,5.14609882 C0,5.14609882 11.04,14.3992462 10.98,14.3327863 C11.5752046,14.9577964 12.4847954,14.9577964 13.08,14.3327863 L24,5.14609882 L24,19.4945001 C23.905757,20.3043517 23.3270097,20.9233437 22.62,20.9704623 L22.62,20.9704623 Z M1.62,3 L22.38,3 L12,11.7837748 L1.62,3 Z',
            id: pathId
          };
          break;

        case 'equal-to':
        case 'equal-circle':
          // alias
          path = {
            d: 'M12,24 C5.372583,24 0,18.627417 0,12 C0,5.372583 5.372583,0 12,0 C18.627417,0 24,5.372583 24,12 C24,18.627417 18.627417,24 12,24 Z M6.75,13.5 C5.92157288,13.5 5.25,14.1715729 5.25,15 C5.25,15.8284271 5.92157288,16.5 6.75,16.5 L17.25,16.5 C18.0784271,16.5 18.75,15.8284271 18.75,15 C18.75,14.1715729 18.0784271,13.5 17.25,13.5 L6.75,13.5 Z M6.75,7.5 C5.92157288,7.5 5.25,8.17157288 5.25,9 C5.25,9.82842712 5.92157288,10.5 6.75,10.5 L17.25,10.5 C18.0784271,10.5 18.75,9.82842712 18.75,9 C18.75,8.17157288 18.0784271,7.5 17.25,7.5 L6.75,7.5 Z',
            id: pathId
          };
          break;

        case 'expand':
          path = {
            d: 'M10.1542464,11.7333478 L18.9127257,2.97038611 L16.0954582,2.97188554 C15.2888111,2.97038611 14.6350971,2.3181307 14.6350971,1.51143321 C14.6350971,0.704735724 15.2888111,0.0509808822 16.0954582,0.0509808822 L22.2367714,0.0509808822 C22.3207347,0.0344870673 22.3987006,0.00149943771 22.4886612,0 C22.5636284,0 22.6146061,0.0704735724 22.688074,0.0839685118 C22.966952,0.115456704 23.2308365,0.20992128 23.4557381,0.401849307 C23.4782283,0.421341997 23.5067158,0.422841434 23.5456988,0.454329626 C23.5516961,0.460327377 23.5531955,0.467824566 23.5891797,0.521804323 C23.8245767,0.784205923 23.9505216,1.10358616 23.9685138,1.43496189 C23.9700131,1.46495064 24,1.48144446 24,1.51143321 C24,1.5984006 23.9640157,1.67337249 23.947523,1.757341 L23.947523,7.90353617 C23.9460236,8.71023366 23.293809,9.3639885 22.4871619,9.3639885 C21.6820141,9.3639885 21.0283001,8.71023366 21.0283001,7.90503561 L21.0283001,5.08609272 L11.64069,14.4740082 C11.64069,14.4740082 11.6294099,14.485289 11.6080149,14.5043546 L5.08727432,21.0281145 L7.90454176,21.0281145 C8.71118885,21.0281145 9.36490286,21.6818693 9.36490286,22.4870673 C9.36490286,23.2952643 8.71118885,23.9475197 7.90454176,23.9475197 L1.76322859,23.9490191 C1.67926532,23.9640135 1.60129943,23.9985006 1.51133879,24 C1.43487224,24 1.38539389,23.928027 1.31192603,23.9160315 C1.03304804,23.8845433 0.769163491,23.7900787 0.544261885,23.5966513 C0.521771725,23.578658 0.493284188,23.5771586 0.454301243,23.5456704 C0.448303867,23.5381732 0.446804523,23.530676 0.410820266,23.4781957 C0.175423252,23.2157941 0.0494783532,22.8949144 0.0314862248,22.5635387 C0.0299868807,22.5350494 0,22.5170561 0,22.4885668 C0,22.4015994 0.0359842569,22.3251281 0.0524770413,22.242659 L0.0524770413,16.0949644 C0.0539763853,15.2882669 0.706191041,14.6360115 1.51283813,14.6345121 C2.31798588,14.6345121 2.97169988,15.2882669 2.97169988,16.093465 L2.97169988,18.9139073 L10.10931,11.7744924 C10.10931,11.7744924 10.1249212,11.7588802 10.1542464,11.7333478 L10.1542464,11.7333478 Z',
            id: pathId
          };
          break;

        case 'external-link':
        case 'link-external':
          // alias
          path = {
            d: 'M1072,1797.25 L1072,1813 L1087.75,1813 L1087.75,1805.5 L1090.75,1805.5 L1090.75,1813.75 C1090.75,1814.99264 1089.74264,1816 1088.5,1816 L1071.25,1816 C1070.00736,1816 1069,1814.99264 1069,1813.75 L1069,1796.5 C1069,1795.25736 1070.00736,1794.25 1071.25,1794.25 L1079.5,1794.25 L1079.5,1797.25 L1072,1797.25 Z M1085.06165,1794.9843 C1084.25156,1794.9828 1083.59505,1794.32782 1083.59505,1793.51775 C1083.59505,1792.70768 1084.25156,1792.05119 1085.06165,1792.05119 L1091.22923,1792.05119 C1091.31355,1792.03463 1091.39185,1792.00151 1091.4822,1792 C1091.55749,1792 1091.60868,1792.07077 1091.68246,1792.08432 C1091.96253,1792.11594 1092.22755,1792.2108 1092.45341,1792.40353 C1092.476,1792.4231 1092.50461,1792.42461 1092.54376,1792.45623 C1092.54978,1792.46225 1092.55128,1792.46978 1092.58742,1792.52398 C1092.82383,1792.78748 1092.95031,1793.1082 1092.96838,1793.44096 C1092.96988,1793.47107 1093,1793.48763 1093,1793.51775 C1093,1793.60508 1092.96386,1793.68036 1092.9473,1793.76468 L1092.9473,1799.93656 C1092.94579,1800.74662 1092.29079,1801.40311 1091.48069,1801.40311 C1090.6721,1801.40311 1090.01559,1800.74662 1090.01559,1799.93806 L1090.01559,1797.10734 L1082.09425,1805.02821 C1082.09425,1805.02821 1081.03269,1806.08973 1079.97113,1805.02821 C1078.91108,1803.9682 1079.97113,1802.90668 1079.97113,1802.90668 L1087.89097,1794.9828 L1085.06165,1794.9843 Z',
            id: pathId,
            transform: 'translate(-1069.000000, -1792.000000)'
          };
          break;

        case 'fbi-cleared':
          path = {
            d: 'M18.3797147,6.1526729 C19.0604494,9.25241121 23.8668698,14.3246355 18.4649757,17.8943551 C18.4649757,17.8943551 12.0000256,21.6516636 12.0000256,24 C12.0000256,21.6516636 5.53494013,17.8943551 5.53494013,17.8943551 C0.13324898,14.3248598 4.93946639,9.25241121 5.62006581,6.1526729 C6.30066523,3.05293458 3.79108176,2.81809346 3.79108176,2.81809346 L6.81094562,0 C8.76748286,2.77106542 12.0000256,0.516635514 12.0000256,0.516635514 C12.0000256,0.516635514 15.2325006,2.77106542 17.1887672,0 L20.2087664,2.81801869 C20.2087664,2.81801869 17.6996566,3.05285981 18.3797147,6.1526729 Z',
            id: pathId
          };
          viewBox = '0 0 18 24';
          break;

        case 'file-alt':
          path = {
            d: 'M13,0 L13,6.50712765 C13,7.60641652 13.8942627,8.5 14.9973917,8.5 L22,8.5 L22,21.0089096 C22,22.6608432 20.656688,24 19.0057979,24 L4.99420208,24 C3.34054993,24 2,22.6582294 2,21.0089096 L2,2.99109042 C2,1.33915679 3.34331197,0 4.99420208,0 L13,0 Z M15.3333333,0 L22,6.5 L16.3314007,6.5 C15.781104,6.5 15.3333333,6.05166687 15.3333333,5.49861994 L15.3333333,0 Z M4.05128205,18.947998 C4.05128205,18.3957133 4.5075251,17.947998 5.05248884,17.947998 L14.3321265,17.947998 C14.8850778,17.947998 15.3333333,18.3918629 15.3333333,18.947998 C15.3333333,19.5002828 14.8770903,19.947998 14.3321265,19.947998 L5.05248884,19.947998 C4.4995376,19.947998 4.05128205,19.5041332 4.05128205,18.947998 Z M4.05128205,14.947998 C4.05128205,14.3957133 4.49448781,13.947998 5.04894579,13.947998 L19.0023363,13.947998 C19.5533307,13.947998 20,14.3918629 20,14.947998 C20,15.5002828 19.5567942,15.947998 19.0023363,15.947998 L5.04894579,15.947998 C4.49795132,15.947998 4.05128205,15.5041332 4.05128205,14.947998 Z M4.05128205,10.947998 C4.05128205,10.3957133 4.49700623,9.94799805 5.04584552,9.94799805 L16.0054365,9.94799805 C16.5547188,9.94799805 17,10.3918629 17,10.947998 C17,11.5002828 16.5542758,11.947998 16.0054365,11.947998 L5.04584552,11.947998 C4.49656328,11.947998 4.05128205,11.5041332 4.05128205,10.947998 Z M4.05128205,6.94799805 C4.05128205,6.3957133 4.49840274,5.94799805 5.06040096,5.94799805 L8.99088109,5.94799805 C9.54820207,5.94799805 10,6.39186287 10,6.94799805 C10,7.5002828 9.55287931,7.94799805 8.99088109,7.94799805 L5.06040096,7.94799805 C4.50307998,7.94799805 4.05128205,7.50413322 4.05128205,6.94799805 Z',
            id: pathId
          };
          break;

        case 'filters':
        case 'filter':
          // alias
          path = {
            d: 'M0,1.99669532 C0,0.893950944 0.897026226,0 2.00494659,0 L21.9950534,0 C23.1023548,0 24,0.887792251 24,1.99669532 L24,2.84364082 C24,3.94638519 23.1029738,4.84033613 21.9950534,4.84033613 L2.00494659,4.84033613 C0.897645164,4.84033613 0,3.95254388 0,2.84364082 L0,1.99669532 Z M4,12.0807289 C4,10.9779846 4.89451376,10.0840336 5.99406028,10.0840336 L18.0059397,10.0840336 C19.1072288,10.0840336 20,10.9718259 20,12.0807289 L20,12.9276744 C20,14.0304188 19.1054862,14.9243697 18.0059397,14.9243697 L5.99406028,14.9243697 C4.8927712,14.9243697 4,14.0365775 4,12.9276744 L4,12.0807289 Z M7,21.1563592 C7,20.0536148 7.88743329,19.1596639 8.99961498,19.1596639 L15.000385,19.1596639 C16.1047419,19.1596639 17,20.0474561 17,21.1563592 L17,22.0033047 C17,23.1060491 16.1125667,24 15.000385,24 L8.99961498,24 C7.89525812,24 7,23.1122077 7,22.0033047 L7,21.1563592 Z',
            id: pathId
          };
          break;

        case 'fingerprinted':
          path = {
            d: 'M18,12 C21.3137085,12 24,14.6862915 24,18 C24,21.3137085 21.3137085,24 18,24 C14.6862915,24 12,21.3137085 12,18 C12,14.6862915 14.6862915,12 18,12 Z M9.74878746,11.477152 C10.9116873,11.477152 11.8828956,12.0269819 12.5057269,12.8959383 C12.0988376,13.3327116 11.7447582,13.8174324 11.4516276,14.3408995 C11.0960791,13.4073706 10.4635089,12.9970204 9.55478174,13.109458 C8.29374456,13.4495218 7.7117274,14.2656748 7.80873026,15.5579171 C8.04571928,18.6423158 9.82065354,20.3566169 11.2548454,21.2819495 C11.7510994,22.3012232 12.4722858,23.1912834 13.3535487,23.887707 C13.1726172,24.0244031 12.957235,24.0361062 12.7073747,23.9234857 C7.66322597,21.781084 6.35368735,18.0573858 6.20818306,15.5579171 C6.06267877,13.0584485 7.80873026,11.477152 9.74878746,11.477152 Z M9.6517846,8.62061637 C11.6193562,8.62061637 13.4980227,9.63044524 14.6741167,11.2764494 C14.2031233,11.5093766 13.7608048,11.7903732 13.3528079,12.1128784 L13.2946811,12.0307702 C12.5861211,11.0589995 11.4544211,10.2529224 9.67603532,10.2529224 C5.74741948,10.2529224 5.06819102,14.3341597 5.04479052,15.3032859 L5.04596877,15.6698728 C5.066147,16.7052338 5.29878125,18.858661 7.90573312,22.24017 C8.29374456,22.7842721 8.29374456,23.2093518 7.90573312,23.5154091 C7.48538739,23.7534538 7.12971024,23.7534538 6.83870165,23.5154091 L6.52630966,23.1418902 C5.28658503,21.6324147 3.44360154,19.0100238 3.44360154,15.3538789 C3.44360154,11.3751328 6.40218878,8.62061637 9.6517846,8.62061637 Z M21.2117825,15.7493724 L20.5393956,15.0860567 C20.4374231,14.9854599 20.2794289,14.9734612 20.1645752,15.0479437 L20.1182826,15.0851534 L16.315524,18.8366089 L15.4321227,17.9651256 C15.3301502,17.8645288 15.1736318,17.8510743 15.0572424,17.9270718 L15.010094,17.9651256 L14.3377071,18.6284414 C14.2357346,18.7290382 14.2226642,18.8840055 14.2985823,18.997721 L14.3365671,19.0436519 L16.1056497,20.7888677 C16.2070713,20.888921 16.3628979,20.9021512 16.4784676,20.8267526 L16.5252567,20.7890074 L21.2130641,16.1644432 C21.3144173,16.0644574 21.3275391,15.9105604 21.2503828,15.795859 L21.2117825,15.7493724 L20.5393956,15.0860567 L21.2117825,15.7493724 Z M9.74878746,5.81509033 C13.8763439,5.81509033 16.2406679,8.12010921 17.4949206,10.5178034 C16.9041824,10.5560624 16.3326626,10.6636256 15.7876511,10.8316357 C14.7023312,9.10234464 12.8201082,7.54941552 9.74878746,7.54941552 C3.83161298,7.54941552 2.42507151,12.8034006 2.42507151,14.9968119 C2.42507151,16.4590861 2.66757866,17.9383634 3.15259296,19.434644 C3.21726153,19.9107333 3.0555901,20.2337938 2.66757866,20.4038257 C2.27956722,20.5738576 1.94005721,20.4548353 1.64904863,20.0467588 C1.16403432,18.6865037 0.873025743,17.088204 0.776022883,15.2518597 C0.630518592,12.4973433 2.66757866,5.81509033 9.74878746,5.81509033 Z M10.4763089,15.0478215 C10.5235848,15.5002792 10.5994311,15.9100885 10.6984128,16.2812645 C10.5685101,16.8326872 10.5,17.4083429 10.5,18 C10.5,18.5635212 10.5621491,19.1125268 10.6799671,19.6405362 C9.30746384,18.1118051 8.98415,16.1146971 8.88522836,15.5130799 L8.87576172,15.455898 C8.77875886,14.8777896 8.95659744,14.4867163 9.40927745,14.282678 C10.0236289,14.1806589 10.3793061,14.4357067 10.4763089,15.0478215 Z M9.79728889,3.00956429 C13.4510633,3.00956429 16.6198234,4.7098831 19.3035692,8.11052072 C19.5945778,8.72263549 19.5622435,9.18172157 19.2065663,9.48777896 C18.8508892,9.79383634 18.4467106,9.69181722 17.9940306,9.18172157 C15.8276334,6.15515409 13.0755814,4.64187035 9.73787464,4.64187035 C6.40016789,4.64187035 3.70389255,6.15515409 1.64904863,9.18172157 C1.13170004,9.69181722 0.679020022,9.79383634 0.291008581,9.48777896 C-0.0970028603,9.18172157 -0.0970028603,8.72263549 0.291008581,8.11052072 C2.97475438,4.7098831 6.14351449,3.00956429 9.79728889,3.00956429 Z M9.74878746,0 C12.0121875,0 14.1947519,0.612114772 16.2964805,1.83634431 C16.7814948,2.27842721 16.8623306,2.70350691 16.5389877,3.11158342 C16.2387407,3.49051161 15.8966737,3.57622156 15.5127865,3.36871327 L15.4234548,3.31562168 C13.6774033,2.26142402 11.7858475,1.7360255 9.74878746,1.73942614 C7.7117274,1.74282678 5.86867305,2.23421892 4.21962442,3.21360255 C3.70227584,3.48565356 3.28193011,3.45164718 2.95858724,3.11158342 C2.63524437,2.77151966 2.76458152,2.3141339 3.34659868,1.73942614 C5.35132446,0.579808714 7.48538739,0 9.74878746,0 Z',
            id: pathId
          };
          viewBox = '0 0 18 24';
          break;

        case 'flag':
          path = {
            d: 'M0,22.5 L0,1.5 C0,0.671572875 0.671572875,0 1.5,0 C2.32842712,0 3,0.671572875 3,1.5 L3,22.5 C3,23.3284271 2.32842712,24 1.5,24 C0.671572875,24 0,23.3284271 0,22.5 Z M23.9911595,13.0020162 C23.9911595,13.0020162 17.625,16.5 11.0766113,13.0020162 C8.25,10.875 5.25,12.0117418 5.25,12.0117418 L5.25,0.765439452 C5.25,0.765439452 7.34745265,-0.492935374 11.1737263,1.81603231 C15,4.125 18.75,4.125 23.9911595,1.81603231 C24.0110506,1.81603231 23.9911595,13.0020162 23.9911595,13.0020162 Z',
            id: pathId
          };
          break;

        case 'gender':
          path = {
            d: 'M8.22857516,13.7654647 C7.80252673,13.7654647 7.45714624,13.4218025 7.45714624,12.9978737 L7.45714624,7.01066416 L6.94286029,7.01066416 L6.94286029,22.9765563 L6.93987744,22.9765563 C6.89951014,23.5529462 6.41782218,24 5.83714551,24 C5.25646883,24 4.77478087,23.5529462 4.73441358,22.9765563 L4.73143072,22.9765563 L4.73143072,13.7654647 L4.26857337,13.7654647 L4.26857337,22.9765563 L4.26559051,22.9765563 C4.22522322,23.5529462 3.74353526,24 3.16285858,24 C2.5821819,24 2.10049394,23.5529462 2.06012665,22.9765563 L2.05714379,22.9765563 L2.05714379,7.01066416 L1.54285784,7.01066416 L1.54285784,12.9978737 C1.54285784,13.4218025 1.19747735,13.7654647 0.771428922,13.7654647 C0.345380493,13.7654647 5.21758845e-17,13.4218025 0,12.9978737 L0,7.01066416 L0.00128571487,7.01066416 C0.0290388032,5.50492236 1.26361915,4.29867462 2.77714412,4.29850941 L6.22285997,4.29850941 C7.73638494,4.29867462 8.97096528,5.50492236 8.99871837,7.01066416 L9.00000408,7.01066416 L9.00000408,12.9978737 C9.00000408,13.4218025 8.65462359,13.7654647 8.22857516,13.7654647 Z M4.50000204,3.9403003 C3.40647774,3.9403003 2.52000114,3.05823403 2.52000114,1.97015015 C2.52000114,0.882066266 3.40647774,1.99877766e-16 4.50000204,0 C5.59352634,-1.99877766e-16 6.48000294,0.882066266 6.48000294,1.97015015 C6.48000294,2.49266645 6.2713963,2.99378185 5.9000741,3.36325668 C5.52875191,3.7327315 5.02513093,3.9403003 4.50000204,3.9403003 L4.50000204,3.9403003 Z M23.304406,13.7496404 L20.3925252,8.33766177 C20.3925252,8.33766177 20.0241007,8.33766177 20.0241007,9.27569807 L23.1821957,16.8399882 L20.1784779,16.8399882 L19.2066551,24 L17.7932253,24 L16.8214026,16.8401082 L13.8170868,16.8401082 L16.9756601,9.27533807 C16.9756601,8.33730177 16.6074748,8.33730177 16.6074748,8.33730177 L13.695594,13.7492804 L13,13.2784023 L16.0041962,4.67659621 L20.9961626,4.67659621 L24,13.2787623 L23.304406,13.7496404 Z M18.5000598,3.89659928 C17.4288786,3.89110355 16.5645298,3.01603068 16.5685061,1.94108039 C16.5724823,0.866130112 17.4432809,-0.00247931694 18.5144732,5.31714792e-06 C19.5856656,0.00248995124 20.4524535,0.875129718 20.4514779,1.95008696 C20.4507524,2.46815078 20.244549,2.9646144 19.8784067,3.32983628 C19.5122643,3.69505817 19.0163053,3.89899174 18.5000598,3.89659928 Z',
            id: pathId
          };
          break;

        case 'giving':
          path = {
            d: 'M8.70759771,12.3365174 L16.1911875,15.7545221 C16.1911875,15.7545221 17.099147,17.0186823 16.6067118,18.3714296 C16.1142767,19.724177 14.8248846,19.3061846 14.8248846,19.3061846 L11.7527145,17.9132648 L11.5757154,18.714098 L14.8242475,20.1763594 C14.8242475,20.1763594 16.234265,20.5567096 16.9913628,19.0238999 C17.4380856,18.1688572 17.5007736,17.0318448 17.1536459,16.0804685 L21.8574948,12.8656901 C21.8574948,12.8656901 23.281813,12.3123055 23.854638,14.0203633 C24.4274629,15.7284212 23.12245,17.0561933 23.12245,17.0561933 C23.12245,17.0561933 16.4074197,21.8210357 14.308671,23.2710795 C12.2099223,24.7211232 11.0189141,23.5599014 11.0189141,23.5599014 L7.46327303,21.1088377 L4.2148904,23.3962516 C3.45948237,23.9281873 2.5,23 2.14178288,22.4352691 L0.213455765,19.9054686 C-0.27192466,18.5827541 0.0984638193,16.95814 1.04074159,16.2767913 C3.89940689,14.2663969 5.70500359,12.9992867 6.47680285,12.4617181 C7.85504659,11.5017528 8.70759771,12.3365174 8.70759771,12.3365174 Z M13.7580059,0.169779255 C14.4527833,-0.281414495 15.5646589,0.197663309 16.2414495,1.23982948 C16.3948834,1.47609697 16.5127832,1.72102175 16.5952791,1.96379246 C16.6331267,1.88814908 16.6775517,1.81356765 16.7254378,1.73982948 C17.4022285,0.697663309 18.5141041,0.218585505 19.2088815,0.669779255 C19.8220226,1.06795774 19.9054226,2.05757233 19.4514006,3.00091158 L21.4975267,3 C22.0511774,3 22.5,3.44266033 22.5,3.99895656 L22.5,5.00104344 C22.5,5.55275191 22.044239,6 21.4975267,6 L21.5,6 L21.5,11.009222 C21.5,11.5564136 21.0443356,12 20.5046024,12 L12.4953976,12 C11.9456547,12 11.5,11.5490248 11.5,11.009222 L11.5,6 L11.5024733,6 C10.9488226,6 10.5,5.55733967 10.5,5.00104344 L10.5,3.99895656 C10.5,3.44724809 10.955761,3 11.5024733,3 L13.813,3 L13.7254378,2.87374659 C13.0824867,1.88368872 13.0634987,0.741612642 13.6588921,0.243037938 Z M14.7144391,1.03603785 C14.3198653,1.29227707 14.2949537,1.95418883 14.6587975,2.51445914 C15.0226413,3.07472946 15.6374602,3.32119536 16.032034,3.06495614 C16.4266078,2.80871692 16.4515194,2.14680517 16.0876756,1.58653485 C15.7238318,1.02626454 15.1090128,0.779798637 14.7144391,1.03603785 Z M19.032034,1.03603785 C18.6374602,0.779798637 18.0226413,1.02626454 17.6587975,1.58653485 C17.2949537,2.14680517 17.3198653,2.80871692 17.7144391,3.06495614 C18.1090128,3.32119536 18.7238318,3.07472946 19.0876756,2.51445914 C19.4515194,1.95418883 19.4266078,1.29227707 19.032034,1.03603785 Z',
            id: pathId
          };
          break;

        case 'equal-to-greater-than':
        case 'greater-than-equal-circle':
          // alias
          path = {
            d: 'M12,24 C5.372583,24 0,18.627417 0,12 C0,5.372583 5.372583,0 12,0 C18.627417,0 24,5.372583 24,12 C24,18.627417 18.627417,24 12,24 Z M7.5,18 C7.08578644,18 6.75,18.3357864 6.75,18.75 C6.75,19.1642136 7.08578644,19.5 7.5,19.5 L16.5,19.5 C16.9142136,19.5 17.25,19.1642136 17.25,18.75 C17.25,18.3357864 16.9142136,18 16.5,18 L7.5,18 Z M12.5214417,9.75 L7.32365075,12.8143837 C6.7750881,13.1377915 6.58713665,13.8540639 6.90384945,14.4142227 C7.22056224,14.9743816 7.92200659,15.1663062 8.47056924,14.8428983 L16.5,9.74980444 L8.47056924,4.65710171 C7.92200659,4.33369385 7.22056224,4.52561844 6.90384945,5.08577728 C6.58713665,5.64593612 6.7750881,6.36220845 7.32365075,6.68561631 L12.5214417,9.75 Z',
            id: pathId
          };
          break;

        case 'grid':
          path = {
            d: 'M1,0 L9.5,0 C10.0522847,-1.01453063e-16 10.5,0.44771525 10.5,1 L10.5,9.5 C10.5,10.0522847 10.0522847,10.5 9.5,10.5 L1,10.5 C0.44771525,10.5 6.76353751e-17,10.0522847 0,9.5 L0,1 C-6.76353751e-17,0.44771525 0.44771525,1.01453063e-16 1,0 Z M14.5,13.5 L23,13.5 C23.5522847,13.5 24,13.9477153 24,14.5 L24,23 C24,23.5522847 23.5522847,24 23,24 L14.5,24 C13.9477153,24 13.5,23.5522847 13.5,23 L13.5,14.5 C13.5,13.9477153 13.9477153,13.5 14.5,13.5 Z M14.5,0 L23,0 C23.5522847,-1.01453063e-16 24,0.44771525 24,1 L24,9.5 C24,10.0522847 23.5522847,10.5 23,10.5 L14.5,10.5 C13.9477153,10.5 13.5,10.0522847 13.5,9.5 L13.5,1 C13.5,0.44771525 13.9477153,1.01453063e-16 14.5,0 Z M1,13.5 L9.5,13.5 C10.0522847,13.5 10.5,13.9477153 10.5,14.5 L10.5,23 C10.5,23.5522847 10.0522847,24 9.5,24 L1,24 C0.44771525,24 6.76353751e-17,23.5522847 0,23 L0,14.5 C-6.76353751e-17,13.9477153 0.44771525,13.5 1,13.5 Z',
            id: pathId
          };
          break;

        case 'volunteer':
        case 'hand-stop':
          // alias
          path = {
            d: 'M16.9156627,15.4178794 C16.914506,15.4199751 16.9156627,10.1288981 16.9156627,10.1288981 C16.9156627,10.1288981 16.9147631,8.76673597 18.4782008,8.7675842 C19.9973655,8.76953015 19.9973655,10.1304948 20,10.1288981 C20,10.1329896 19.9973655,18.4600915 20,18.4615385 C19.9524498,18.4465696 19.9973655,24 11.6465863,24 C4.01722088,24 4,18.8607069 4,18.8607069 L4,4.04158004 C4,4.04158004 4,2.94276923 5.15662651,2.94386694 C6.37751004,2.94386694 6.37995181,4.03768815 6.37751004,4.04158004 C6.38393574,4.04417464 6.37751004,10.977131 6.37751004,10.977131 L6.95582329,10.977131 L6.95582329,2.1954262 C6.95582329,2.1954262 6.95832932,1.07356341 8.25426506,1.07166736 C9.49224096,1.07166736 9.53349398,2.19482744 9.52610442,2.1954262 C9.52880321,2.19208316 9.52610442,10.0790021 9.52610442,10.0790021 L10.1686747,10.0790021 L10.1686747,1.1975052 C10.1686747,1.1975052 10.183261,0.00214553015 11.7108434,0 C13.2004498,0.00653638254 13.1919679,1.19895218 13.188755,1.1975052 C13.1871486,1.20354262 13.188755,10.029106 13.188755,10.029106 L13.7670683,10.029106 L13.7670683,2.59459459 C13.7670683,2.59459459 13.7679679,1.51090229 15.0873574,1.51030353 C16.4030843,1.51224948 16.4030843,2.59349688 16.4016064,2.59459459 C16.4030843,2.61056133 16.4016064,15.4178794 16.4016064,15.4178794',
            id: pathId
          };
          break;

        case 'shape-personality':
          path = {
            d: 'M0.631872597,24 C-0.462601514,22.2021376 -0.0189336199,18.6026627 1.07554049,17.4033377 C1.59688526,16.831802 7.4346002,15.6689203 7.4346002,15.6689203 C8.50628918,15.4437447 8.88430136,14.5153766 8.30717317,13.5726458 C8.30717317,13.5726458 6,10.4094318 6,7.5 C6,3.2712357 6.84393526,0 12,0 C17.1567645,0 18,3.2712357 18,7.5 C18,10.4004313 15.7014161,13.5605308 15.7014161,13.5605308 C15.1138315,14.491916 15.5058938,15.4290632 16.6017758,15.6655253 C16.6017758,15.6655253 22.4317748,16.8453028 22.9377241,17.4033377 C24.0238007,18.6026627 24.456272,22.2021376 23.3701953,24 L0.631872597,24 Z',
            id: pathId
          };
          break;

        case 'shape-heart':
        case 'heart':
          // temp alias
          path = {
            d: 'M11.9995557,24 C12.945672,22.9641578 18.3496117,17.0522781 21.7277086,13.361143 C24.7543578,10.0515009 24.6895143,5.2285187 21.937931,2.23720863 C19.1852987,-0.756552109 14.7381841,-0.744116549 11.9995557,2.26499952 C9.26108566,-0.744058458 4.81411612,-0.75649419 2.06164185,2.23720863 C-0.689941404,5.2285187 -0.753631187,10.0515009 2.27186429,13.361143 C5.65019193,17.0522781 11.0534393,22.9641578 11.9995557,24 Z',
            id: pathId
          };
          break;

        case 'shape-spiritual-gifts':
        case 'gift':
          // temp alias
          path = {
            d: 'M17.9036783,6 L22.9993054,6 C23.5519738,6 24,6.45097518 24,6.99077797 L24,11.009222 C24,11.5564136 23.5525308,12 22.9993054,12 L22,12 L22,22.9975267 C22,23.5511774 21.5446944,24 21.0081969,24 L2.99180311,24 C2.44404538,24 2,23.544239 2,22.9975267 L2,12 L1.00069463,12 C0.448026248,12 0,11.5490248 0,11.009222 L0,6.99077797 C0,6.44358641 0.44746922,6 1.00069463,6 L6.62296886,6 C6.56419946,5.91778761 6.506795,5.83360141 6.45087566,5.74749317 C5.09729441,3.66316083 5.12645681,1.24194601 6.5160117,0.339558509 C7.9055666,-0.56282899 10.1293178,0.395326618 11.4828991,2.47965896 C11.7881425,2.94969265 12.0230681,3.43685811 12.1879321,3.91987415 C12.2688645,3.7719176 12.3565098,3.62496961 12.4508757,3.47965896 C13.8044569,1.39532662 16.0282081,0.43717101 17.417763,1.33955851 C18.6436502,2.13565897 18.8107377,4.11386973 17.9036783,6 Z M11.064068,6.12991228 C11.8532156,5.61743384 11.9030387,4.29361033 11.1753511,3.1730697 C10.4476636,2.05252908 9.21802569,1.55959727 8.4288781,2.07207571 C7.63973052,2.58455414 7.58990735,3.90837766 8.31759494,5.02891828 C9.04528253,6.14945891 10.2749204,6.64239071 11.064068,6.12991228 Z M14.4288781,6.12991228 C15.2180257,6.64239071 16.4476636,6.14945891 17.1753511,5.02891828 C17.9030387,3.90837766 17.8532156,2.58455414 17.064068,2.07207571 C16.2749204,1.55959727 15.0452825,2.05252908 14.3175949,3.1730697 C13.5899073,4.29361033 13.6397305,5.61743384 14.4288781,6.12991228 Z',
            id: pathId
          };
          break;

        case 'home':
          /**
           * NOTE: Not shown in the doc's icon set anymore.
           * We'll figure out later where it's supposed to go.
           */
          path = {
            d: 'M12.44852,9.14368019 L17.11136,13.6691687 C17.4185266,13.9679993 17.5999773,14.2399952 17.6,14.6126022 L17.6,22.8265753 C17.6,23.4746399 17.0627417,24 16.4,24 L13.52,24 L13.52,19.4823148 C13.52,18.8342502 12.9827417,18.3088901 12.32,18.3088901 L11.74,18.3088901 C11.0772583,18.3088901 10.54,18.8342502 10.54,19.4823148 L10.54,24 L7.6,24 C6.9372583,24 6.4,23.4746399 6.4,22.8265753 L6.4,14.6126022 C6.40002356,14.2440429 6.57758454,13.976001 6.87922,13.6760332 L11.51302,9.18122978 L11.55148,9.14368019 C12.0201073,8.68543994 11.9798927,8.68543994 12.44852,9.14368019 Z M12.7644917,0.283466786 C12.7991459,0.310236673 12.8322528,0.338841703 12.8636615,0.369151542 L23.648907,10.8392121 C24.116914,11.2934545 24.1170481,12.0299797 23.6492066,12.4843827 L22.0269557,14.0592255 C21.8022052,14.2774191 21.4973712,14.4 21.1795178,14.4 C20.8616645,14.4 20.5568305,14.2774191 20.33208,14.0592255 L11.9841358,5.95494834 L3.66753049,14.0283371 C3.19954485,14.4825092 2.44094009,14.4825092 1.97295445,14.0283371 L0.350883247,12.4536688 C-0.116961082,11.9993594 -0.116961082,11.2629239 0.350883247,10.8086146 L11.1346307,0.340008254 C11.5786983,-0.0905826302 12.2898962,-0.115254777 12.7644917,0.283466786 Z',
            id: pathId
          };
          break;

        case 'wait':
        case 'hourglass':
          // alias
          path = {
            d: 'M17.8181818,6.72229253 C17.8181818,7.43445353 17.4363216,8.11472265 16.763601,8.60098751 L12.0612542,12 L7.26201899,8.60323701 C6.57377999,8.11612092 6.18181818,7.42776796 6.18181818,6.70621695 L6.18181818,4.28571429 C6.18181818,3.57563389 6.9260721,3 7.84415584,3 L16.1558442,3 C17.0739279,3 17.8181818,3.57563389 17.8181818,4.28571429 L17.8181818,6.72229253 Z M17.8181818,17.2777075 L17.8181818,19.7142857 C17.8181818,20.4243661 17.0739279,21 16.1558442,21 L7.84415584,21 C6.9260721,21 6.18181818,20.4243661 6.18181818,19.7142857 L6.18181818,17.2937831 C6.18181818,16.572232 6.57377999,15.8838791 7.26201899,15.396763 L12.0612542,12 L16.763601,15.3990125 C17.4363216,15.8852773 17.8181818,16.5655465 17.8181818,17.2777075 Z M5.125,0 L18.875,0 C19.4963203,-1.14134695e-16 20,0.503679656 20,1.125 C20,1.74632034 19.4963203,2.25 18.875,2.25 L5.125,2.25 C4.50367966,2.25 4,1.74632034 4,1.125 C4,0.503679656 4.50367966,1.14134695e-16 5.125,0 Z M5.125,21.75 L18.875,21.75 C19.4963203,21.75 20,22.2536797 20,22.875 C20,23.4963203 19.4963203,24 18.875,24 L5.125,24 C4.50367966,24 4,23.4963203 4,22.875 C4,22.2536797 4.50367966,21.75 5.125,21.75 Z',
            id: pathId
          };
          break;

        case 'image':
          path = {
            d: 'M0,2.00494659 C0,0.897645164 0.897026226,-1.56302636e-17 2.00494659,-7.36065686e-18 L21.9950534,1.41847109e-16 C23.1023548,1.50112096e-16 24,0.897026226 24,2.00494659 L24,21.9950534 C24,23.1023548 23.1029738,24 21.9950534,24 L2.00494659,24 C0.897645164,24 0,23.1029738 0,21.9950534 L0,2.00494659 Z M4,3 C3.44771525,3 3,3.44771525 3,4 L3,20 C3,20.5522847 3.44771525,21 4,21 L20,21 C20.5522847,21 21,20.5522847 21,20 L21,4 C21,3.44771525 20.5522847,3 20,3 L4,3 Z M10.4208968,16.037909 L15.0848033,10.5188506 C15.4412771,10.0970155 16.0722211,10.0440296 16.4940563,10.4005034 C16.5670174,10.4621595 16.6307679,10.5339516 16.6833645,10.6136912 L19.5,14.8838786 L19.5,19.5 L4.5,19.5 L7.94630653,15.5189943 C8.26420709,15.151771 8.80001114,15.0660823 9.21658347,15.3158446 L10.4208968,16.037909 Z M8.24999986,9.74999972 C7.00735925,9.74999972 6,8.74264047 6,7.49999986 C6,6.25735925 7.00735925,5.25 8.24999986,5.25 C9.49264047,5.25 10.4999997,6.25735925 10.4999997,7.49999986 C10.4999998,8.09693189 10.2627925,8.66939872 9.84059232,9.0913879 C9.41839215,9.51337708 8.84580682,9.75029818 8.24887486,9.74999972 L8.24999986,9.74999972 Z',
            id: pathId
          };
          break;

        case 'receive':
        case 'inbox-in':
          // alias
          path = {
            d: 'M22.882763,23 L1.12607812,23 C0.491965007,22.9866945 -0.0117750325,22.4555706 0.000209482438,21.8129278 L0.000209482438,14.2922425 C0.000176973079,14.146769 0.0254128444,14.0024253 0.0747619511,13.8658185 L3.06823311,5.57808218 C3.21908505,5.11375326 3.6447801,4.79817836 4.12713088,4.79310345 L9.75394687,4.79310345 L9.75394687,7.16724793 L4.9017184,7.16724793 L2.75359642,13.1051702 L6.37255015,13.1051702 C7.00646846,13.1184723 7.5098466,13.6498111 7.49715519,14.2922425 L7.49715519,15.4793147 L16.5003135,15.4793147 L16.5003135,14.2922425 C16.488329,13.6495997 16.992069,13.1184757 17.6261821,13.1051702 L21.2451359,13.1051702 L19.0970139,7.16724793 L14.246049,7.16724793 L14.246049,4.79310345 L19.872865,4.79310345 C20.3552158,4.79817836 20.7809108,5.11375326 20.9317628,5.57808218 L23.9252339,13.8658185 C23.974583,14.0024253 23.9998189,14.146769 23.9997864,14.2922425 L23.9997864,21.8129278 C24.0118264,22.4521587 23.5133926,22.9818494 22.882763,23 Z M15.7560524,9.87021933 C15.7572079,10.1882738 15.6390363,10.4944722 15.4262525,10.7247752 L12.8004893,13.5424649 C12.5937406,13.7684543 12.3057481,13.8965517 12.0044205,13.8965517 C11.703093,13.8965517 11.4151005,13.7684543 11.2083518,13.5424649 L8.58258859,10.7247752 C8.36980476,10.4944722 8.25163321,10.1882738 8.25278869,9.87021933 C8.24080417,9.21647358 8.74454421,8.67617339 9.37865732,8.66263805 C9.6792378,8.66348597 9.96640392,8.79103538 10.1734625,9.01566343 L10.8785519,9.77251858 L10.8785519,2.21699388 C10.8588864,1.78920164 11.0690711,1.38493688 11.4255169,1.16497295 C11.7819627,0.945009017 12.2268784,0.945009017 12.5833242,1.16497295 C12.93977,1.38493688 13.1499546,1.78920164 13.1302892,2.21699388 L13.1302892,9.77251858 L13.834115,9.01566343 C14.0418198,8.79121712 14.3292861,8.66373707 14.6301838,8.66263805 C15.2642969,8.67617339 15.7680369,9.21647358 15.7560524,9.87021933 Z',
            id: pathId
          };
          break;

        case 'input':
        case 'pencil-input':
          // alias
          path = {
            d: 'M12.5262139,14.6271642 L9.37297035,11.4739207 L16.5515396,4.30023165 L18.307918,2.54158655 L21.4613474,5.69501602 L19.7053343,7.45400373 L12.5262139,14.6271642 Z M10.9034679,16.2485632 L9.94169211,17.2095405 L6,18 L6.78863241,14.0565017 L7.7503463,13.0954416 L10.9034679,16.2485632 Z M22.9430132,4.21084044 L19.7898823,1.05770958 L20.1948302,0.652239075 C21.0643103,-0.217413025 22.4791448,-0.217413025 23.3478899,0.652239075 C24.21737,1.52115791 24.21737,2.93562579 23.3478899,3.80527788 L22.9430132,4.21084044 Z M1.5,21 L22.5,21 C23.3284271,21 24,21.6715729 24,22.5 C24,23.3284271 23.3284271,24 22.5,24 L1.5,24 C0.671572875,24 1.01453063e-16,23.3284271 0,22.5 C-1.01453063e-16,21.6715729 0.671572875,21 1.5,21 Z',
            id: pathId
          };
          break;

        case 'info':
          path = {
            d: 'M14.8262313,5.33767245 C13.3530974,5.33502292 12.1607825,4.1389842 12.1625373,2.66565923 C12.1642921,1.19233427 13.3594527,-0.00086009464 14.8325887,4.65199288e-07 C16.3057247,0.000861025038 17.4994908,1.19545093 17.4995247,2.66877693 C17.4989038,3.37724332 17.2169033,4.0564452 16.7155618,4.5569619 C16.2142204,5.0574786 15.5346064,5.33830918 14.8262313,5.33767245 Z M15.826084,9.88153264 C15.7821028,9.88118982 15.8912436,12.004719 14.3973871,14.6615587 C14.4185654,14.6765856 11.8818551,18.8036005 12.0441825,19.9992355 C12.0853359,19.9888367 11.7725941,21.5883113 13.6409827,21.5925966 C13.6004309,21.6256214 14.3075595,21.6429337 14.817585,21.4332433 C14.8124709,21.4246157 14.7333529,22.6282498 14.7333529,22.6282498 C14.7333529,22.6282498 13.0213351,23.982781 10.4474424,23.982781 C10.4794506,24.0399173 6.97840296,24.122765 7.00174729,21.1945277 C6.99482822,21.1951562 6.94344663,19.5231184 8.51449589,16.8128561 C8.50986312,16.8879333 10.8756424,12.9640952 10.7835887,11.2363495 C10.8127089,11.2600039 10.8939929,9.61830552 9.18678849,9.56334037 C9.17643997,9.53711479 8.1519368,9.63007561 7.7580915,9.80234167 L7.92619474,8.52768709 C7.92619474,8.52768709 10.4331229,7.09327931 12.3805694,7.09327931 C12.388391,7.06431119 15.8701856,6.83793701 15.826084,9.88153264 Z',
            id: pathId
          };
          break;

        case 'equal-to-lesser-than':
        case 'less-than-equal-circle':
          // alias
          path = {
            d: 'M12,24 C5.372583,24 0,18.627417 0,12 C0,5.372583 5.372583,0 12,0 C18.627417,0 24,5.372583 24,12 C24,18.627417 18.627417,24 12,24 Z M7.5,18 C7.08578644,18 6.75,18.3357864 6.75,18.75 C6.75,19.1642136 7.08578644,19.5 7.5,19.5 L16.5,19.5 C16.9142136,19.5 17.25,19.1642136 17.25,18.75 C17.25,18.3357864 16.9142136,18 16.5,18 L7.5,18 Z M10.7285583,9.75 L15.9263492,6.68561631 C16.4749119,6.36220845 16.6628633,5.64593612 16.3461506,5.08577728 C16.0294378,4.52561844 15.3279934,4.33369385 14.7794308,4.65710171 L6.75,9.74980444 L14.7794308,14.8428983 C15.3279934,15.1663062 16.0294378,14.9743816 16.3461506,14.4142227 C16.6628633,13.8540639 16.4749119,13.1377915 15.9263492,12.8143837 L10.7285583,9.75 Z',
            id: pathId
          };
          break;

        case 'link':
          path = {
            d: 'M7.56514447,13.4392956 C7.89240117,13.1164386 9.64361862,11.3652523 10.0333328,10.9755451 C10.1774038,11.7170183 10.5383603,12.3970129 11.0706343,12.9296848 C11.6097102,13.4700181 12.3043302,13.8287956 13.059326,13.956862 C13.0596406,13.9570414 13.0600091,13.9571046 13.0603677,13.9570409 L13.0604855,13.9580215 C13.2122213,13.9917248 13.3670659,14.0103108 13.5227602,14.0135084 C13.6797107,14.0188386 13.8369416,14.0140464 13.9934756,13.9991615 C13.9938007,13.9990148 13.9941787,13.9990602 13.9944563,13.9992793 L13.9944618,13.9981753 C14.8903023,13.9273613 15.7339396,13.5368166 16.3712145,12.8979062 L19.7005801,9.56859982 C21.1700069,8.09919914 21.1817242,5.72854693 19.7267512,4.2735999 C18.2717783,2.81865287 15.9010839,2.83036987 14.4316571,4.29977055 L12.5044118,6.22698147 C11.0545597,5.79269089 9.50757996,5.77725246 8.04105319,6.1824384 C8.08546712,6.11813045 8.12755653,6.05260741 8.17423518,5.98920819 C8.39122949,5.69452254 8.6302519,5.41661879 8.88921697,5.15792161 L11.9330921,2.11410062 C13.726597,0.308146703 16.33946,-0.410450678 18.7834193,0.230103175 C21.2273786,0.870657028 23.1293275,2.77257201 23.7698927,5.21648785 C24.410458,7.66040368 23.6918478,10.2732201 21.8858618,12.0666931 L18.8414935,15.1110071 C18.4175877,15.5352398 17.9426218,15.9051007 17.4277372,16.2119137 C17.4268579,16.2123147 17.4260142,16.2127908 17.4252157,16.2133367 C17.3560775,16.2545233 17.2851749,16.2928362 17.21507,16.3310838 C17.18758,16.3463678 17.1605149,16.3625697 17.1327234,16.3768127 C17.1238046,16.3820697 17.1148272,16.386775 17.1060347,16.3912955 C16.9400728,16.4788958 16.7707797,16.5579878 16.599613,16.6315083 C15.2172483,17.2249792 13.6869545,17.3680769 12.22748,17.0403464 C12.2020576,17.0344005 12.1771167,17.0302921 12.1520012,17.0242833 C12.1426903,17.0219989 12.1342369,17.0199555 12.1237611,17.0176154 C11.9839113,16.9840239 11.8459922,16.944474 11.7090641,16.9029566 C11.5445824,16.8523761 11.3825807,16.7963865 11.2216527,16.7340747 C9.64110229,16.1164544 8.34256095,14.9463745 7.56514447,13.4392956 Z M16.4100341,10.5655696 C15.8271974,11.1652394 14.8154692,12.1769496 13.9482258,13.0413702 C13.8039234,12.3001681 13.44294,11.6204619 12.910798,11.0879671 C12.3718737,10.5478289 11.6774319,10.1892362 10.9226556,10.0613392 C10.9223808,10.0611199 10.922023,10.0610321 10.9216755,10.0610987 C10.9214924,10.0609156 10.921496,10.0601796 10.921496,10.0601796 C10.7698401,10.0262813 10.6150123,10.0077333 10.4593434,10.0048149 C10.3024391,9.99905503 10.1452208,10.0038479 9.98875068,10.0191612 L9.98776999,10.0190433 L9.98794944,10.0199624 C9.09215581,10.0908202 8.24857179,10.4813602 7.61131933,11.120231 L4.28238518,14.4491059 C2.81302643,15.9184385 2.80130976,18.2889809 4.25621528,19.7438605 C5.7111208,21.1987401 8.08170537,21.1870236 9.55106412,19.717691 L11.4784943,17.7902952 C12.9281729,18.2249166 14.4751396,18.2403143 15.9414855,17.8347174 C15.8975018,17.8988393 15.8550432,17.9646095 15.8084878,18.0278854 C15.5914822,18.3227147 15.3524386,18.6007619 15.0934426,18.8596016 L12.0493209,21.9036691 C9.27358556,24.679355 4.79536315,24.7014883 2.04693116,21.9531053 C-0.701500834,19.2047222 -0.679367129,14.7265795 2.09636817,11.9508936 L5.14012008,8.90719588 C5.56398889,8.48254992 6.03921964,8.1125556 6.55455251,7.80597932 C6.55523734,7.80545697 6.5559569,7.80498211 6.55670608,7.80455812 C6.62584549,7.7631262 6.69656497,7.72463025 6.766853,7.68656574 C6.79415986,7.67109861 6.82122321,7.65526472 6.84852824,7.64016557 C6.85750685,7.63521491 6.86630117,7.63032648 6.87521693,7.62568276 C7.04154506,7.53844863 7.21059398,7.45911244 7.3817607,7.385592 C8.76413542,6.79216185 10.2944161,6.64906533 11.7538937,6.97675392 C11.7786436,6.98227383 11.8041338,6.98693148 11.829004,6.99294143 C11.8380707,6.99498179 11.8469513,6.99745237 11.8575492,6.99991447 C11.9968491,7.0330794 12.1348914,7.07250608 12.2722467,7.11445062 C12.4361768,7.16497249 12.5987912,7.22108177 12.7595971,7.28327152 C14.3354568,7.89957732 15.631237,9.06468083 16.4100341,10.5655696 Z',
            id: pathId
          };
          break;

        case 'list':
          path = {
            d: 'M13.992516,0 C14.5489341,0 15,0.44296875 15,0.994563103 L15,3.8054369 C15,4.35471893 14.5510798,4.8 13.992516,4.8 L1.00748397,4.8 C0.45106594,4.8 0,4.35703125 0,3.8054369 L0,0.994563103 C0,0.445281068 0.448920205,0 1.00748397,0 L13.992516,0 Z M23.0054369,0 C23.5547189,0 24,0.44296875 24,0.994563103 L24,3.8054369 C24,4.35471893 23.5570312,4.8 23.0054369,4.8 L20.194563,4.8 C19.6452809,4.8 19.1999998,4.35703125 19.1999998,3.8054369 L19.1999998,0.994563103 C19.1999998,0.445281068 19.6429686,0 20.194563,0 L23.0054369,0 Z M13.992516,9.6 C14.5489341,9.6 15,10.0429688 15,10.5945631 L15,13.4054369 C15,13.9547189 14.5510798,14.4 13.992516,14.4 L1.00748397,14.4 C0.45106594,14.4 0,13.9570313 0,13.4054369 L0,10.5945631 C0,10.0452811 0.448920205,9.6 1.00748397,9.6 L13.992516,9.6 Z M23.0054369,9.6 C23.5547189,9.6 24,10.0429688 24,10.5945631 L24,13.4054369 C24,13.9547189 23.5570312,14.4 23.0054369,14.4 L20.194563,14.4 C19.6452809,14.4 19.1999998,13.9570313 19.1999998,13.4054369 L19.1999998,10.5945631 C19.1999998,10.0452811 19.6429686,9.6 20.194563,9.6 L23.0054369,9.6 Z M13.992516,19.2 C14.5489341,19.2 15,19.6429687 15,20.1945631 L15,23.0054369 C15,23.5547189 14.5510798,24 13.992516,24 L1.00748397,24 C0.45106594,24 0,23.5570312 0,23.0054369 L0,20.1945631 C0,19.6452811 0.448920205,19.2 1.00748397,19.2 L13.992516,19.2 Z M23.0054369,19.2 C23.5547189,19.2 24,19.6429687 24,20.1945631 L24,23.0054369 C24,23.5547189 23.5570312,24 23.0054369,24 L20.194563,24 C19.6452809,24 19.1999998,23.5570312 19.1999998,23.0054369 L19.1999998,20.1945631 C19.1999998,19.6452811 19.6429686,19.2 20.194563,19.2 L23.0054369,19.2 Z',
            id: pathId,
            transform: 'translate(12.000000, 12.000000) scale(-1, 1) translate(-12.000000, -12.000000)'
          };
          break;

        case 'category':
        case 'list-category':
          // alias
          path = {
            d: 'M1.5,0 L16.5,0 C17.3284271,0 18,0.671572875 18,1.5 L18,6 C18,6.82842712 17.3284271,7.5 16.5,7.5 L1.5,7.5 C0.671572875,7.5 0,6.82842712 0,6 L0,1.5 C0,0.671572875 0.671572875,0 1.5,0 Z M3,2.25 C2.58578644,2.25 2.25,2.58578644 2.25,3 L2.25,4.5 C2.25,4.91421356 2.58578644,5.25 3,5.25 L15,5.25 C15.4142136,5.25 15.75,4.91421356 15.75,4.5 L15.75,3 C15.75,2.58578644 15.4142136,2.25 15,2.25 L3,2.25 Z M1.5,16.5 L16.5,16.5 C17.3284271,16.5 18,17.1715729 18,18 L18,22.5 C18,23.3284271 17.3284271,24 16.5,24 L1.5,24 C0.671572875,24 0,23.3284271 0,22.5 L0,18 C0,17.1715729 0.671572875,16.5 1.5,16.5 Z M3,18.75 C2.58578644,18.75 2.25,19.0857864 2.25,19.5 L2.25,21 C2.25,21.4142136 2.58578644,21.75 3,21.75 L15,21.75 C15.4142136,21.75 15.75,21.4142136 15.75,21 L15.75,19.5 C15.75,19.0857864 15.4142136,18.75 15,18.75 L3,18.75 Z M1.5,9 L22.5,9 C23.3284271,9 24,9.67157288 24,10.5 L24,13.5 C24,14.3284271 23.3284271,15 22.5,15 L1.5,15 C0.671572875,15 0,14.3284271 0,13.5 L0,10.5 C0,9.67157288 0.671572875,9 1.5,9 Z',
            id: pathId
          };
          break;

        case 'locked':
        case 'lock':
          // alias
          path = {
            d: 'M3,12.9115683 C3,11.8056306 3.8926228,10.9090909 4.99508929,10.9090909 L19.0049107,10.9090909 C20.1067681,10.9090909 21,11.8088821 21,12.9115683 L21,21.9975226 C21,23.1034603 20.1073772,24 19.0049107,24 L4.99508929,24 C3.8932319,24 3,23.1002088 3,21.9975226 L3,12.9115683 Z M5.25,4.00019776 C5.25,1.79094954 7.04269577,0 9.2456504,0 L14.7543496,0 C16.9610864,0 18.75,1.78919875 18.75,4.00019776 L18.75,10.9090909 L5.25,10.9090909 L5.25,4.00019776 Z M9.75,17.4545455 C9.75,16.2495605 10.726433,15.2727273 11.9340904,15.2727273 L12.0659096,15.2727273 C13.2721494,15.2727273 14.25,16.2411596 14.25,17.4545455 L14.25,17.4545455 C14.25,18.6595304 13.273567,19.6363636 12.0659096,19.6363636 L11.9340904,19.6363636 C10.7278506,19.6363636 9.75,18.6679313 9.75,17.4545455 L9.75,17.4545455 Z M8.5,5.17991954 C8.5,4.07639863 9.38655484,3.18181818 10.5059191,3.18181818 L13.4940809,3.18181818 C14.6019194,3.18181818 15.5,4.06852453 15.5,5.17991954 L15.5,11.1818182 L8.5,11.1818182 L8.5,5.17991954 Z',
            id: pathId
          };
          break;

        case 'location':
        case 'map-marker':
          // alias
          path = {
            d: 'M3.5,8.00026668 C3.5,3.58171939 7.30545,0 12,0 C16.6937,0 20.5,3.58171939 20.5,8.00026668 C20.5,12.4172139 12,24 12,24 C12,24 3.5,12.4172139 3.5,8.00026668 L3.5,8.00026668 Z M8.6,7.99946665 C8.6,6.23140771 10.1215,4.79855995 12,4.79855995 C13.87765,4.79855995 15.4,6.23140771 15.4,7.99946665 C15.4,9.76592553 13.87765,11.1987733 12,11.1987733 C10.1215,11.1987733 8.6,9.76592553 8.6,7.99946665 L8.6,7.99946665 Z',
            id: pathId
          };
          break;

        case 'marital-status':
          path = {
            d: 'M17.6624405,8.00413495 C19.6985093,9.65416874 21,12.1750946 21,15 C21,19.9705627 16.9705627,24 12,24 C7.02943725,24 3,19.9705627 3,15 C3,12.1746275 4.30192122,9.65333498 6.3385697,8.00331641 L8.22497994,10.3361384 C6.86763503,11.4361618 6,13.1167574 6,15 C6,18.3137085 8.6862915,21 12,21 C15.3137085,21 18,18.3137085 18,15 C18,13.1167574 17.132365,11.4361618 15.7750201,10.3361384 Z M15,0 L17.25,2.953125 L12,10.5 L6.75,2.953125 L9,0 L15,0 Z',
            id: pathId
          };
          break;

        case 'menu':
        case 'ellipsis-h':
          // alias
          path = {
            d: 'M3,15 C1.34314575,15 0,13.6568542 0,12 C0,10.3431458 1.34314575,9 3,9 C4.65685425,9 6,10.3431458 6,12 C6,13.6568542 4.65685425,15 3,15 Z M12,15 C10.3431458,15 9,13.6568542 9,12 C9,10.3431458 10.3431458,9 12,9 C13.6568542,9 15,10.3431458 15,12 C15,13.6568542 13.6568542,15 12,15 Z M21,15 C19.3431458,15 18,13.6568542 18,12 C18,10.3431458 19.3431458,9 21,9 C22.6568542,9 24,10.3431458 24,12 C24,13.6568542 22.6568542,15 21,15 Z',
            id: pathId
          };
          break;

        case 'milestone':
          path = {
            d: 'M5.25,0 L18.75,0 C19.5784271,0 20.25,0.707836006 20.25,1.58099597 L20.25,22.4129393 C20.25,23.2860993 19.5784271,23.9939353 18.75,23.9939353 C18.4642852,23.9939353 18.1845133,23.9079288 17.9435987,23.7460342 L12.0156437,19.7624496 L6.05422751,23.7533563 C5.35493423,24.2215024 4.4279801,24.0035102 3.98381751,23.2664569 C3.83110089,23.0130356 3.75,22.7190223 3.75,22.4188033 L3.75,1.58099597 C3.75,0.707836006 4.42157288,0 5.25,0 Z M12,12.9675 L15.0858726,14.7473392 L14.3467319,11.2624994 L16.9930467,8.87766078 L13.4503601,8.50375057 L12,5.25 L10.5496399,8.50375057 L7.00695329,8.87766078 L9.65326805,11.2624994 L8.91412743,14.7473392 L12,12.9675 Z M0.75,1.5 L2.25,1.5 L2.25,6.75 L0.75,6.75 C0.335786438,6.75 0,6.41421356 0,6 L0,2.25 C0,1.83578644 0.335786438,1.5 0.75,1.5 Z M21.75,1.5 L23.25,1.5 C23.6642136,1.5 24,1.83578644 24,2.25 L24,6 C24,6.41421356 23.6642136,6.75 23.25,6.75 L21.75,6.75 L21.75,1.5 Z',
            id: pathId
          };
          break;

        case 'ministry':
          path = {
            d: 'M8.83688618,21.6733586 C8.78424814,21.680014 8.73241682,21.6840476 8.68098885,21.6866694 C11.5912067,19.0503307 15.0029986,14.9352866 16.825162,9.11142229 C16.8215318,9.1382455 14.2315791,15.6702023 7.56570785,21.4012946 L7.56570785,21.4012946 C6.61405715,22.342292 5.5934116,23.210852 4.51229837,23.9997178 C4.51229837,23.9997178 3.82074347,24.0342048 4.04460639,23.3406332 C5.11474189,22.6310903 6.1410672,21.8575916 7.11798202,21.0243579 C5.01165384,18.7332924 5.93372703,11.1481715 12.8892083,8.2581214 C17.4648856,6.35750509 18.4611764,0 18.4611764,0 C18.4611764,0 24.8844286,18.8216275 8.83688618,21.6733586 L8.83688618,21.6733586 Z',
            id: pathId
          };
          break;

        case 'minus':
        case 'minus-circle':
          // alias
          path = {
            d: 'M12,24 C5.372583,24 0,18.627417 0,12 C0,5.372583 5.372583,0 12,0 C18.627417,0 24,5.372583 24,12 C24,18.627417 18.627417,24 12,24 Z M6.75,10.5 C5.92157288,10.5 5.25,11.1715729 5.25,12 C5.25,12.8284271 5.92157288,13.5 6.75,13.5 L17.25,13.5 C18.0784271,13.5 18.75,12.8284271 18.75,12 C18.75,11.1715729 18.0784271,10.5 17.25,10.5 L6.75,10.5 Z',
            id: pathId
          };
          break;

        case 'navigate':
        case 'compas':
          // alias
          path = {
            d: 'M12,24 C5.372583,24 0,18.627417 0,12 C0,5.372583 5.372583,0 12,0 C18.627417,0 24,5.372583 24,12 C24,18.627417 18.627417,24 12,24 Z M12,21.75 C17.3847763,21.75 21.75,17.3847763 21.75,12 C21.75,6.61522369 17.3847763,2.25 12,2.25 C6.61522369,2.25 2.25,6.61522369 2.25,12 C2.25,17.3847763 6.61522369,21.75 12,21.75 Z M10.4090097,10.4090097 L17.8336309,6.16636906 L13.5909903,13.5909903 L6.16636906,17.8336309 L10.4090097,10.4090097 Z',
            id: pathId
          };
          break;

        case 'newsletter':
        case 'newspaper':
          // alias
          path = {
            d: 'M20.46152,20.9806674 C20.46152,21.0241658 3.69232,20.9806674 3.69232,20.9806674 C3.69232,20.9806674 0,20.8064925 0,16.8005601 L0,11.0954876 C-1.11632554e-15,9.99091808 0.8954305,9.09548758 2,9.09548758 L5.84616,9.09548758 L5.84616,5 C5.84616,3.8954305 6.7415905,3 7.84616,3 L22,3 C23.1045695,3 24,3.8954305 24,5 L24,17.0618225 C24,17.0618225 23.84616,20.4581426 20.46152,20.9806674 Z M3,12 C2.58578644,12 2.25,12.3357864 2.25,12.75 C2.25,13.1642136 2.58578644,13.5 3,13.5 L6,13.5 L6,12 L3,12 Z M3,15 C2.58578644,15 2.25,15.3357864 2.25,15.75 C2.25,16.1642136 2.58578644,16.5 3,16.5 L6,16.5 L6,15 L3,15 Z M17.25,6 C16.8357864,6 16.5,6.33578644 16.5,6.75 C16.5,7.16421356 16.8357864,7.5 17.25,7.5 L21,7.5 C21.4142136,7.5 21.75,7.16421356 21.75,6.75 C21.75,6.33578644 21.4142136,6 21,6 L17.25,6 Z M17.25,9 C16.8357864,9 16.5,9.33578644 16.5,9.75 C16.5,10.1642136 16.8357864,10.5 17.25,10.5 L21,10.5 C21.4142136,10.5 21.75,10.1642136 21.75,9.75 C21.75,9.33578644 21.4142136,9 21,9 L17.25,9 Z M17.25,12 C16.8357864,12 16.5,12.3357864 16.5,12.75 C16.5,13.1642136 16.8357864,13.5 17.25,13.5 L21,13.5 C21.4142136,13.5 21.75,13.1642136 21.75,12.75 C21.75,12.3357864 21.4142136,12 21,12 L17.25,12 Z M9,15 C8.58578644,15 8.25,15.3357864 8.25,15.75 C8.25,16.1642136 8.58578644,16.5 9,16.5 L21,16.5 C21.4142136,16.5 21.75,16.1642136 21.75,15.75 C21.75,15.3357864 21.4142136,15 21,15 L9,15 Z M9.25,6 C8.69771525,6 8.25,6.44771525 8.25,7 L8.25,11 C8.25,11.5522847 8.69771525,12 9.25,12 L13.25,12 C13.8022847,12 14.25,11.5522847 14.25,11 L14.25,7 C14.25,6.44771525 13.8022847,6 13.25,6 L9.25,6 Z M6,10.5150146 L2.5,10.5150146 C1.94771525,10.5150146 1.5,10.9627299 1.5,11.5150146 L1.5,16.4725346 C1.57630749,17.2797346 1.8050713,18.9326146 3.86442157,18.9326146 C5.92377184,18.9326146 6,16.5494146 6,16.5494146 L6,10.5150146 Z',
            id: pathId
          };
          break;

        case 'certified':
          path = {
            d: 'M18.75,7.98608591 C18.4989635,7.94238221 18.2630766,7.83245136 18.0673545,7.6664001 L17.3890954,7.09096299 C16.8460054,6.63020373 16.0472421,6.63717443 15.5122762,7.10734175 L14.8441631,7.69452847 C14.6123922,7.89822579 14.3211683,8.021843 14.013639,8.04706503 L13.127142,8.11977115 C12.4173133,8.17798779 11.8574314,8.74772775 11.8116119,9.45846431 L11.7543883,10.3460953 C11.7345373,10.6540178 11.6160214,10.9473548 11.4164001,11.1826455 L10.840963,11.8609046 C10.3802037,12.4039946 10.3871744,13.2027579 10.8573417,13.7377238 L11.4445285,14.4058369 C11.5951376,14.577203 11.7019687,14.7810709 11.7576187,15 L1.5,15 C0.671572875,15 0,14.3284271 0,13.5 L0,1.5 C0,0.671572875 0.671572875,0 1.5,0 L17.25,0 C18.0784271,0 18.75,0.671572875 18.75,1.5 L18.75,7.98608591 L18.75,7.98608591 Z M11.8214468,15.5336444 L11.8697711,16.122858 C11.9279878,16.8326867 12.4977278,17.3925686 13.2084643,17.4383881 L14.0960953,17.4956117 C14.4040178,17.5154627 14.6973548,17.6339786 14.9326455,17.8335999 L15.4980443,18.313286 L13.1481097,24 L11.7957573,22.0029644 L9,22.3613924 L11.8214468,15.5336444 Z M21.2153847,15.6227746 L24,22.3613924 L21.4544263,21.8892146 L19.8518903,24 L17.5222248,18.3623362 L18.1558369,17.8054715 C18.3876078,17.6017742 18.6788317,17.478157 18.986361,17.452935 L19.872858,17.3802289 C20.5826867,17.3220122 21.1425686,16.7522722 21.1883881,16.0415357 L21.2153847,15.6227746 Z M14.6970714,16.3092088 L14.0313482,16.2662911 C13.4982958,16.2319264 13.0709908,15.812015 13.0273284,15.2796435 L12.9727988,14.6147707 C12.9538822,14.3841238 12.8611693,14.1657059 12.7083964,13.9918776 L12.2680063,13.4907929 C11.9153808,13.0895684 11.9101528,12.490496 12.2557222,12.0831784 L12.6873001,11.5744841 C12.8370161,11.3980161 12.9259029,11.1780134 12.9407912,10.9470714 L12.9837089,10.2813482 C13.0180736,9.74829581 13.437985,9.32099085 13.9703565,9.27732836 L14.6352293,9.22279877 C14.8658762,9.20388225 15.0842941,9.11116934 15.2581224,8.95839635 L15.7592071,8.51800631 C16.1604316,8.16538082 16.759504,8.1601528 17.1668216,8.50572225 L17.6755159,8.93730008 C17.8519839,9.08701608 18.0719866,9.17590295 18.3029286,9.19079125 L18.9686518,9.2337089 C19.5017042,9.26807357 19.9290092,9.68798499 19.9726716,10.2203565 L20.0272012,10.8852293 C20.0461178,11.1158762 20.1388307,11.3342941 20.2916036,11.5081224 L20.7319937,12.0092071 C21.0846192,12.4104316 21.0898472,13.009504 20.7442778,13.4168216 L20.3126999,13.9255159 C20.1629839,14.1019839 20.0740971,14.3219866 20.0592088,14.5529286 L20.0162911,15.2186518 C19.9819264,15.7517042 19.562015,16.1790092 19.0296435,16.2226716 L18.3647707,16.2772012 C18.1341238,16.2961178 17.9157059,16.3888307 17.7418776,16.5416036 L17.2407929,16.9819937 C16.8395684,17.3346192 16.240496,17.3398472 15.8331784,16.9942778 L15.3244841,16.5626999 C15.1480161,16.4129839 14.9280134,16.3240971 14.6970714,16.3092088 Z M16.5,15 C17.7426407,15 18.75,13.9926407 18.75,12.75 C18.75,11.5073593 17.7426407,10.5 16.5,10.5 C15.2573593,10.5 14.25,11.5073593 14.25,12.75 C14.25,13.9926407 15.2573593,15 16.5,15 Z M3.82505731,8.34 C3.36939074,8.34 3,8.67578644 3,9.09 C3,9.50421356 3.36939074,9.84 3.82505731,9.84 L8.92494269,9.84 C9.38060926,9.84 9.75,9.50421356 9.75,9.09 C9.75,8.67578644 9.38060926,8.34 8.92494269,8.34 L3.82505731,8.34 Z M3.82505731,4.59 C3.36939074,4.59 3,4.92578644 3,5.34 C3,5.75421356 3.36939074,6.09 3.82505731,6.09 L14.9249427,6.09 C15.3806093,6.09 15.75,5.75421356 15.75,5.34 C15.75,4.92578644 15.3806093,4.59 14.9249427,4.59 L3.82505731,4.59 Z',
            id: pathId
          };
          break;

        case 'class':
        case 'notebook':
          // temp alias
          path = {
            d: 'M3,20.25 L4.00208688,20.25 C5.10173938,20.25 6,19.3545822 6,18.2500283 L6,17.7499717 C6,16.6390552 5.10550383,15.75 4.00208688,15.75 L3,15.75 L3,14.25 L4.00208688,14.25 C5.10173938,14.25 6,13.3545822 6,12.2500283 L6,11.7499717 C6,10.6390552 5.10550383,9.75 4.00208688,9.75 L3,9.75 L3,8.25 L4.00208688,8.25 C5.10173938,8.25 6,7.35458219 6,6.25002835 L6,5.74997165 C6,4.63905519 5.10550383,3.75 4.00208688,3.75 L3,3.75 L3,2.00494659 C3,0.897645164 3.90234375,-1.84831745e-22 4.99456145,1.56701153e-22 L22.0054385,5.47594672e-21 C23.1070044,5.82040277e-21 24,0.897026226 24,2.00494659 L24,21.9950534 C24,23.1023548 23.0976563,24 22.0054385,24 L4.99456145,24 C3.89299558,24 3,23.1029738 3,21.9950534 L3,20.25 Z M0,6 C0,5.58578644 0.338231385,5.25 0.743083477,5.25 L3.75691652,5.25 C4.1673102,5.25 4.5,5.58289862 4.5,6 C4.5,6.41421356 4.16176862,6.75 3.75691652,6.75 L0.743083477,6.75 C0.332689805,6.75 0,6.41710138 0,6 Z M0,12 C0,11.5857864 0.338231385,11.25 0.743083477,11.25 L3.75691652,11.25 C4.1673102,11.25 4.5,11.5828986 4.5,12 C4.5,12.4142136 4.16176862,12.75 3.75691652,12.75 L0.743083477,12.75 C0.332689805,12.75 0,12.4171014 0,12 Z M0,18 C0,17.5857864 0.338231385,17.25 0.743083477,17.25 L3.75691652,17.25 C4.1673102,17.25 4.5,17.5828986 4.5,18 C4.5,18.4142136 4.16176862,18.75 3.75691652,18.75 L0.743083477,18.75 C0.332689805,18.75 0,18.4171014 0,18 Z M14.3033009,6.75 L9,12.0533009 L14.3033009,17.3566017 L19.6066017,12.0533009 L14.3033009,6.75 Z M14.3033009,8.625 L17.7316017,12.0533009 L14.3033009,15.4816017 L10.875,12.0533009 L14.3033009,8.625 Z',
            id: pathId
          };
          break;

        case 'class-101':
          path = {
            d: 'M16.5535439,17.625 L11.8679005,13.0606602 C11.266546,12.4748737 11.266546,11.5251263 11.8679005,10.9393398 L16.5535439,6.375 L12.3189164,2.25 L2.30979682,12 L12.3189164,21.75 L16.5535439,17.625 Z M23.5489841,13.0606602 L12.3189164,24 L0,12 L12.3189164,0 L23.5489841,10.9393398 C24.1503386,11.5251263 24.1503386,12.4748737 23.5489841,13.0606602 Z',
            id: pathId
          };
          break;

        case 'class-201':
          path = {
            d: 'M17.625,7.4464561 L13.0606602,12.1320995 C12.4748737,12.733454 11.5251263,12.733454 10.9393398,12.1320995 L6.375,7.4464561 L2.25,11.6810836 L12,21.6902032 L21.75,11.6810836 L17.625,7.4464561 Z M13.0606602,0.451015884 L24,11.6810836 L12,24 L0,11.6810836 L10.9393398,0.451015884 C11.5251263,-0.150338628 12.4748737,-0.150338628 13.0606602,0.451015884 Z',
            id: pathId
          };
          break;

        case 'class-301':
          path = {
            d: 'M17.625,7.4464561 L13.0606602,12.1320995 C12.4748737,12.733454 11.5251263,12.733454 10.9393398,12.1320995 L6.375,7.4464561 L2.25,11.6810836 L12,21.6902032 L21.75,11.6810836 L17.625,7.4464561 Z M13.0606602,0.451015884 L24,11.6810836 L12,24 L0,11.6810836 L10.9393398,0.451015884 C11.5251263,-0.150338628 12.4748737,-0.150338628 13.0606602,0.451015884 Z',
            id: pathId
          };
          break;

        case 'class-401':
          path = {
            d: 'M6.375,16.5535439 L10.9393398,11.8679005 C11.5251263,11.266546 12.4748737,11.266546 13.0606602,11.8679005 L17.625,16.5535439 L21.75,12.3189164 L12,2.30979682 L2.25,12.3189164 L6.375,16.5535439 Z M10.9393398,23.5489841 L0,12.3189164 L12,0 L24,12.3189164 L13.0606602,23.5489841 C12.4748737,24.1503386 11.5251263,24.1503386 10.9393398,23.5489841 Z',
            id: pathId
          };
          break;

        case 'class-taken':
          path = {
            d: 'M12,13.5819059 L17.5366705,19.1185764 L13.1185764,23.5366705 C12.5008037,24.1544432 11.4991963,24.1544432 10.8814236,23.5366705 L6.4633295,19.1185764 L12,13.5819059 Z M19.1185764,6.4633295 L23.5366705,10.8814236 C24.1544432,11.4991963 24.1544432,12.5008037 23.5366705,13.1185764 L19.1185764,17.5366705 L13.5819059,12 L19.1185764,6.4633295 Z M4.88142364,6.4633295 L10.4180941,12 L4.88142364,17.5366705 L0.463329498,13.1185764 C-0.154443166,12.5008037 -0.154443166,11.4991963 0.463329498,10.8814236 L4.88142364,6.4633295 Z M13.1185764,0.463329498 L17.5366705,4.88142364 L12,10.4180941 L6.4633295,4.88142364 L10.8814236,0.463329498 C11.4991963,-0.154443166 12.5008037,-0.154443166 13.1185764,0.463329498 Z',
            id: pathId
          };
          break;

        case 'not-equal-to':
        case 'not-equal-circle':
          // alias
          path = {
            d: 'M2.76280604,4.33959537 C2.83602374,4.52194215 2.94649623,4.69281657 3.0942235,4.84054384 L5.97135235,7.71767269 C5.53884689,7.9808591 5.25,8.45669765 5.25,9 C5.25,9.82842712 5.92157288,10.5 6.75,10.5 L8.75367966,10.5 L11.7536797,13.5 L6.75,13.5 C5.92157288,13.5 5.25,14.1715729 5.25,15 C5.25,15.8284271 5.92157288,16.5 6.75,16.5 L14.7536797,16.5 L19.5344562,21.2807765 C19.5454777,21.291798 19.5566281,21.3026122 19.5679024,21.313219 C17.5032085,22.9930313 14.8691993,24 12,24 C5.372583,24 0,18.627417 0,12 C0,9.0877737 1.0373965,6.41784434 2.76280604,4.33959537 Z M4.77857776,2.41524935 C6.7878205,0.899040983 9.28891911,0 12,0 C18.627417,0 24,5.372583 24,12 C24,14.676975 23.1234369,17.1492177 21.6416796,19.1453593 L18.4266887,15.9303683 C18.6291289,15.6746778 18.75,15.3514544 18.75,15 C18.75,14.1715729 18.0784271,13.5 17.25,13.5 L15.9963203,13.5 L12.9963203,10.5 L17.25,10.5 C18.0784271,10.5 18.75,9.82842712 18.75,9 C18.75,8.17157288 18.0784271,7.5 17.25,7.5 L9.99632034,7.5 L5.21554384,2.7192235 C5.0852292,2.58890885 4.93690252,2.48758414 4.77857776,2.41524935 Z',
            id: pathId
          };
          break;

        case 'date':
        case 'calendar':
          // alias
          path = {
            d: 'M21,3 L21.9950534,3 C23.1023548,3 24,3.90234375 24,4.99456145 L24,22.0054385 C24,23.1070044 23.1029738,24 21.9950534,24 L2.00494659,24 C0.897645164,24 0,23.0976562 0,22.0054385 L0,4.99456145 C0,3.89299558 0.897026226,3 2.00494659,3 L3,3 L3,5.49013764 C3,6.61019951 3.89449617,7.5 4.99791312,7.5 L7.00208688,7.5 C8.10173938,7.5 9,6.60015397 9,5.49013764 L9,3 L15,3 L15,5.49013764 C15,6.61019951 15.8944962,7.5 16.9979131,7.5 L19.0020869,7.5 C20.1017394,7.5 21,6.60015397 21,5.49013764 L21,3 Z M4.5,0.990777969 C4.5,0.443586406 4.94266033,0 5.49895656,0 L6.50104344,0 C7.05275191,0 7.5,0.45097518 7.5,0.990777969 L7.5,5.00922203 C7.5,5.55641359 7.05733967,6 6.50104344,6 L5.49895656,6 C4.94724809,6 4.5,5.54902482 4.5,5.00922203 L4.5,0.990777969 Z M16.5,0.990777969 C16.5,0.443586406 16.9426603,0 17.4989566,0 L18.5010434,0 C19.0527519,0 19.5,0.45097518 19.5,0.990777969 L19.5,5.00922203 C19.5,5.55641359 19.0573397,6 18.5010434,6 L17.4989566,6 C16.9472481,6 16.5,5.54902482 16.5,5.00922203 L16.5,0.990777969 Z',
            id: pathId
          };
          break;

        case 'attachment':
        case 'paperclip':
          // alias
          path = {
            d: 'M3.87887844,20.4100007 C-0.828121557,16.0349419 0.653878443,8.95776541 5.31437844,4.55588306 L8.07587844,2.174236 C11.6218784,-1.12223459 16.8337478,-0.298116944 19.4188784,2.174236 C21.3337478,3.93717717 21.4648784,9.40529482 17.9188784,12.7003536 L15.1543784,15.0820007 C12.7783784,17.2081184 11.360758,18.9426313 8.15987844,16.430236 C4.83374783,13.8195301 6.33374783,10.9960007 9.59987844,8.53988306 L13.2163784,5.32247129 L15.3568784,7.31447129 L11.7343784,10.5248242 C10.5523784,11.6231772 7.83374783,13.8195301 10.2343784,14.5060007 C10.8337478,15.2312948 11.8333784,14.1925889 13.0153784,13.094236 L15.7783784,10.7140007 C15.7963784,10.6900007 15.8233784,10.6730595 15.8458784,10.6532948 C18.2098784,8.45376541 19,5.64705882 16.8337478,3.93717717 C14.8216172,2.35705953 12.6493784,1.90741247 10.2838784,4.10553012 C10.2613784,4.12670659 10.2448784,4.14929482 10.2223784,4.17188306 L7.45487844,6.54788306 C3.90737844,9.84294188 2.40737844,15.1878831 5.95487844,18.4871772 C9.50087844,21.7836478 13.7503784,20.3732948 17.2978784,17.0754125 L20.8230839,12.9869707 L22.8068293,14.9618388 L19.4368784,19.0660007 C14.6983784,23.3916478 8.58587844,24.7836478 3.87887844,20.4100007 Z',
            id: pathId
          };
          break;

        case 'send':
        case 'paper-plane':
          // alias
          path = {
            d: 'M19.8740221,22 L13.0951145,17.6975218 C13.0951145,17.6975218 11.0956207,19.6536574 10.0804179,20.6138683 C9.8545085,20.866716 9.50784373,20.9756096 9.17751184,20.8974872 C8.84717994,20.8193648 8.58637461,20.5668066 8.49823101,20.2396863 L6.31489438,13.6594411 L-6.21683924e-16,10.996824 L24,2 L19.8740221,22 Z M7.97029305,12.7617291 L9.32959093,16.2040407 L10.0852987,14.9305234 L23.4976886,2.51839673 L7.97029305,12.7617291 Z',
            id: pathId
          };
          break;

        case 'person-record':
          path = {
            d: 'M0,5.55172414 L22,5.55172414 C23.1045695,5.55172414 24,6.44715464 24,7.55172414 L24,21 C24,22.1045695 23.1045695,23 22,23 L2,23 C0.8954305,23 1.11632554e-15,22.1045695 0,21 L0,5.55172414 Z M7.71720621,18.4482759 L15.5335047,18.4482759 C15.9068435,17.8231571 15.7581815,16.5716155 15.3848427,16.1546088 C15.2109226,15.9605794 14.4825306,15.8517857 14.4825306,15.8517857 C13.4035914,15.5942877 12.9542198,14.6155714 13.4754976,13.64197 C13.4754976,13.64197 13.6875,13.7196902 13.6875,12.7112069 C13.6875,11.2408607 13.3976378,10.1034483 11.625,10.1034483 C9.85260275,10.1034483 9.5625,11.2408607 9.5625,12.7112069 C9.5625,13.7228197 9.77529462,13.644234 9.77529462,13.644234 C10.2507895,14.6389198 9.85719352,15.6056402 8.78956368,15.8472382 C8.78956368,15.8472382 8.04892931,15.9558852 7.86971704,16.1546088 C7.49349157,16.5716155 7.34098073,17.8231571 7.71720621,18.4482759 Z M2,1 L8.63667643,1 C9.05577806,1 9.46429028,1.13165809 9.80452099,1.37638087 L13.5,4.03448276 L-8.34887715e-14,4.03448276 L-9.08162434e-14,3 C-9.09515142e-14,1.8954305 0.8954305,1 2,1 Z',
            id: pathId
          };
          break;

        case 'phone':
          path = {
            d: 'M24,4.69184873 C24,4.2959 23.8801648,3.87595439 23.6255149,3.51150158 C23.6007989,3.47625615 21.0865061,-0.0460377189 19.6305081,0.00045626014 C15.540382,0.13018946 10.7327425,4.09492603 7.42004743,7.39749835 C4.10735239,10.7000707 0.131069779,15.4956996 0,19.5909193 L0,19.6246649 C0,21.0584793 3.48645612,23.5796528 3.52090875,23.6036497 C4.46910498,24.2658139 5.51167145,24.0243452 5.9348396,23.4221732 C6.19398327,23.0554707 8.86555986,19.0472397 9.16739483,18.5560533 C9.29846461,18.3408312 9.36287605,18.0813648 9.36287605,17.7964017 C9.36287605,17.4304491 9.25577331,17.0255015 9.04681064,16.628053 C8.84309075,16.241853 8.1765073,15.0735043 7.84845837,14.5028282 C8.20347023,13.9996434 9.11197104,12.8155467 10.9828985,10.952038 C12.8395956,9.099028 14.0357009,8.18414648 14.5442517,7.82794261 C15.1172138,8.15490027 16.2886032,8.81781442 16.6750718,9.0202882 C17.4023218,9.40198877 18.1273249,9.44623304 18.6179004,9.13577324 C19.079266,8.84406102 23.0690301,6.1894048 23.448009,5.91569024 C23.8075147,5.65622384 24,5.19428366 24,4.69184873 L24,4.69184873 L24,4.69184873 Z',
            id: pathId
          };
          break;

        case 'phone-cell':
          path = {
            d: 'M7.1,0h9.8a1.5,1.5,0,0,1,1.5,1.5v21A1.5,1.5,0,0,1,16.9,24H7.1a1.5,1.5,0,0,1-1.5-1.5V1.5A1.5,1.5,0,0,1,7.1,0ZM9.8,1.5a.4.4,0,0,0-.4.4c0,.2.1.3.4.3h4.4c.3,0,.4-.1.4-.3a.4.4,0,0,0-.4-.4ZM12,21a1.1,1.1,0,1,0,1.1,1.1A1.1,1.1,0,0,0,12,21ZM7.9,3.8a.8.8,0,0,0-.8.7v15a.8.8,0,0,0,.8.7h8.2a.8.8,0,0,0,.8-.7V4.5a.8.8,0,0,0-.8-.7Z',
            id: pathId
          };
          break;

        case 'phone-home':
          path = {
            d: 'M15.75,8.25 L17.6025039,8.25 C18.4288969,8.25 19.3111294,8.88692567 19.5739828,9.67548596 L23.8736588,22.574514 C24.1360836,23.3617882 23.6818745,24 22.8475133,24 L1.85012831,24 C1.02097908,24 0.561129378,23.3630743 0.823982811,22.574514 L5.12365883,9.67548596 C5.38608355,8.88821181 6.26828792,8.25 7.09513779,8.25 L8.25,8.25 L8.25,6.74308348 C8.25,6.3326898 8.74934793,6 9.375,6 C9.99632034,6 10.5,6.33823138 10.5,6.74308348 L10.5,8.25 L13.5,8.25 L13.5,6.74308348 C13.5,6.3326898 13.9993479,6 14.625,6 C15.2463203,6 15.75,6.33823138 15.75,6.74308348 L15.75,8.25 Z M12,19.5 C14.0710678,19.5 15.75,17.8210678 15.75,15.75 C15.75,13.6789322 14.0710678,12 12,12 C9.92893219,12 8.25,13.6789322 8.25,15.75 C8.25,17.8210678 9.92893219,19.5 12,19.5 Z M23.3266596,7.85779186 C23.0315789,8.14234691 22.6472339,8.29495321 22.2837108,8.23829576 C21.9003831,8.17867908 17.9981063,7.42253803 17.5558227,7.32645449 C17.0853737,7.22444561 16.6855631,6.78878079 16.4826215,6.16072436 C16.3745611,5.82717564 16.0759329,4.78831413 15.9314541,4.2786427 C15.4235826,4.19236074 14.1837973,4.03308905 12.0050814,4.03100091 C9.81184218,4.02679926 8.58285694,4.18288353 8.0788369,4.2668016 C7.93634164,4.77579634 7.64165425,5.8150139 7.53448345,6.14911622 C7.42378546,6.49255844 7.2488608,6.78255916 7.03393636,6.98981717 C6.86657716,7.1512066 6.67636328,7.26167637 6.47298559,7.30933623 C6.0072431,7.41657579 2.08418338,8.1735927 1.71662309,8.23450886 C1.11443947,8.33588807 0.360323912,7.88218474 0.192336955,6.9701538 C0.186196288,6.9370508 -0.380715457,3.53461754 0.461365575,2.72257388 C2.96328977,0.458357625 8.11504494,-0.00568085052 12.0002001,5.21753737e-05 C15.8853553,0.00578520126 21.0373833,0.483164987 23.5157122,2.72614155 C24.3981277,3.52441702 23.8061274,6.94325018 23.7999434,6.97720947 C23.735456,7.32783952 23.5592008,7.63354549 23.3266596,7.85779186 Z',
            id: pathId
          };
          break;

        case 'phone-work':
          path = {
            d: 'M8.25,0.75 L21,0.75 C22.6568542,0.75 24,2.09314575 24,3.75 L24,20.25 C24,21.9068542 22.6568542,23.25 21,23.25 L8.25,23.25 L8.25,0.75 Z M0,21.75 L0,2.25 L0,21.75 Z M13.5,3 C12.6715729,3 12,3.67157288 12,4.5 L12,7.5 C12,8.32842712 12.6715729,9 13.5,9 L18.75,9 C19.5784271,9 20.25,8.32842712 20.25,7.5 L20.25,4.5 C20.25,3.67157288 19.5784271,3 18.75,3 L13.5,3 Z M12.75,12 C12.3357864,12 12,12.3357864 12,12.75 L12,13.5 C12,13.9142136 12.3357864,14.25 12.75,14.25 L13.5,14.25 C13.9142136,14.25 14.25,13.9142136 14.25,13.5 L14.25,12.75 C14.25,12.3357864 13.9142136,12 13.5,12 L12.75,12 Z M15.75,12 C15.3357864,12 15,12.3357864 15,12.75 L15,13.5 C15,13.9142136 15.3357864,14.25 15.75,14.25 L16.5,14.25 C16.9142136,14.25 17.25,13.9142136 17.25,13.5 L17.25,12.75 C17.25,12.3357864 16.9142136,12 16.5,12 L15.75,12 Z M18.75,12 C18.3357864,12 18,12.3357864 18,12.75 L18,13.5 C18,13.9142136 18.3357864,14.25 18.75,14.25 L19.5,14.25 C19.9142136,14.25 20.25,13.9142136 20.25,13.5 L20.25,12.75 C20.25,12.3357864 19.9142136,12 19.5,12 L18.75,12 Z M12.75,15 C12.3357864,15 12,15.3357864 12,15.75 L12,16.5 C12,16.9142136 12.3357864,17.25 12.75,17.25 L13.5,17.25 C13.9142136,17.25 14.25,16.9142136 14.25,16.5 L14.25,15.75 C14.25,15.3357864 13.9142136,15 13.5,15 L12.75,15 Z M15.75,15 C15.3357864,15 15,15.3357864 15,15.75 L15,16.5 C15,16.9142136 15.3357864,17.25 15.75,17.25 L16.5,17.25 C16.9142136,17.25 17.25,16.9142136 17.25,16.5 L17.25,15.75 C17.25,15.3357864 16.9142136,15 16.5,15 L15.75,15 Z M18.75,15 C18.3357864,15 18,15.3357864 18,15.75 L18,16.5 C18,16.9142136 18.3357864,17.25 18.75,17.25 L19.5,17.25 C19.9142136,17.25 20.25,16.9142136 20.25,16.5 L20.25,15.75 C20.25,15.3357864 19.9142136,15 19.5,15 L18.75,15 Z M12.75,18 C12.3357864,18 12,18.3357864 12,18.75 L12,19.5 C12,19.9142136 12.3357864,20.25 12.75,20.25 L13.5,20.25 C13.9142136,20.25 14.25,19.9142136 14.25,19.5 L14.25,18.75 C14.25,18.3357864 13.9142136,18 13.5,18 L12.75,18 Z M15.75,18 C15.3357864,18 15,18.3357864 15,18.75 L15,19.5 C15,19.9142136 15.3357864,20.25 15.75,20.25 L16.5,20.25 C16.9142136,20.25 17.25,19.9142136 17.25,19.5 L17.25,18.75 C17.25,18.3357864 16.9142136,18 16.5,18 L15.75,18 Z M18.75,18 C18.3357864,18 18,18.3357864 18,18.75 L18,19.5 C18,19.9142136 18.3357864,20.25 18.75,20.25 L19.5,20.25 C19.9142136,20.25 20.25,19.9142136 20.25,19.5 L20.25,18.75 C20.25,18.3357864 19.9142136,18 19.5,18 L18.75,18 Z M1.5,0 L5.25,0 C6.07842712,0 6.75,0.671572875 6.75,1.5 L6.75,22.5 C6.75,23.3284271 6.07842712,24 5.25,24 L1.5,24 C0.671572875,24 0,23.3284271 0,22.5 L0,1.5 C0,0.671572875 0.671572875,0 1.5,0 Z',
            id: pathId
          };
          break;

        case 'pin':
          path = {
            d: 'M15.5151908,3.0487672 L14.7337958,2.27438897 C14.2087834,1.75409103 14.2087834,0.910521393 14.7337958,0.390223454 C15.2588082,-0.130074485 16.1100215,-0.130074485 16.635034,0.390223454 L23.6062407,7.29883033 C24.1312531,7.81912827 24.1312531,8.6626979 23.6062407,9.18299584 C23.0812282,9.70329378 22.2300149,9.70329378 21.7050025,9.18299584 L21.1948878,8.67746191 C20.3199207,8.31085821 19.0055795,8.99653992 17.2518645,10.734507 C15.9213488,12.053075 15.255522,13.131256 15.2543841,13.9690501 L15.2560676,13.9707185 C16.6561007,15.3581797 16.6561007,17.6076987 15.2560676,18.9951599 L14.6223215,19.623215 L4.48126139,9.5732193 L5.11500746,8.94516413 C6.5150406,7.55770295 8.78494282,7.55770295 10.184976,8.94516413 L10.1855239,8.94570718 C11.0405253,8.93506635 12.12848,8.27522263 13.4493881,6.96617601 C15.2027974,5.22851195 15.8913982,3.92270902 15.5151908,3.0487672 Z M8.23869883,13.3230621 L10.7736831,15.8352828 L0,24 L8.23869883,13.3230621 Z',
            id: pathId
          };
          break;

        case 'leadership':
        case 'shape-abilities': // alias

        case 'placeholder': // alias

        case 'circle-filled':
          // alias
          circle = {
            id: circleId,
            cx: '12',
            cy: '12',
            r: '12'
          };
          break;

        case 'plus-circle':
          path = {
            d: 'M12,24 C18.627417,24 24,18.627417 24,12 C24,5.372583 18.627417,0 12,0 C5.372583,0 0,5.372583 0,12 C0,18.627417 5.372583,24 12,24 Z M13.5,10.5 L17.25,10.5 C18.0784271,10.5 18.75,11.1715729 18.75,12 C18.75,12.8284271 18.0784271,13.5 17.25,13.5 L13.5,13.5 L13.5,17.25 C13.5,18.0784271 12.8284271,18.75 12,18.75 C11.1715729,18.75 10.5,18.0784271 10.5,17.25 L10.5,13.5 L6.75,13.5 C5.92157288,13.5 5.25,12.8284271 5.25,12 C5.25,11.1715729 5.92157288,10.5 6.75,10.5 L10.5,10.5 L10.5,6.75 C10.5,5.92157288 11.1715729,5.25 12,5.25 C12.8284271,5.25 13.5,5.92157288 13.5,6.75 L13.5,10.5 Z',
            id: pathId
          };
          break;

        case 'on':
        case 'power-square':
          // alias
          path = {
            d: 'M3,0 L21,0 C22.6568542,-3.04359188e-16 24,1.34314575 24,3 L24,21 C24,22.6568542 22.6568542,24 21,24 L3,24 C1.34314575,24 2.02906125e-16,22.6568542 0,21 L0,3 C-2.02906125e-16,1.34314575 1.34314575,3.04359188e-16 3,0 Z M12,20.25 C8.72231548,20.250165 5.8242847,18.0783939 4.84387965,14.8872359 C3.8634746,11.6960778 5.02787847,8.22500018 7.71914733,6.31608833 C8.13744749,5.93720401 8.77109281,5.9506725 9.17356495,6.3470028 C9.57603708,6.7433331 9.61170691,7.38896583 9.25543856,7.82893533 L9.26380488,7.83934543 C7.16225762,9.09724982 6.14474629,11.6337854 6.77882647,14.0341031 C7.41290665,16.4344207 9.54195741,18.1056303 11.9784199,18.1155511 C14.4148823,18.1254719 16.5569382,16.4716535 17.2097745,14.0765759 C17.8626109,11.6814983 16.8649739,9.13675743 14.7733334,7.86177918 C14.3909299,7.43120082 14.4060681,6.77046125 14.807773,6.35858483 C15.2094779,5.94670842 15.8569804,5.92802878 16.2808527,6.31608833 C18.9721215,8.22500018 20.1365254,11.6960778 19.1561204,14.8872359 C18.1757153,18.0783939 15.2776845,20.250165 12,20.25 Z M12.0255071,10.7247634 C11.4197588,10.7247634 10.9287028,10.2237319 10.9287028,9.60567823 L10.9287028,4.86908517 C10.9287028,4.2510315 11.4197588,3.75 12.0255071,3.75 C12.6312554,3.75 13.1223114,4.2510315 13.1223114,4.86908517 L13.1223114,9.60567823 C13.1223114,10.2237319 12.6312554,10.7247634 12.0255071,10.7247634 Z',
            id: pathId
          };
          break;

        case 'off':
        case 'power-off-square':
          // alias
          path = {
            d: 'M3,0 L21,0 C22.6568542,-3.04359188e-16 24,1.34314575 24,3 L24,21 C24,22.6568542 22.6568542,24 21,24 L3,24 C1.34314575,24 2.02906125e-16,22.6568542 0,21 L0,3 C-2.02906125e-16,1.34314575 1.34314575,3.04359188e-16 3,0 Z M12,20.25 C7.44365081,20.25 3.75,16.5563492 3.75,12 C3.75,7.44365081 7.44365081,3.75 12,3.75 C16.5563492,3.75 20.25,7.44365081 20.25,12 C20.25,16.5563492 16.5563492,20.25 12,20.25 Z M12,18.1875 C15.4172619,18.1875 18.1875,15.4172619 18.1875,12 C18.1875,8.58273811 15.4172619,5.8125 12,5.8125 C8.58273811,5.8125 5.8125,8.58273811 5.8125,12 C5.8125,15.4172619 8.58273811,18.1875 12,18.1875 Z M12.0998294,15.3653884 C11.4751515,15.3653884 10.96875,14.8643569 10.96875,14.2463032 L10.96875,9.50971017 C10.96875,8.8916565 11.4751515,8.390625 12.0998294,8.390625 C12.7245073,8.390625 13.2309089,8.8916565 13.2309089,9.50971017 L13.2309089,14.2463032 C13.2309089,14.8643569 12.7245073,15.3653884 12.0998294,15.3653884 Z',
            id: pathId
          };
          break;

        case 'pulpit':
        case 'preferred-service':
          // temp alias
          path = {
            d: 'M14.75,13.5 C15.3022847,13.5 15.75,13.9477153 15.75,14.5 L15.75,23 C15.75,23.5522847 15.3022847,24 14.75,24 L9.25,24 C8.69771525,24 8.25,23.5522847 8.25,23 L8.25,14.5 C8.25,13.9477153 8.69771525,13.5 9.25,13.5 L14.75,13.5 Z M15.773708,0.375125231 L16.9991889,2.4977205 C17.1939099,2.83498713 17.0969096,3.26062707 16.7864781,3.48245795 L19.106,7.5 L22.4000278,7.5 C23.2836681,7.5 24,8.17157288 24,9 C24,9.19803903 23.9581706,9.39411782 23.8769252,9.57692308 L21.2103049,15.5769231 C20.961878,16.1358935 20.3793177,16.5 19.7334075,16.5 L17.099,16.5 L17.0997951,14 C17.0997951,12.9456382 16.2839173,12.0818349 15.2490575,12.0054857 L15.0997951,12 L8.75,12 C7.6454305,12 6.75,12.8954305 6.75,14 L6.75,14 L6.75,16.5 L4.26700985,16.5 C3.62109972,16.5 3.03853943,16.1358935 2.79011246,15.5769231 L0.123492169,9.57692308 C-0.216369458,8.81222112 0.169347741,7.93401043 0.985015648,7.61538462 C1.18000453,7.53921576 1.38915161,7.5 1.60038956,7.5 L18.24,7.5 L16.139,3.86 L16.0751508,3.89723955 C15.7164314,4.10434633 15.2577386,3.98143996 15.0506318,3.6227205 L13.8251508,1.50012523 C13.6180441,1.14140576 13.7409504,0.68271296 14.0996699,0.475606179 L14.7491889,0.100606179 C15.1079084,-0.106500603 15.5666012,0.0164057638 15.773708,0.375125231 Z',
            id: pathId
          };
          break;

        case 'unknown':
        case 'question':
          // alias
          path = {
            d: 'M12,24.0004395 C13.5294039,24.0004395 14.7692308,22.6571954 14.7692308,21.0002197 C14.7692308,19.3432441 13.5294039,18 12,18 C10.4705961,18 9.23076923,19.3432441 9.23076923,21.0002197 C9.23076923,22.6571954 10.4705961,24.0004395 12,24.0004395 Z M12,8.72791198 C12,8.72791198 14,8.72791198 14,6.54593399 C14,4.36395599 12,4.36395599 12,4.36395599 C10.125,4.40002441 10.125,5.5 10,6 L6,6 C6.00363041,6 6.50748065,0 12,0 C18,0 18,6.54593399 18,6.54593399 C18,6.54593399 18,11.5414166 14,12.8044697 L14,16 L10,16 L10,10.90989 C10,9.7048168 10.8954305,8.72791198 12,8.72791198 Z',
            id: pathId
          };
          break;

        case 'help':
        case 'question-circle':
          // alias
          path = {
            d: 'M12,24 C18.627417,24 24,18.627417 24,12 C24,5.372583 18.627417,0 12,0 C5.372583,0 0,5.372583 0,12 C0,18.627417 5.372583,24 12,24 Z M11.8213258,19.8675475 C12.6706503,19.8675475 13.3591638,19.1789835 13.3591638,18.3295968 C13.3591638,17.4802101 12.6706503,16.7916461 11.8213258,16.7916461 C10.9720013,16.7916461 10.2834878,17.4802101 10.2834878,18.3295968 C10.2834878,19.1789835 10.9720013,19.8675475 11.8213258,19.8675475 Z M12.0095874,10.331555 C12.0095874,10.331555 13.3461165,10.331555 13.3461165,8.96455012 C13.3461165,7.59754521 12.0095874,7.59754521 12.0095874,7.59754521 C10.7565913,7.62014201 10.7565913,8.30927454 10.6730583,8.62252356 L8,8.62252356 C8.00242608,8.62252356 8.33913134,4.86353538 12.0095874,4.86353538 C16.0191748,4.86353538 16.0191748,8.96455012 16.0191748,8.96455012 C16.0191748,8.96455012 16.0191748,12.0942101 13.3461165,12.8855104 L13.3461165,14.8875039 L10.6730583,14.8875039 L10.6730583,11.69856 C10.6730583,10.943584 11.2714427,10.331555 12.0095874,10.331555 Z',
            id: pathId
          };
          break;

        case 'keywords':
        case 'quotation':
          // alias
          path = {
            d: 'M3.80769231,12.7142857 L0.692307692,12.7142857 C0.309956712,12.7142857 0,12.4158089 0,12.047619 L0,8.33333333 C0,6.83333333 0.111253739,5.88602864 0.333764554,5.18758085 C0.556275369,4.48913307 0.967655472,3.86252088 1.56791721,3.30772548 C2.16817894,2.75293008 2.93401863,2.31702594 3.86545925,2 L4.5,3.72381995 C3.63065542,4.00121765 3.22639257,4.38758722 2.84864166,4.88294026 C2.47089074,5.3782933 2.25,6.33333333 2.25,8 L3.80769231,8 C4.19004329,8 4.5,8.29847683 4.5,8.66666667 L4.5,12.047619 C4.5,12.4158089 4.19004329,12.7142857 3.80769231,12.7142857 Z M9.80769231,12.7142857 L6.69230769,12.7142857 C6.30995671,12.7142857 6,12.4158089 6,12.047619 L6,8.33333333 C6,6.83333333 6.11125374,5.88602864 6.33376455,5.18758085 C6.55627537,4.48913307 6.96765547,3.86252088 7.56791721,3.30772548 C8.16817894,2.75293008 8.93401863,2.31702594 9.86545925,2 L10.5,3.72381995 C9.63065542,4.00121765 9.22639257,4.38758722 8.84864166,4.88294026 C8.47089074,5.3782933 8.25,6.33333333 8.25,8 L9.80769231,8 C10.1900433,8 10.5,8.29847683 10.5,8.66666667 L10.5,12.047619 C10.5,12.4158089 10.1900433,12.7142857 9.80769231,12.7142857 Z M20.1923077,11.2857143 L23.3076923,11.2857143 C23.6900433,11.2857143 24,11.5841911 24,11.952381 L24,15.6666667 C24,17.1666667 23.8887463,18.1139714 23.6662354,18.8124191 C23.4437246,19.5108669 23.0323445,20.1374791 22.4320828,20.6922745 C21.8318211,21.2470699 21.0659814,21.6829741 20.1345408,22 L19.5,20.2761801 C20.3693446,19.9987824 20.7736074,19.6124128 21.1513583,19.1170597 C21.5291093,18.6217067 21.75,17.6666667 21.75,16 L20.1923077,16 C19.8099567,16 19.5,15.7015232 19.5,15.3333333 L19.5,11.952381 C19.5,11.5841911 19.8099567,11.2857143 20.1923077,11.2857143 Z M14.1923077,11.2857143 L17.3076923,11.2857143 C17.6900433,11.2857143 18,11.5841911 18,11.952381 L18,15.6666667 C18,17.1666667 17.8887463,18.1139714 17.6662354,18.8124191 C17.4437246,19.5108669 17.0323445,20.1374791 16.4320828,20.6922745 C15.8318211,21.2470699 15.0659814,21.6829741 14.1345408,22 L13.5,20.2761801 C14.3693446,19.9987824 14.7736074,19.6124128 15.1513583,19.1170597 C15.5291093,18.6217067 15.75,17.6666667 15.75,16 L14.1923077,16 C13.8099567,16 13.5,15.7015232 13.5,15.3333333 L13.5,11.952381 C13.5,11.5841911 13.8099567,11.2857143 14.1923077,11.2857143 Z',
            id: pathId
          };
          break;

        case 'reassigned':
        case 'reassign':
          // alias
          path = {
            d: 'M23.202925,22 C23.1946757,22 23.1871764,22 23.1781772,21.9992314 C22.7979612,21.9869337 22.5594825,21.6948631 22.5264855,21.3197829 C22.5017377,21.0446216 21.7308066,14.3700394 11.2257461,14.3769568 L11.2257461,18.6450309 C11.2257461,18.9332585 11.058511,19.1953535 10.7960345,19.3175619 C10.5350578,19.4413077 10.2230857,19.4028773 9.99960573,19.2199489 L0.274475454,11.2310488 C0.100491013,11.0888566 0,10.8782583 0,10.6545937 C0.000749932933,10.4316977 0.101990879,10.2210994 0.275975319,10.0796757 L10.0018555,2.16609915 C10.2260855,1.98547653 10.5350578,1.949352 10.7967844,2.0715605 C11.059261,2.19530621 11.2257461,2.45586395 11.2257461,2.74255432 L11.2257461,6.91685835 C15.5836064,7.05443898 18.9823024,8.44331164 21.1706067,10.9827888 C24.7312883,15.1140509 23.9363594,21.1176393 23.8988627,21.3674365 C23.8426177,21.7317562 23.5733918,22 23.202925,22 L23.202925,22 Z',
            id: pathId
          };
          break;

        case 'recurring':
          path = {
            d: 'M20.25,15.75 L20.25,7.5 L16.5,7.5 L16.5,11.25 L10.5,5.625 L16.5,0 L16.5,3.75 L20.25,3.75 L22.125,3.75 C23.1605339,3.75 24,4.59678841 24,5.61858103 L24,17.631419 C24,18.6634078 23.1677535,19.5 22.125,19.5 L20.25,19.5 L16.5,19.5 L16.5,15.75 L20.25,15.75 Z M3.75,7.5 L3.75,16.5 L7.5,16.5 L7.5,12.75 L13.5,18.375 L7.5,24 L7.5,20.25 L3.75,20.25 L1.875,20.25 C0.839466094,20.25 0,19.4090783 0,18.3733045 L0,5.62669548 C0,4.59022519 0.832246542,3.75 1.875,3.75 L3.75,3.75 L7.5,3.75 L7.5,7.5 L3.75,7.5 Z',
            id: pathId
          };
          break;

        case 'recurring-serving-op':
          path = {
            d: 'M3,3 L3,5.49013764 C3,6.61019951 3.89449617,7.5 4.99791312,7.5 L4.99791312,7.5 L7.00208688,7.5 C8.10173938,7.5 9,6.60015397 9,5.49013764 L9,5.49013764 L9,3 L15,3 L15,5.49013764 C15,6.55928761 15.8150265,7.4186333 16.8488065,7.49454665 L16.9979131,7.5 L19.0020869,7.5 C20.1017394,7.5 21,6.60015397 21,5.49013764 L21,5.49013764 L21,3 L21.9950534,3 C23.1023548,3 24,3.90234375 24,4.99456145 L24,22.0054385 C24,23.1070044 23.1029738,24 21.9950534,24 L2.00494659,24 C0.897645164,24 0,23.0976562 0,22.0054385 L0,4.99456145 C0,3.89299558 0.897026226,3 2.00494659,3 L3,3 Z M9.75,10.875 L6.9375,10.875 C6.41612327,10.875 6,11.2987087 6,11.8213799 L6,11.8213799 L6,18.1786201 C6,18.7045391 6.41973305,19.125 6.9375,19.125 L6.9375,19.125 L9.749,19.125 L9.75,21 L12.75,18.1875 L9.75,15.375 L9.749,17.25 L7.875,17.25 L7.875,12.75 L9.75,12.75 L9.75,10.875 Z M17.0625,18.75 C17.5838767,18.75 18,18.3317039 18,17.8157095 L18,17.8157095 L18,11.8092905 C18,11.2983942 17.580267,10.875 17.0625,10.875 L17.0625,10.875 L14.25,10.875 L14.25,9 L11.25,11.8125 L14.25,14.625 L14.25,12.75 L16.125,12.75 L16.125,16.875 L14.25,16.875 L14.25,18.75 Z M6.50104344,0 C7.05275191,0 7.5,0.45097518 7.5,0.990777969 L7.5,5.00922203 C7.5,5.55641359 7.05733967,6 6.50104344,6 L5.49895656,6 C4.94724809,6 4.5,5.54902482 4.5,5.00922203 L4.5,0.990777969 C4.5,0.443586406 4.94266033,0 5.49895656,0 L6.50104344,0 Z M18.5010434,0 C19.0527519,0 19.5,0.45097518 19.5,0.990777969 L19.5,5.00922203 C19.5,5.55641359 19.0573397,6 18.5010434,6 L17.4989566,6 C16.9472481,6 16.5,5.54902482 16.5,5.00922203 L16.5,0.990777969 C16.5,0.443586406 16.9426603,0 17.4989566,0 L18.5010434,0 Z',
            id: pathId
          };
          break;

        case 'refresh':
          path = {
            d: 'M19.8508908,7.33333333 L24,11.9047619 L21.7350724,11.9047619 C21.7362553,11.9681102 21.7368495,12.0316041 21.7368495,12.0952381 C21.7368495,17.565487 17.3461126,22 11.929864,22 C10.0449026,22 8.28414878,21.4629018 6.78945148,20.5319685 L9.33126829,17.5980725 C10.1182667,17.9778448 10.9994791,18.1904762 11.929864,18.1904762 C15.26294,18.1904762 17.964932,15.4615451 17.964932,12.0952381 C17.964932,12.0315129 17.9639637,11.9680161 17.9620412,11.9047619 L15.7017815,11.9047619 L19.8508908,7.33333333 Z M12.070136,2 C13.9550974,2 15.7158512,2.53709821 17.2105485,3.46803154 L14.6687317,6.40192746 C13.8817333,6.02215522 13.0005209,5.80952381 12.070136,5.80952381 C8.73705996,5.80952381 6.03506798,8.53845486 6.03506798,11.9047619 C6.03506798,11.9684871 6.03603626,12.0319839 6.03795876,12.0952381 L8.29821848,12.0952381 L4.14910924,16.6666667 L0,12.0952381 L2.26492759,12.0952381 C2.26374465,12.0318898 2.26315049,11.9683959 2.26315049,11.9047619 C2.26315049,6.43451295 6.65388745,2 12.070136,2 Z',
            id: pathId
          };
          viewBox = '0 0 24 20';
          break;

        case 'reply':
          path = {
            d: 'M23.202925,22 C23.1946757,22 23.1871764,22 23.1781772,21.9992314 C22.7979612,21.9869337 22.5594825,21.6948631 22.5264855,21.3197829 C22.5017377,21.0446216 21.7308066,14.3700394 11.2257461,14.3769568 L11.2257461,18.6450309 C11.2257461,18.9332585 11.058511,19.1953535 10.7960345,19.3175619 C10.5350578,19.4413077 10.2230857,19.4028773 9.99960573,19.2199489 L0.274475454,11.2310488 C0.100491013,11.0888566 0,10.8782583 0,10.6545937 C0.000749932933,10.4316977 0.101990879,10.2210994 0.275975319,10.0796757 L10.0018555,2.16609915 C10.2260855,1.98547653 10.5350578,1.949352 10.7967844,2.0715605 C11.059261,2.19530621 11.2257461,2.45586395 11.2257461,2.74255432 L11.2257461,6.91685835 C15.5836064,7.05443898 18.9823024,8.44331164 21.1706067,10.9827888 C24.7312883,15.1140509 23.9363594,21.1176393 23.8988627,21.3674365 C23.8426177,21.7317562 23.5733918,22 23.202925,22 L23.202925,22 Z',
            id: pathId
          };
          break;

        case 'restricted':
        case 'ban':
          // alias
          path = {
            d: 'M6.97794874,19.4696432 C8.41240463,20.4359688 10.140334,21 12,21 C16.9705627,21 21,16.9705627 21,12 C21,10.140334 20.4359688,8.41240463 19.4696432,6.97794874 L6.97794874,19.4696432 Z M4.80174803,17.4032033 L17.3576801,4.84727118 C17.3730419,4.8319094 17.3887741,4.81714706 17.4048478,4.80298475 C15.8998292,3.67094031 14.0282678,3 12,3 C7.02943725,3 3,7.02943725 3,12 C3,14.0275291 3.67045167,15.8984659 4.80174803,17.4032033 Z M12,24 C5.372583,24 0,18.627417 0,12 C0,5.372583 5.372583,0 12,0 C18.627417,0 24,5.372583 24,12 C24,18.627417 18.627417,24 12,24 Z',
            id: pathId
          };
          break;

        case 'save':
          path = {
            d: 'M18.6665143,0 L20.9849143,0 L24,3.01508571 L24,21.6068571 C23.9996215,22.9283966 22.9283966,23.9996215 21.6068571,24 L2.39314286,24 C1.07144655,24 0,22.9285534 0,21.6068571 L0,2.39314286 C0,1.07144655 1.07144655,0 2.39314286,0 L5.26491429,0 L5.26491429,5.05988571 C5.26491429,6.19260596 6.18316547,7.11085714 7.31588571,7.11085714 L16.6155429,7.11085714 C17.7482631,7.11085714 18.6665143,6.19260596 18.6665143,5.05988571 L18.6665143,0 Z M4.95852924,9.75 C4.29107697,9.75 3.75,10.3095817 3.75,10.9998607 L3.75,19.7501393 C3.75,20.081623 3.87732682,20.3995299 4.10397002,20.6339243 C4.33061322,20.8683186 4.63800736,21 4.95852924,21 L19.0414708,21 C19.3619926,21 19.6693868,20.8683186 19.89603,20.6339243 C20.1226732,20.3995299 20.25,20.081623 20.25,19.7501393 L20.25,10.9998607 C20.25,10.3095817 19.708923,9.75 19.0414708,9.75 L4.95852924,9.75 Z M13.5,0.75 L15.75,0.75 C16.1642136,0.75 16.5,1.08578644 16.5,1.5 L16.5,4.5 C16.5,4.91421356 16.1642136,5.25 15.75,5.25 L13.5,5.25 C13.0857864,5.25 12.75,4.91421356 12.75,4.5 L12.75,1.5 C12.75,1.08578644 13.0857864,0.75 13.5,0.75 Z',
            id: pathId
          };
          break;

        case 'search':
          path = {
            d: 'M24,20.8149885 L20.8149885,24 L14.3793447,17.5643562 C10.2833094,20.0489233 4.976888,19.0826768 2.01954977,15.3137606 C-0.937788463,11.5448443 -0.614152692,6.16088664 2.77336697,2.77336697 C6.16088664,-0.614152692 11.5448443,-0.937788463 15.3137606,2.01954977 C19.0826768,4.976888 20.0489233,10.2833094 17.5643562,14.3793447 L24,20.8149885 Z M9.46418379,3.58551688 C6.2176942,3.58640076 3.58652827,6.21876085 3.58711748,9.46525051 C3.58770669,12.7117402 6.21982796,15.343145 9.46631766,15.3428505 C12.7128074,15.3425559 15.3444511,12.7106735 15.3444512,9.46418379 C15.3444513,7.90478704 14.7248738,6.40928251 13.6220637,5.30677258 C12.5192536,4.20426266 11.0235805,3.58509232 9.46418379,3.58551688 L9.46418379,3.58551688 Z',
            id: pathId
          };
          break;

        case 'security':
        case 'shield':
          // alias
          path = {
            d: 'M0.749819383,2.60427204 C4.82130954,0.765944584 12.0000213,0 12.0000213,0 C12.0000213,0 19.1786696,0.765944584 23.2501597,2.60427204 C23.2501597,2.60427204 28.3395701,11.8978942 12.0000213,24 C-4.33952744,11.8978942 0.749819383,2.60427204 0.749819383,2.60427204 Z M3,4.2 C3,4.2 0.6,11.4 12,21 C23.4,11.4 21,4.2 21,4.2 C16.2,3 11.9999787,2.4 12,2.4 C11.9999787,2.4 9,3 3,4.2 Z M4.8,6 C4.8,6 11.9999787,4.8 12,4.8 C11.9999787,4.8 19.2,6 19.2,6 C19.2,6 18,12 12,18 C6,12 4.8,6 4.8,6 Z',
            id: pathId
          };
          break;

        case 'select':
        case 'hand-select':
          // alias
          path = {
            d: 'M15.6708075,24 L14.6729247,24 C13.0200556,24 11.5429361,23.3626459 10.5654448,22.3622667 C10.5022584,22.318387 8.35494622,19.9639754 4.12350823,15.2990321 C3.57683659,14.6945788 3.70089691,13.8217379 4.40060469,13.3494873 C5.10031247,12.8772367 6.11070263,12.9844081 6.65737426,13.5888613 L9.3437322,16.5591594 L9.3437322,6.61179258 C9.3437322,5.8596953 10.0635513,5.25 10.9514933,5.25 C11.8394352,5.25 12.5592543,5.8596953 12.5592543,6.61179258 L12.5592543,11.9610266 C12.8538542,11.6783114 13.2848801,11.5 13.7650752,11.5 C14.5764705,11.5 15.2474802,12.0091066 15.3571414,12.6707591 C15.6520148,12.3791992 16.089863,12.1944444 16.578657,12.1944444 C17.3900523,12.1944444 18.0610621,12.703551 18.1707233,13.3652035 C18.4655967,13.0736436 18.9034448,12.8888889 19.3922389,12.8888889 C20.2801808,12.8888889 21,13.4985842 21,14.2506815 L21,19.5132074 C20.9615684,22.0114537 18.5903576,24 15.6708075,24 Z M3.75,6.75 L6.16304348,6.75 C6.57725704,6.75 6.91304348,7.08578644 6.91304348,7.5 C6.91304348,7.91421356 6.57725704,8.25 6.16304348,8.25 L3.75,8.25 C3.33578644,8.25 3,7.91421356 3,7.5 C3,7.08578644 3.33578644,6.75 3.75,6.75 Z M11.6086957,0.75 L11.6086957,3 C11.6086957,3.41421356 11.2583098,3.75 10.826087,3.75 C10.3938641,3.75 10.0434783,3.41421356 10.0434783,3 L10.0434783,0.75 C10.0434783,0.335786438 10.3938641,0 10.826087,0 C11.2583098,0 11.6086957,0.335786438 11.6086957,0.75 Z M6.22538114,2.03033009 L7.88554489,3.62132034 C8.19117259,3.91421356 8.19117259,4.3890873 7.88554489,4.68198052 C7.57991718,4.97487373 7.08439676,4.97487373 6.77876905,4.68198052 L5.11860531,3.09099026 C4.8129776,2.79809704 4.8129776,2.3232233 5.11860531,2.03033009 C5.42423301,1.73743687 5.91975343,1.73743687 6.22538114,2.03033009 Z M15.4891304,6.75 L17.9021739,6.75 C18.3163875,6.75 18.6521739,7.08578644 18.6521739,7.5 C18.6521739,7.91421356 18.3163875,8.25 17.9021739,8.25 L15.4891304,8.25 C15.0749169,8.25 14.7391304,7.91421356 14.7391304,7.5 C14.7391304,7.08578644 15.0749169,6.75 15.4891304,6.75 Z M14.5099097,3.62132034 L16.1700734,2.03033009 C16.4757011,1.73743687 16.9712215,1.73743687 17.2768492,2.03033009 C17.5824769,2.3232233 17.5824769,2.79809704 17.2768492,3.09099026 L15.6166855,4.68198052 C15.3110578,4.97487373 14.8155374,4.97487373 14.5099097,4.68198052 C14.2042819,4.3890873 14.2042819,3.91421356 14.5099097,3.62132034 Z',
            id: pathId
          };
          break;

        case 'serving-opportunity':
          path = {
            d: 'M21.7595424,13.3994832 C20.8983029,14.2148936 19.9061096,15.1566117 18.8918373,16.1193938 L13.0385125,21.6284902 C12.7843337,21.8688719 12.439571,22.0026292 12.0810375,21.9999608 C11.2818984,21.9930013 10.6321898,21.3855197 10.6116666,20.6260897 C10.6020835,20.2778706 10.7425534,19.9410419 11.0005283,19.6936488 L16.6911407,14.2897961 L16.1598057,13.78525 L10.4684733,19.189635 C10.2133886,19.4286865 9.86919927,19.5621393 9.51099831,19.5608775 C8.70206149,19.553841 8.04774584,18.9328394 8.03906752,18.1638893 C8.0363514,17.8233363 8.17726867,17.4959427 8.43032912,17.2548697 L14.1211816,11.8507128 L13.51601,11.2759789 L7.82219771,16.6777784 C7.56813289,16.918183 7.22343211,17.0519498 6.86496272,17.0492491 C6.06561355,17.0429313 5.41547448,16.435314 5.39527182,15.6756821 C5.38462318,15.3272322 5.52531736,14.9899768 5.78429353,14.7431652 L11.2021188,9.60090089 L11.366991,9.75747369 C11.8093326,10.1723015 12.4071605,10.4027349 13.0285129,10.3979089 C13.7414936,10.3891189 14.4226195,10.1157614 14.9265037,9.6361849 C15.940776,8.66861216 15.9995732,7.1524643 15.0544977,6.25530749 L12.4159817,3.75037086 C15.1315298,1.35778185 19.3489477,1.42692063 21.9760922,3.90709574 C23.2665509,5.10877081 23.995681,6.75248443 23.9999971,8.46968334 C24.001757,10.2735023 23.2069144,12.0231026 21.7595424,13.3994832 Z M14.4884443,9.21962066 C14.1022224,9.59072249 13.5777914,9.80230752 13.0286729,9.80857467 C12.5710821,9.81344865 12.1301813,9.64539859 11.8028906,9.3413657 L6.96367808,4.745091 L6.52545868,5.1610469 L8.19698009,6.74745861 L2.77915482,11.8901792 C2.62026117,12.0412867 2.49031904,12.217587 2.39517287,12.4111507 C2.2458383,12.7110854 2.18292599,13.0433237 2.21286144,13.3739327 C0.782688687,12.0024189 -0.00239440134,10.2616396 5.48582097e-06,8.46968334 C0.00429956501,6.75240008 0.733257314,5.10855841 2.02351035,3.90656344 C4.12287185,1.92634263 7.31501705,1.43528218 9.964257,2.68500665 C10.3621032,2.87179537 10.7389771,3.09648836 11.0890841,3.35563098 L11.2589961,3.48163445 L14.6188382,6.66852584 C15.3202452,7.338846 15.2638478,8.48375132 14.4883643,9.21977274 L14.4884443,9.21962066 Z M8.6327196,7.1612853 L10.6707838,9.09567036 L5.2531185,14.2383149 C4.99805827,14.4773821 4.65391914,14.6109086 4.29572352,14.6097856 C3.48677056,14.6025036 2.83255312,13.9814601 2.82379272,13.2124932 C2.82089874,12.8719748 2.9618479,12.5445892 3.21505432,12.3037017 L8.6327196,7.1612853 Z',
            id: pathId
          };
          break;

        case 'settings':
        case 'cog':
          // alias
          path = {
            d: 'M20.8964629,11.0886717 C20.9304942,11.3894737 20.9304942,12.6105263 20.8964629,12.9130278 L23.2091399,14.179856 C24.0652951,14.6480536 24.2551538,15.8589095 23.6327397,16.8828262 L22.2714888,19.1175987 C21.6490748,20.1415154 20.4490246,20.5901693 19.5928695,20.1202723 L17.2586991,18.8423977 C16.7455433,19.1967323 16.2037296,19.5179278 15.6162424,19.7626481 L15.6162424,22.3005532 C15.6162424,23.2386478 14.6060509,24 13.3603273,24 L10.6405122,24 C9.39389292,24 8.38370147,23.2386478 8.38370147,22.3005532 L8.38370147,19.7643475 C7.79621424,19.5179278 7.25440056,19.197582 6.74034924,18.8432474 L4.40707439,20.121122 C3.55091922,20.5910191 2.3508691,20.1406657 1.72845504,19.1175987 L0.368099705,16.8819764 C-0.255209913,15.8589095 -0.0653512362,14.6480536 0.791699489,14.1790063 L3.10437646,12.9113283 C3.06944963,12.6105263 3.06944963,11.388624 3.1034809,11.0878219 L0.790803929,9.82014396 C-0.066246796,9.35194637 -0.256105473,8.14109053 0.366308586,7.11717384 L1.72755948,4.8824013 C2.34997354,3.85848461 3.55002366,3.40898093 4.40617883,3.87887797 L6.73766256,5.15675262 C7.25260944,4.80156824 7.79531868,4.47952307 8.38370147,4.23310328 L8.38370147,1.6994468 C8.38370147,0.761352164 9.39389292,0 10.6405122,0 L13.3603273,0 C14.6060509,0 15.6162424,0.761352164 15.6162424,1.6994468 L15.6162424,4.23310328 C16.2046252,4.47952307 16.7473344,4.80156824 17.2622813,5.15590289 L19.593765,3.87887797 C20.4508157,3.40898093 21.6499703,3.85933433 22.2732799,4.8824013 L23.6336353,7.11717384 C24.2560493,8.14278998 24.0661906,9.35194637 23.2100355,9.82099369 L20.8964629,11.0886717 Z M12.000449,15.6 C10.0120743,15.6 8.4,13.9881 8.4,12 C8.4,10.0119 10.0120743,8.4 12.000449,8.4 C13.9879257,8.4 15.6,10.0119 15.6,12 C15.6,13.9881 13.9879257,15.6 12.000449,15.6 L12.000449,15.6 Z',
            id: pathId
          };
          break;

        case 'shape-experiences':
        case 'shoe-prints': // temp alias

        case 'feet':
          // temp alias
          path = {
            d: 'M4.89851989,0.00195306941 C7.63309477,0.118914958 9.05094991,1.71205263 9.11877545,5.17823252 C9.18660098,8.64441242 6.41374236,9.66821441 6.55647743,12.0615829 C6.6992125,14.4549513 7.48184382,14.3132644 7.53617961,15.916259 C7.53075357,16.3837211 7.28341645,18.9518165 4.67243478,19 C1.12832445,18.9118931 1.26533203,16.0594327 1.28115799,16.0263927 C1.64982746,12.7193008 0.753626047,11.1254472 0.753626047,11.1254472 C0.753626047,11.1254472 -0.00300548474,9.09898888 8.98351072e-06,6.99543701 C0.270708233,-0.311266904 4.89851989,0.00195306941 4.89851989,0.00195306941 Z M19.1014801,5.00195307 C19.1014801,5.00195307 23.7292918,4.6887331 23.999991,11.995437 C24.0030055,14.0989889 23.246374,16.1254472 23.246374,16.1254472 C23.246374,16.1254472 22.3501725,17.7193008 22.718842,21.0263927 C22.734668,21.0594327 22.8716755,23.9118931 19.3275652,24 C16.7165835,23.9518165 16.4692464,21.3837211 16.4638204,20.916259 C16.5181562,19.3132644 17.3007875,19.4549513 17.4435226,17.0615829 C17.5862576,14.6682144 14.813399,13.6444124 14.8812246,10.1782325 C14.9490501,6.71205263 16.3669052,5.11891496 19.1014801,5.00195307 Z',
            id: pathId
          };
          break;

        case 'shrink':
        case 'contract':
          // alias
          path = {
            d: 'M19.9480569,9.01240099 C20.7591446,9.01390855 21.4164574,9.66969538 21.4164574,10.4807605 C21.4164574,11.2918256 20.7591446,11.94912 19.9480569,11.94912 L13.7729353,11.94912 C13.6885098,11.9657031 13.6101147,11.9988693 13.5196588,12.0003769 C13.4442789,12.0003769 13.3930206,11.9295218 13.3191483,11.9159538 C13.0387351,11.8842951 12.7733978,11.7893191 12.5472581,11.5963519 C12.5246441,11.5767537 12.4959998,11.5752461 12.4568022,11.5435874 C12.4507718,11.5375572 12.4492642,11.5300194 12.4130819,11.4757474 C12.176389,11.2119251 12.0497507,10.8908157 12.0316596,10.5576458 C12.030152,10.5274947 12,10.5109116 12,10.4807605 C12,10.3933222 12.0361824,10.3179444 12.0527659,10.2335213 L12.0527659,4.05404946 C12.0542735,3.24298435 12.7100787,2.58568996 13.5211664,2.58568996 C14.3307466,2.58568996 14.9880593,3.24298435 14.9880593,4.0525419 L14.9880593,6.88674709 L21.4025761,0.472367532 C21.4025761,0.472367532 22.4654327,-0.590459415 23.5282893,0.472367532 C24.5896383,1.53368692 23.5282893,2.59651387 23.5282893,2.59651387 L17.1152802,9.01390855 L19.9480569,9.01240099 Z M4.05194312,14.987599 C3.24085537,14.9860915 2.58354263,14.3303046 2.58354263,13.5192395 C2.58354263,12.7081744 3.24085537,12.05088 4.05194312,12.05088 L10.2270647,12.05088 C10.3114902,12.0342969 10.3898853,12.0011307 10.4803412,11.9996231 C10.5557211,11.9996231 10.6069794,12.0704782 10.6808517,12.0840462 C10.9612649,12.1157049 11.2266022,12.2106809 11.4527419,12.4036481 C11.4753559,12.4232463 11.5040002,12.4247539 11.5431978,12.4564126 C11.5492282,12.4624428 11.5507358,12.4699806 11.5869181,12.5242526 C11.823611,12.7880749 11.9502493,13.1091843 11.9683404,13.4423542 C11.969848,13.4725053 12,13.4890884 12,13.5192395 C12,13.6066778 11.9638176,13.6820556 11.9472341,13.7664787 L11.9472341,19.9459505 C11.9457265,20.7570156 11.2899213,21.41431 10.4788336,21.41431 C9.66925343,21.41431 9.01194068,20.7570156 9.01194068,19.9474581 L9.01194068,17.1132529 L2.59742392,23.5276325 C2.59742392,23.5276325 1.5345673,24.5904594 0.471710676,23.5276325 C-0.589638345,22.4663131 0.471710676,21.4034861 0.471710676,21.4034861 L6.88471984,14.9860915 L4.05194312,14.987599 Z',
            id: pathId
          };
          break;

        case 'snail-mail':
          path = {
            d: 'M1.5,3 L22.5,3 C23.3284271,3 24,3.7007717 24,4.56521739 L24,19.4347826 C24,20.2992283 23.3284271,21 22.5,21 L1.5,21 C0.671572875,21 0,20.2992283 0,19.4347826 L0,4.56521739 C0,3.7007717 0.671572875,3 1.5,3 Z M18,5.34782609 C17.5857864,5.34782609 17.25,5.69821193 17.25,6.13043478 L17.25,10.0434783 C17.25,10.4757011 17.5857864,10.826087 18,10.826087 L21,10.826087 C21.4142136,10.826087 21.75,10.4757011 21.75,10.0434783 L21.75,6.13043478 C21.75,5.69821193 21.4142136,5.34782609 21,5.34782609 L18,5.34782609 Z M3.65491928,11.1912228 C3.12472592,11.1912228 2.69491928,11.6397167 2.69491928,12.192962 C2.69491928,12.7462072 3.12472592,13.1947011 3.65491928,13.1947011 L12.4319753,13.1947011 C12.9621687,13.1947011 13.3919753,12.7462072 13.3919753,12.192962 C13.3919753,11.6397167 12.9621687,11.1912228 12.4319753,11.1912228 L3.65491928,11.1912228 Z M3.65491928,15.1981793 C3.12472592,15.1981793 2.69491928,15.6466732 2.69491928,16.1999185 C2.69491928,16.7531637 3.12472592,17.2016576 3.65491928,17.2016576 L14.9615858,17.2016576 C15.4917791,17.2016576 15.9215858,16.7531637 15.9215858,16.1999185 C15.9215858,15.6466732 15.4917791,15.1981793 14.9615858,15.1981793 L3.65491928,15.1981793 Z',
            id: pathId
          };
          break;

        case 'sort':
        case 'arrow-sort':
          // alias
          path = {
            d: 'M16.5,15.75 L16.5,9.75 C16.5,8.92157288 17.1715729,8.25 18,8.25 L19.5,8.25 C20.3284271,8.25 21,8.92157288 21,9.75 L21,15.75 L23.2672381,15.75 C23.410851,15.75 23.5512974,15.7919374 23.6711204,15.8705996 C24.008738,16.0922409 24.1016069,16.5438716 23.8785488,16.8793449 L19.3612704,23.6732093 C19.3068177,23.7551047 19.2362609,23.8252133 19.153842,23.8793202 C18.8162244,24.1009616 18.361707,24.0086825 18.1386489,23.6732093 L13.6213705,16.8793449 C13.5422055,16.7602828 13.5,16.6207285 13.5,16.4780277 C13.5,16.0759491 13.8280326,15.75 14.2326812,15.75 L16.5,15.75 Z M7.5,8.25 L7.5,14.25 C7.5,15.0784271 6.82842712,15.75 6,15.75 L4.5,15.75 C3.67157288,15.75 3,15.0784271 3,14.25 L3,8.25 L0.732681231,8.25 C0.32803256,8.25 0,7.92405089 0,7.52197229 C0,7.37927152 0.0422054679,7.23971717 0.121370475,7.12065515 L4.63864891,0.326790733 C4.86170696,-0.00868254475 5.3162244,-0.100961566 5.653842,0.120679772 C5.73626093,0.174786669 5.80681767,0.244895278 5.86127042,0.326790733 L10.3785488,7.12065515 C10.6016069,7.45612842 10.508738,7.90775905 10.1711204,8.12940039 C10.0512974,8.20806259 9.910851,8.25 9.76723809,8.25 L7.5,8.25 Z',
            id: pathId
          };
          break;

        case 'alphabetical':
        case 'sort-alpha':
          // alias
          path = {
            d: 'M1.33219532,2.67857143 C0.604237928,2.67857143 8.52651283e-14,2.08069576 0,1.33539268 C0,0.597211565 0.59644416,0 1.33219532,0 L15.6452966,0 C16.373254,0 16.977492,0.597875668 16.977492,1.34317875 C16.977492,2.08135986 16.3810478,2.67857143 15.6452966,2.67857143 L1.33219532,2.67857143 Z M1.32453024,8.03571429 C0.593261719,8.03571429 2.84217094e-14,7.43783862 1.13686838e-13,6.69253554 C1.13686838e-13,5.95435442 0.59301239,5.35714286 1.32453024,5.35714286 L22.6754698,5.35714286 C23.4067383,5.35714286 24,5.95501852 24,6.70032161 C24,7.43850272 23.4069876,8.03571429 22.6754698,8.03571429 L1.32453024,8.03571429 Z M1.32453024,13.2857143 C0.593261719,13.2857143 2.84217094e-14,12.6878386 1.13686838e-13,11.9425355 C1.13686838e-13,11.2043544 0.59301239,10.6071429 1.32453024,10.6071429 L19.6754698,10.6071429 C20.4067383,10.6071429 21,11.2050185 21,11.9503216 C21,12.6885027 20.4069876,13.2857143 19.6754698,13.2857143 L1.32453024,13.2857143 Z M4.14230769,20.8941718 L3.96923077,20.2039877 C3.86153792,19.828219 3.75769281,19.42945 3.65769231,19.0076687 C3.55769181,18.5858875 3.45769281,18.1794498 3.35769231,17.7883436 L3.31153846,17.7883436 C3.21923031,18.1871186 3.12500048,18.5954734 3.02884615,19.0134202 C2.93269183,19.4313671 2.83076977,19.828219 2.72307692,20.2039877 L2.53846154,20.8941718 L4.14230769,20.8941718 Z M4.48846154,22.2170245 L2.19230769,22.2170245 L1.73076923,24 L0,24 L2.35384615,16.5 L4.39615385,16.5 L6.75,24 L4.95,24 L4.48846154,22.2170245 Z M9,16.5 L11.7030303,16.5 C12.1151536,16.5 12.4969679,16.5287574 12.8484848,16.586273 C13.2000018,16.6437886 13.5070694,16.745398 13.769697,16.8911043 C14.0323245,17.0368105 14.2383831,17.2285264 14.3878788,17.4662577 C14.5373745,17.7039889 14.6121212,18.0030657 14.6121212,18.3634969 C14.6121212,18.5322094 14.5858588,18.7009194 14.5333333,18.8696319 C14.4808078,19.0383444 14.4020207,19.1955514 14.2969697,19.3412577 C14.1919187,19.4869639 14.0545463,19.6173307 13.8848485,19.732362 C13.7151507,19.8473932 13.5171728,19.9317482 13.2909091,19.9854294 L13.2909091,20.0314417 C13.8565685,20.1311355 14.2828268,20.3228513 14.569697,20.6065951 C14.8565671,20.8903388 15,21.2852735 15,21.791411 C15,22.1748485 14.9212129,22.5045998 14.7636364,22.7806748 C14.6060598,23.0567498 14.3878802,23.2848917 14.1090909,23.4651074 C13.8303016,23.645323 13.5050524,23.7795241 13.1333333,23.8677147 C12.7616143,23.9559053 12.3616183,24 11.9333333,24 L9,24 L9,16.5 Z M11.6181818,19.5253067 C12.0545476,19.5253067 12.3717162,19.4428689 12.569697,19.2779908 C12.7676778,19.1131127 12.8666667,18.8888051 12.8666667,18.6050613 C12.8666667,18.3213176 12.7656576,18.1180988 12.5636364,17.9953988 C12.3616152,17.8726988 12.0505072,17.8113497 11.630303,17.8113497 L10.7818182,17.8113497 L10.7818182,19.5253067 L11.6181818,19.5253067 Z M11.7878788,22.6886503 L10.7818182,22.6886503 L10.7818182,20.7216258 L11.7878788,20.7216258 C12.2808105,20.7216258 12.6484836,20.796395 12.8909091,20.9459356 C13.1333345,21.0954762 13.2545455,21.3351211 13.2545455,21.6648773 C13.2545455,22.3473961 12.7656615,22.6886503 11.7878788,22.6886503 Z M17.25,20.2943787 C17.25,19.6952633 17.3594347,19.1608751 17.5783074,18.6911982 C17.7971801,18.2215213 18.0926538,17.8239661 18.4647374,17.4985207 C18.8368209,17.1730753 19.2701824,16.9252967 19.7648346,16.7551775 C20.2594869,16.5850583 20.7825848,16.5 21.334144,16.5 C21.8681933,16.5 22.3518947,16.5943038 22.7852626,16.7829142 C23.2186306,16.9715246 23.5797651,17.1915668 23.868677,17.4430473 L22.8049611,18.4526627 C22.5860884,18.2825435 22.3650303,18.1494088 22.1417802,18.0532544 C21.91853,17.9571001 21.6580754,17.9090237 21.3604086,17.9090237 C21.0627417,17.9090237 20.7847776,17.9626474 20.5265078,18.0698964 C20.268238,18.1771455 20.0428025,18.3306203 19.8501946,18.5303254 C19.6575866,18.7300306 19.5065667,18.974111 19.3971304,19.262574 C19.287694,19.5510369 19.2329767,19.8764775 19.2329767,20.2389053 C19.2329767,20.9859505 19.4212043,21.5647169 19.7976654,21.9752219 C20.1741264,22.3857269 20.677526,22.5909763 21.3078794,22.5909763 C21.6580757,22.5909763 21.9644929,22.5318053 22.2271401,22.4134615 C22.4897873,22.2951178 22.7261663,22.1397939 22.936284,21.9474852 L24,22.9349112 C23.6410488,23.2899426 23.231763,23.5562121 22.7721304,23.7337278 C22.3124977,23.9112435 21.8156641,24 21.2816148,24 C20.7300556,24 20.2091464,23.920489 19.7188716,23.7614645 C19.2285968,23.60244 18.7996127,23.3676051 18.4319066,23.0569527 C18.0642005,22.7463002 17.7752929,22.3598396 17.5651751,21.8975592 C17.3550573,21.4352788 17.25,20.9008906 17.25,20.2943787 Z',
            id: pathId
          };
          break;

        case 'alpha-numeric':
        case 'sort-alpha-numeric':
          // alias
          path = {
            d: 'M1.33219532,2.67857143 C0.604237928,2.67857143 8.52651283e-14,2.08069576 0,1.33539268 C0,0.597211565 0.59644416,0 1.33219532,0 L15.6452966,0 C16.373254,0 16.977492,0.597875668 16.977492,1.34317875 C16.977492,2.08135986 16.3810478,2.67857143 15.6452966,2.67857143 L1.33219532,2.67857143 Z M1.32453024,8.03571429 C0.593261719,8.03571429 2.84217094e-14,7.43783862 1.13686838e-13,6.69253554 C1.13686838e-13,5.95435442 0.59301239,5.35714286 1.32453024,5.35714286 L22.6754698,5.35714286 C23.4067383,5.35714286 24,5.95501852 24,6.70032161 C24,7.43850272 23.4069876,8.03571429 22.6754698,8.03571429 L1.32453024,8.03571429 Z M1.32453024,13.2857143 C0.593261719,13.2857143 2.84217094e-14,12.6878386 1.13686838e-13,11.9425355 C1.13686838e-13,11.2043544 0.59301239,10.6071429 1.32453024,10.6071429 L19.6754698,10.6071429 C20.4067383,10.6071429 21,11.2050185 21,11.9503216 C21,12.6885027 20.4069876,13.2857143 19.6754698,13.2857143 L1.32453024,13.2857143 Z M4.14230769,20.8941718 L3.96923077,20.2039877 C3.86153792,19.828219 3.75769281,19.42945 3.65769231,19.0076687 C3.55769181,18.5858875 3.45769281,18.1794498 3.35769231,17.7883436 L3.31153846,17.7883436 C3.21923031,18.1871186 3.12500048,18.5954734 3.02884615,19.0134202 C2.93269183,19.4313671 2.83076977,19.828219 2.72307692,20.2039877 L2.53846154,20.8941718 L4.14230769,20.8941718 Z M4.48846154,22.2170245 L2.19230769,22.2170245 L1.73076923,24 L0,24 L2.35384615,16.5 L4.39615385,16.5 L6.75,24 L4.95,24 L4.48846154,22.2170245 Z M15.678,20.628 L10.158,22.752 L10.158,21.3 L12.27,20.604 L13.89,20.04 L13.89,19.992 L12.27,19.428 L10.158,18.732 L10.158,17.28 L15.678,19.404 L15.678,20.628 Z M21.2820796,19.9711684 C21.4679213,19.9711684 21.6576318,19.9180582 21.8512168,19.8118361 C22.0448019,19.705614 22.2228974,19.5197282 22.3855088,19.254173 C22.3080748,18.6851261 22.1628882,18.2924897 21.9499447,18.0762519 C21.7370011,17.8600141 21.4988951,17.7518968 21.2356195,17.7518968 C20.9878306,17.7518968 20.7710186,17.8448397 20.585177,18.0307284 C20.3993354,18.216617 20.3064159,18.5144137 20.3064159,18.9241275 C20.3064159,19.3110793 20.3993354,19.5823209 20.585177,19.7378604 C20.7710186,19.8933999 21.0033172,19.9711684 21.2820796,19.9711684 Z M19.7605088,22.1335357 C19.8844033,22.2701069 20.0508839,22.389605 20.2599558,22.4920334 C20.4690276,22.5944618 20.6819679,22.6456753 20.8987832,22.6456753 C21.107855,22.6456753 21.3014372,22.6077394 21.4795354,22.5318665 C21.6576336,22.4559936 21.8144352,22.3289083 21.9499447,22.150607 C22.0854542,21.9723056 22.1938602,21.7408967 22.2751659,21.4563733 C22.3564716,21.1718499 22.4048672,20.8171493 22.420354,20.392261 C22.3274332,20.5136577 22.2190272,20.6217749 22.0951327,20.7166161 C21.9712383,20.8114572 21.8434741,20.8911226 21.7118363,20.9556146 C21.5801985,21.0201065 21.4485626,21.0694232 21.3169248,21.103566 C21.185287,21.1377088 21.0613944,21.15478 20.9452434,21.15478 C20.6277639,21.15478 20.3354549,21.1092569 20.0683075,21.0182094 C19.8011602,20.9271619 19.5707974,20.7905927 19.3772124,20.6084977 C19.1836274,20.4264027 19.0306975,20.1949938 18.9184181,19.914264 C18.8061388,19.6335343 18.75,19.303492 18.75,18.9241275 C18.75,18.5523502 18.8158179,18.2166176 18.9474558,17.9169196 C19.0790936,17.6172216 19.2552533,17.3611543 19.4759403,17.1487102 C19.6966272,16.936266 19.9560273,16.7750385 20.2541482,16.6650228 C20.5522692,16.555007 20.8678081,16.5 21.2007743,16.5 C21.5569708,16.5 21.9034828,16.5682846 22.2403208,16.7048558 C22.5771588,16.8414271 22.8752753,17.0538681 23.1346792,17.3421851 C23.3940832,17.6305022 23.6031519,18.0003771 23.7618916,18.4518209 C23.9206313,18.9032648 24,19.4476448 24,20.0849772 C24,20.7602462 23.9167597,21.3444588 23.7502765,21.8376328 C23.5837934,22.3308067 23.3631098,22.7367207 23.088219,23.0553869 C22.8133283,23.3740532 22.4958536,23.6111525 22.1357854,23.766692 C21.7757172,23.9222314 21.4021037,24 21.0149336,24 C20.5270993,24 20.1031545,23.9127475 19.7430863,23.7382398 C19.3830181,23.5637321 19.0868374,23.3626719 18.8545354,23.1350531 L19.7605088,22.1335357 Z',
            id: pathId
          };
          break;

        case 'numerical':
        case 'sort-numeric':
          // alias
          path = {
            d: 'M1.33219532,2.67857143 C0.604237928,2.67857143 8.52651283e-14,2.08069576 0,1.33539268 C0,0.597211565 0.59644416,0 1.33219532,0 L15.6452966,0 C16.373254,0 16.977492,0.597875668 16.977492,1.34317875 C16.977492,2.08135986 16.3810478,2.67857143 15.6452966,2.67857143 L1.33219532,2.67857143 Z M1.32453024,8.03571429 C0.593261719,8.03571429 2.84217094e-14,7.43783862 1.13686838e-13,6.69253554 C1.13686838e-13,5.95435442 0.59301239,5.35714286 1.32453024,5.35714286 L22.6754698,5.35714286 C23.4067383,5.35714286 24,5.95501852 24,6.70032161 C24,7.43850272 23.4069876,8.03571429 22.6754698,8.03571429 L1.32453024,8.03571429 Z M1.32453024,13.2857143 C0.593261719,13.2857143 2.84217094e-14,12.6878386 1.13686838e-13,11.9425355 C1.13686838e-13,11.2043544 0.59301239,10.6071429 1.32453024,10.6071429 L19.6754698,10.6071429 C20.4067383,10.6071429 21,11.2050185 21,11.9503216 C21,12.6885027 20.4069876,13.2857143 19.6754698,13.2857143 L1.32453024,13.2857143 Z M0,22.5944882 L1.79331683,22.5944882 L1.79331683,18.2598425 L0.246905941,18.2598425 L0.246905941,17.1850394 C0.697403243,17.1062988 1.07858755,17.0118116 1.3904703,16.9015748 C1.70235304,16.791338 2.00556783,16.6574811 2.30012376,16.5 L3.70358911,16.5 L3.70358911,22.5944882 L5.25,22.5944882 L5.25,24 L0,24 L0,22.5944882 Z M9.08094714,23.0262751 C9.55121381,22.5857783 9.98100026,22.1742678 10.3703194,21.7917311 C10.7596385,21.4091944 11.0949876,21.0498471 11.3763767,20.7136785 C11.6577657,20.3775099 11.8774772,20.06453 12.0355176,19.7747295 C12.1935581,19.484929 12.2725771,19.2086566 12.2725771,18.9459042 C12.2725771,18.5826875 12.180067,18.3064152 11.9950441,18.1170788 C11.8100211,17.9277425 11.5556184,17.8330757 11.2318282,17.8330757 C10.9620031,17.8330757 10.7230187,17.9084227 10.5148678,18.059119 C10.306717,18.2098153 10.1101331,18.385625 9.92511013,18.5865533 L9,17.6707883 C9.36233661,17.2843876 9.73237697,16.9926594 10.1101322,16.7955951 C10.4878874,16.5985307 10.938874,16.5 11.4631057,16.5 C11.8254423,16.5 12.1550095,16.5560273 12.4518172,16.6680835 C12.7486248,16.7801397 13.0049549,16.9385616 13.220815,17.1433539 C13.4366751,17.3481463 13.6024223,17.5935071 13.7180617,17.8794436 C13.833701,18.1653801 13.8915198,18.4860879 13.8915198,18.8415765 C13.8915198,19.1506971 13.8259918,19.4656089 13.6949339,19.7863215 C13.563876,20.1070341 13.3884923,20.4277418 13.1687775,20.7484544 C12.9490628,21.069167 12.6985146,21.3898747 12.4171256,21.7105873 C12.1357365,22.0312999 11.8447152,22.3462117 11.5440529,22.6553323 C11.7290758,22.6321483 11.9352962,22.6108965 12.1627203,22.5915765 C12.3901443,22.5722565 12.5925101,22.5625966 12.7698238,22.5625966 L14.25,22.5625966 L14.25,24 L9.08094714,24 L9.08094714,23.0262751 Z M18.892779,21.9172989 C19.1466096,22.1297431 19.4245061,22.3042482 19.726477,22.4408194 C20.0284479,22.5773907 20.3588604,22.6456753 20.7177243,22.6456753 C21.1291049,22.6456753 21.4573292,22.5717003 21.702407,22.4237481 C21.9474848,22.2757959 22.0700219,22.0652517 22.0700219,21.7921093 C22.0700219,21.6327761 22.0371995,21.4886198 21.9715536,21.3596358 C21.9059078,21.2306519 21.7899352,21.1225346 21.6236324,21.0352807 C21.4573296,20.9480269 21.2297607,20.8797423 20.940919,20.8304249 C20.6520773,20.7811075 20.2800898,20.7564492 19.8249453,20.7564492 L19.8249453,19.5728376 C20.2013148,19.5728376 20.5142219,19.5500761 20.7636761,19.5045524 C21.0131304,19.4590286 21.2144412,19.3926408 21.3676149,19.3053869 C21.5207885,19.2181331 21.6301966,19.1157062 21.6958425,18.9981032 C21.7614883,18.8805002 21.7943107,18.7496214 21.7943107,18.6054628 C21.7943107,18.3550822 21.7067842,18.1597124 21.5317287,18.0193475 C21.3566731,17.8789826 21.1028463,17.8088012 20.7702407,17.8088012 C20.4726462,17.8088012 20.2035023,17.865705 19.9628009,17.9795144 C19.7220995,18.0933238 19.4704608,18.2488609 19.2078775,18.4461305 L18.2363239,17.4218513 C18.6214461,17.1335342 19.0262561,16.9078157 19.4507659,16.7446889 C19.8752756,16.5815622 20.3457305,16.5 20.8621444,16.5 C21.2910306,16.5 21.6827116,16.5436263 22.0371991,16.6308801 C22.3916867,16.718134 22.693653,16.847116 22.9431072,17.01783 C23.1925614,17.1885441 23.3873078,17.3952947 23.5273523,17.638088 C23.6673968,17.8808813 23.7374179,18.1616069 23.7374179,18.4802731 C23.7374179,18.8596377 23.617069,19.180196 23.3763676,19.4419575 C23.1356662,19.7037191 22.7921248,19.9180568 22.345733,20.0849772 L22.345733,20.1305008 C22.8271359,20.2518974 23.2231932,20.458648 23.5339168,20.7507587 C23.8446405,21.0428694 24,21.4241251 24,21.8945372 C24,22.228378 23.9168498,22.5261747 23.750547,22.7879363 C23.5842442,23.0496978 23.3610517,23.269726 23.0809628,23.4480273 C22.8008739,23.6263287 22.4726496,23.7628979 22.0962801,23.857739 C21.7199106,23.9525801 21.3216651,24 20.9015317,24 C20.218815,24 19.6411402,23.9070571 19.1684902,23.7211684 C18.6958401,23.5352798 18.3063473,23.2867997 18,22.9757208 L18.892779,21.9172989 Z',
            id: pathId
          };
          break;

        case 'spinner':
          path = {
            d: 'M32 16c-0.040-2.089-0.493-4.172-1.331-6.077-0.834-1.906-2.046-3.633-3.533-5.060-1.486-1.428-3.248-2.557-5.156-3.302-1.906-0.748-3.956-1.105-5.981-1.061-2.025 0.040-4.042 0.48-5.885 1.292-1.845 0.809-3.517 1.983-4.898 3.424s-2.474 3.147-3.193 4.994c-0.722 1.846-1.067 3.829-1.023 5.79 0.040 1.961 0.468 3.911 1.254 5.694 0.784 1.784 1.921 3.401 3.316 4.736 1.394 1.336 3.046 2.391 4.832 3.085 1.785 0.697 3.701 1.028 5.598 0.985 1.897-0.040 3.78-0.455 5.502-1.216 1.723-0.759 3.285-1.859 4.574-3.208 1.29-1.348 2.308-2.945 2.977-4.67 0.407-1.046 0.684-2.137 0.829-3.244 0.039 0.002 0.078 0.004 0.118 0.004 1.105 0 2-0.895 2-2 0-0.056-0.003-0.112-0.007-0.167h0.007zM28.822 21.311c-0.733 1.663-1.796 3.169-3.099 4.412s-2.844 2.225-4.508 2.868c-1.663 0.646-3.447 0.952-5.215 0.909-1.769-0.041-3.519-0.429-5.119-1.14-1.602-0.708-3.053-1.734-4.25-2.991s-2.141-2.743-2.76-4.346c-0.621-1.603-0.913-3.319-0.871-5.024 0.041-1.705 0.417-3.388 1.102-4.928 0.683-1.541 1.672-2.937 2.883-4.088s2.642-2.058 4.184-2.652c1.542-0.596 3.192-0.875 4.832-0.833 1.641 0.041 3.257 0.404 4.736 1.064 1.48 0.658 2.82 1.609 3.926 2.774s1.975 2.54 2.543 4.021c0.57 1.481 0.837 3.064 0.794 4.641h0.007c-0.005 0.055-0.007 0.11-0.007 0.167 0 1.032 0.781 1.88 1.784 1.988-0.195 1.088-0.517 2.151-0.962 3.156z',
            id: pathId
          };
          viewBox = '0 0 32 32';
          break;

        case 'filled-or-exists':
        case 'square-filled-partial':
          // alias
          path = {
            d: 'M3,0 L21,0 C22.6568542,0 24,1.34314575 24,3 L24,21 C24,22.6568542 22.6568542,24 21,24 L3,24 C1.34314575,24 0,22.6568542 0,21 L0,3 C0,1.34314575 1.34314575,0 3,0 Z M4.5,3 C3.67157288,3 3,3.67157288 3,4.5 L3,19.5 C3,20.3284271 3.67157288,21 4.5,21 L19.5,21 C20.3284271,21 21,20.3284271 21,19.5 L21,4.5 C21,3.67157288 20.3284271,3 19.5,3 L4.5,3 Z M6.375,5.25 C5.75367966,5.25 5.25,5.75367966 5.25,6.375 L5.25,17.625 C5.25,18.2463203 5.75367966,18.75 6.375,18.75 L17.625,18.75 C18.2463203,18.75 18.75,18.2463203 18.75,17.625 L18.75,6.375 C18.75,5.75367966 18.2463203,5.25 17.625,5.25 L6.375,5.25 Z',
            id: pathId
          };
          break;

        case 'blank-or-null':
        case 'square-outline':
          // alias
          path = {
            d: 'M3,0 L21,0 C22.6568542,0 24,1.34314575 24,3 L24,21 C24,22.6568542 22.6568542,24 21,24 L3,24 C1.34314575,24 0,22.6568542 0,21 L0,3 C0,1.34314575 1.34314575,0 3,0 Z M4.5,3 C3.67157288,3 3,3.67157288 3,4.5 L3,19.5 C3,20.3284271 3.67157288,21 4.5,21 L19.5,21 C20.3284271,21 21,20.3284271 21,19.5 L21,4.5 C21,3.67157288 20.3284271,3 19.5,3 L4.5,3 Z',
            id: pathId
          };
          break;

        case 'favorite':
        case 'star':
          // alias
          path = {
            d: 'M12.0005549,18.4610348 L5.81293432,23.1828535 C4.93293642,23.8543864 4.48505373,23.5486863 4.81778908,22.4833115 L7.21129266,14.819628 L1.00803895,10.120327 C0.125817714,9.45199654 0.299341408,8.91182271 1.40597665,8.91383378 L9.04062806,8.9277081 L11.4086835,1.2553715 C11.735565,0.196297773 12.2632287,0.188793791 12.5924263,1.2553715 L14.9604818,8.9277081 L22.5951332,8.91383378 C23.6971293,8.91183114 23.8705889,9.45555946 22.9930709,10.120327 L16.7898171,14.819628 L19.1833207,22.4833115 C19.5137151,23.5411908 19.063482,23.8508064 18.1881755,23.1828535 L12.0005549,18.4610348 Z',
            id: pathId
          };
          break;

        case 'start-or-run':
        case 'power':
          // alias
          path = {
            d: 'M12,24 C7.19272937,24.00024 2.94228423,20.8413002 1.50435682,16.1996158 C0.0664294108,11.5579314 1.77422175,6.50909117 5.72141608,3.73249211 C6.33492298,3.18138765 7.26426946,3.20097818 7.85456192,3.77745862 C8.44485439,4.35393906 8.49717014,5.29304121 7.97464321,5.93299685 L7.98691382,5.9481388 C4.90464451,7.77781791 3.41229456,11.4673242 4.34227882,14.9586954 C5.27226308,18.4500665 8.39487088,20.8809168 11.9683491,20.8953471 C15.5418274,20.9097773 18.6835093,18.5042233 19.6410026,15.020474 C20.5984959,11.5367248 19.135295,7.83528354 16.0675557,5.98076972 C15.5066972,5.35447393 15.5288999,4.39339818 16.1180671,3.79430521 C16.7072343,3.19521225 17.6569046,3.16804187 18.2785839,3.73249211 C22.2257782,6.50909117 23.9335706,11.5579314 22.4956432,16.1996158 C21.0577158,20.8413002 16.8072706,24.00024 12,24 Z M12.0374104,10.1451104 C11.1489796,10.1451104 10.4287641,9.41633732 10.4287641,8.51735016 L10.4287641,1.62776025 C10.4287641,0.728773089 11.1489796,0 12.0374104,0 C12.9258412,0 13.6460567,0.728773089 13.6460567,1.62776025 L13.6460567,8.51735016 C13.6460567,9.41633732 12.9258412,10.1451104 12.0374104,10.1451104 Z',
            id: pathId
          };
          break;

        case 'status':
          path = {
            d: 'M5.25,18 C2.35050506,18 0,15.5375661 0,12.5 C0,9.46243388 2.35050506,7 5.25,7 C8.14949494,7 10.5,9.46243388 10.5,12.5 C10.5,15.5375661 8.14949494,18 5.25,18 Z M5.25,15.6428571 C6.90685425,15.6428571 8.25,14.2357521 8.25,12.5 C8.25,10.7642479 6.90685425,9.35714286 5.25,9.35714286 C3.59314575,9.35714286 2.25,10.7642479 2.25,12.5 C2.25,14.2357521 3.59314575,15.6428571 5.25,15.6428571 Z M18.75,18 C15.8505051,18 13.5,15.5375661 13.5,12.5 C13.5,9.46243388 15.8505051,7 18.75,7 C21.6494949,7 24,9.46243388 24,12.5 C24,15.5375661 21.6494949,18 18.75,18 Z',
            id: pathId
          };
          break;

        case 'stepper':
        case 'caret-sort':
          // alias
          path = {
            d: 'M12,24 L4,14 L20,14 L12,24 Z M12,-8.8817842e-16 L20,10 L4,10 L12,-8.8817842e-16 Z',
            id: pathId
          };
          break;

        case 'steps':
        case 'stairs':
          // alias
          path = {
            d: 'M17.4991396,0 L22.5,0 C23.3284271,-1.52163685e-16 24,0.671502667 24,1.49984319 L24,22.5001568 C24,23.3284973 23.3284271,24 22.5,24 L15.9991396,24 L15.9991396,1.49984319 C15.9991396,0.671502667 16.6707125,1.52163685e-16 17.4991396,0 Z M9.50336966,7.94998169 L16.00423,7.94998169 L16.00423,23.9999814 L8.00336966,23.9999814 L8.00336966,9.44982487 C8.00336966,8.62148436 8.67494253,7.94998169 9.50336966,7.94998169 Z M1.5,16.0500059 L8.00086036,16.0500059 L8.00086036,24 L1.5,24 C0.671572875,24 1.01453063e-16,23.3284973 0,22.5001568 L0,17.5498491 C-1.01453063e-16,16.7215085 0.671572875,16.0500059 1.5,16.0500059 Z',
            id: pathId
          };
          break;

        case 'subjects-and-objects':
          path = {
            d: 'M0,22.5 L0,6.75 C0,5.92157288 0.671572875,5.25 1.5,5.25 L9,5.25 C9.82842712,5.25 10.5,5.92157288 10.5,6.75 L10.5,13.5 L17.25,13.5 C18.0784271,13.5 18.75,14.1715729 18.75,15 L18.75,22.5 C18.75,23.3284271 18.0784271,24 17.25,24 L1.5,24 C0.671572875,24 0,23.3284271 0,22.5 Z M7.5,15.75 L3,15.75 C2.58578644,15.75 2.25,16.0857864 2.25,16.5 L2.25,21 C2.25,21.4142136 2.58578644,21.75 3,21.75 L7.5,21.75 C7.91421356,21.75 8.25,21.4142136 8.25,21 L8.25,16.5 C8.25,16.0857864 7.91421356,15.75 7.5,15.75 Z M15,0 L22.5,0 C23.3284271,0 24,0.671572875 24,1.5 L24,9 C24,9.82842712 23.3284271,10.5 22.5,10.5 L15,10.5 C14.1715729,10.5 13.5,9.82842712 13.5,9 L13.5,1.5 C13.5,0.671572875 14.1715729,0 15,0 Z M11.25,15.75 C10.8357864,15.75 10.5,16.0857864 10.5,16.5 L10.5,21 C10.5,21.4142136 10.8357864,21.75 11.25,21.75 L15.75,21.75 C16.1642136,21.75 16.5,21.4142136 16.5,21 L16.5,16.5 C16.5,16.0857864 16.1642136,15.75 15.75,15.75 L11.25,15.75 Z M3,7.5 C2.58578644,7.5 2.25,7.83578644 2.25,8.25 L2.25,12.75 C2.25,13.1642136 2.58578644,13.5 3,13.5 L7.5,13.5 C7.91421356,13.5 8.25,13.1642136 8.25,12.75 L8.25,8.25 C8.25,7.83578644 7.91421356,7.5 7.5,7.5 L3,7.5 Z',
            id: pathId
          };
          break;

        case 'success':
        case 'check':
          // alias
          path = {
            d: 'M4.02567631,12.0970368 C3.62905808,11.7058293 2.98997798,11.7019183 2.58939467,12.0970368 L0.301073862,14.3541398 C-0.0955443586,14.7453473 -0.0969839309,15.3782 0.297194127,15.7670006 L6.31787685,21.7055479 C6.71235235,22.0946419 7.34866361,22.0978573 7.7459171,21.7060233 L23.6998368,5.96975024 C24.0940462,5.58091877 24.0960585,4.95248327 23.6954752,4.55736481 L21.4071544,2.30026174 C21.0105362,1.90905427 20.3648961,1.91161375 19.973989,2.29718797 L7.03213793,15.0624836 L4.02567631,12.0970368 Z',
            id: pathId
          };
          break;

        case 'target':
          path = {
            d: 'M12,0 C12.8284271,0 13.5,0.67646277 13.5,1.50639765 L13.5007422,3.1245622 C17.2692326,3.75712009 20.2434601,6.73162403 20.875605,10.5002546 L22.3701679,10.5 C23.2702993,10.5 24,11.1657972 24,12 C24,12.8284271 23.2634922,13.5 22.3701679,13.5 L20.8754378,13.5007422 C20.2429357,17.2689004 17.2689004,20.2429357 13.5007422,20.8754378 L13.5,22.4936024 C13.5,23.2793428 12.9061253,23.9245764 12.1373892,23.9938438 L12,24 C11.1715729,24 10.5,23.3235372 10.5,22.4936024 L10.5002546,20.875605 C6.73162403,20.2434601 3.75712009,17.2692326 3.1245622,13.5007422 L1.6298321,13.5 C0.729700688,13.5 0,12.8342028 0,12 C0,11.1715729 0.736507773,10.5 1.6298321,10.5 L3.12439496,10.5002546 C3.75659563,6.73129179 6.73129179,3.75659563 10.5002546,3.12439496 L10.5,1.50639765 C10.5,0.720657226 11.0938747,0.0754236496 11.8626108,0.00615615481 L12,0 Z M5.41716352,10.5004355 L7.3701679,10.5 C8.27029931,10.5 9,11.1657972 9,12 C9,12.8284271 8.26349223,13.5 7.3701679,13.5 L5.4173901,13.500563 C5.99021825,16.0240066 7.97685023,18.0103813 10.5004355,18.5828365 L10.5,16.5063976 C10.5,15.7206572 11.0938747,15.0754236 11.8626108,15.0061562 L12,15 C12.8284271,15 13.5,15.6764628 13.5,16.5063976 L13.500563,18.5826099 C16.0236738,18.0098573 18.0098573,16.0236738 18.5826099,13.500563 L16.6298321,13.5 C15.7297007,13.5 15,12.8342028 15,12 C15,11.1715729 15.7365078,10.5 16.6298321,10.5 L18.5828365,10.5004355 C18.0103813,7.97685023 16.0240066,5.99021825 13.500563,5.4173901 L13.5,7.49360235 C13.5,8.27934277 12.9061253,8.92457635 12.1373892,8.99384385 L12,9 C11.1715729,9 10.5,8.32353723 10.5,7.49360235 L10.5004355,5.41716352 C7.97651739,5.98969422 5.98969422,7.97651739 5.41716352,10.5004355 Z',
            id: pathId
          };
          break;

        case 'task':
          path = {
            d: 'M11.9968248,23.9955666 C6.32674797,23.9955666 1.73024253,19.2833017 1.73024253,13.4704284 C1.73024253,7.65755501 6.32674797,2.94529011 11.9968248,2.94529011 C17.6669016,2.94529011 22.263407,7.65755501 22.263407,13.4704284 C22.263407,19.2833017 17.6669016,23.9955666 11.9968248,23.9955666 Z M11.9968248,20.9883842 C16.0468796,20.9883842 19.3300978,17.6224807 19.3300978,13.4704284 C19.3300978,9.31837597 16.0468796,5.95247246 11.9968248,5.95247246 C7.94676992,5.95247246 4.66355175,9.31837597 4.66355175,13.4704284 C4.66355175,17.6224807 7.94676992,20.9883842 11.9968248,20.9883842 Z M1.50642314,3.1829634 L5.93406365,0.196482165 C6.45996274,-0.158241249 7.17384833,-0.0194759473 7.52857174,0.506423141 C7.88329516,1.03232223 7.74452986,1.74620782 7.21863077,2.10093123 L2.79099026,5.08741247 C2.26509117,5.44213588 1.55120558,5.30337058 1.19648217,4.77747149 C0.841758751,4.2515724 0.980524053,3.53768681 1.50642314,3.1829634 Z M18.0667505,0.196482165 L22.494391,3.1829634 C23.0202901,3.53768681 23.1590554,4.2515724 22.8043319,4.77747149 C22.4496085,5.30337058 21.7357229,5.44213588 21.2098239,5.08741247 L16.7821833,2.10093123 C16.2562843,1.74620782 16.117519,1.03232223 16.4722424,0.506423141 C16.8269658,-0.0194759473 17.5408514,-0.158241249 18.0667505,0.196482165 Z M9.19581774,13.873828 L10.0767927,14.7449904 L15.2051082,9.67379586 C15.6075695,9.27581733 16.2411004,9.2807838 16.6349481,9.67024471 L16.8027987,9.83622573 C17.1933333,10.2224104 17.19657,10.8572031 16.802628,11.2467573 L10.7900878,17.1923277 C10.3964429,17.5815881 9.76000525,17.5844189 9.36922809,17.1979943 L7.59615863,15.4446739 C7.20594652,15.0588081 7.20787066,14.4292699 7.60171838,14.039809 L7.76956898,13.873828 C8.16010357,13.4876433 8.80197002,13.4843671 9.19581774,13.873828 Z',
            id: pathId
          };
          break;

        case 'template':
          path = {
            d: 'M1.5,0 L4.5,0 C5.32842712,0 6,0.671572875 6,1.5 L6,22.5 C6,23.3284271 5.32842712,24 4.5,24 L1.5,24 C0.671572875,24 0,23.3284271 0,22.5 L0,1.5 C0,0.671572875 0.671572875,0 1.5,0 Z M10.5,9 L22.5,9 C23.3284271,9 24,9.67157288 24,10.5 L24,22.5 C24,23.3284271 23.3284271,24 22.5,24 L10.5,24 C9.67157288,24 9,23.3284271 9,22.5 L9,10.5 C9,9.67157288 9.67157288,9 10.5,9 Z M10.5,0 L22.5,0 C23.3284271,0 24,0.671572875 24,1.5 L24,4.5 C24,5.32842712 23.3284271,6 22.5,6 L10.5,6 C9.67157288,6 9,5.32842712 9,4.5 L9,1.5 C9,0.671572875 9.67157288,0 10.5,0 Z',
            id: pathId
          };
          break;

        case 'text':
        case 'file':
          path = {
            d: 'M1.13686838e-13,21.9068213 C1.13686838e-13,21.1693042 0.604237928,20.5714286 1.33219532,20.5714286 L15.6452966,20.5714286 C16.3810478,20.5714286 16.977492,21.1686401 16.977492,21.9068213 L16.977492,22.6646073 C16.977492,23.4021243 16.373254,24 15.6452966,24 L1.33219532,24 C0.59644416,24 1.13686838e-13,23.4027884 1.13686838e-13,22.6646073 L1.13686838e-13,21.9068213 Z M1.13686838e-13,15.0496784 C1.13686838e-13,14.3121614 0.593261719,13.7142857 1.32453024,13.7142857 L22.6754698,13.7142857 C23.4069876,13.7142857 24,14.3114973 24,15.0496784 L24,15.8074645 C24,16.5449815 23.4067383,17.1428571 22.6754698,17.1428571 L1.32453024,17.1428571 C0.59301239,17.1428571 1.13686838e-13,16.5456456 1.13686838e-13,15.8074645 L1.13686838e-13,15.0496784 Z M1.13686838e-13,8.19253554 C1.13686838e-13,7.45501852 0.604530308,6.85714286 1.33931943,6.85714286 L18.1462111,6.85714286 C18.8858968,6.85714286 19.4855305,7.45435442 19.4855305,8.19253554 L19.4855305,8.95032161 C19.4855305,9.68783862 18.8810002,10.2857143 18.1462111,10.2857143 L1.33931943,10.2857143 C0.599633732,10.2857143 1.13686838e-13,9.68850272 1.13686838e-13,8.95032161 L1.13686838e-13,8.19253554 Z M1.13686838e-13,1.33539268 C1.13686838e-13,0.597875668 0.587350533,2.0480018e-13 1.32086427,1.86039073e-13 L7.63090422,2.46469511e-14 C8.36039741,5.98867722e-15 8.95176849,0.597211565 8.95176849,1.33539268 L8.95176849,2.09317875 C8.95176849,2.83069576 8.36441796,3.42857143 7.63090422,3.42857143 L1.32086427,3.42857143 C0.591371077,3.42857143 1.13686838e-13,2.83135986 1.13686838e-13,2.09317875 L1.13686838e-13,1.33539268 Z',
            id: pathId
          };
          break;

        case 'note':
        case 'text-lines':
          // alias
          path = {
            d: 'M18.671 32h-14.678c-2.201 0-3.992-1.786-3.992-3.988v-24.024c0-2.199 1.787-3.988 3.992-3.988h18.682c2.201 0 3.992 1.786 3.992 3.988v16.679h-9.337c-1.471 0-2.663 1.191-2.663 2.657v8.676h4.004zM17.778 32v-7.331c0-0.737 0.597-1.335 1.331-1.335h7.558l-8.889 8.667zM2.735 6.736c0 0.736 0.608 1.333 1.335 1.333h12.373c0.737 0 1.335-0.592 1.335-1.333 0-0.736-0.608-1.333-1.335-1.333h-12.373c-0.737 0-1.335 0.592-1.335 1.333zM2.735 12.069c0 0.736 0.591 1.333 1.33 1.333h18.605c0.735 0 1.33-0.592 1.33-1.333 0-0.736-0.591-1.333-1.33-1.333h-18.605c-0.735 0-1.33 0.592-1.33 1.333zM2.735 17.403c0 0.736 0.594 1.333 1.326 1.333h14.613c0.732 0 1.326-0.592 1.326-1.333 0-0.736-0.594-1.333-1.326-1.333h-14.613c-0.732 0-1.326 0.592-1.326 1.333zM2.735 22.736c0 0.736 0.596 1.333 1.345 1.333h5.241c0.743 0 1.345-0.592 1.345-1.333 0-0.736-0.596-1.333-1.345-1.333h-5.241c-0.743 0-1.345 0.592-1.345 1.333z',
            id: pathId
          };
          viewBox = '0 0 27 32';
          break;

        case 'ticket':
          path = {
            d: 'M2.5338853,19.3913498 L0.225507942,17.0829725 C-0.075169314,16.7822952 -0.075169314,16.2948011 0.225507942,15.9941238 L11.351636,4.86799577 L19.1320042,12.648364 L8.00587619,23.7744921 C7.70519893,24.0751693 7.21770478,24.0751693 6.91702752,23.7744921 L4.60865017,21.4661147 C5.18158066,20.8931842 5.18158066,19.9642803 4.60865017,19.3913498 C4.03571967,18.8184193 3.1068158,18.8184193 2.5338853,19.3913498 Z M19.3913498,2.5338853 C18.8184193,3.1068158 18.8184193,4.03571967 19.3913498,4.60865017 C19.9642803,5.18158066 20.8931842,5.18158066 21.4661147,4.60865017 L23.7744921,6.91702752 C24.0751693,7.21770478 24.0751693,7.70519893 23.7744921,8.00587619 L20.4287323,11.351636 L12.648364,3.57126773 L15.9941238,0.225507942 C16.2948011,-0.075169314 16.7822952,-0.075169314 17.0829725,0.225507942 L19.3913498,2.5338853 Z M4.34930456,15.7605113 C4.20607193,15.9037439 4.20607193,16.1359699 4.34930456,16.2792025 L4.60865017,16.5385481 C4.75188279,16.6817808 4.98410876,16.6817808 5.12734138,16.5385481 L12.3890184,9.27687111 C12.532251,9.13363849 12.532251,8.90141252 12.3890184,8.7581799 L12.1296728,8.49883429 C11.9864402,8.35560166 11.7542142,8.35560166 11.6109816,8.49883429 L4.34930456,15.7605113 Z M5.90537821,17.316585 C5.76214558,17.4598176 5.76214558,17.6920436 5.90537821,17.8352762 L6.16472382,18.0946218 C6.30795644,18.2378544 6.54018241,18.2378544 6.68341503,18.0946218 L11.351636,13.4264008 C11.4948686,13.2831682 11.4948686,13.0509423 11.351636,12.9077096 L11.0922904,12.648364 C10.9490577,12.5051314 10.7168318,12.5051314 10.5735992,12.648364 L5.90537821,17.316585 Z M7.46145186,18.8726586 C7.31821923,19.0158912 7.31821923,19.2481172 7.46145186,19.3913498 L7.72079746,19.6506954 C7.86403009,19.7939281 8.09625606,19.7939281 8.23948868,19.6506954 L14.2044377,13.6857465 C14.3476703,13.5425138 14.3476703,13.3102879 14.2044377,13.1670552 L13.9450921,12.9077096 C13.8018594,12.764477 13.5696335,12.764477 13.4264008,12.9077096 L7.46145186,18.8726586 Z',
            id: pathId
          };
          break;

        case 'time':
          path = {
            d: 'M13.5,9.99810702 L17.1112286,14.7903692 C17.4427857,15.2303604 17.3580417,15.8534434 16.9137638,16.1882309 L16.1134616,16.7913018 C15.6728476,17.1233282 15.0470625,17.0360487 14.7153221,16.5958143 L11.2228212,11.9611091 C10.8054211,11.8407178 10.5,11.4552996 10.5,11.009222 L10.5,11.001893 C10.225159,10.6371666 10.2360102,10.147389 10.5,9.79962236 L10.5,6.99077797 C10.5,6.44358641 10.9426603,6 11.4989566,6 L12.5010434,6 C13.0527519,6 13.5,6.45097518 13.5,6.99077797 L13.5,9.99810702 Z M12,24 C5.372583,24 0,18.627417 0,12 C0,5.372583 5.372583,0 12,0 C18.627417,0 24,5.372583 24,12 C24,18.627417 18.627417,24 12,24 Z M12,21 C16.9705627,21 21,16.9705627 21,12 C21,7.02943725 16.9705627,3 12,3 C7.02943725,3 3,7.02943725 3,12 C3,16.9705627 7.02943725,21 12,21 Z',
            id: pathId
          };
          break;

        case 'future':
        case 'time-future':
          // alias
          path = {
            d: 'M21.6158493,10.1106267 L16.246602,10.1106267 L14.0466357,14.8404414 L19.706043,18.4537939 C17.7273724,21.2086795 14.5148268,23 10.8879012,23 C4.87505776,23 0,18.0755914 0,11.9996563 C0,5.92509609 4.87505776,1 10.8879012,1 C16.2637968,1 20.7293114,4.9360289 21.6158493,10.1106267 Z M17.8765435,10.1106267 L16.246602,10.1106267 L14.0466357,14.8404414 L17.2832983,16.9069481 C15.8168301,18.8549004 13.498484,20.1125215 10.8894713,20.1125215 C6.45593357,20.1125215 2.86081675,16.47998 2.86081675,11.9997103 C2.86081675,7.52059946 6.45593357,3.88747852 10.8894713,3.88747852 C14.6797414,3.88747852 17.8565561,6.54212688 18.6992024,10.1106267 L22.8940808,10.1106267 C23.9983262,10.1106267 24.3324911,10.8081955 23.6368874,11.6686902 L21.1761541,14.7127338 C21.144911,14.7631767 21.1244077,14.8200591 21.0834011,14.866209 C21.0482525,14.9048461 20.9926007,14.8941135 20.9525704,14.9252379 C20.8090472,15.0508084 20.6440444,15.1366686 20.4507275,15.1527674 C20.4312005,15.1549139 20.4175316,15.1688662 20.3853122,15.172086 C20.3794541,15.172086 20.3755487,15.1688662 20.3335657,15.1602802 C20.1041239,15.1463279 19.8981144,15.0475886 19.737017,14.8887473 C19.7223718,14.874795 19.7008921,14.8812345 19.6872232,14.866209 C19.647193,14.8222056 19.6286423,14.7653232 19.5973992,14.7148803 L17.1347286,11.6694169 C16.4397035,10.8099137 16.7706991,10.1106267 17.8765435,10.1106267 Z M9.8550409,13.1 L9.71378405,13.1 L9.71378405,6.5 L11.9104352,6.5 L11.9104352,12.2853575 L14.7290815,14.4874342 L13.376688,16.2183472 L9.67696056,13.327923 L9.8550409,13.1 Z',
            id: pathId
          };
          break;

        case 'history':
        case 'time-history':
          // alias
          path = {
            d: 'M2.38504596,13.8893733 L7.75407089,13.8893733 L9.95394608,9.15955861 L4.29477309,5.54620607 C6.27336177,2.79132052 9.48577429,1 13.1125497,1 C19.1251441,1 24,5.92440861 24,12.0003437 C24,18.0749039 19.1251441,23 13.1125497,23 C7.73687674,23 3.27154711,19.0639711 2.38504596,13.8893733 Z M6.12419688,13.8893733 L7.75407089,13.8893733 L9.95394608,9.15955861 L6.71741752,7.09305195 C8.18382491,5.14509956 10.502075,3.88747852 13.1109797,3.88747852 C17.5443338,3.88747852 21.1393017,7.52002001 21.1393017,12.0002897 C21.1393017,16.4794005 17.5443338,20.1125215 13.1109797,20.1125215 C9.32086656,20.1125215 6.1441834,17.4578731 5.30157201,13.8893733 L1.10686733,13.8893733 C0.00266766057,13.8893733 -0.331483328,13.1918045 0.364091557,12.3313098 L2.82472286,9.28726616 C2.85596471,9.23682329 2.87646717,9.1799409 2.91747209,9.13379104 C2.95261917,9.09515395 3.00826871,9.10588647 3.04829733,9.07476215 C3.19181456,8.94919159 3.35681056,8.86333138 3.55011949,8.8472326 C3.56964564,8.84508609 3.58331395,8.83113381 3.6155321,8.82791405 C3.62138995,8.82791405 3.62529518,8.83113381 3.66727641,8.83971983 C3.89670872,8.85367211 4.10270965,8.95241135 4.26380042,9.11125274 C4.27844504,9.12520502 4.29992381,9.1187655 4.31359212,9.13379104 C4.35362073,9.1777944 4.37217058,9.23467678 4.40341242,9.28511966 L6.86598105,12.3305831 C7.56097731,13.1900863 7.22999549,13.8893733 6.12419688,13.8893733 Z M12.4496014,10.9 L12.2715285,10.672077 L15.9711027,7.78165281 L17.3234402,9.51256584 L14.5049106,11.7146425 L14.5049106,17.5 L12.3083504,17.5 L12.3083504,10.9 L12.4496014,10.9 Z',
            id: pathId
          };
          break;

        case 'false':
        case 'times-circle':
          // alias
          path = {
            d: 'M3.51471863,20.4852814 C-1.17157288,15.7989899 -1.17157288,8.20101013 3.51471863,3.51471863 C8.20101013,-1.17157288 15.7989899,-1.17157288 20.4852814,3.51471863 C25.1715729,8.20101013 25.1715729,15.7989899 20.4852814,20.4852814 C15.7989899,25.1715729 8.20101013,25.1715729 3.51471863,20.4852814 Z M14.1213203,12 L16.7729708,9.34834957 C17.3587572,8.76256313 17.3587572,7.81281566 16.7729708,7.22702923 C16.1871843,6.64124279 15.2374369,6.64124279 14.6516504,7.22702923 L12,9.87867966 L9.34834957,7.22702923 C8.76256313,6.64124279 7.81281566,6.64124279 7.22702923,7.22702923 C6.64124279,7.81281566 6.64124279,8.76256313 7.22702923,9.34834957 L9.87867966,12 L7.22702923,14.6516504 C6.64124279,15.2374369 6.64124279,16.1871843 7.22702923,16.7729708 C7.81281566,17.3587572 8.76256313,17.3587572 9.34834957,16.7729708 L12,14.1213203 L14.6516504,16.7729708 C15.2374369,17.3587572 16.1871843,17.3587572 16.7729708,16.7729708 C17.3587572,16.1871843 17.3587572,15.2374369 16.7729708,14.6516504 L14.1213203,12 Z',
            id: pathId
          };
          break;

        case 'not-selected':
        case 'times-square':
          // alias
          path = {
            d: 'M3,0 L21,0 C22.6568542,-3.04359188e-16 24,1.34314575 24,3 L24,21 C24,22.6568542 22.6568542,24 21,24 L3,24 C1.34314575,24 2.02906125e-16,22.6568542 0,21 L0,3 C-2.02906125e-16,1.34314575 1.34314575,3.04359188e-16 3,0 Z M14.1213203,12 L16.7729708,9.34834957 C17.3587572,8.76256313 17.3587572,7.81281566 16.7729708,7.22702923 C16.1871843,6.64124279 15.2374369,6.64124279 14.6516504,7.22702923 L12,9.87867966 L9.34834957,7.22702923 C8.76256313,6.64124279 7.81281566,6.64124279 7.22702923,7.22702923 C6.64124279,7.81281566 6.64124279,8.76256313 7.22702923,9.34834957 L9.87867966,12 L7.22702923,14.6516504 C6.64124279,15.2374369 6.64124279,16.1871843 7.22702923,16.7729708 C7.81281566,17.3587572 8.76256313,17.3587572 9.34834957,16.7729708 L12,14.1213203 L14.6516504,16.7729708 C15.2374369,17.3587572 16.1871843,17.3587572 16.7729708,16.7729708 C17.3587572,16.1871843 17.3587572,15.2374369 16.7729708,14.6516504 L14.1213203,12 Z',
            id: pathId
          };
          break;

        case 'undo':
          path = {
            d: 'M3.0116951,12.5 C3.00392737,12.3343086 3,12.167613 3,12 C3,6.20101013 7.70101013,1.5 13.5,1.5 C19.2989899,1.5 24,6.20101013 24,12 C24,17.7989899 19.2989899,22.5 13.5,22.5 C11.4792117,22.5 9.59175453,21.929142 7.99009445,20.9398921 L10.6847026,17.8603399 C11.5365084,18.2702922 12.4914286,18.5 13.5,18.5 C17.0898509,18.5 20,15.5898509 20,12 C20,8.41014913 17.0898509,5.5 13.5,5.5 C9.91014913,5.5 7,8.41014913 7,12 C7,12.168236 7.00639146,12.3349792 7.01894482,12.5 L10,12.5 L5,17.5 L0,12.5 L3.0116951,12.5 Z',
            id: pathId
          };
          break;

        case 'upload-1':
        case 'arrow-to-top':
          // alias
          path = {
            d: 'M1.5,0 L22.5,0 C23.3284271,0 24,0.671572875 24,1.5 C24,2.32842712 23.3284271,3 22.5,3 L1.5,3 C0.671572875,3 0,2.32842712 0,1.5 C0,0.671572875 0.671572875,0 1.5,0 Z M16.3743166,15.0032727 L13.8756444,12.4565455 L13.872364,22.0909091 C13.872364,22.0909091 13.872364,24 11.9978912,24 C10.1234184,24 10.1234184,22.0909091 10.1234184,22.0909091 L10.1248243,12.4565455 L7.62427755,15.0032727 C6.91010341,15.7306364 5.74980474,15.7306364 5.0356306,15.0032727 C4.32145647,14.274 4.32145647,13.0941818 5.0356306,12.3649091 L10.4865975,6.81327273 C11.0598127,6.27109091 11.5640458,6 11.9992971,6 C12.4345483,6 12.940656,6.27236364 13.51762,6.81709091 L18.9629635,12.3649091 C19.6790122,13.0941818 19.6790122,14.274 18.9629635,15.0032727 C18.2487894,15.7306364 17.0903652,15.7306364 16.3743166,15.0032727 Z',
            id: pathId
          };
          break;

        case 'unpin':
          path = {
            d: 'M8.67932194,2.28702636 L7.75495376,2.29120429 C7.13387889,2.29401141 6.632669,1.79173004 6.63547013,1.16932745 C6.63827126,0.546924862 7.14402269,0.040092251 7.76509756,0.0372851316 L16.0118381,6.21724894e-15 C16.632913,-0.0027954104 17.1341229,0.49948596 17.1313217,1.12188855 C17.1285206,1.74429114 16.6227692,2.25112375 16.0016943,2.25393087 L15.3982431,2.25665834 C14.6605594,2.55935001 14.2870391,3.75021105 14.2776824,5.82924145 C14.2705837,7.40656868 14.5155854,8.44499232 15.0126876,8.94451234 L15.0146792,8.94450334 C16.6708788,8.93701769 18.0074385,10.2764347 18,11.9361749 L17.9965876,12.6874813 L6,12.7417032 L6.00338126,11.9903968 C6.01085095,10.3306566 7.35952142,8.97910294 9.01572107,8.97161729 L9.01636931,8.97161436 C9.51804912,8.45619046 9.77241279,7.41550981 9.77946031,5.84957241 C9.78881539,3.77090453 9.4221026,2.58338918 8.67932194,2.28702636 Z M10.4604772,12.7371812 L13.459292,12.7236272 L11.9091656,24 L10.4604772,12.7371812 Z',
            id: pathId
          };
          viewBox = '0 0 12 24';
          break;

        case 'urgent':
        case 'exclamation':
          // alias
          path = {
            d: 'M8.5,3.50359317 C8.5,1.56861209 10.0709366,0 12,0 C13.9329966,0 15.5,1.56571558 15.5,3.50359317 L15.5,10.380699 C15.5,12.3156801 13.9290634,13.8842922 12,13.8842922 C10.0670034,13.8842922 8.5,12.3185766 8.5,10.380699 L8.5,3.50359317 Z M12,24 C10.0670034,24 8.5,22.4329966 8.5,20.5 C8.5,18.5670034 10.0670034,17 12,17 C13.9329966,17 15.5,18.5670034 15.5,20.5 C15.5,22.4329966 13.9329966,24 12,24 Z',
            id: pathId
          };
          break;

        case 'person':
        case 'user-alt':
          // temp alias
          path = {
            d: 'M2.60178343,24 C1.55942713,22.2021376 1.98196798,18.6026627 3.02432428,17.4033377 C3.5208431,16.831802 7.11539157,15.8319015 7.11539157,15.8319015 C8.16941576,15.5167139 8.55741833,14.4934514 8.01566925,13.5294741 C8.01566925,13.5294741 5.99610607,10.5659104 5.99610607,7.65647853 C5.99610607,3.42771423 7.08778102,0 11.9983189,0 C16.9095232,0 18.0005317,3.42771423 18.0005317,7.65647853 C18.0005317,10.5569098 15.991193,13.517492 15.991193,13.517492 C15.4371974,14.4726469 15.8455988,15.5017088 16.9009202,15.8263068 C16.9009202,15.8263068 20.5064522,16.8453028 20.9883087,17.4033377 C22.0226674,18.6026627 22.4345447,22.2021376 21.400186,24 L2.60178343,24 Z',
            id: pathId
          };
          break;

        case 'user':
        case 'user-circle':
          // alias
          path = {
            d: 'M4.58220596,18.3279117 C4.6902024,17.7163856 4.89869008,17.1768123 5.17221281,16.8770861 C5.49805329,16.5198762 8.55434494,15.9228463 8.55434494,15.9228463 C9.55125787,15.710441 9.90170373,14.8307947 9.37881256,13.9317916 C9.37881256,13.9317916 8.25,12.5058949 8.25,10.6875 C8.25,8.04452231 8.77745954,6 12,6 C15.2229778,6 15.75,8.04452231 15.75,10.6875 C15.75,12.5002695 14.6192476,13.9362746 14.6192476,13.9362746 C14.083084,14.8161034 14.4693468,15.7026639 15.4848235,15.926084 C15.4848235,15.926084 18.5198592,16.5283143 18.8360776,16.8770861 C19.1072065,17.1764863 19.3131626,17.7152121 19.4194972,18.3259166 C20.8726842,16.6231489 21.75,14.4140285 21.75,12 C21.75,6.61522369 17.3847763,2.25 12,2.25 C6.61522369,2.25 2.25,6.61522369 2.25,12 C2.25,14.4149714 3.12800129,16.6248746 4.58220596,18.3279117 Z M12,24 C5.372583,24 0,18.627417 0,12 C0,5.372583 5.372583,0 12,0 C18.627417,0 24,5.372583 24,12 C24,18.627417 18.627417,24 12,24 Z',
            id: pathId
          };
          break;

        case 'people':
        case 'users':
          // alias
          path = {
            d: 'M9.90163697,4.75270034 C10.938818,5.04123796 12.0611476,5.72858641 12.6857143,7.27997986 C13.5749195,9.48872246 13.4551766,11.0729644 13.1675748,12.2245159 C13.132575,12.1918113 13.0979074,12.1585143 13.0635762,12.1246405 C13.0474044,12.2331244 13.0293672,12.3413404 13.0094978,12.4491658 C13.0457077,12.4391815 13.0812918,12.4293958 13.116206,12.419818 C12.968816,12.9538655 12.7934263,13.3889316 12.6857143,13.7468354 C12.3428571,14.8860759 10.9714286,16.7848101 10.9714286,16.7848101 L14.4833261,17.9816593 C15.0012018,18.1581506 15.5974324,18.7130503 15.8057329,19.2178892 C15.8057329,19.2178892 16.4413067,20.5491094 16.4568529,21.6796219 C16.4646315,22.5422305 16.3162863,23.3964338 15.9635817,24 L0.49518179,24 C-0.362528533,22.5435039 -0.0148377756,19.6274736 0.842872548,18.6558685 C1.25143661,18.1928522 4.31429605,17.3184685 5.77964258,16.9204689 C4.23203483,15.5885376 3.28822442,13.1166869 3.28822442,10.7596788 C3.28822442,7.53004696 4.08657033,4.87716279 7.56344238,4.58388698 C7.54953936,4.61564196 7.54285714,4.63291139 7.54285714,4.63291139 C7.54285714,4.63291139 7.92322564,4.55631244 8.48629585,4.56087664 C9.01240003,4.57700356 9.48235069,4.64267853 9.90163697,4.75270034 Z M19.7949382,19.443038 C20.0170132,16.9764098 18.5142857,16.0253165 18.5142857,16.0253165 L14.4,14.5063291 C14.4,14.5063291 15.0857143,13.3670886 15.7714286,12.2278481 C17.8285714,8.05063291 15.7714286,4.25316456 15.7714286,4.25316456 C15.7714286,4.25316456 14.7496082,1.98963839 11.6875059,1.97475724 C12.4026935,0.7597647 13.6564865,0 15.7700452,0 C19.8112648,0 20.7090089,2.77688242 20.7090089,6.20271678 C20.7090089,8.55243326 19.7701342,11.0169924 18.2302041,12.3519619 C19.6626462,12.7475309 22.7710235,13.6468276 23.1675226,14.0989065 C24.018652,15.0705115 24.3575682,17.9865419 23.5064388,19.443038 L19.7949382,19.443038 Z',
            id: pathId
          };
          break;

        case 'team':
        case 'users-circle':
          // alias
          path = {
            d: 'M8.69769204,8.63139988 C6.07829544,8.85658841 5.47683974,10.8935756 5.47683974,13.373412 C5.47683974,15.183214 6.1878851,17.0811967 7.35381771,18.1039052 C6.24985884,18.4095047 3.94236997,19.0808904 3.63456706,19.4364122 C3.43205923,19.6702143 3.2672892,20.0506517 3.15638205,20.4972755 C1.19635723,18.3204167 0,15.4177748 0,12.230345 C0,5.47571195 5.372583,0 12,0 C18.627417,0 24,5.47571195 24,12.230345 C24,15.300314 22.8901926,18.106098 21.0571732,20.2536808 C21.1627839,18.6222538 20.9029189,16.4603368 20.4534524,15.9374003 C20.1547389,15.5902766 17.8129579,14.8997618 16.7337886,14.5960286 C17.8939369,13.5709873 18.6012639,11.6786034 18.6012639,9.87440009 C18.6012639,7.2439118 17.9249238,5.11171396 14.8803606,5.11171396 C13.2880534,5.11171396 12.3434742,5.69509072 11.804668,6.62800904 C14.1115865,6.63943536 14.8814028,8.3774584 14.8814028,8.3774584 C14.8814028,8.3774584 16.4312076,11.2933016 14.8814028,14.5007292 C14.3648012,15.3754822 13.8481996,16.2502352 13.8481996,16.2502352 L16.9478092,17.4165725 C16.9478092,17.4165725 18.7560194,19.8711926 17.4645154,23.0786202 L15.6564621,24 C15.9147938,21.2360901 14.7891684,19.7899272 14.7891684,19.7899272 C14.5192413,19.3163341 13.8783864,18.8027273 13.3400562,18.6373085 L11.2651916,17.9997411 C11.2651916,17.9997411 12.2983948,16.5418195 12.5566956,15.6670665 C12.6378434,15.3922541 12.769978,15.0581935 12.8810183,14.6481312 C12.8547147,14.6554854 12.8279065,14.6629992 12.8006268,14.6706655 C12.8155959,14.587873 12.8291847,14.5047805 12.8413682,14.4214824 C12.8672325,14.447492 12.8933503,14.4730588 12.9197184,14.4981706 C13.136391,13.6139648 13.2266026,12.3975225 12.5566956,10.7015644 C12.0861612,9.51034443 11.2406235,8.98257167 10.4592348,8.76102131 C10.1433541,8.67654231 9.78930389,8.62611453 9.39294892,8.61373165 C8.96874459,8.61022708 8.68218359,8.66904272 8.68218359,8.66904272 C8.68218359,8.66904272 8.68721782,8.65578258 8.69769204,8.63139988 Z',
            id: pathId
          };
          break;

        case 'video':
        case 'video-reel':
          // alias
          path = {
            d: 'M0,20.25 L3.75,20.25 L3.75,24 L1.5,24 C0.671572875,24 0,23.3284271 0,22.5 L0,20.25 Z M0,13.5 L3.75,13.5 L3.75,17.25 L0,17.25 L0,13.5 Z M0,6.75 L3.75,6.75 L3.75,10.5 L0,10.5 L0,6.75 Z M1.5,0 L3.75,0 L3.75,3.75 L0,3.75 L0,1.5 C0,0.671572875 0.671572875,0 1.5,0 Z M20.25,20.25 L24,20.25 L24,22.5 C24,23.3284271 23.3284271,24 22.5,24 L20.25,24 L20.25,20.25 Z M20.25,13.5 L24,13.5 L24,17.25 L20.25,17.25 L20.25,13.5 Z M20.25,6.75 L24,6.75 L24,10.5 L20.25,10.5 L20.25,6.75 Z M20.25,0 L22.5,0 C23.3284271,0 24,0.671572875 24,1.5 L24,3.75 L20.25,3.75 L20.25,0 Z M6,0 L18,0 L18,10.5 L6,10.5 L6,0 Z M6,13.5 L18,13.5 L18,24 L6,24 L6,13.5 Z',
            id: pathId
          };
          break;

        case 'venue':
          path = {
            d: 'M16.0227262,23.999996 C13.2157251,23.999996 8.66815041,23.999996 2.38000213,23.999996 C1.76537498,23.9991286 1.17626597,23.7768608 0.742272697,23.34164 C0.308279421,22.9064192 0.0649524356,22.3166206 0.0658210297,21.7019934 L0.0658187123,12.3529054 C0.0658187123,12.3529054 0.957093482,12.3529054 2.38000213,12.3529054 C2.49030442,15.0418757 2.53878908,16.3235723 2.52545612,16.1979951 C7.92893474,16.1979951 11.2159037,16.1979951 12.3863631,16.1979951 C13.3560599,18.2629659 14.568181,20.8636329 16.0227262,23.999996 Z M22.8119972,9.81272425 C22.0379882,9.79373083 21.3486704,9.31824571 21.0559977,8.60145189 L19.4999982,3.77927156 L21.614543,3.77927156 L23.6625424,8.60145189 C23.9407241,9.25672442 23.5661788,9.81272425 22.8119972,9.81272425 Z M16.9214522,9.81272425 C16.1904462,9.82581306 15.5534391,9.31721515 15.4043618,8.60145189 L14.7999983,3.77927156 L16.9145431,3.77927156 L18.0119973,8.60145189 C18.1596336,9.25672442 17.6752701,9.81272425 16.9214522,9.81272425 Z M12.9134534,8.60145189 C12.90081,8.93964541 12.7526883,9.25854507 12.5024285,9.48637113 C12.2521686,9.7141972 11.9207998,9.83180555 11.5829084,9.81272425 C11.2493702,9.83558312 10.9215297,9.71753708 10.6791251,9.48729761 C10.4367205,9.25705814 10.3019656,8.93572434 10.3076361,8.60145189 L10.6632723,3.77927156 L12.7778171,3.77927156 L12.9134534,8.60145189 Z M8.64290929,3.77927156 L7.81818228,8.60145189 C7.63443058,9.3185499 6.98570169,9.81818365 6.24545549,9.81272425 C5.49163754,9.81272425 5.03272859,9.25672442 5.21163762,8.60145189 L6.52909176,3.77927156 L8.6440002,3.77927156 L8.64290929,3.77927156 Z M4.50763784,3.77927156 L2.72000203,8.60145189 C2.39463935,9.31719671 1.69161229,9.78658599 0.905820771,9.81272425 C0.152002821,9.81272425 -0.195997071,9.25672442 0.113457379,8.60145189 L2.39309304,3.77927156 L4.50909239,3.77927156 L4.50763784,3.77927156 Z M2.32041898,0 L21.7019416,0 C22.3183216,0.000867368352 22.9091106,0.245859216 23.3443416,0.681080003 C23.7795725,1.11630079 24.0008685,1.63537247 24,2.24999963 L2.48689958e-14,2.24999963 C-0.00140967431,0.970107628 1.03724274,0.00220738766 2.32041898,0 Z M15.7499988,16.0001307 C15.7499988,13.7908574 17.596761,11.999998 19.8749981,11.999998 C22.1528227,11.999998 23.9999974,13.7908574 23.9999974,16.0001307 C23.9999974,18.2086039 19.8749981,23.999996 19.8749981,23.999996 C19.8749981,23.999996 15.7499988,18.2086039 15.7499988,16.0001307 Z M17.9999984,16.1254661 C17.9999984,17.1604659 18.8390608,17.999997 19.8749981,17.999997 C20.9104667,17.999997 21.7499978,17.1604659 21.7499978,16.1254661 C21.7499978,15.0895287 20.9104667,14.2499976 19.8749981,14.2499976 C18.8390608,14.2499976 17.9999984,15.0895287 17.9999984,16.1254661 Z',
            id: pathId
          };
          break;

        case 'view':
          path = {
            d: 'M15,12.0002952 C15,13.6571495 13.6568542,15.0002952 12,15.0002952 C10.3431458,15.0002952 9,13.6571495 9,12.0002952 C9,10.343441 10.3431458,9.00029523 12,9.00029523 C13.6568542,9.00029523 15,10.343441 15,12.0002952 Z M12,4.00029523 C6.74120779,3.96480183 1.98984925,7.13237419 0,12.0002952 C2.01850425,16.8447054 6.75188895,20.0002952 12,20.0002952 C17.2481111,20.0002952 21.9814957,16.8447054 24,12.0002952 C22.0101507,7.13237419 17.2587922,3.96480183 12,4.00029523 Z M12,17.0002952 C9.23857625,17.0002952 7,14.761719 7,12.0002952 C7,9.23887149 9.23857625,7.00029523 12,7.00029523 C14.7614237,7.00029523 17,9.23887149 17,12.0002952 L17,12.0002952 C17,14.761719 14.7614237,17.0002952 12,17.0002952 L12,17.0002952 Z',
            id: pathId
          };
          break;

        case 'audio':
        case 'volume':
          // alias
          path = {
            d: 'M12.6171623,0 L12.6171623,24 L5.95455928,17.1609701 L1.5,17.1609701 C0.671572875,17.1609701 0,16.4893973 0,15.6609701 L0,8.33902986 C0,7.51060273 0.671572875,6.83902986 1.5,6.83902986 L6.17467737,6.83902986 L12.6171623,0 Z M15.7473535,8.33151365 L17.2878408,6.46614904 C18.6146439,7.89112905 19.3697853,9.8676553 19.3783686,11.9379493 C19.3670327,14.0197403 18.6593543,16.0193682 17.3978149,17.5342352 L15.7473535,15.7931642 C15.7473535,15.7931642 17.0677227,13.7748819 17.0677227,12.062435 C17.0677227,10.349988 15.7473535,8.33151365 15.7473535,8.33151365 Z M19.0482763,4.60078444 L20.5887636,2.85971344 C20.5887636,2.85971344 24,6.2192908 24,12.0616665 C24,17.9040423 20.5887636,21.1399023 20.5887636,21.1399023 L18.9383022,19.3988313 C18.9383022,19.3988313 21.6885055,16.5345073 21.6885055,12.0630113 C21.6885055,7.59151525 19.0482763,4.60136076 19.0482763,4.60136076 L19.0482763,4.60078444 Z',
            id: pathId
          };
          break;

        case 'want-help':
        case 'hand-help':
          // alias
          path = {
            d: 'M23.12245,11.0561933 C23.12245,11.0561933 16.4074197,15.8210357 14.308671,17.2710795 C12.2099223,18.7211232 11.0189141,17.5599014 11.0189141,17.5599014 L7.46327303,15.1088377 L4.2148904,17.3962516 C3.45948237,17.9281873 2.5,17 2.14178288,16.4352691 L0.213455765,13.9054686 C-0.27192466,12.5827541 0.0984638193,10.95814 1.04074159,10.2767913 C3.89940689,8.26639694 5.70500359,6.99928672 6.47680285,6.46171812 C7.85504659,5.50175278 8.70759771,6.33651742 8.70759771,6.33651742 L16.1911875,9.75452209 C16.1911875,9.75452209 17.099147,11.0186823 16.6067118,12.3714296 C16.1142767,13.724177 14.8248846,13.3061846 14.8248846,13.3061846 L11.7527145,11.9132648 L11.5757154,12.714098 L14.8242475,14.1763594 C14.8242475,14.1763594 16.234265,14.5567096 16.9913628,13.0238999 C17.4380856,12.1688572 17.5007736,11.0318448 17.1536459,10.0804685 L21.8574948,6.86569011 C21.8574948,6.86569011 23.281813,6.31230552 23.854638,8.02036334 C24.4274629,9.72842116 23.12245,11.0561933 23.12245,11.0561933 Z',
            id: pathId
          };
          break;

        case 'workflow':
          path = {
            d: 'M12,16.5 L16.5,16.5 L16.5,12 L14.0085302,12 C12.8992496,12 12,11.0980496 12,9.9914698 L12,7.5 L7.5,7.5 L7.5,12 L9.9914698,12 C11.1007504,12 12,12.9019504 12,14.0085302 L12,16.5 Z M12,19.5 L12,21.9914698 C12,23.1007504 11.0980496,24 9.9914698,24 L2.0085302,24 C0.899249601,24 0,23.0980496 0,21.9914698 L0,14.0085302 C0,12.8992496 0.901950359,12 2.0085302,12 L4.5,12 L4.5,6 C4.5,4.5 6,4.5 6,4.5 L12,4.5 L12,2.0085302 C12,0.899249601 12.9019504,0 14.0085302,0 L21.9914698,0 C23.1007504,0 24,0.901950359 24,2.0085302 L24,9.9914698 C24,11.1007504 23.0980496,12 21.9914698,12 L19.5,12 L19.5,18 C19.5,19.5 18,19.5 18,19.5 L12,19.5 Z',
            id: pathId
          };
          break;

        case 'scan':
          path = {
            d: 'M3,0 L21,0 C22.6568542,0 24,1.34314575 24,3 L24,21 C24,22.6568542 22.6568542,24 21,24 L3,24 C1.34314575,24 0,22.6568542 0,21 L0,3 C0,1.34314575 1.34314575,0 3,0 Z M8.25,0 L8.25,3 L4.5,3 C3.67157288,3 3,3.67157288 3,4.5 L3,8.25 L0,8.25 L0,15.75 L3,15.75 L3,19.5 C3,20.3284271 3.67157288,21 4.5,21 L8.25,21 L8.25,24 L15.75,24 L15.75,21 L19.5,21 C20.3284271,21 21,20.3284271 21,19.5 L21,15.75 L24,15.75 L24,8.25 L21,8.25 L21,4.5 C21,3.67157288 20.3284271,3 19.5,3 L15.75,3 L15.75,0 L8.25,0 Z',
            id: pathId
          };
          break;

        case 'sign-out':
          path = {
            d: 'M12.75,6.75 L9.75,6.75 L9.75,17.25 L12.75,17.25 L12.75,21.75 C12.75,22.9926407 11.7426407,24 10.5,24 L2.25,24 C1.00735931,24 0,22.9926407 0,21.75 L0,2.25 C0,1.00735931 1.00735931,0 2.25,0 L10.5,0 C11.7426407,0 12.75,1.00735931 12.75,2.25 L12.75,6.75 Z M3,3 L3,21 L9.75,21 L9.75,3 L3,3 Z M16.1221364,15.9368849 L18.3505227,13.6880799 L8.42045455,13.6851276 C8.42045455,13.6851276 6.75,13.6851276 6.75,11.9981021 C6.75,10.3110766 8.42045455,10.3110766 8.42045455,10.3110766 L18.3505227,10.3123418 L16.1221364,8.06184979 C15.4856932,7.41909307 15.4856932,6.37482427 16.1221364,5.73206754 C16.76025,5.08931082 17.7925909,5.08931082 18.4307045,5.73206754 L23.2883864,10.6379378 C23.7627955,11.1538314 24,11.6076413 24,11.9993674 C24,12.3910935 23.7616818,12.8465904 23.2850455,13.365858 L18.4307045,18.2666672 C17.7925909,18.9111109 16.76025,18.9111109 16.1221364,18.2666672 C15.4856932,17.6239105 15.4856932,16.5813287 16.1221364,15.9368849 Z',
            id: pathId
          };
          break;

        case 'splitter':
          path = {
            d: 'M2,18 C1.44771525,18 1,17.5522847 1,17 C1,16.4477153 1.44771525,16 2,16 C2.55228475,16 3,16.4477153 3,17 C3,17.5522847 2.55228475,18 2,18 Z M2,21 C1.44771525,21 1,20.5522847 1,20 C1,19.4477153 1.44771525,19 2,19 C2.55228475,19 3,19.4477153 3,20 C3,20.5522847 2.55228475,21 2,21 Z M2,24 C1.44771525,24 1,23.5522847 1,23 C1,22.4477153 1.44771525,22 2,22 C2.55228475,22 3,22.4477153 3,23 C3,23.5522847 2.55228475,24 2,24 Z M2,27 C1.44771525,27 1,26.5522847 1,26 C1,25.4477153 1.44771525,25 2,25 C2.55228475,25 3,25.4477153 3,26 C3,26.5522847 2.55228475,27 2,27 Z M2,30 C1.44771525,30 1,29.5522847 1,29 C1,28.4477153 1.44771525,28 2,28 C2.55228475,28 3,28.4477153 3,29 C3,29.5522847 2.55228475,30 2,30 Z M5,18 C4.44771525,18 4,17.5522847 4,17 C4,16.4477153 4.44771525,16 5,16 C5.55228475,16 6,16.4477153 6,17 C6,17.5522847 5.55228475,18 5,18 Z M5,21 C4.44771525,21 4,20.5522847 4,20 C4,19.4477153 4.44771525,19 5,19 C5.55228475,19 6,19.4477153 6,20 C6,20.5522847 5.55228475,21 5,21 Z M5,24 C4.44771525,24 4,23.5522847 4,23 C4,22.4477153 4.44771525,22 5,22 C5.55228475,22 6,22.4477153 6,23 C6,23.5522847 5.55228475,24 5,24 Z M5,27 C4.44771525,27 4,26.5522847 4,26 C4,25.4477153 4.44771525,25 5,25 C5.55228475,25 6,25.4477153 6,26 C6,26.5522847 5.55228475,27 5,27 Z M5,30 C4.44771525,30 4,29.5522847 4,29 C4,28.4477153 4.44771525,28 5,28 C5.55228475,28 6,28.4477153 6,29 C6,29.5522847 5.55228475,30 5,30 Z',
            id: pathId,
            transform: 'translate(-1.000000, -16.000000)'
          };
          viewBox = '0 0 5 14';
          break;

        case 'training':
          path = {
            d: 'M13.6934638,3.38674394 L23.593311,8.12616608 C23.9402985,8.2922818 24.0952231,8.72670786 23.9393447,9.09648383 C23.8655806,9.27146769 23.7304653,9.40872384 23.5629236,9.47886912 L21.6422618,10.2819739 L21.642396,14.8098019 C22.0438074,14.9894944 22.3314285,15.4747025 22.3314285,16.0450684 L22.3314285,20.4106272 C22.3314285,20.4727982 22.284135,20.5231978 22.2257954,20.5231978 C22.1796849,20.5231978 22.1389024,20.4913245 22.125082,20.4444447 L22.0043538,20.0361214 C21.7251919,18.9066172 21.5977928,19.4731364 21.4296808,19.9422906 L21.3991532,20.0361214 L21.1439953,20.8973593 C21.1210898,20.9746723 21.0437091,21.0175589 20.9711607,20.9931492 C20.9283011,20.9787286 20.8947382,20.9429326 20.8812408,20.8972466 L20.5591377,19.8113893 C20.4225804,19.3773757 20.2753682,19.0910586 20.052158,19.9422906 L20.0216303,20.0361214 L19.895245,20.462964 C19.8681311,20.5545793 19.7764527,20.6054112 19.6904872,20.5765042 C19.6361496,20.5582325 19.5957254,20.5116107 19.5817292,20.4548316 L19.5763828,20.4106272 L19.5763828,16.0450684 C19.5763828,15.4750277 19.863676,14.9900478 20.2647288,14.8101096 L20.2647389,10.8588947 L13.5111396,13.6872875 C12.5398527,14.0939398 11.4601614,14.0939398 10.4888745,13.6872875 L0.437090453,9.47886912 C0.0830413974,9.33063807 -0.0912125595,8.90460993 0.0478833472,8.52730864 C0.113705736,8.34876369 0.242503094,8.20477467 0.406703087,8.12616608 L10.3065503,3.38674394 C11.3836735,2.87108535 12.6163406,2.87108535 13.6934638,3.38674394 Z M18.5965587,13.3911807 L18.5965587,16.0173065 C18.5965587,16.7355905 18.2678235,17.4087299 17.7157745,17.8208334 C15.8751144,19.1948824 14.0064615,19.881907 12.1098156,19.881907 C10.2111656,19.881907 8.31251561,19.1934297 6.4138656,17.8164752 C5.84847468,17.4064454 5.51009147,16.7248515 5.51009147,15.9960452 L5.51009147,13.4359545 L10.4888745,15.520536 C11.399456,15.9017725 12.4053147,15.9255998 13.3278058,15.5920178 L13.5111396,15.520536 L18.5965587,13.3911807 Z',
            id: pathId
          };
          viewBox = '0 0 24 18';
          break;

        case 'transfer':
          path = {
            d: 'M8.12940039,13.8288796 C8.20806259,13.9487026 8.25,14.089149 8.25,14.2327619 L8.25,16.5 L14.25,16.5 C15.0784271,16.5 15.75,17.1715729 15.75,18 L15.75,19.5 C15.75,20.3284271 15.0784271,21 14.25,21 L8.25,21 L8.25,23.2673188 C8.25,23.6719674 7.92405089,24 7.52197229,24 C7.37927152,24 7.23971717,23.9577945 7.12065515,23.8786295 L0.326790733,19.3613511 C-0.00868254475,19.138293 -0.100961566,18.6837756 0.120679772,18.346158 C0.174786669,18.2637391 0.244895278,18.1931823 0.326790733,18.1387296 L7.12065515,13.6214512 C7.45612842,13.3983931 7.90775905,13.491262 8.12940039,13.8288796 Z M16.8793449,0.121451151 L23.6732093,4.63872958 C23.7551047,4.69318233 23.8252133,4.76373907 23.8793202,4.846158 C24.1009616,5.1837756 24.0086825,5.63829303 23.6732093,5.86135109 L16.8793449,10.3786295 C16.7602828,10.4577945 16.6207285,10.5 16.4780277,10.5 C16.0759491,10.5 15.75,10.1719674 15.75,9.76731877 L15.75,7.5 L9.75,7.5 C8.92157288,7.5 8.25,6.82842712 8.25,6 L8.25,4.5 C8.25,3.67157288 8.92157288,3 9.75,3 L15.75,3 L15.75,0.732761906 C15.75,0.589149005 15.7919374,0.44870263 15.8705996,0.328879564 C16.0922409,-0.00873804317 16.5438716,-0.101606907 16.8793449,0.121451151 Z',
            id: pathId
          };
          break;

        case 'upload-2':
        case 'cloud-upload':
          // alias
          path = {
            d: 'M16,18.0094723 L16.6666667,18.0094723 C19.2693333,17.7957375 21.3333333,16.600998 21.3333333,13.8910521 C21.3333333,11.1586773 19.236,9.94612652 16.6013333,9.80099797 C16.2866667,7.47564276 14.358,5.67868742 12,5.67868742 C9.42266667,5.67868742 7.33333333,7.81669486 7.33333333,10.4560555 C4.756,10.4560555 2.66666667,11.5940629 2.66666667,14.2321042 C2.66666667,16.8708051 4.756,18.0088126 8,18.0088126 L8,20.6861806 C4.01933333,20.6861806 0,19.0625 0,14.2314445 C0,11.2635656 1.33333333,9.5625 4.78933333,7.90204668 C6.66666667,4.3125 9.102,3 12,3 C14.664,3 17.3333333,4.3125 19.0126667,7.24830853 C21.3333333,8.25 24,11.1875 24,13.8897327 C24,19.0625 19.4973333,20.6875 16,20.6875 L16,18.0094723 Z M15.113,15.75225 L13.3356667,14.001375 L13.3333333,19.6875 C13.3333333,19.6875 13.3333333,21 12,21 C10.6666667,21 10.6666667,19.6875 10.6666667,19.6875 L10.6676667,14.001375 L8.889,15.75225 C8.381,16.2523125 7.55566667,16.2523125 7.04766667,15.75225 C6.53966667,15.250875 6.53966667,14.43975 7.04766667,13.938375 L10.925,10.121625 C10.9676667,10.0599375 10.993,9.990375 11.0476667,9.9365625 C11.0663333,9.9181875 11.0956667,9.9260625 11.1156667,9.909 C11.3356667,9.71475 11.617,9.594 11.9303333,9.5769375 C11.9876667,9.5664375 11.993,9.5625 12.001,9.5625 C12.045,9.5664375 12.0636667,9.5835 12.0903333,9.586125 C12.3543333,9.6058125 12.5796667,9.7108125 12.7756667,9.864375 C12.8303333,9.9024375 12.9063333,9.8893125 12.9543333,9.9365625 C13.0103333,9.993 13.0383333,10.0625625 13.081,10.12425 L16.9543333,13.938375 C17.4636667,14.43975 17.4636667,15.250875 16.9543333,15.75225 C16.4463333,16.2523125 15.6223333,16.2523125 15.113,15.75225 Z',
            id: pathId
          };
          break;

        case 'share':
          path = {
            d: 'M16.875,7.5 L18.75,7.5 C19.9926407,7.5 21,8.50735931 21,9.75 L21,21.75 C21,22.9926407 19.9926407,24 18.75,24 L5.25,24 C4.00735931,24 3,22.9926407 3,21.75 L3,9.75 C3,8.50735931 4.00735931,7.5 5.25,7.5 L7.125,7.5 C7.74632034,7.5 8.25,8.00367966 8.25,8.625 C8.25,9.24632034 7.74632034,9.75 7.125,9.75 L5.25,9.75 L5.25,21.75 L18.75,21.75 L18.75,9.75 L16.875,9.75 C16.2536797,9.75 15.75,9.24632034 15.75,8.625 C15.75,8.00367966 16.2536797,7.5 16.875,7.5 Z M14.62459,5.48025296 L13.1253866,3.93007115 L13.1234184,13.8379447 C13.1234184,13.8379447 13.1234184,15 11.9987347,15 C10.874051,15 10.874051,13.8379447 10.874051,13.8379447 L10.8748946,3.93007115 L9.37456653,5.48025296 C8.94606205,5.92299605 8.24988285,5.92299605 7.82137836,5.48025296 C7.39287388,5.03634783 7.39287388,4.31819763 7.82137836,3.87429249 L11.0919585,0.495035573 C11.4358876,0.165011858 11.7384275,0 11.9995782,0 C12.260729,0 12.5643936,0.165786561 12.910572,0.497359684 L16.1777781,3.87429249 C16.6074073,4.31819763 16.6074073,5.03634783 16.1777781,5.48025296 C15.7492736,5.92299605 15.0542191,5.92299605 14.62459,5.48025296 Z',
            id: pathId
          };
          break;

        case 'slot':
          path = {
            d: 'M3,0 L21,0 C22.6568542,0 24,1.34314575 24,3 L24,21 C24,22.6568542 22.6568542,24 21,24 L3,24 C1.34314575,24 0,22.6568542 0,21 L0,3 C0,1.34314575 1.34314575,0 3,0 Z M9,3 L9,0 L5.25,0 L5.25,3 L4.5,3 C3.67157288,3 3,3.67157288 3,4.5 L3,5.25 L0,5.25 L0,9 L3,9 L3,15 L0,15 L0,18.75 L3,18.75 L3,19.5 C3,20.3284271 3.67157288,21 4.5,21 L5.25,21 L5.25,24 L9,24 L9,21 L15,21 L15,24 L18.75,24 L18.75,21 L19.5,21 C20.3284271,21 21,20.3284271 21,19.5 L21,18.75 L24,18.75 L24,15 L21,15 L21,9 L24,9 L24,5.25 L21,5.25 L21,4.5 C21,3.67157288 20.3284271,3 19.5,3 L18.75,3 L18.75,0 L15,0 L15,3 L9,3 Z',
            id: pathId
          };
          break;

        case 'slot-add':
          path = {
            d: 'M3,0 L21,0 C22.6568542,0 24,1.34314575 24,3 L24,21 C24,22.6568542 22.6568542,24 21,24 L3,24 C1.34314575,24 0,22.6568542 0,21 L0,3 C0,1.34314575 1.34314575,0 3,0 Z M9,3 L9,0 L5.25,0 L5.25,3 L4.5,3 C3.67157288,3 3,3.67157288 3,4.5 L3,5.25 L0,5.25 L0,9 L3,9 L3,15 L0,15 L0,18.75 L3,18.75 L3,19.5 C3,20.3284271 3.67157288,21 4.5,21 L5.25,21 L5.25,24 L9,24 L9,21 L15,21 L15,24 L18.75,24 L18.75,21 L19.5,21 C20.3284271,21 21,20.3284271 21,19.5 L21,18.75 L24,18.75 L24,15 L21,15 L21,9 L24,9 L24,5.25 L21,5.25 L21,4.5 C21,3.67157288 20.3284271,3 19.5,3 L18.75,3 L18.75,0 L15,0 L15,3 L9,3 Z M13.5,11.25 L16.875,11.25 C17.4963203,11.25 18,11.7536797 18,12.375 C18,12.9963203 17.4963203,13.5 16.875,13.5 L13.5,13.5 L13.5,16.875 C13.5,17.4963203 12.9963203,18 12.375,18 C11.7536797,18 11.25,17.4963203 11.25,16.875 L11.25,13.5 L7.875,13.5 C7.25367966,13.5 6.75,12.9963203 6.75,12.375 C6.75,11.7536797 7.25367966,11.25 7.875,11.25 L11.25,11.25 L11.25,7.875 C11.25,7.25367966 11.7536797,6.75 12.375,6.75 C12.9963203,6.75 13.5,7.25367966 13.5,7.875 L13.5,11.25 Z',
            id: pathId
          };
          break;

        case 'slot-recurring':
          path = {
            d: 'M3,0 L21,0 C22.6568542,0 24,1.34314575 24,3 L24,21 C24,22.6568542 22.6568542,24 21,24 L3,24 C1.34314575,24 0,22.6568542 0,21 L0,3 C0,1.34314575 1.34314575,0 3,0 Z M9,0 L9,3 L15,3 L15,0 L18.75,0 L18.75,3 L19.5,3 C20.3284271,3 21,3.67157288 21,4.5 L21,4.5 L21,5.25 L24,5.25 L24,9 L21,9 L21,15 L24,15 L24,18.75 L21,18.75 L21,19.5 C21,20.3284271 20.3284271,21 19.5,21 L19.5,21 L18.75,21 L18.75,24 L15,24 L15,21 L9,21 L9,24 L5.25,24 L5.25,21 L4.5,21 C3.67157288,21 3,20.3284271 3,19.5 L3,19.5 L3,18.75 L0,18.75 L0,15 L3,15 L3,9 L0,9 L0,5.25 L3,5.25 L3,4.5 C3,3.67157288 3.67157288,3 4.5,3 L4.5,3 L5.25,3 L5.25,0 L9,0 Z M9.75,7.875 L6.9375,7.875 C6.41612327,7.875 6,8.29870871 6,8.8213799 L6,8.8213799 L6,15.1786201 C6,15.7045391 6.41973305,16.125 6.9375,16.125 L6.9375,16.125 L9.749,16.125 L9.75,18 L12.75,15.1875 L9.75,12.375 L9.749,14.25 L7.875,14.25 L7.875,9.75 L9.75,9.75 L9.75,7.875 Z M17.0625,15.75 C17.5838767,15.75 18,15.3317039 18,14.8157095 L18,14.8157095 L18,8.80929051 C18,8.2983942 17.580267,7.875 17.0625,7.875 L17.0625,7.875 L14.25,7.875 L14.25,6 L11.25,8.8125 L14.25,11.625 L14.25,9.75 L16.125,9.75 L16.125,13.875 L14.25,13.875 L14.25,15.75 Z',
            id: pathId
          };
          break;

        case 'password':
          path = {
            d: 'M23.5922996,19.8100524 L23.9945444,23.1569082 C24.0441843,23.5699341 23.7495329,23.9449907 23.336422,23.9946204 C23.2781743,24.001618 23.2193085,24.0017895 23.161021,23.9951314 L19.3878862,23.5641277 C18.9915703,23.5188567 18.6992378,23.1725794 18.7211608,22.7743699 L18.7994751,21.3518705 C18.8197387,20.9838018 18.5705833,20.6551469 18.2106616,20.5751807 L15.9702311,20.0774096 C15.6557231,20.0075333 15.4204656,19.7454408 15.3848868,19.4252971 L15.1333109,17.1615796 C15.094825,16.8152771 14.8237946,16.540565 14.4779805,16.4973471 L12.054146,16.1944301 L10.2246212,14.5699594 C9.38897694,14.8895201 8.48185771,15.0645861 7.53384122,15.0645861 C3.37301561,15.0645861 0,11.6922636 0,7.53229305 C0,3.37232247 3.37301561,0 7.53384122,0 C11.6946668,0 15.0676824,3.37232247 15.0676824,7.53229305 C15.0676824,8.52232234 14.8766382,9.46774002 14.529397,10.333706 L23.5922996,19.8100524 Z M3.76692061,6.02583444 C3.76692061,7.27382561 4.77882529,8.28552235 6.02707298,8.28552235 C7.27532066,8.28552235 8.28722535,7.27382561 8.28722535,6.02583444 C8.28722535,4.77784326 7.27532066,3.76614652 6.02707298,3.76614652 C4.77882529,3.76614652 3.76692061,4.77784326 3.76692061,6.02583444 Z',
            id: pathId
          };
          break;

        case 'playlist':
          path = {
            d: 'M1.5,10.5 L22.5,10.5 C23.3284271,10.5 24,11.1715729 24,12 L24,22.5 C24,23.3284271 23.3284271,24 22.5,24 L1.5,24 C0.671572875,24 0,23.3284271 0,22.5 L0,12 C0,11.1715729 0.671572875,10.5 1.5,10.5 Z M14.1455799,17.8603001 C14.2129265,17.8121954 14.2718466,17.7532753 14.3199513,17.6859286 C14.5607081,17.3488692 14.4826393,16.8804566 14.1455799,16.6396999 L10.9359286,14.3470919 C10.8087281,14.2562343 10.6563172,14.207392 10.5,14.207392 C10.0857864,14.207392 9.75,14.5431784 9.75,14.957392 L9.75,19.542608 C9.75,19.6989252 9.79884235,19.8513361 9.8896999,19.9785367 C10.1304566,20.3155961 10.5988692,20.3936649 10.9359286,20.1529081 L14.1455799,17.8603001 Z M19.5,8.25 L5.25,8.25 C4.42157288,8.25 3.75,7.57842712 3.75,6.75 C3.75,5.92157288 4.42157288,5.25 5.25,5.25 L19.5,5.25 C20.3284271,5.25 21,5.92157288 21,6.75 C21,7.57842712 20.3284271,8.25 19.5,8.25 Z M18,3 L7.5,3 C6.67157288,3 6,2.32842712 6,1.5 C6,0.671572875 6.67157288,0 7.5,0 L18,0 C18.8284271,0 19.5,0.671572875 19.5,1.5 C19.5,2.32842712 18.8284271,3 18,3 Z',
            id: pathId
          };
          break;

        case 'document':
          path = {
            d: 'M10.2307692,0 L10.2307692,8.50031539 C10.2307692,9.60477591 11.1263659,10.5 12.2311403,10.5 L12.2311403,10.5 L21,10.5 L21,21.0089096 C21,22.6608432 19.6470745,24 18.0074602,24 L5.99253976,24 C4.33980569,24 3,22.6582294 3,21.0089096 L3,2.99109042 C3,1.33915679 4.35292554,0 5.99253976,0 L10.2307692,0 Z M13.3076923,0 L13.3076923,6.50405791 C13.3076923,7.05410154 13.7545122,7.5 14.3133272,7.5 L21,7.5 L13.3076923,0 Z',
            id: pathId
          };
          break;

        case 'spreadsheet':
          path = {
            d: 'M10.5,0 L10.5,8.99560601 C10.5,9.78940496 11.1137008,10.4385087 11.8921193,10.4958781 L12.004394,10.5 L21,10.5 L21,21.7529248 C21,22.9939502 19.993672,24 18.7566822,24 L5.24331781,24 C4.0043676,24 3,22.9993054 3,21.7529248 L3,2.24707517 C3,1.00604982 4.00632798,0 5.24331781,0 L10.5,0 Z M8.25,18 L6.75,18 C6.36537312,18 6.04836963,18.2895301 6.0050458,18.6625342 L6,18.75 L6,20.25 C6,20.6346269 6.28953014,20.9516304 6.66253416,20.9949542 L6.75,21 L8.25,21 C8.63462688,21 8.95163037,20.7104699 8.9949542,20.3374658 L9,20.25 L9,18.75 C9,18.3357864 8.66421356,18 8.25,18 Z M12.75,18 L11.25,18 C10.8653731,18 10.5483696,18.2895301 10.5050458,18.6625342 L10.5,18.75 L10.5,20.25 C10.5,20.6346269 10.7895301,20.9516304 11.1625342,20.9949542 L11.25,21 L12.75,21 C13.1346269,21 13.4516304,20.7104699 13.4949542,20.3374658 L13.5,20.25 L13.5,18.75 C13.5,18.3357864 13.1642136,18 12.75,18 Z M17.25,18 L15.75,18 C15.3653731,18 15.0483696,18.2895301 15.0050458,18.6625342 L15,18.75 L15,20.25 C15,20.6346269 15.2895301,20.9516304 15.6625342,20.9949542 L15.75,21 L17.25,21 C17.6346269,21 17.9516304,20.7104699 17.9949542,20.3374658 L18,20.25 L18,18.75 C18,18.3357864 17.6642136,18 17.25,18 Z M8.25,13.5 L6.75,13.5 C6.36537312,13.5 6.04836963,13.7895301 6.0050458,14.1625342 L6,14.25 L6,15.75 C6,16.1346269 6.28953014,16.4516304 6.66253416,16.4949542 L6.75,16.5 L8.25,16.5 C8.63462688,16.5 8.95163037,16.2104699 8.9949542,15.8374658 L9,15.75 L9,14.25 C9,13.8357864 8.66421356,13.5 8.25,13.5 Z M12.75,13.5 L11.25,13.5 C10.8653731,13.5 10.5483696,13.7895301 10.5050458,14.1625342 L10.5,14.25 L10.5,15.75 C10.5,16.1346269 10.7895301,16.4516304 11.1625342,16.4949542 L11.25,16.5 L12.75,16.5 C13.1346269,16.5 13.4516304,16.2104699 13.4949542,15.8374658 L13.5,15.75 L13.5,14.25 C13.5,13.8357864 13.1642136,13.5 12.75,13.5 Z M17.25,13.5 L15.75,13.5 C15.3653731,13.5 15.0483696,13.7895301 15.0050458,14.1625342 L15,14.25 L15,15.75 C15,16.1346269 15.2895301,16.4516304 15.6625342,16.4949542 L15.75,16.5 L17.25,16.5 C17.6346269,16.5 17.9516304,16.2104699 17.9949542,15.8374658 L18,15.75 L18,14.25 C18,13.8357864 17.6642136,13.5 17.25,13.5 Z M8.25,9 L6.75,9 C6.36537312,9 6.04836963,9.28953014 6.0050458,9.66253416 L6,9.75 L6,11.25 C6,11.6346269 6.28953014,11.9516304 6.66253416,11.9949542 L6.75,12 L8.25,12 C8.63462688,12 8.95163037,11.7104699 8.9949542,11.3374658 L9,11.25 L9,9.75 C9,9.33578644 8.66421356,9 8.25,9 Z M13.5,0 L13.5,6.75345182 C13.5,7.165759 13.8417483,7.5 14.2465482,7.5 L21,7.5 L13.5,0 Z',
            id: pathId
          };
          break;

        case 'one-time-serving-op':
          path = {
            d: 'M21,3 L21.9950534,3 C23.1023548,3 24,3.90234375 24,4.99456145 L24,22.0054385 C24,23.1070044 23.1029738,24 21.9950534,24 L2.00494659,24 C0.897645164,24 0,23.0976562 0,22.0054385 L0,4.99456145 C0,3.89299558 0.897026226,3 2.00494659,3 L3,3 L3,5.49013764 C3,6.61019951 3.89449617,7.5 4.99791312,7.5 L7.00208688,7.5 C8.10173938,7.5 9,6.60015397 9,5.49013764 L9,3 L15,3 L15,5.49013764 C15,6.61019951 15.8944962,7.5 16.9979131,7.5 L19.0020869,7.5 C20.1017394,7.5 21,6.60015397 21,5.49013764 L21,3 Z M3,12.4996846 L3,19.0003154 C3,20.1047759 3.8932319,21 4.99508929,21 L19.0049107,21 C20.1073772,21 21,20.1047107 21,19.0003154 L21,12.4996846 C21,11.3952241 20.1067681,10.5 19.0049107,10.5 L4.99508929,10.5 C3.8926228,10.5 3,11.3952893 3,12.4996846 Z M4.5,0.990777969 C4.5,0.443586406 4.94266033,0 5.49895656,0 L6.50104344,0 C7.05275191,0 7.5,0.45097518 7.5,0.990777969 L7.5,5.00922203 C7.5,5.55641359 7.05733967,6 6.50104344,6 L5.49895656,6 C4.94724809,6 4.5,5.54902482 4.5,5.00922203 L4.5,0.990777969 Z M16.5,0.990777969 C16.5,0.443586406 16.9426603,0 17.4989566,0 L18.5010434,0 C19.0527519,0 19.5,0.45097518 19.5,0.990777969 L19.5,5.00922203 C19.5,5.55641359 19.0573397,6 18.5010434,6 L17.4989566,6 C16.9472481,6 16.5,5.54902482 16.5,5.00922203 L16.5,0.990777969 Z M13.5,12 L13.5,19.5 L11.5591142,19.5 L11.5591142,15.4789994 C11.5591142,14.8983912 11.5447018,14.5494138 11.5158766,14.4320568 C11.4870515,14.3146998 11.4077834,14.2259114 11.2780701,14.1656887 C11.1483568,14.105466 10.8593086,14.0753552 10.4109169,14.0753552 L10.21875,14.0753552 L10.21875,13.1998147 C11.1571698,13.0052492 11.8697816,12.6053149 12.3566069,12 L13.5,12 Z',
            id: pathId
          };
          break;

        case 'baby':
          path = {
            d: 'M7,6.66421356 C7.26521649,6.66421356 7.5195704,6.7695704 7.70710678,6.95710678 L18,17.25 L18,18 C18,21.3137085 15.3137085,24 12,24 C8.6862915,24 6,21.3137085 6,18 L6,7.66421356 C6,7.11192881 6.44771525,6.66421356 7,6.66421356 Z M17.6649243,7.88032163 C17.8780749,8.07007527 18,8.34185606 18,8.62723236 L18,15 L13.5960114,10.9470085 L16.2530893,7.96230802 C16.6203168,7.54980062 17.2524169,7.51309406 17.6649243,7.88032163 Z M12,0 C14.0710678,0 15.75,1.67893219 15.75,3.75 C15.75,5.82106781 14.0710678,7.5 12,7.5 C9.92893219,7.5 8.25,5.82106781 8.25,3.75 C8.25,1.67893219 9.92893219,0 12,0 Z',
            id: pathId
          };
          break;

        case 'camp-summer':
          path = {
            d: 'M20.2284886,6 C20.2794375,6 20.3291931,6.00510956 20.3772708,6.01484421 C20.5633893,5.96807755 20.7636052,6.03540849 20.9074577,6.21626161 L23.0783645,8.94555125 C23.3083871,9.23473848 23.3074186,9.70895038 23.0741754,10.0021864 L22.9623123,10.1428221 L22.1218531,10.1480886 L21.252,10.148 L23.7854556,12.6955512 C24.0729839,12.9847385 24.0717732,13.4589504 23.7802193,13.7521864 L23.6403904,13.8928221 L22.5898164,13.8980886 L21.252,13.898 L23.7854556,16.4455512 C24.0729839,16.7347385 24.0717732,17.2089504 23.7802193,17.5021864 L23.6403904,17.6428221 L22.5898164,17.6480886 L20.974,17.648 L20.9741863,23.2543023 C20.9741863,23.6661398 20.6403261,24 20.2284886,24 C19.8166511,24 19.4827909,23.6661398 19.4827909,23.2543023 L19.482,17.648 L17.9101836,17.6480886 L16.8596096,17.6428221 L16.7197807,17.5021864 C16.4282268,17.2089504 16.4270161,16.7347385 16.7145444,16.4455512 L19.247,13.898 L17.9101836,13.8980886 L16.8596096,13.8928221 L16.7197807,13.7521864 C16.4282268,13.4589504 16.4270161,12.9847385 16.7145444,12.6955512 L19.247,10.148 L18.3781469,10.1480886 L17.5376877,10.1428221 L17.4258246,10.0021864 C17.1925814,9.70895038 17.1916129,9.23473848 17.4216355,8.94555125 L19.5925423,6.21626161 C19.7315054,6.04155555 19.9230655,5.97278576 20.1044485,6.00964481 C20.1444024,6.00354831 20.1860311,6 20.2284886,6 Z M11.1660196,9.75 C13.2869338,15.5557882 15.7521277,19.9183072 18.5616013,22.8375572 C18.8139143,23.0996872 18.8126237,23.523385 18.5587388,23.7838919 C18.4373199,23.9084777 18.2730969,23.9784048 18.1019223,23.9784048 L12.5215598,23.9810945 C11.9481893,22.512139 11.7171468,18.8454471 11.2287487,16.8642024 C10.8446967,18.8439868 10.6365854,22.5191194 10.0008315,23.9811629 L4.39805042,23.9784048 C4.04014206,23.9784048 3.75,23.6788164 3.75,23.3092553 C3.75,23.1197149 3.82784785,22.9390663 3.96420846,22.8121771 C7.10123377,19.893046 9.50183747,15.538987 11.1660196,9.75 Z M5.70652174,8.67391304 L5.70652174,10.5 L4.79347826,10.5 L4.79347826,8.67391304 L5.70652174,8.67391304 Z M7.99388175,7.34826251 L9.28512022,8.63950098 L8.63950098,9.28512022 L7.34826251,7.99388175 L7.99388175,7.34826251 Z M2.50611825,7.34826251 L3.15173749,7.99388175 L1.86049902,9.28512022 L1.21487978,8.63950098 L2.50611825,7.34826251 Z M5.25,3.0625 C6.45812289,3.0625 7.4375,4.04187711 7.4375,5.25 C7.4375,6.45812289 6.45812289,7.4375 5.25,7.4375 C4.04187711,7.4375 3.0625,6.45812289 3.0625,5.25 C3.0625,4.04187711 4.04187711,3.0625 5.25,3.0625 Z M10.5,4.79347826 L10.5,5.70652174 L8.67391304,5.70652174 L8.67391304,4.79347826 L10.5,4.79347826 Z M1.82608696,4.79347826 L1.82608696,5.70652174 L0,5.70652174 L0,4.79347826 L1.82608696,4.79347826 Z M8.63950098,1.21487978 L9.28512022,1.86049902 L7.99388175,3.15173749 L7.34826251,2.50611825 L8.63950098,1.21487978 Z M1.86049902,1.21487978 L3.15173749,2.50611825 L2.50611825,3.15173749 L1.21487978,1.86049902 L1.86049902,1.21487978 Z M5.70652174,0 L5.70652174,1.82608696 L4.79347826,1.82608696 L4.79347826,0 L5.70652174,0 Z',
            id: pathId
          };
          break;

        case 'camp-winter':
          path = {
            d: 'M11.1660196,9.75 C13.2869338,15.5557882 15.7521277,19.9183072 18.5616013,22.8375572 C18.8139143,23.0996872 18.8126237,23.523385 18.5587388,23.7838919 C18.4373199,23.9084777 18.2730969,23.9784048 18.1019223,23.9784048 L12.68,23.978 L12.7016012,23.9536029 C12.7529985,23.8754494 12.763487,23.7581293 12.7329359,23.6639975 L12.7023256,23.5987207 C11.9913768,22.5039813 11.7654547,19.0414141 11.2287487,16.8642024 C10.8076207,19.0351136 10.5980434,22.4945081 9.80420632,23.589203 C9.76969972,23.6367873 9.75,23.7045318 9.75,23.7756108 C9.75,23.8597113 9.77703765,23.9341487 9.81853767,23.9796807 L4.39805042,23.9784048 C4.04014206,23.9784048 3.75,23.6788164 3.75,23.3092553 C3.75,23.1197149 3.82784785,22.9390663 3.96420846,22.8121771 C7.10123377,19.893046 9.50183747,15.538987 11.1660196,9.75 Z M20.2284886,6 C20.2847447,6 20.3395459,6.0062295 20.3922399,6.0180363 C20.6295739,5.96488308 20.887652,6.03102885 21.0718222,6.21626161 L23.7854556,8.94555125 C24.0729839,9.23473848 24.0717732,9.70895038 23.7802193,10.0021864 L23.6403904,10.1428221 C23.348705,10.4361903 22.8784784,10.4384161 22.5898164,10.1480886 L20.974,8.523 L20.9745128,10.6339219 C21.0086979,10.6580938 21.0412766,10.6855398 21.0718222,10.7162616 L23.7854556,13.4455512 C24.0729839,13.7347385 24.0717732,14.2089504 23.7802193,14.5021864 L23.6403904,14.6428221 C23.348705,14.9361903 22.8784784,14.9384161 22.5898164,14.6480886 L20.974,13.023 L20.9745128,15.1339219 C21.0086979,15.1580938 21.0412766,15.1855398 21.0718222,15.2162616 L23.7854556,17.9455512 C24.0729839,18.2347385 24.0717732,18.7089504 23.7802193,19.0021864 L23.6403904,19.1428221 C23.348705,19.4361903 22.8784784,19.4384161 22.5898164,19.1480886 L20.974,17.523 L20.9741863,23.2543023 C20.9741863,23.6661398 20.6403261,24 20.2284886,24 C19.8166511,24 19.4827909,23.6661398 19.4827909,23.2543023 L19.482,17.566 L17.9101836,19.1480886 C17.6215216,19.4384161 17.151295,19.4361903 16.8596096,19.1428221 L16.7197807,19.0021864 C16.4282268,18.7089504 16.4270161,18.2347385 16.7145444,17.9455512 L19.4281778,15.2162616 L19.482,15.169 L19.482,13.066 L17.9101836,14.6480886 C17.6215216,14.9384161 17.151295,14.9361903 16.8596096,14.6428221 L16.7197807,14.5021864 C16.4282268,14.2089504 16.4270161,13.7347385 16.7145444,13.4455512 L19.4281778,10.7162616 L19.482,10.669 L19.482,8.566 L17.9101836,10.1480886 C17.6215216,10.4384161 17.151295,10.4361903 16.8596096,10.1428221 L16.7197807,10.0021864 C16.4282268,9.70895038 16.4270161,9.23473848 16.7145444,8.94555125 L19.4281778,6.21626161 C19.6067128,6.03669661 19.8547019,5.96904244 20.0869469,6.01296529 C20.1319324,6.00469264 20.1796625,6 20.2284886,6 Z M3.45867249,7.5 C3.63407111,7.5 3.77625979,7.63991102 3.77625979,7.8125 L3.77625979,8.36091132 L4.13451653,8.00839336 C4.25880978,7.8860911 4.46032897,7.8860911 4.58462223,8.00839336 L4.61462927,8.03791973 C4.73892253,8.16022199 4.73892253,8.35851312 4.61462927,8.48081537 L3.77625979,9.30575535 L3.77625979,10.6726497 L4.97929601,9.98920254 L5.28616054,8.86231357 C5.33165503,8.69524559 5.50617576,8.59610002 5.67596351,8.64086575 L5.7169539,8.65167316 C5.88674164,8.69643889 5.98750124,8.86816405 5.94200675,9.03523203 L5.81087568,9.51678053 L6.29354551,9.24257487 C6.44544518,9.15628037 6.63967852,9.20749136 6.72737784,9.3569578 L6.74855032,9.3930422 C6.83624964,9.54250864 6.78420497,9.73363064 6.6323053,9.81992513 L6.14963547,10.0941308 L6.63902327,10.2231613 C6.80881102,10.2679271 6.90957061,10.4396522 6.86407612,10.6067202 L6.85309278,10.647054 C6.80759829,10.814122 6.63307756,10.9132675 6.46328981,10.8685018 L5.3180558,10.5665528 L4.11501958,11.25 L5.3180558,11.9334472 L6.46328981,11.6314982 C6.63307756,11.5867325 6.80759829,11.685878 6.85309278,11.852946 L6.86407612,11.8932798 C6.90957061,12.0603478 6.80881102,12.2320729 6.63902327,12.2768387 L6.14963547,12.4058692 L6.6323053,12.6800749 C6.78420497,12.7663694 6.83624964,12.9574914 6.74855032,13.1069578 L6.72737784,13.1430422 C6.63967852,13.2925086 6.44544518,13.3437196 6.29354551,13.2574251 L5.81087568,12.9832195 L5.94200675,13.464768 C5.98750124,13.631836 5.88674164,13.8035611 5.7169539,13.8483268 L5.67596351,13.8591342 C5.50617576,13.9039 5.33165503,13.8047544 5.28616054,13.6376864 L4.97929601,12.5107975 L3.77625979,11.8273503 L3.77625979,13.1942447 L4.61462927,14.0191846 C4.73892253,14.1414869 4.73892253,14.339778 4.61462927,14.4620803 L4.58462223,14.4916066 C4.46032897,14.6139089 4.25880978,14.6139089 4.13451653,14.4916066 L3.77625979,14.1390887 L3.77625979,14.6875 C3.77625979,14.860089 3.63407111,15 3.45867249,15 L3.41632751,15 C3.24092889,15 3.09874021,14.860089 3.09874021,14.6875 L3.09874021,14.1390887 L2.74048347,14.4916066 C2.61619022,14.6139089 2.41467103,14.6139089 2.29037777,14.4916066 L2.26037073,14.4620803 C2.13607747,14.339778 2.13607747,14.1414869 2.26037073,14.0191846 L3.09874021,13.1942447 L3.09874021,11.8273503 L1.89570399,12.5107975 L1.58883946,13.6376864 C1.54334497,13.8047544 1.36882424,13.9039 1.19903649,13.8591342 L1.1580461,13.8483268 C0.988258356,13.8035611 0.887498763,13.631836 0.932993253,13.464768 L1.06412432,12.9832195 L0.581454489,13.2574251 C0.429554824,13.3437196 0.235321476,13.2925086 0.147622163,13.1430422 L0.126449676,13.1069578 C0.0387503637,12.9574914 0.0907950325,12.7663694 0.242694697,12.6800749 L0.725364528,12.4058692 L0.235976726,12.2768387 C0.0661889793,12.2320729 -0.0345706139,12.0603478 0.0109238757,11.8932798 L0.0219072171,11.852946 C0.0674017068,11.685878 0.241922441,11.5867325 0.411710188,11.6314982 L1.5569442,11.9334472 L2.75998042,11.25 L1.5569442,10.5665528 L0.411710188,10.8685018 C0.241922441,10.9132675 0.0674017068,10.814122 0.0219072171,10.647054 L0.0109238757,10.6067202 C-0.0345706139,10.4396522 0.0661889793,10.2679271 0.235976726,10.2231613 L0.725364528,10.0941308 L0.242694697,9.81992513 C0.0907950325,9.73363064 0.0387503637,9.54250864 0.126449676,9.3930422 L0.147622163,9.3569578 C0.235321476,9.20749136 0.429554824,9.15628037 0.581454489,9.24257487 L1.06412432,9.51678053 L0.932993253,9.03523203 C0.887498763,8.86816405 0.988258356,8.69643889 1.1580461,8.65167316 L1.19903649,8.64086575 C1.36882424,8.59610002 1.54334497,8.69524559 1.58883946,8.86231357 L1.89570399,9.98920254 L3.09874021,10.6726497 L3.09874021,9.30575535 L2.26037073,8.48081537 C2.13607747,8.35851312 2.13607747,8.16022199 2.26037073,8.03791973 L2.29037777,8.00839336 C2.41467103,7.8860911 2.61619022,7.8860911 2.74048347,8.00839336 L3.09874021,8.36091132 L3.09874021,7.8125 C3.09874021,7.63991102 3.24092889,7.5 3.41632751,7.5 L3.45867249,7.5 Z M10.9586725,0 C11.1340711,0 11.2762598,0.139911016 11.2762598,0.3125 L11.2762598,0.86091132 L11.6345165,0.508393356 C11.7588098,0.386091103 11.960329,0.386091103 12.0846222,0.508393356 L12.1146293,0.537919732 C12.2389225,0.660221985 12.2389225,0.858513116 12.1146293,0.980815369 L11.2762598,1.80575535 L11.2762598,3.17264973 L12.479296,2.48920254 L12.7861605,1.36231357 C12.831655,1.19524559 13.0061758,1.09610002 13.1759635,1.14086575 L13.2169539,1.15167316 C13.3867416,1.19643889 13.4875012,1.36816405 13.4420067,1.53523203 L13.3108757,2.01678053 L13.7935455,1.74257487 C13.9454452,1.65628037 14.1396785,1.70749136 14.2273778,1.8569578 L14.2485503,1.8930422 C14.3362496,2.04250864 14.284205,2.23363064 14.1323053,2.31992513 L13.6496355,2.59413079 L14.1390233,2.72316132 C14.308811,2.76792706 14.4095706,2.93965221 14.3640761,3.1067202 L14.3530928,3.14705398 C14.3075983,3.31412196 14.1330776,3.41326753 13.9632898,3.3685018 L12.8180558,3.06655281 L11.6150196,3.75 L12.8180558,4.43344719 L13.9632898,4.1314982 C14.1330776,4.08673247 14.3075983,4.18587804 14.3530928,4.35294602 L14.3640761,4.3932798 C14.4095706,4.56034779 14.308811,4.73207294 14.1390233,4.77683868 L13.6496355,4.90586921 L14.1323053,5.18007487 C14.284205,5.26636936 14.3362496,5.45749136 14.2485503,5.6069578 L14.2273778,5.6430422 C14.1396785,5.79250864 13.9454452,5.84371963 13.7935455,5.75742513 L13.3108757,5.48321947 L13.4420067,5.96476797 C13.4875012,6.13183595 13.3867416,6.30356111 13.2169539,6.34832684 L13.1759635,6.35913425 C13.0061758,6.40389998 12.831655,6.30475441 12.7861605,6.13768643 L12.479296,5.01079746 L11.2762598,4.32735027 L11.2762598,5.69424465 L12.1146293,6.51918463 C12.2389225,6.64148688 12.2389225,6.83977801 12.1146293,6.96208027 L12.0846222,6.99160664 C11.960329,7.1139089 11.7588098,7.1139089 11.6345165,6.99160664 L11.2762598,6.63908868 L11.2762598,7.1875 C11.2762598,7.36008898 11.1340711,7.5 10.9586725,7.5 L10.9163275,7.5 C10.7409289,7.5 10.5987402,7.36008898 10.5987402,7.1875 L10.5987402,6.63908868 L10.2404835,6.99160664 C10.1161902,7.1139089 9.91467103,7.1139089 9.79037777,6.99160664 L9.76037073,6.96208027 C9.63607747,6.83977801 9.63607747,6.64148688 9.76037073,6.51918463 L10.5987402,5.69424465 L10.5987402,4.32735027 L9.39570399,5.01079746 L9.08883946,6.13768643 C9.04334497,6.30475441 8.86882424,6.40389998 8.69903649,6.35913425 L8.6580461,6.34832684 C8.48825836,6.30356111 8.38749876,6.13183595 8.43299325,5.96476797 L8.56412432,5.48321947 L8.08145449,5.75742513 C7.92955482,5.84371963 7.73532148,5.79250864 7.64762216,5.6430422 L7.62644968,5.6069578 C7.53875036,5.45749136 7.59079503,5.26636936 7.7426947,5.18007487 L8.22536453,4.90586921 L7.73597673,4.77683868 C7.56618898,4.73207294 7.46542939,4.56034779 7.51092388,4.3932798 L7.52190722,4.35294602 C7.56740171,4.18587804 7.74192244,4.08673247 7.91171019,4.1314982 L9.0569442,4.43344719 L10.2599804,3.75 L9.0569442,3.06655281 L7.91171019,3.3685018 C7.74192244,3.41326753 7.56740171,3.31412196 7.52190722,3.14705398 L7.51092388,3.1067202 C7.46542939,2.93965221 7.56618898,2.76792706 7.73597673,2.72316132 L8.22536453,2.59413079 L7.7426947,2.31992513 C7.59079503,2.23363064 7.53875036,2.04250864 7.62644968,1.8930422 L7.64762216,1.8569578 C7.73532148,1.70749136 7.92955482,1.65628037 8.08145449,1.74257487 L8.56412432,2.01678053 L8.43299325,1.53523203 C8.38749876,1.36816405 8.48825836,1.19643889 8.6580461,1.15167316 L8.69903649,1.14086575 C8.86882424,1.09610002 9.04334497,1.19524559 9.08883946,1.36231357 L9.39570399,2.48920254 L10.5987402,3.17264973 L10.5987402,1.80575535 L9.76037073,0.980815369 C9.63607747,0.858513116 9.63607747,0.660221985 9.76037073,0.537919732 L9.79037777,0.508393356 C9.91467103,0.386091103 10.1161902,0.386091103 10.2404835,0.508393356 L10.5987402,0.86091132 L10.5987402,0.3125 C10.5987402,0.139911016 10.7409289,0 10.9163275,0 L10.9586725,0 Z',
            id: pathId
          };
          break;

        case 'replied-successful':
          path = {
            d: 'M3.86648724,16.7995776 L0,0 L22.490594,7.55714216 L16.5728554,9.79368428 L14.526833,15.3209513 C14.444233,15.5957254 14.1998302,15.807869 13.8902735,15.8734902 C13.5807168,15.9391113 13.2558544,15.847643 13.0441529,15.6352563 C12.0927982,14.8286994 10.2190564,13.1855868 10.2190564,13.1855868 L3.86648724,16.7995776 Z M15.021568,9.03962515 L0.470720095,0.435442304 L13.039579,10.8613666 L13.7477589,11.9310942 L15.021568,9.03962515 Z M10.2940578,15.9874157 L19.5758903,23.0388174 L18.6670444,24 L9.38521192,16.9485983 L10.2940578,15.9874157 Z M20.2749494,10.8480956 L23.844885,13.4122417 L22.965895,14.3954802 L19.3959595,11.8313342 L20.2749494,10.8480956 Z M18.6450967,15.1301871 L24,19.2969244 L23.0785252,20.2483972 L17.7236218,16.0816598 L18.6450967,15.1301871 Z',
            id: pathId
          };
          break;

        case 'replied-unsuccessful':
          path = {
            d: 'M0,16.8780397 L3.77136124,11.1210434 C3.77136124,11.1210434 2.05669971,9.42297059 1.21502146,8.56080833 C0.993386396,8.36895443 0.897935126,8.07454892 0.966413747,7.79401412 C1.03489237,7.51347932 1.25627369,7.29199004 1.54301273,7.21713397 L7.31096336,5.36293244 L9.64489519,0 C9.64489519,0 13.0962272,5.67194238 12.7837097,8.51852512 C12.4711921,11.3651079 13.1462319,12.0640059 14.5150689,13.8659893 C15.8839059,15.6679727 15.6420578,16.3014585 15.6420578,16.3014585 C15.6974858,16.900125 15.2365755,17.4710519 14.6142595,17.536761 C14.6142595,17.536761 13.9440219,17.7799382 12.4711921,17.3854402 C10.9983623,16.9909421 10.5977137,16.5091902 9.64489519,16.0741305 C8.69207665,15.6390709 6.90357863,15.3483652 5.3210132,15.4947808 C2.57433535,15.7488977 0,16.8780397 0,16.8780397 Z M8.09785782,6.76878196 L5.08048042,7.92316749 L6.1967891,8.56495334 C6.1967891,8.56495334 9.32311562,12.1209337 11.7941184,13.699366 C14.2651212,15.2777984 14.8902166,16.6946434 14.8902166,16.6946434 C14.8902166,16.6946434 14.816995,15.130443 13.0483772,13.699366 C11.2797593,12.2682891 8.09785782,6.76878196 8.09785782,6.76878196 Z M13.0858039,22.1257568 L13.468386,23.238267 L11.1108092,24 L10.7282271,22.8874898 L13.0858039,22.1257568 Z M15.3245217,19.153916 L15.3245217,20.3266047 L8.87209148,20.3266047 L8.87209148,19.153916 L15.3245217,19.153916 Z M18.6650668,9.67943013 L19.8564881,9.88322623 L18.4364067,17.683307 L17.2449853,17.4795109 L18.6650668,9.67943013 Z M22.9178946,12.6992569 L24,13.2236992 L22.2491166,16.6179614 L21.1670112,16.0935191 L22.9178946,12.6992569 Z',
            id: pathId
          };
          break;

        case 'test':
          path = {
            d: '',
            id: pathId
          };
          break;

        default:
          console.warn("Whoops, you have something wrong with the <Icon> type, '".concat(type, "', you passed in."));
        // eslint-disable-line no-console
      }

      var isButton = (0, _lodash.isFunction)(onClick);
      var ElementType = isButton ? 'button' : 'div';
      return /*#__PURE__*/_react["default"].createElement(ElementType // eslint-disable-next-line react/jsx-props-no-spreading
      , _extends({}, otherProps, {
        className: rootClasses,
        "data-testid": "".concat(dataTestId, "-").concat(type),
        id: id,
        onClick: this.onClick,
        onKeyDown: this.onKeyDown,
        onMouseDown: this.onMouseDown,
        style: containerStyle,
        tabIndex: tabIndex,
        type: isButton ? 'button' : null
      }), /*#__PURE__*/_react["default"].createElement(_iconSVG["default"], {
        circle: circle,
        gradientId: gradientId,
        maskId: maskId,
        path: path,
        polygon: polygon,
        renderGradientColor: renderGradientColor,
        style: svgStyle,
        title: title,
        type: type,
        viewBox: viewBox
      }));
    }
  }]);

  return Icon;
}(_react["default"].PureComponent);

Icon.propTypes = propTypes;
Icon.defaultProps = defaultProps;
var _default = Icon;
exports["default"] = _default;